// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.metaprogamme;

import fr.ifremer.quadrige3.core.dao.administration.program.Program;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.administration.user.Quser;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Programme virtuel (métaprogramme)
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Metaprogramme
    implements Serializable, Comparable<Metaprogramme>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 442571845093938316L;

    // Generate 4 attributes
    private String metCd;

    /**
     * Code unique identifiant le métaprogramme
     * @return this.metCd String
     */
    public String getMetCd()
    {
        return this.metCd;
    }

    /**
     * Code unique identifiant le métaprogramme
     * @param metCdIn String
     */
    public void setMetCd(String metCdIn)
    {
        this.metCd = metCdIn;
    }

    private String metNm;

    /**
     * Libellé du métaprogramme
     * @return this.metNm String
     */
    public String getMetNm()
    {
        return this.metNm;
    }

    /**
     * Libellé du métaprogramme
     * @param metNmIn String
     */
    public void setMetNm(String metNmIn)
    {
        this.metNm = metNmIn;
    }

    private String metDc;

    /**
     * Description longue
     * @return this.metDc String
     */
    public String getMetDc()
    {
        return this.metDc;
    }

    /**
     * Description longue
     * @param metDcIn String
     */
    public void setMetDc(String metDcIn)
    {
        this.metDc = metDcIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 5 associations
    private Collection<Program> programs = new HashSet<Program>();

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @return this.programs Collection<Program>
     */
    public Collection<Program> getPrograms()
    {
        return this.programs;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param programsIn Collection<Program>
     */
    public void setPrograms(Collection<Program> programsIn)
    {
        this.programs = programsIn;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToAdd Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPrograms(Program elementToAdd)
    {
        return this.programs.add(elementToAdd);
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToRemove Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePrograms(Program elementToRemove)
    {
        return this.programs.remove(elementToRemove);
    }

    private Collection<Department> departments = new HashSet<Department>();

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.departments Collection<Department>
     */
    public Collection<Department> getDepartments()
    {
        return this.departments;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param departmentsIn Collection<Department>
     */
    public void setDepartments(Collection<Department> departmentsIn)
    {
        this.departments = departmentsIn;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param elementToAdd Department
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addDepartments(Department elementToAdd)
    {
        return this.departments.add(elementToAdd);
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param elementToRemove Department
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeDepartments(Department elementToRemove)
    {
        return this.departments.remove(elementToRemove);
    }

    private Collection<Quser> qusers = new HashSet<Quser>();

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @return this.qusers Collection<Quser>
     */
    public Collection<Quser> getQusers()
    {
        return this.qusers;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param qusersIn Collection<Quser>
     */
    public void setQusers(Collection<Quser> qusersIn)
    {
        this.qusers = qusersIn;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param elementToAdd Quser
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addQusers(Quser elementToAdd)
    {
        return this.qusers.add(elementToAdd);
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param elementToRemove Quser
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeQusers(Quser elementToRemove)
    {
        return this.qusers.remove(elementToRemove);
    }

    private Collection<PmfmMet> pmfmMets = new HashSet<PmfmMet>();

    /**
     * Liste des PMFM ou éléments constitutifs associés à un programme
     * @return this.pmfmMets Collection<PmfmMet>
     */
    public Collection<PmfmMet> getPmfmMets()
    {
        return this.pmfmMets;
    }

    /**
     * Liste des PMFM ou éléments constitutifs associés à un programme
     * @param pmfmMetsIn Collection<PmfmMet>
     */
    public void setPmfmMets(Collection<PmfmMet> pmfmMetsIn)
    {
        this.pmfmMets = pmfmMetsIn;
    }

    /**
     * Liste des PMFM ou éléments constitutifs associés à un programme
     * @param elementToAdd PmfmMet
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPmfmMets(PmfmMet elementToAdd)
    {
        return this.pmfmMets.add(elementToAdd);
    }

    /**
     * Liste des PMFM ou éléments constitutifs associés à un programme
     * @param elementToRemove PmfmMet
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePmfmMets(PmfmMet elementToRemove)
    {
        return this.pmfmMets.remove(elementToRemove);
    }

    private Collection<MonLocMet> monLocMets = new HashSet<MonLocMet>();

    /**
     * Liste des lieux d'un métaprogramme
     * @return this.monLocMets Collection<MonLocMet>
     */
    public Collection<MonLocMet> getMonLocMets()
    {
        return this.monLocMets;
    }

    /**
     * Liste des lieux d'un métaprogramme
     * @param monLocMetsIn Collection<MonLocMet>
     */
    public void setMonLocMets(Collection<MonLocMet> monLocMetsIn)
    {
        this.monLocMets = monLocMetsIn;
    }

    /**
     * Liste des lieux d'un métaprogramme
     * @param elementToAdd MonLocMet
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addMonLocMets(MonLocMet elementToAdd)
    {
        return this.monLocMets.add(elementToAdd);
    }

    /**
     * Liste des lieux d'un métaprogramme
     * @param elementToRemove MonLocMet
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeMonLocMets(MonLocMet elementToRemove)
    {
        return this.monLocMets.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an Metaprogramme instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Metaprogramme))
        {
            return false;
        }
        final Metaprogramme that = (Metaprogramme)object;
        if (this.metCd == null || that.getMetCd() == null || !this.metCd.equals(that.getMetCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.metCd == null ? 0 : this.metCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Metaprogramme}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Metaprogramme}.
         * @return new MetaprogrammeImpl()
         */
        public static Metaprogramme newInstance()
        {
            return new MetaprogrammeImpl();
        }

        /**
         * Constructs a new instance of {@link Metaprogramme}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param metNm String
         * @return newInstance
         */
        public static Metaprogramme newInstance(String metNm)
        {
            final Metaprogramme entity = new MetaprogrammeImpl();
            entity.setMetNm(metNm);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Metaprogramme}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param metNm String
         * @param metDc String
         * @param updateDt Timestamp
         * @param programs Collection<Program>
         * @param departments Collection<Department>
         * @param qusers Collection<Quser>
         * @param pmfmMets Collection<PmfmMet>
         * @param monLocMets Collection<MonLocMet>
         * @return newInstance Metaprogramme
         */
        public static Metaprogramme newInstance(String metNm, String metDc, Timestamp updateDt, Collection<Program> programs, Collection<Department> departments, Collection<Quser> qusers, Collection<PmfmMet> pmfmMets, Collection<MonLocMet> monLocMets)
        {
            final Metaprogramme entity = new MetaprogrammeImpl();
            entity.setMetNm(metNm);
            entity.setMetDc(metDc);
            entity.setUpdateDt(updateDt);
            entity.setPrograms(programs);
            entity.setDepartments(departments);
            entity.setQusers(qusers);
            entity.setPmfmMets(pmfmMets);
            entity.setMonLocMets(monLocMets);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Metaprogramme o)
    {
        int cmp = 0;
        if (this.getMetCd() != null)
        {
            cmp = this.getMetCd().compareTo(o.getMetCd());
        }
        else
        {
            if (this.getMetNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMetNm().compareTo(o.getMetNm()));
            }
            if (this.getMetDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMetDc().compareTo(o.getMetDc()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Metaprogramme.java merge-point
}