// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.metaprogamme;

import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocation;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Liste des lieux d'un métaprogramme
 */
// HibernateEntity.vsl annotations merge-point
public abstract class MonLocMet
    implements Serializable, Comparable<MonLocMet>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 4669194959258532954L;

    // Generate 2 attributes
    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private Integer monLocMetId;

    /**
     * 
     * @return this.monLocMetId Integer
     */
    public Integer getMonLocMetId()
    {
        return this.monLocMetId;
    }

    /**
     * 
     * @param monLocMetIdIn Integer
     */
    public void setMonLocMetId(Integer monLocMetIdIn)
    {
        this.monLocMetId = monLocMetIdIn;
    }

    // Generate 3 associations
    private Collection<PmfmMet> pmfmMets = new HashSet<PmfmMet>();

    /**
     * Liste des PMFM ou éléments constitutifs associés à un programme
     * @return this.pmfmMets Collection<PmfmMet>
     */
    public Collection<PmfmMet> getPmfmMets()
    {
        return this.pmfmMets;
    }

    /**
     * Liste des PMFM ou éléments constitutifs associés à un programme
     * @param pmfmMetsIn Collection<PmfmMet>
     */
    public void setPmfmMets(Collection<PmfmMet> pmfmMetsIn)
    {
        this.pmfmMets = pmfmMetsIn;
    }

    /**
     * Liste des PMFM ou éléments constitutifs associés à un programme
     * @param elementToAdd PmfmMet
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPmfmMets(PmfmMet elementToAdd)
    {
        return this.pmfmMets.add(elementToAdd);
    }

    /**
     * Liste des PMFM ou éléments constitutifs associés à un programme
     * @param elementToRemove PmfmMet
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePmfmMets(PmfmMet elementToRemove)
    {
        return this.pmfmMets.remove(elementToRemove);
    }

    private MonitoringLocation monitoringLocation;

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @return this.monitoringLocation MonitoringLocation
     */
    public MonitoringLocation getMonitoringLocation()
    {
        return this.monitoringLocation;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param monitoringLocationIn MonitoringLocation
     */
    public void setMonitoringLocation(MonitoringLocation monitoringLocationIn)
    {
        this.monitoringLocation = monitoringLocationIn;
    }

    private Metaprogramme metaprogramme;

    /**
     * Programme virtuel (métaprogramme)
     * @return this.metaprogramme Metaprogramme
     */
    public Metaprogramme getMetaprogramme()
    {
        return this.metaprogramme;
    }

    /**
     * Programme virtuel (métaprogramme)
     * @param metaprogrammeIn Metaprogramme
     */
    public void setMetaprogramme(Metaprogramme metaprogrammeIn)
    {
        this.metaprogramme = metaprogrammeIn;
    }

    /**
     * Returns <code>true</code> if the argument is an MonLocMet instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof MonLocMet))
        {
            return false;
        }
        final MonLocMet that = (MonLocMet)object;
        if (this.monLocMetId == null || that.getMonLocMetId() == null || !this.monLocMetId.equals(that.getMonLocMetId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.monLocMetId == null ? 0 : this.monLocMetId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link MonLocMet}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link MonLocMet}.
         * @return new MonLocMetImpl()
         */
        public static MonLocMet newInstance()
        {
            return new MonLocMetImpl();
        }

        /**
         * Constructs a new instance of {@link MonLocMet}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param monitoringLocation MonitoringLocation
         * @param metaprogramme Metaprogramme
         * @return newInstance
         */
        public static MonLocMet newInstance(MonitoringLocation monitoringLocation, Metaprogramme metaprogramme)
        {
            final MonLocMet entity = new MonLocMetImpl();
            entity.setMonitoringLocation(monitoringLocation);
            entity.setMetaprogramme(metaprogramme);
            return entity;
        }

        /**
         * Constructs a new instance of {@link MonLocMet}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param pmfmMets Collection<PmfmMet>
         * @param monitoringLocation MonitoringLocation
         * @param metaprogramme Metaprogramme
         * @return newInstance MonLocMet
         */
        public static MonLocMet newInstance(Timestamp updateDt, Collection<PmfmMet> pmfmMets, MonitoringLocation monitoringLocation, Metaprogramme metaprogramme)
        {
            final MonLocMet entity = new MonLocMetImpl();
            entity.setUpdateDt(updateDt);
            entity.setPmfmMets(pmfmMets);
            entity.setMonitoringLocation(monitoringLocation);
            entity.setMetaprogramme(metaprogramme);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(MonLocMet o)
    {
        int cmp = 0;
        if (this.getMonLocMetId() != null)
        {
            cmp = this.getMonLocMetId().compareTo(o.getMonLocMetId());
        }
        else
        {
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// MonLocMet.java merge-point
}