// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.metaprogamme;

import fr.ifremer.quadrige3.core.dao.referential.Unit;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Fraction;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Matrix;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Method;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Parameter;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Liste des PMFM ou éléments constitutifs associés à un programme
 */
// HibernateEntity.vsl annotations merge-point
public abstract class PmfmMet
    implements Serializable, Comparable<PmfmMet>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -5327519249329437915L;

    // Generate 2 attributes
    private Integer pmfmMetId;

    /**
     * Identifiant de l'association
     * @return this.pmfmMetId Integer
     */
    public Integer getPmfmMetId()
    {
        return this.pmfmMetId;
    }

    /**
     * Identifiant de l'association
     * @param pmfmMetIdIn Integer
     */
    public void setPmfmMetId(Integer pmfmMetIdIn)
    {
        this.pmfmMetId = pmfmMetIdIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 7 associations
    private Unit unit;

    /**
     * Liste l'ensemble des unités de mesure.
     * @return this.unit Unit
     */
    public Unit getUnit()
    {
        return this.unit;
    }

    /**
     * Liste l'ensemble des unités de mesure.
     * @param unitIn Unit
     */
    public void setUnit(Unit unitIn)
    {
        this.unit = unitIn;
    }

    private Fraction fraction;

    /**
     * Liste les fractions (compléter la description).
     * @return this.fraction Fraction
     */
    public Fraction getFraction()
    {
        return this.fraction;
    }

    /**
     * Liste les fractions (compléter la description).
     * @param fractionIn Fraction
     */
    public void setFraction(Fraction fractionIn)
    {
        this.fraction = fractionIn;
    }

    private Collection<MonLocMet> monLocMets = new HashSet<MonLocMet>();

    /**
     * Liste des lieux d'un métaprogramme
     * @return this.monLocMets Collection<MonLocMet>
     */
    public Collection<MonLocMet> getMonLocMets()
    {
        return this.monLocMets;
    }

    /**
     * Liste des lieux d'un métaprogramme
     * @param monLocMetsIn Collection<MonLocMet>
     */
    public void setMonLocMets(Collection<MonLocMet> monLocMetsIn)
    {
        this.monLocMets = monLocMetsIn;
    }

    /**
     * Liste des lieux d'un métaprogramme
     * @param elementToAdd MonLocMet
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addMonLocMets(MonLocMet elementToAdd)
    {
        return this.monLocMets.add(elementToAdd);
    }

    /**
     * Liste des lieux d'un métaprogramme
     * @param elementToRemove MonLocMet
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeMonLocMets(MonLocMet elementToRemove)
    {
        return this.monLocMets.remove(elementToRemove);
    }

    private Matrix matrix;

    /**
     * Support utilisé pour mesurer un paramètre.
     * @return this.matrix Matrix
     */
    public Matrix getMatrix()
    {
        return this.matrix;
    }

    /**
     * Support utilisé pour mesurer un paramètre.
     * @param matrixIn Matrix
     */
    public void setMatrix(Matrix matrixIn)
    {
        this.matrix = matrixIn;
    }

    private Method method;

    /**
     * Méthode utilisée pour mesurer un paramètre.
     * @return this.method Method
     */
    public Method getMethod()
    {
        return this.method;
    }

    /**
     * Méthode utilisée pour mesurer un paramètre.
     * @param methodIn Method
     */
    public void setMethod(Method methodIn)
    {
        this.method = methodIn;
    }

    private Metaprogramme metaprogramme;

    /**
     * Programme virtuel (métaprogramme)
     * @return this.metaprogramme Metaprogramme
     */
    public Metaprogramme getMetaprogramme()
    {
        return this.metaprogramme;
    }

    /**
     * Programme virtuel (métaprogramme)
     * @param metaprogrammeIn Metaprogramme
     */
    public void setMetaprogramme(Metaprogramme metaprogrammeIn)
    {
        this.metaprogramme = metaprogrammeIn;
    }

    private Parameter parameter;

    /**
     * Liste les différents paramètres mesurés. Attention, voir PARAMETRE SISMER.
     * @return this.parameter Parameter
     */
    public Parameter getParameter()
    {
        return this.parameter;
    }

    /**
     * Liste les différents paramètres mesurés. Attention, voir PARAMETRE SISMER.
     * @param parameterIn Parameter
     */
    public void setParameter(Parameter parameterIn)
    {
        this.parameter = parameterIn;
    }

    /**
     * Returns <code>true</code> if the argument is an PmfmMet instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof PmfmMet))
        {
            return false;
        }
        final PmfmMet that = (PmfmMet)object;
        if (this.pmfmMetId == null || that.getPmfmMetId() == null || !this.pmfmMetId.equals(that.getPmfmMetId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.pmfmMetId == null ? 0 : this.pmfmMetId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link PmfmMet}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link PmfmMet}.
         * @return new PmfmMetImpl()
         */
        public static PmfmMet newInstance()
        {
            return new PmfmMetImpl();
        }

        /**
         * Constructs a new instance of {@link PmfmMet}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param metaprogramme Metaprogramme
         * @param parameter Parameter
         * @return newInstance
         */
        public static PmfmMet newInstance(Metaprogramme metaprogramme, Parameter parameter)
        {
            final PmfmMet entity = new PmfmMetImpl();
            entity.setMetaprogramme(metaprogramme);
            entity.setParameter(parameter);
            return entity;
        }

        /**
         * Constructs a new instance of {@link PmfmMet}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param unit Unit
         * @param fraction Fraction
         * @param monLocMets Collection<MonLocMet>
         * @param matrix Matrix
         * @param method Method
         * @param metaprogramme Metaprogramme
         * @param parameter Parameter
         * @return newInstance PmfmMet
         */
        public static PmfmMet newInstance(Timestamp updateDt, Unit unit, Fraction fraction, Collection<MonLocMet> monLocMets, Matrix matrix, Method method, Metaprogramme metaprogramme, Parameter parameter)
        {
            final PmfmMet entity = new PmfmMetImpl();
            entity.setUpdateDt(updateDt);
            entity.setUnit(unit);
            entity.setFraction(fraction);
            entity.setMonLocMets(monLocMets);
            entity.setMatrix(matrix);
            entity.setMethod(method);
            entity.setMetaprogramme(metaprogramme);
            entity.setParameter(parameter);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(PmfmMet o)
    {
        int cmp = 0;
        if (this.getPmfmMetId() != null)
        {
            cmp = this.getPmfmMetId().compareTo(o.getPmfmMetId());
        }
        else
        {
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// PmfmMet.java merge-point
}