// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.program;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Périodes d'application d'un moratoire
 * Un moratoire peut avoir plusieurs période d'activité
 */
// HibernateEntity.vsl annotations merge-point
public abstract class MorPeriod
    implements Serializable, Comparable<MorPeriod>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -8023555772415993498L;

    private MorPeriodPK morPeriodPk;

    /**
     * Get the composite primary key identifier class
     * @return morPeriodPk
     */
    public MorPeriodPK getMorPeriodPk()
    {
        return this.morPeriodPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param morPeriodPkIn
     */
    public void setMorPeriodPk(MorPeriodPK morPeriodPkIn) {
        this.morPeriodPk = morPeriodPkIn;
    }

    // Generate 3 attributes
    /**
     * Date de début de la période d'activité du moratoire
     * @return this.morPerStartDt Date
     */
    public Date getMorPerStartDt()
    {
        return this.getMorPeriodPk().getMorPerStartDt();
    }

    /**
     * Date de début de la période d'activité du moratoire
     * @param morPerStartDtIn Date
     */
    public void setMorPerStartDt(Date morPerStartDtIn)
    {
        this.getMorPeriodPk().setMorPerStartDt(morPerStartDtIn);
    }

    private Date morPerEndDt;

    /**
     * Date de fin de la période d'activité du moratoire
     * @return this.morPerEndDt Date
     */
    public Date getMorPerEndDt()
    {
        return this.morPerEndDt;
    }

    /**
     * Date de fin de la période d'activité du moratoire
     * @param morPerEndDtIn Date
     */
    public void setMorPerEndDt(Date morPerEndDtIn)
    {
        this.morPerEndDt = morPerEndDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 1 associations
    private Moratorium moratorium;

    /**
     * Moratoire sur la restriction d'accès aux données
     * @return this.moratorium Moratorium
     */
    public Moratorium getMoratorium()
    {
        return this.moratorium;
    }

    /**
     * Moratoire sur la restriction d'accès aux données
     * @param moratoriumIn Moratorium
     */
    public void setMoratorium(Moratorium moratoriumIn)
    {
        this.moratorium = moratoriumIn;
    }

    /**
     * Returns <code>true</code> if the argument is an MorPeriod instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof MorPeriod))
        {
            return false;
        }
        final MorPeriod that = (MorPeriod)object;
        if (this.morPeriodPk == null || that.morPeriodPk == null || !this.morPeriodPk.equals(that.morPeriodPk))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.morPeriodPk == null ? 0 : this.morPeriodPk.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link MorPeriod}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link MorPeriod}.
         * @return new MorPeriodImpl()
         */
        public static MorPeriod newInstance()
        {
            return new MorPeriodImpl();
        }

        /**
         * Constructs a new instance of {@link MorPeriod}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param morPerEndDt Date
         * @param moratorium Moratorium
         * @return newInstance
         */
        public static MorPeriod newInstance(Date morPerEndDt, Moratorium moratorium)
        {
            final MorPeriod entity = new MorPeriodImpl();
            entity.setMorPerEndDt(morPerEndDt);
            entity.setMoratorium(moratorium);
            return entity;
        }

        /**
         * Constructs a new instance of {@link MorPeriod}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param morPerEndDt Date
         * @param updateDt Timestamp
         * @param moratorium Moratorium
         * @return newInstance MorPeriod
         */
        public static MorPeriod newInstance(Date morPerEndDt, Timestamp updateDt, Moratorium moratorium)
        {
            final MorPeriod entity = new MorPeriodImpl();
            entity.setMorPerEndDt(morPerEndDt);
            entity.setUpdateDt(updateDt);
            entity.setMoratorium(moratorium);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(MorPeriod o)
    {
        int cmp = 0;
        if (this.getMorPeriodPk() != null)
        {
            cmp = this.getMorPeriodPk().compareTo(o.getMorPeriodPk());
        }
        else
        {
            if (this.getMorPerEndDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMorPerEndDt().compareTo(o.getMorPerEndDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// MorPeriod.java merge-point
}