// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.program;

import fr.ifremer.quadrige3.core.dao.referential.Unit;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Fraction;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Matrix;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Method;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Parameter;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Quadruplets ou éléments constitutifs de quadruplets concernés par le moratoire
 */
// HibernateEntity.vsl annotations merge-point
public abstract class PmfmMor
    implements Serializable, Comparable<PmfmMor>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -4155453659498993867L;

    // Generate 2 attributes
    private Integer pmfmMorId;

    /**
     * Identifiant de l'association
     * @return this.pmfmMorId Integer
     */
    public Integer getPmfmMorId()
    {
        return this.pmfmMorId;
    }

    /**
     * Identifiant de l'association
     * @param pmfmMorIdIn Integer
     */
    public void setPmfmMorId(Integer pmfmMorIdIn)
    {
        this.pmfmMorId = pmfmMorIdIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 6 associations
    private Unit unit;

    /**
     * Liste l'ensemble des unités de mesure.
     * @return this.unit Unit
     */
    public Unit getUnit()
    {
        return this.unit;
    }

    /**
     * Liste l'ensemble des unités de mesure.
     * @param unitIn Unit
     */
    public void setUnit(Unit unitIn)
    {
        this.unit = unitIn;
    }

    private Method method;

    /**
     * Méthode utilisée pour mesurer un paramètre.
     * @return this.method Method
     */
    public Method getMethod()
    {
        return this.method;
    }

    /**
     * Méthode utilisée pour mesurer un paramètre.
     * @param methodIn Method
     */
    public void setMethod(Method methodIn)
    {
        this.method = methodIn;
    }

    private Fraction fraction;

    /**
     * Liste les fractions (compléter la description).
     * @return this.fraction Fraction
     */
    public Fraction getFraction()
    {
        return this.fraction;
    }

    /**
     * Liste les fractions (compléter la description).
     * @param fractionIn Fraction
     */
    public void setFraction(Fraction fractionIn)
    {
        this.fraction = fractionIn;
    }

    private Moratorium moratorium;

    /**
     * Moratoire sur la restriction d'accès aux données
     * @return this.moratorium Moratorium
     */
    public Moratorium getMoratorium()
    {
        return this.moratorium;
    }

    /**
     * Moratoire sur la restriction d'accès aux données
     * @param moratoriumIn Moratorium
     */
    public void setMoratorium(Moratorium moratoriumIn)
    {
        this.moratorium = moratoriumIn;
    }

    private Parameter parameter;

    /**
     * Liste les différents paramètres mesurés. Attention, voir PARAMETRE SISMER.
     * @return this.parameter Parameter
     */
    public Parameter getParameter()
    {
        return this.parameter;
    }

    /**
     * Liste les différents paramètres mesurés. Attention, voir PARAMETRE SISMER.
     * @param parameterIn Parameter
     */
    public void setParameter(Parameter parameterIn)
    {
        this.parameter = parameterIn;
    }

    private Matrix matrix;

    /**
     * Support utilisé pour mesurer un paramètre.
     * @return this.matrix Matrix
     */
    public Matrix getMatrix()
    {
        return this.matrix;
    }

    /**
     * Support utilisé pour mesurer un paramètre.
     * @param matrixIn Matrix
     */
    public void setMatrix(Matrix matrixIn)
    {
        this.matrix = matrixIn;
    }

    /**
     * Returns <code>true</code> if the argument is an PmfmMor instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof PmfmMor))
        {
            return false;
        }
        final PmfmMor that = (PmfmMor)object;
        if (this.pmfmMorId == null || that.getPmfmMorId() == null || !this.pmfmMorId.equals(that.getPmfmMorId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.pmfmMorId == null ? 0 : this.pmfmMorId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link PmfmMor}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link PmfmMor}.
         * @return new PmfmMorImpl()
         */
        public static PmfmMor newInstance()
        {
            return new PmfmMorImpl();
        }

        /**
         * Constructs a new instance of {@link PmfmMor}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param moratorium Moratorium
         * @param parameter Parameter
         * @return newInstance
         */
        public static PmfmMor newInstance(Moratorium moratorium, Parameter parameter)
        {
            final PmfmMor entity = new PmfmMorImpl();
            entity.setMoratorium(moratorium);
            entity.setParameter(parameter);
            return entity;
        }

        /**
         * Constructs a new instance of {@link PmfmMor}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param unit Unit
         * @param method Method
         * @param fraction Fraction
         * @param moratorium Moratorium
         * @param parameter Parameter
         * @param matrix Matrix
         * @return newInstance PmfmMor
         */
        public static PmfmMor newInstance(Timestamp updateDt, Unit unit, Method method, Fraction fraction, Moratorium moratorium, Parameter parameter, Matrix matrix)
        {
            final PmfmMor entity = new PmfmMorImpl();
            entity.setUpdateDt(updateDt);
            entity.setUnit(unit);
            entity.setMethod(method);
            entity.setFraction(fraction);
            entity.setMoratorium(moratorium);
            entity.setParameter(parameter);
            entity.setMatrix(matrix);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(PmfmMor o)
    {
        int cmp = 0;
        if (this.getPmfmMorId() != null)
        {
            cmp = this.getPmfmMorId().compareTo(o.getPmfmMorId());
        }
        else
        {
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// PmfmMor.java merge-point
}