// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.program;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.Status;
import fr.ifremer.quadrige3.core.vo.administration.program.ProgramVO;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Activités à l'origine de la collecte d'un ensemble cohérent de données.
 * @see Program
 */
public interface ProgramDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Program}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link ProgramVO}.
     */
    public static final int TRANSFORM_PROGRAMVO = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toProgramVO(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toProgramVO(
        Program source,
        ProgramVO target);

    /**
     * Converts this DAO's entity to an object of type {@link ProgramVO}.
     * @param entity
     * @return ProgramVO
     */
    public ProgramVO toProgramVO(Program entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link ProgramVO}.
     * @param entities
     */
    public Collection<ProgramVO> toProgramVOCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link ProgramVO}.
     * @param entities
     * @return ProgramVO[]
     */
    public ProgramVO[] toProgramVOArray(Collection<?> entities);

    /**
     * Copies the fields of {@link ProgramVO} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void programVOToEntity(
        ProgramVO source,
        Program target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link ProgramVO} to this DAO's entity.
     * @param programVO
     * @return Program
     */
    public Program programVOToEntity(ProgramVO programVO);

    /**
     * Converts a Collection of instances of type {@link ProgramVO} to this
     * DAO's entity.
     * @param instances
     */
    public void programVOToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of Program from the persistent store.
     * @param progCd
     * @return Program
     */
    public Program get(String progCd);

    /**
     * <p>
     * Does the same thing as {@link #get(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param progCd the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, String progCd);

    /**
     * Loads an instance of Program from the persistent store.
     * @param progCd
     * @return Program
     */
    public Program load(String progCd);

    /**
     * <p>
     * Does the same thing as {@link #load(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param progCd the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, String progCd);

    /**
     * Loads all entities of type {@link Program}.
     *
     * @return the loaded entities.
     */
    public Collection<Program> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Program and adds it to the persistent store.
     * @param program
     * @return Program
     */
    public Program create(Program program);

    /**
     * <p>
     * Does the same thing as {@link #create(Program)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param program
     * @return Object
     */
    public Object create(int transform, Program program);

    /**
     * Creates a new instance of Program and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Program
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Program> create(Collection<Program> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Program)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Program> entities);

    /**
     * <p>
     * Creates a new <code>Program</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param progNm Libellé du programme
     * @param progDc Description du programme
     * @param progCreationDt Date de création de l'objet
     * @param updateDt Date de mise à jour de l'objet
     * @param isDepartmentHermetic 
     * @return Program
     */
    public Program create(
        String progNm,
        String progDc,
        Date progCreationDt,
        Timestamp updateDt,
        String isDepartmentHermetic);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Date, Timestamp, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param progNm Libellé du programme
     * @param progDc Description du programme
     * @param progCreationDt Date de création de l'objet
     * @param updateDt Date de mise à jour de l'objet
     * @param isDepartmentHermetic 
     * @return Program
     */
    public Object create(
        int transform,
        String progNm,
        String progDc,
        Date progCreationDt,
        Timestamp updateDt,
        String isDepartmentHermetic);

    /**
     * <p>
     * Creates a new <code>Program</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param progNm
     * @param status
     * @return Program
     */
    public Program create(
        String progNm,
        Status status);

    /**
     * <p>
     * Does the same thing as {@link #create(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param progNm
     * @param status
     * @return Object
     */
    public Object create(
        int transform,
        String progNm,
        Status status);

    /**
     * Updates the <code>program</code> instance in the persistent store.
     * @param program
     */
    public void update(Program program);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Program> entities);

    /**
     * Removes the instance of Program from the persistent store.
     * @param program
     */
    public void remove(Program program);

    /**
     * Removes the instance of Program having the given
     * <code>identifier</code> from the persistent store.
     * @param progCd
     */
    public void remove(String progCd);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Program> entities);

    /**
     * 
     * @param program 
     * @return ProgramVO
     */
    public ProgramVO save(ProgramVO program);

    /**
     * 
     * @param programCode 
     * @return void
     */
    public void updateDate(String programCode);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Program> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.administration.program.ProgramDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link Program} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link ProgramVO} - {@link #TRANSFORM_PROGRAMVO}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.administration.program.ProgramDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Program entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Program)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.administration.program.ProgramDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Program)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}