// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.program;

import fr.ifremer.quadrige3.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * types de privilège applicables sur un programme (responsable, consultation intégrale, saisisseur)
 * @see ProgramPrivilege
 */
public interface ProgramPrivilegeDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link ProgramPrivilege}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link ProgramPrivilegeIds}.
     */
    public static final int TRANSFORM_PROGRAMPRIVILEGEIDS = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toProgramPrivilegeIds(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toProgramPrivilegeIds(
        ProgramPrivilege source,
        ProgramPrivilegeIds target);

    /**
     * Converts this DAO's entity to an object of type {@link ProgramPrivilegeIds}.
     * @param entity
     * @return ProgramPrivilegeIds
     */
    public ProgramPrivilegeIds toProgramPrivilegeIds(ProgramPrivilege entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link ProgramPrivilegeIds}.
     * @param entities
     */
    public Collection<ProgramPrivilegeIds> toProgramPrivilegeIdsCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link ProgramPrivilegeIds}.
     * @param entities
     * @return ProgramPrivilegeIds[]
     */
    public ProgramPrivilegeIds[] toProgramPrivilegeIdsArray(Collection<?> entities);

    /**
     * Copies the fields of {@link ProgramPrivilegeIds} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void programPrivilegeIdsToEntity(
        ProgramPrivilegeIds source,
        ProgramPrivilege target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link ProgramPrivilegeIds} to this DAO's entity.
     * @param programPrivilegeIds
     * @return ProgramPrivilege
     */
    public ProgramPrivilege programPrivilegeIdsToEntity(ProgramPrivilegeIds programPrivilegeIds);

    /**
     * Converts a Collection of instances of type {@link ProgramPrivilegeIds} to this
     * DAO's entity.
     * @param instances
     */
    public void programPrivilegeIdsToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of ProgramPrivilege from the persistent store.
     * @param progPrivId
     * @return ProgramPrivilege
     */
    public ProgramPrivilege get(Integer progPrivId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param progPrivId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer progPrivId);

    /**
     * Loads an instance of ProgramPrivilege from the persistent store.
     * @param progPrivId
     * @return ProgramPrivilege
     */
    public ProgramPrivilege load(Integer progPrivId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param progPrivId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer progPrivId);

    /**
     * Loads all entities of type {@link ProgramPrivilege}.
     *
     * @return the loaded entities.
     */
    public Collection<ProgramPrivilege> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of ProgramPrivilege and adds it to the persistent store.
     * @param programPrivilege
     * @return ProgramPrivilege
     */
    public ProgramPrivilege create(ProgramPrivilege programPrivilege);

    /**
     * <p>
     * Does the same thing as {@link #create(ProgramPrivilege)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param programPrivilege
     * @return Object
     */
    public Object create(int transform, ProgramPrivilege programPrivilege);

    /**
     * Creates a new instance of ProgramPrivilege and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of ProgramPrivilege
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<ProgramPrivilege> create(Collection<ProgramPrivilege> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(ProgramPrivilege)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<ProgramPrivilege> entities);

    /**
     * <p>
     * Creates a new <code>ProgramPrivilege</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param progPrivNm Libellé du privilège
     * @param progPrivDc Description du privilège
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return ProgramPrivilege
     */
    public ProgramPrivilege create(
        String progPrivNm,
        String progPrivDc,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param progPrivNm Libellé du privilège
     * @param progPrivDc Description du privilège
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return ProgramPrivilege
     */
    public Object create(
        int transform,
        String progPrivNm,
        String progPrivDc,
        Timestamp updateDt);


    /**
     * Updates the <code>programPrivilege</code> instance in the persistent store.
     * @param programPrivilege
     */
    public void update(ProgramPrivilege programPrivilege);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<ProgramPrivilege> entities);

    /**
     * Removes the instance of ProgramPrivilege from the persistent store.
     * @param programPrivilege
     */
    public void remove(ProgramPrivilege programPrivilege);

    /**
     * Removes the instance of ProgramPrivilege having the given
     * <code>identifier</code> from the persistent store.
     * @param progPrivId
     */
    public void remove(Integer progPrivId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<ProgramPrivilege> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<ProgramPrivilege> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.administration.program.ProgramPrivilegeDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link ProgramPrivilege} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link ProgramPrivilegeIds} - {@link #TRANSFORM_PROGRAMPRIVILEGEIDS}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.administration.program.ProgramPrivilegeDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final ProgramPrivilege entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,ProgramPrivilege)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.administration.program.ProgramPrivilegeDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,ProgramPrivilege)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}