// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.strategy;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Liste des périodes durant lesquels une stratégie est appliquée en un lieu.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class AppliedPeriod
    implements Serializable, Comparable<AppliedPeriod>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 252077637755485187L;

    private AppliedPeriodPK appliedPeriodPk;

    /**
     * Get the composite primary key identifier class
     * @return appliedPeriodPk
     */
    public AppliedPeriodPK getAppliedPeriodPk()
    {
        return this.appliedPeriodPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param appliedPeriodPkIn
     */
    public void setAppliedPeriodPk(AppliedPeriodPK appliedPeriodPkIn) {
        this.appliedPeriodPk = appliedPeriodPkIn;
    }

    // Generate 3 attributes
    /**
     * Date de début de la période applicable
     * @return this.appliedPeriodStartDt Date
     */
    public Date getAppliedPeriodStartDt()
    {
        return this.getAppliedPeriodPk().getAppliedPeriodStartDt();
    }

    /**
     * Date de début de la période applicable
     * @param appliedPeriodStartDtIn Date
     */
    public void setAppliedPeriodStartDt(Date appliedPeriodStartDtIn)
    {
        this.getAppliedPeriodPk().setAppliedPeriodStartDt(appliedPeriodStartDtIn);
    }

    private Date appliedPeriodEndDt;

    /**
     * Date de fin de la période applicable. Si elle n'est pas définie, la période est en cours.
     * @return this.appliedPeriodEndDt Date
     */
    public Date getAppliedPeriodEndDt()
    {
        return this.appliedPeriodEndDt;
    }

    /**
     * Date de fin de la période applicable. Si elle n'est pas définie, la période est en cours.
     * @param appliedPeriodEndDtIn Date
     */
    public void setAppliedPeriodEndDt(Date appliedPeriodEndDtIn)
    {
        this.appliedPeriodEndDt = appliedPeriodEndDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 1 associations
    private AppliedStrategy appliedStrategy;

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * @return this.appliedStrategy AppliedStrategy
     */
    public AppliedStrategy getAppliedStrategy()
    {
        return this.appliedStrategy;
    }

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * @param appliedStrategyIn AppliedStrategy
     */
    public void setAppliedStrategy(AppliedStrategy appliedStrategyIn)
    {
        this.appliedStrategy = appliedStrategyIn;
    }

    /**
     * Returns <code>true</code> if the argument is an AppliedPeriod instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof AppliedPeriod))
        {
            return false;
        }
        final AppliedPeriod that = (AppliedPeriod)object;
        if (this.appliedPeriodPk == null || that.appliedPeriodPk == null || !this.appliedPeriodPk.equals(that.appliedPeriodPk))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.appliedPeriodPk == null ? 0 : this.appliedPeriodPk.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link AppliedPeriod}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link AppliedPeriod}.
         * @return new AppliedPeriodImpl()
         */
        public static AppliedPeriod newInstance()
        {
            return new AppliedPeriodImpl();
        }

        /**
         * Constructs a new instance of {@link AppliedPeriod}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param appliedPeriodEndDt Date
         * @param appliedStrategy AppliedStrategy
         * @return newInstance
         */
        public static AppliedPeriod newInstance(Date appliedPeriodEndDt, AppliedStrategy appliedStrategy)
        {
            final AppliedPeriod entity = new AppliedPeriodImpl();
            entity.setAppliedPeriodEndDt(appliedPeriodEndDt);
            entity.setAppliedStrategy(appliedStrategy);
            return entity;
        }

        /**
         * Constructs a new instance of {@link AppliedPeriod}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param appliedPeriodEndDt Date
         * @param updateDt Timestamp
         * @param appliedStrategy AppliedStrategy
         * @return newInstance AppliedPeriod
         */
        public static AppliedPeriod newInstance(Date appliedPeriodEndDt, Timestamp updateDt, AppliedStrategy appliedStrategy)
        {
            final AppliedPeriod entity = new AppliedPeriodImpl();
            entity.setAppliedPeriodEndDt(appliedPeriodEndDt);
            entity.setUpdateDt(updateDt);
            entity.setAppliedStrategy(appliedStrategy);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(AppliedPeriod o)
    {
        int cmp = 0;
        if (this.getAppliedPeriodPk() != null)
        {
            cmp = this.getAppliedPeriodPk().compareTo(o.getAppliedPeriodPk());
        }
        else
        {
            if (this.getAppliedPeriodEndDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAppliedPeriodEndDt().compareTo(o.getAppliedPeriodEndDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// AppliedPeriod.java merge-point
}