// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.strategy;

import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.referential.Frequency;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocation;
import fr.ifremer.quadrige3.core.dao.referential.taxon.ReferenceTaxon;
import fr.ifremer.quadrige3.core.dao.referential.taxon.TaxonGroup;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Identifie les conditions d'application locale de la stratégie pour une période donnée.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class AppliedStrategy
    implements Serializable, Comparable<AppliedStrategy>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 5163852483680502024L;

    // Generate 2 attributes
    private Integer appliedStratId;

    /**
     * 
     * @return this.appliedStratId Integer
     */
    public Integer getAppliedStratId()
    {
        return this.appliedStratId;
    }

    /**
     * 
     * @param appliedStratIdIn Integer
     */
    public void setAppliedStratId(Integer appliedStratIdIn)
    {
        this.appliedStratId = appliedStratIdIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 8 associations
    private TaxonGroup taxonGroup;

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @return this.taxonGroup TaxonGroup
     */
    public TaxonGroup getTaxonGroup()
    {
        return this.taxonGroup;
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param taxonGroupIn TaxonGroup
     */
    public void setTaxonGroup(TaxonGroup taxonGroupIn)
    {
        this.taxonGroup = taxonGroupIn;
    }

    private ReferenceTaxon referenceTaxon;

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @return this.referenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getReferenceTaxon()
    {
        return this.referenceTaxon;
    }

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @param referenceTaxonIn ReferenceTaxon
     */
    public void setReferenceTaxon(ReferenceTaxon referenceTaxonIn)
    {
        this.referenceTaxon = referenceTaxonIn;
    }

    private Collection<AppliedPeriod> appliedPeriods = new HashSet<AppliedPeriod>();

    /**
     * Liste des périodes durant lesquels une stratégie est appliquée en un lieu.
     * @return this.appliedPeriods Collection<AppliedPeriod>
     */
    public Collection<AppliedPeriod> getAppliedPeriods()
    {
        return this.appliedPeriods;
    }

    /**
     * Liste des périodes durant lesquels une stratégie est appliquée en un lieu.
     * @param appliedPeriodsIn Collection<AppliedPeriod>
     */
    public void setAppliedPeriods(Collection<AppliedPeriod> appliedPeriodsIn)
    {
        this.appliedPeriods = appliedPeriodsIn;
    }

    /**
     * Liste des périodes durant lesquels une stratégie est appliquée en un lieu.
     * @param elementToAdd AppliedPeriod
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addAppliedPeriods(AppliedPeriod elementToAdd)
    {
        return this.appliedPeriods.add(elementToAdd);
    }

    /**
     * Liste des périodes durant lesquels une stratégie est appliquée en un lieu.
     * @param elementToRemove AppliedPeriod
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeAppliedPeriods(AppliedPeriod elementToRemove)
    {
        return this.appliedPeriods.remove(elementToRemove);
    }

    private MonitoringLocation monitoringLocation;

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @return this.monitoringLocation MonitoringLocation
     */
    public MonitoringLocation getMonitoringLocation()
    {
        return this.monitoringLocation;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param monitoringLocationIn MonitoringLocation
     */
    public void setMonitoringLocation(MonitoringLocation monitoringLocationIn)
    {
        this.monitoringLocation = monitoringLocationIn;
    }

    private Strategy strategy;

    /**
     * Définie les paramètres à mesurer dans un programme particulier.
     * @return this.strategy Strategy
     */
    public Strategy getStrategy()
    {
        return this.strategy;
    }

    /**
     * Définie les paramètres à mesurer dans un programme particulier.
     * @param strategyIn Strategy
     */
    public void setStrategy(Strategy strategyIn)
    {
        this.strategy = strategyIn;
    }

    private Frequency frequency;

    /**
     * Liste des fréquences d'application des stratégies.
     * @return this.frequency Frequency
     */
    public Frequency getFrequency()
    {
        return this.frequency;
    }

    /**
     * Liste des fréquences d'application des stratégies.
     * @param frequencyIn Frequency
     */
    public void setFrequency(Frequency frequencyIn)
    {
        this.frequency = frequencyIn;
    }

    private Department department;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.department Department
     */
    public Department getDepartment()
    {
        return this.department;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param departmentIn Department
     */
    public void setDepartment(Department departmentIn)
    {
        this.department = departmentIn;
    }

    private Collection<PmfmAppliedStrategy> pmfmAppliedStrategies = new HashSet<PmfmAppliedStrategy>();

    /**
     * PMSF associés à une stratégie pour un lieu données.
     * @return this.pmfmAppliedStrategies Collection<PmfmAppliedStrategy>
     */
    public Collection<PmfmAppliedStrategy> getPmfmAppliedStrategies()
    {
        return this.pmfmAppliedStrategies;
    }

    /**
     * PMSF associés à une stratégie pour un lieu données.
     * @param pmfmAppliedStrategiesIn Collection<PmfmAppliedStrategy>
     */
    public void setPmfmAppliedStrategies(Collection<PmfmAppliedStrategy> pmfmAppliedStrategiesIn)
    {
        this.pmfmAppliedStrategies = pmfmAppliedStrategiesIn;
    }

    /**
     * PMSF associés à une stratégie pour un lieu données.
     * @param elementToAdd PmfmAppliedStrategy
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPmfmAppliedStrategies(PmfmAppliedStrategy elementToAdd)
    {
        return this.pmfmAppliedStrategies.add(elementToAdd);
    }

    /**
     * PMSF associés à une stratégie pour un lieu données.
     * @param elementToRemove PmfmAppliedStrategy
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePmfmAppliedStrategies(PmfmAppliedStrategy elementToRemove)
    {
        return this.pmfmAppliedStrategies.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an AppliedStrategy instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof AppliedStrategy))
        {
            return false;
        }
        final AppliedStrategy that = (AppliedStrategy)object;
        if (this.appliedStratId == null || that.getAppliedStratId() == null || !this.appliedStratId.equals(that.getAppliedStratId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.appliedStratId == null ? 0 : this.appliedStratId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link AppliedStrategy}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link AppliedStrategy}.
         * @return new AppliedStrategyImpl()
         */
        public static AppliedStrategy newInstance()
        {
            return new AppliedStrategyImpl();
        }

        /**
         * Constructs a new instance of {@link AppliedStrategy}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param monitoringLocation MonitoringLocation
         * @param strategy Strategy
         * @return newInstance
         */
        public static AppliedStrategy newInstance(MonitoringLocation monitoringLocation, Strategy strategy)
        {
            final AppliedStrategy entity = new AppliedStrategyImpl();
            entity.setMonitoringLocation(monitoringLocation);
            entity.setStrategy(strategy);
            return entity;
        }

        /**
         * Constructs a new instance of {@link AppliedStrategy}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param taxonGroup TaxonGroup
         * @param referenceTaxon ReferenceTaxon
         * @param appliedPeriods Collection<AppliedPeriod>
         * @param monitoringLocation MonitoringLocation
         * @param strategy Strategy
         * @param frequency Frequency
         * @param department Department
         * @param pmfmAppliedStrategies Collection<PmfmAppliedStrategy>
         * @return newInstance AppliedStrategy
         */
        public static AppliedStrategy newInstance(Timestamp updateDt, TaxonGroup taxonGroup, ReferenceTaxon referenceTaxon, Collection<AppliedPeriod> appliedPeriods, MonitoringLocation monitoringLocation, Strategy strategy, Frequency frequency, Department department, Collection<PmfmAppliedStrategy> pmfmAppliedStrategies)
        {
            final AppliedStrategy entity = new AppliedStrategyImpl();
            entity.setUpdateDt(updateDt);
            entity.setTaxonGroup(taxonGroup);
            entity.setReferenceTaxon(referenceTaxon);
            entity.setAppliedPeriods(appliedPeriods);
            entity.setMonitoringLocation(monitoringLocation);
            entity.setStrategy(strategy);
            entity.setFrequency(frequency);
            entity.setDepartment(department);
            entity.setPmfmAppliedStrategies(pmfmAppliedStrategies);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(AppliedStrategy o)
    {
        int cmp = 0;
        if (this.getAppliedStratId() != null)
        {
            cmp = this.getAppliedStratId().compareTo(o.getAppliedStratId());
        }
        else
        {
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// AppliedStrategy.java merge-point
}