// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.strategy;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocation;
import fr.ifremer.quadrige3.core.vo.administration.strategy.AppliedStrategyVO;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Map;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Identifie les conditions d'application locale de la stratégie pour une période donnée.
 * @see AppliedStrategy
 */
public interface AppliedStrategyDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link AppliedStrategy}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link AppliedStrategyVO}.
     */
    public static final int TRANSFORM_APPLIEDSTRATEGYVO = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toAppliedStrategyVO(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toAppliedStrategyVO(
        AppliedStrategy source,
        AppliedStrategyVO target);

    /**
     * Converts this DAO's entity to an object of type {@link AppliedStrategyVO}.
     * @param entity
     * @return AppliedStrategyVO
     */
    public AppliedStrategyVO toAppliedStrategyVO(AppliedStrategy entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link AppliedStrategyVO}.
     * @param entities
     */
    public Collection<AppliedStrategyVO> toAppliedStrategyVOCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link AppliedStrategyVO}.
     * @param entities
     * @return AppliedStrategyVO[]
     */
    public AppliedStrategyVO[] toAppliedStrategyVOArray(Collection<?> entities);

    /**
     * Copies the fields of {@link AppliedStrategyVO} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void appliedStrategyVOToEntity(
        AppliedStrategyVO source,
        AppliedStrategy target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link AppliedStrategyVO} to this DAO's entity.
     * @param appliedStrategyVO
     * @return AppliedStrategy
     */
    public AppliedStrategy appliedStrategyVOToEntity(AppliedStrategyVO appliedStrategyVO);

    /**
     * Converts a Collection of instances of type {@link AppliedStrategyVO} to this
     * DAO's entity.
     * @param instances
     */
    public void appliedStrategyVOToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of AppliedStrategy from the persistent store.
     * @param appliedStratId
     * @return AppliedStrategy
     */
    public AppliedStrategy get(Integer appliedStratId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param appliedStratId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer appliedStratId);

    /**
     * Loads an instance of AppliedStrategy from the persistent store.
     * @param appliedStratId
     * @return AppliedStrategy
     */
    public AppliedStrategy load(Integer appliedStratId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param appliedStratId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer appliedStratId);

    /**
     * Loads all entities of type {@link AppliedStrategy}.
     *
     * @return the loaded entities.
     */
    public Collection<AppliedStrategy> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of AppliedStrategy and adds it to the persistent store.
     * @param appliedStrategy
     * @return AppliedStrategy
     */
    public AppliedStrategy create(AppliedStrategy appliedStrategy);

    /**
     * <p>
     * Does the same thing as {@link #create(AppliedStrategy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param appliedStrategy
     * @return Object
     */
    public Object create(int transform, AppliedStrategy appliedStrategy);

    /**
     * Creates a new instance of AppliedStrategy and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of AppliedStrategy
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<AppliedStrategy> create(Collection<AppliedStrategy> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(AppliedStrategy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<AppliedStrategy> entities);

    /**
     * <p>
     * Creates a new <code>AppliedStrategy</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return AppliedStrategy
     */
    public AppliedStrategy create(
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return AppliedStrategy
     */
    public Object create(
        int transform,
        Timestamp updateDt);

    /**
     * <p>
     * Creates a new <code>AppliedStrategy</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param monitoringLocation
     * @param strategy
     * @return AppliedStrategy
     */
    public AppliedStrategy create(
        MonitoringLocation monitoringLocation,
        Strategy strategy);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param monitoringLocation
     * @param strategy
     * @return Object
     */
    public Object create(
        int transform,
        MonitoringLocation monitoringLocation,
        Strategy strategy);

    /**
     * Updates the <code>appliedStrategy</code> instance in the persistent store.
     * @param appliedStrategy
     */
    public void update(AppliedStrategy appliedStrategy);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<AppliedStrategy> entities);

    /**
     * Removes the instance of AppliedStrategy from the persistent store.
     * @param appliedStrategy
     */
    public void remove(AppliedStrategy appliedStrategy);

    /**
     * Removes the instance of AppliedStrategy having the given
     * <code>identifier</code> from the persistent store.
     * @param appliedStratId
     */
    public void remove(Integer appliedStratId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<AppliedStrategy> entities);

    /**
     * 
     * @param appliedStrategy 
     * @param pmfmStratIdMapping 
     * @param updateDt 
     * @return AppliedStrategyVO
     */
    public AppliedStrategyVO save(AppliedStrategyVO appliedStrategy, Map<Integer,Integer> pmfmStratIdMapping, Timestamp updateDt);

    /**
     * 
     * @param appliedStratIds 
     * @return void
     */
    public void checkCanRemove(Collection<Integer> appliedStratIds);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<AppliedStrategy> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.administration.strategy.AppliedStrategyDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link AppliedStrategy} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link AppliedStrategyVO} - {@link #TRANSFORM_APPLIEDSTRATEGYVO}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.administration.strategy.AppliedStrategyDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final AppliedStrategy entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,AppliedStrategy)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.administration.strategy.AppliedStrategyDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,AppliedStrategy)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}