// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.strategy;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.quadrige3.core.vo.administration.strategy.PmfmStrategyVO;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * PSFM associés à une stratégie
 * PMSF associés à une stratégie.
 * @see PmfmStrategy
 */
public interface PmfmStrategyDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link PmfmStrategy}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link PmfmStrategyVO}.
     */
    public static final int TRANSFORM_PMFMSTRATEGYVO = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toPmfmStrategyVO(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toPmfmStrategyVO(
        PmfmStrategy source,
        PmfmStrategyVO target);

    /**
     * Converts this DAO's entity to an object of type {@link PmfmStrategyVO}.
     * @param entity
     * @return PmfmStrategyVO
     */
    public PmfmStrategyVO toPmfmStrategyVO(PmfmStrategy entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link PmfmStrategyVO}.
     * @param entities
     */
    public Collection<PmfmStrategyVO> toPmfmStrategyVOCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link PmfmStrategyVO}.
     * @param entities
     * @return PmfmStrategyVO[]
     */
    public PmfmStrategyVO[] toPmfmStrategyVOArray(Collection<?> entities);

    /**
     * Copies the fields of {@link PmfmStrategyVO} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void pmfmStrategyVOToEntity(
        PmfmStrategyVO source,
        PmfmStrategy target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link PmfmStrategyVO} to this DAO's entity.
     * @param pmfmStrategyVO
     * @return PmfmStrategy
     */
    public PmfmStrategy pmfmStrategyVOToEntity(PmfmStrategyVO pmfmStrategyVO);

    /**
     * Converts a Collection of instances of type {@link PmfmStrategyVO} to this
     * DAO's entity.
     * @param instances
     */
    public void pmfmStrategyVOToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of PmfmStrategy from the persistent store.
     * @param pmfmStratId
     * @return PmfmStrategy
     */
    public PmfmStrategy get(Integer pmfmStratId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param pmfmStratId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer pmfmStratId);

    /**
     * Loads an instance of PmfmStrategy from the persistent store.
     * @param pmfmStratId
     * @return PmfmStrategy
     */
    public PmfmStrategy load(Integer pmfmStratId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param pmfmStratId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer pmfmStratId);

    /**
     * Loads all entities of type {@link PmfmStrategy}.
     *
     * @return the loaded entities.
     */
    public Collection<PmfmStrategy> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of PmfmStrategy and adds it to the persistent store.
     * @param pmfmStrategy
     * @return PmfmStrategy
     */
    public PmfmStrategy create(PmfmStrategy pmfmStrategy);

    /**
     * <p>
     * Does the same thing as {@link #create(PmfmStrategy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param pmfmStrategy
     * @return Object
     */
    public Object create(int transform, PmfmStrategy pmfmStrategy);

    /**
     * Creates a new instance of PmfmStrategy and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of PmfmStrategy
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<PmfmStrategy> create(Collection<PmfmStrategy> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(PmfmStrategy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<PmfmStrategy> entities);

    /**
     * <p>
     * Creates a new <code>PmfmStrategy</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param pmfmStratParAcquisNumber Nombre de fois où un paramètre peut être saisi
Il est constant pour tous les niveaux de saisie, est obligatoire et par défaut prend la valeur 1
     * @param pmfmStratPresRk Rang pour la presentation des résultats
     * @param pmfmStratParIsIndiv Indique si la saisie du paramètre se fait sur des individus
     * @param pmfmStratIsUniqueByTaxon 
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return PmfmStrategy
     */
    public PmfmStrategy create(
        Integer pmfmStratParAcquisNumber,
        Integer pmfmStratPresRk,
        String pmfmStratParIsIndiv,
        String pmfmStratIsUniqueByTaxon,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(Integer, Integer, String, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param pmfmStratParAcquisNumber Nombre de fois où un paramètre peut être saisi
Il est constant pour tous les niveaux de saisie, est obligatoire et par défaut prend la valeur 1
     * @param pmfmStratPresRk Rang pour la presentation des résultats
     * @param pmfmStratParIsIndiv Indique si la saisie du paramètre se fait sur des individus
     * @param pmfmStratIsUniqueByTaxon 
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return PmfmStrategy
     */
    public Object create(
        int transform,
        Integer pmfmStratParAcquisNumber,
        Integer pmfmStratPresRk,
        String pmfmStratParIsIndiv,
        String pmfmStratIsUniqueByTaxon,
        Timestamp updateDt);

    /**
     * <p>
     * Creates a new <code>PmfmStrategy</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param pmfmStratParAcquisNumber
     * @param pmfm
     * @param strategy
     * @return PmfmStrategy
     */
    public PmfmStrategy create(
        Integer pmfmStratParAcquisNumber,
        Pmfm pmfm,
        Strategy strategy);

    /**
     * <p>
     * Does the same thing as {@link #create(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param pmfmStratParAcquisNumber
     * @param pmfm
     * @param strategy
     * @return Object
     */
    public Object create(
        int transform,
        Integer pmfmStratParAcquisNumber,
        Pmfm pmfm,
        Strategy strategy);

    /**
     * Updates the <code>pmfmStrategy</code> instance in the persistent store.
     * @param pmfmStrategy
     */
    public void update(PmfmStrategy pmfmStrategy);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<PmfmStrategy> entities);

    /**
     * Removes the instance of PmfmStrategy from the persistent store.
     * @param pmfmStrategy
     */
    public void remove(PmfmStrategy pmfmStrategy);

    /**
     * Removes the instance of PmfmStrategy having the given
     * <code>identifier</code> from the persistent store.
     * @param pmfmStratId
     */
    public void remove(Integer pmfmStratId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<PmfmStrategy> entities);

    /**
     * 
     * @param pmfmStrategy 
     * @param updateDt 
     * @return PmfmStrategyVO
     */
    public PmfmStrategyVO save(PmfmStrategyVO pmfmStrategy, Timestamp updateDt);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<PmfmStrategy> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.administration.strategy.PmfmStrategyDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link PmfmStrategy} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link PmfmStrategyVO} - {@link #TRANSFORM_PMFMSTRATEGYVO}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.administration.strategy.PmfmStrategyDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final PmfmStrategy entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,PmfmStrategy)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.administration.strategy.PmfmStrategyDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,PmfmStrategy)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}