// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.strategy;

import fr.ifremer.quadrige3.core.dao.administration.program.Program;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.administration.user.Quser;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Définie les paramètres à mesurer dans un programme particulier.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Strategy
    implements Serializable, Comparable<Strategy>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1032764945377952068L;

    // Generate 5 attributes
    private Integer stratId;

    /**
     * Identifiant interne de la stratégie
     * @return this.stratId Integer
     */
    public Integer getStratId()
    {
        return this.stratId;
    }

    /**
     * Identifiant interne de la stratégie
     * @param stratIdIn Integer
     */
    public void setStratId(Integer stratIdIn)
    {
        this.stratId = stratIdIn;
    }

    private String stratNm;

    /**
     * Libellé de la stratégie
     * @return this.stratNm String
     */
    public String getStratNm()
    {
        return this.stratNm;
    }

    /**
     * Libellé de la stratégie
     * @param stratNmIn String
     */
    public void setStratNm(String stratNmIn)
    {
        this.stratNm = stratNmIn;
    }

    private String stratDc;

    /**
     * Description de la stratégie (de type commentaire car taille insuffisante)
     * @return this.stratDc String
     */
    public String getStratDc()
    {
        return this.stratDc;
    }

    /**
     * Description de la stratégie (de type commentaire car taille insuffisante)
     * @param stratDcIn String
     */
    public void setStratDc(String stratDcIn)
    {
        this.stratDc = stratDcIn;
    }

    private Date stratCreationDt;

    /**
     * Date de création de l'objet
     * @return this.stratCreationDt Date
     */
    public Date getStratCreationDt()
    {
        return this.stratCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param stratCreationDtIn Date
     */
    public void setStratCreationDt(Date stratCreationDtIn)
    {
        this.stratCreationDt = stratCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de mise à jour de l'objet
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de mise à jour de l'objet
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 5 associations
    private Collection<Quser> qusers = new HashSet<Quser>();

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @return this.qusers Collection<Quser>
     */
    public Collection<Quser> getQusers()
    {
        return this.qusers;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param qusersIn Collection<Quser>
     */
    public void setQusers(Collection<Quser> qusersIn)
    {
        this.qusers = qusersIn;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param elementToAdd Quser
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addQusers(Quser elementToAdd)
    {
        return this.qusers.add(elementToAdd);
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param elementToRemove Quser
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeQusers(Quser elementToRemove)
    {
        return this.qusers.remove(elementToRemove);
    }

    private Collection<Department> departments = new HashSet<Department>();

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.departments Collection<Department>
     */
    public Collection<Department> getDepartments()
    {
        return this.departments;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param departmentsIn Collection<Department>
     */
    public void setDepartments(Collection<Department> departmentsIn)
    {
        this.departments = departmentsIn;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param elementToAdd Department
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addDepartments(Department elementToAdd)
    {
        return this.departments.add(elementToAdd);
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param elementToRemove Department
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeDepartments(Department elementToRemove)
    {
        return this.departments.remove(elementToRemove);
    }

    private Collection<PmfmStrategy> pmfmStrategies = new HashSet<PmfmStrategy>();

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * @return this.pmfmStrategies Collection<PmfmStrategy>
     */
    public Collection<PmfmStrategy> getPmfmStrategies()
    {
        return this.pmfmStrategies;
    }

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * @param pmfmStrategiesIn Collection<PmfmStrategy>
     */
    public void setPmfmStrategies(Collection<PmfmStrategy> pmfmStrategiesIn)
    {
        this.pmfmStrategies = pmfmStrategiesIn;
    }

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * @param elementToAdd PmfmStrategy
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPmfmStrategies(PmfmStrategy elementToAdd)
    {
        return this.pmfmStrategies.add(elementToAdd);
    }

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * @param elementToRemove PmfmStrategy
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePmfmStrategies(PmfmStrategy elementToRemove)
    {
        return this.pmfmStrategies.remove(elementToRemove);
    }

    private Collection<AppliedStrategy> appliedStrategies = new HashSet<AppliedStrategy>();

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * @return this.appliedStrategies Collection<AppliedStrategy>
     */
    public Collection<AppliedStrategy> getAppliedStrategies()
    {
        return this.appliedStrategies;
    }

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * @param appliedStrategiesIn Collection<AppliedStrategy>
     */
    public void setAppliedStrategies(Collection<AppliedStrategy> appliedStrategiesIn)
    {
        this.appliedStrategies = appliedStrategiesIn;
    }

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * @param elementToAdd AppliedStrategy
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addAppliedStrategies(AppliedStrategy elementToAdd)
    {
        return this.appliedStrategies.add(elementToAdd);
    }

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * @param elementToRemove AppliedStrategy
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeAppliedStrategies(AppliedStrategy elementToRemove)
    {
        return this.appliedStrategies.remove(elementToRemove);
    }

    private Program program;

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Strategy instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Strategy))
        {
            return false;
        }
        final Strategy that = (Strategy)object;
        if (this.stratId == null || that.getStratId() == null || !this.stratId.equals(that.getStratId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.stratId == null ? 0 : this.stratId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Strategy}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Strategy}.
         * @return new StrategyImpl()
         */
        public static Strategy newInstance()
        {
            return new StrategyImpl();
        }

        /**
         * Constructs a new instance of {@link Strategy}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param stratNm String
         * @param program Program
         * @return newInstance
         */
        public static Strategy newInstance(String stratNm, Program program)
        {
            final Strategy entity = new StrategyImpl();
            entity.setStratNm(stratNm);
            entity.setProgram(program);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Strategy}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param stratNm String
         * @param stratDc String
         * @param stratCreationDt Date
         * @param updateDt Timestamp
         * @param qusers Collection<Quser>
         * @param departments Collection<Department>
         * @param pmfmStrategies Collection<PmfmStrategy>
         * @param appliedStrategies Collection<AppliedStrategy>
         * @param program Program
         * @return newInstance Strategy
         */
        public static Strategy newInstance(String stratNm, String stratDc, Date stratCreationDt, Timestamp updateDt, Collection<Quser> qusers, Collection<Department> departments, Collection<PmfmStrategy> pmfmStrategies, Collection<AppliedStrategy> appliedStrategies, Program program)
        {
            final Strategy entity = new StrategyImpl();
            entity.setStratNm(stratNm);
            entity.setStratDc(stratDc);
            entity.setStratCreationDt(stratCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setQusers(qusers);
            entity.setDepartments(departments);
            entity.setPmfmStrategies(pmfmStrategies);
            entity.setAppliedStrategies(appliedStrategies);
            entity.setProgram(program);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Strategy o)
    {
        int cmp = 0;
        if (this.getStratId() != null)
        {
            cmp = this.getStratId().compareTo(o.getStratId());
        }
        else
        {
            if (this.getStratNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStratNm().compareTo(o.getStratNm()));
            }
            if (this.getStratDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStratDc().compareTo(o.getStratDc()));
            }
            if (this.getStratCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStratCreationDt().compareTo(o.getStratCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Strategy.java merge-point
}