// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.strategy;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.administration.program.Program;
import fr.ifremer.quadrige3.core.vo.administration.strategy.StrategyVO;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Définie les paramètres à mesurer dans un programme particulier.
 * @see Strategy
 */
public interface StrategyDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Strategy}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link StrategyVO}.
     */
    public static final int TRANSFORM_STRATEGYVO = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toStrategyVO(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toStrategyVO(
        Strategy source,
        StrategyVO target);

    /**
     * Converts this DAO's entity to an object of type {@link StrategyVO}.
     * @param entity
     * @return StrategyVO
     */
    public StrategyVO toStrategyVO(Strategy entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link StrategyVO}.
     * @param entities
     */
    public Collection<StrategyVO> toStrategyVOCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link StrategyVO}.
     * @param entities
     * @return StrategyVO[]
     */
    public StrategyVO[] toStrategyVOArray(Collection<?> entities);

    /**
     * Copies the fields of {@link StrategyVO} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void strategyVOToEntity(
        StrategyVO source,
        Strategy target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link StrategyVO} to this DAO's entity.
     * @param strategyVO
     * @return Strategy
     */
    public Strategy strategyVOToEntity(StrategyVO strategyVO);

    /**
     * Converts a Collection of instances of type {@link StrategyVO} to this
     * DAO's entity.
     * @param instances
     */
    public void strategyVOToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of Strategy from the persistent store.
     * @param stratId
     * @return Strategy
     */
    public Strategy get(Integer stratId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param stratId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer stratId);

    /**
     * Loads an instance of Strategy from the persistent store.
     * @param stratId
     * @return Strategy
     */
    public Strategy load(Integer stratId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param stratId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer stratId);

    /**
     * Loads all entities of type {@link Strategy}.
     *
     * @return the loaded entities.
     */
    public Collection<Strategy> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Strategy and adds it to the persistent store.
     * @param strategy
     * @return Strategy
     */
    public Strategy create(Strategy strategy);

    /**
     * <p>
     * Does the same thing as {@link #create(Strategy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param strategy
     * @return Object
     */
    public Object create(int transform, Strategy strategy);

    /**
     * Creates a new instance of Strategy and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Strategy
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Strategy> create(Collection<Strategy> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Strategy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Strategy> entities);

    /**
     * <p>
     * Creates a new <code>Strategy</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param stratNm Libellé de la stratégie
     * @param stratDc Description de la stratégie (de type commentaire car taille insuffisante)
     * @param stratCreationDt Date de création de l'objet
     * @param updateDt Date de mise à jour de l'objet
     * @return Strategy
     */
    public Strategy create(
        String stratNm,
        String stratDc,
        Date stratCreationDt,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param stratNm Libellé de la stratégie
     * @param stratDc Description de la stratégie (de type commentaire car taille insuffisante)
     * @param stratCreationDt Date de création de l'objet
     * @param updateDt Date de mise à jour de l'objet
     * @return Strategy
     */
    public Object create(
        int transform,
        String stratNm,
        String stratDc,
        Date stratCreationDt,
        Timestamp updateDt);

    /**
     * <p>
     * Creates a new <code>Strategy</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param stratNm
     * @param program
     * @return Strategy
     */
    public Strategy create(
        String stratNm,
        Program program);

    /**
     * <p>
     * Does the same thing as {@link #create(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param stratNm
     * @param program
     * @return Object
     */
    public Object create(
        int transform,
        String stratNm,
        Program program);

    /**
     * Updates the <code>strategy</code> instance in the persistent store.
     * @param strategy
     */
    public void update(Strategy strategy);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Strategy> entities);

    /**
     * Removes the instance of Strategy from the persistent store.
     * @param strategy
     */
    public void remove(Strategy strategy);

    /**
     * Removes the instance of Strategy having the given
     * <code>identifier</code> from the persistent store.
     * @param stratId
     */
    public void remove(Integer stratId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Strategy> entities);

    /**
     * 
     * @param strategy 
     * @param updateDt 
     * @return StrategyVO
     */
    public StrategyVO save(StrategyVO strategy, Timestamp updateDt);

    /**
     * 
     * @param stratIds 
     * @return void
     */
    public void removeByIds(Collection<Integer> stratIds);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Strategy> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.administration.strategy.StrategyDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link Strategy} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link StrategyVO} - {@link #TRANSFORM_STRATEGYVO}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.administration.strategy.StrategyDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Strategy entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Strategy)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.administration.strategy.StrategyDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Strategy)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}