// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.strategy;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Fonction de calcul affichées lors de la saisie en mode colonne.
 * Permet de fournir un calcul sur une série de mesure.
 * Ces calculs ne sont pas stockés et sont là uniquement pour un contrôle lors de la saisie
 */
// HibernateEntity.vsl annotations merge-point
public abstract class UiFunction
    implements Serializable, Comparable<UiFunction>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -9193921057398452432L;

    // Generate 3 attributes
    private String uiFunctionCd;

    /**
     * Code de la fonction de calcul
     * @return this.uiFunctionCd String
     */
    public String getUiFunctionCd()
    {
        return this.uiFunctionCd;
    }

    /**
     * Code de la fonction de calcul
     * @param uiFunctionCdIn String
     */
    public void setUiFunctionCd(String uiFunctionCdIn)
    {
        this.uiFunctionCd = uiFunctionCdIn;
    }

    private String uiFunctionNm;

    /**
     * Libellé de la fonction de calcul
     * @return this.uiFunctionNm String
     */
    public String getUiFunctionNm()
    {
        return this.uiFunctionNm;
    }

    /**
     * Libellé de la fonction de calcul
     * @param uiFunctionNmIn String
     */
    public void setUiFunctionNm(String uiFunctionNmIn)
    {
        this.uiFunctionNm = uiFunctionNmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private Collection<PmfmStrategy> pmfmStrategies = new HashSet<PmfmStrategy>();

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * @return this.pmfmStrategies Collection<PmfmStrategy>
     */
    public Collection<PmfmStrategy> getPmfmStrategies()
    {
        return this.pmfmStrategies;
    }

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * @param pmfmStrategiesIn Collection<PmfmStrategy>
     */
    public void setPmfmStrategies(Collection<PmfmStrategy> pmfmStrategiesIn)
    {
        this.pmfmStrategies = pmfmStrategiesIn;
    }

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * @param elementToAdd PmfmStrategy
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPmfmStrategies(PmfmStrategy elementToAdd)
    {
        return this.pmfmStrategies.add(elementToAdd);
    }

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * @param elementToRemove PmfmStrategy
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePmfmStrategies(PmfmStrategy elementToRemove)
    {
        return this.pmfmStrategies.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    /**
     * Returns <code>true</code> if the argument is an UiFunction instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof UiFunction))
        {
            return false;
        }
        final UiFunction that = (UiFunction)object;
        if (this.uiFunctionCd == null || that.getUiFunctionCd() == null || !this.uiFunctionCd.equals(that.getUiFunctionCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.uiFunctionCd == null ? 0 : this.uiFunctionCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link UiFunction}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link UiFunction}.
         * @return new UiFunctionImpl()
         */
        public static UiFunction newInstance()
        {
            return new UiFunctionImpl();
        }

        /**
         * Constructs a new instance of {@link UiFunction}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param uiFunctionNm String
         * @param status Status
         * @return newInstance
         */
        public static UiFunction newInstance(String uiFunctionNm, Status status)
        {
            final UiFunction entity = new UiFunctionImpl();
            entity.setUiFunctionNm(uiFunctionNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link UiFunction}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param uiFunctionNm String
         * @param updateDt Timestamp
         * @param pmfmStrategies Collection<PmfmStrategy>
         * @param status Status
         * @return newInstance UiFunction
         */
        public static UiFunction newInstance(String uiFunctionNm, Timestamp updateDt, Collection<PmfmStrategy> pmfmStrategies, Status status)
        {
            final UiFunction entity = new UiFunctionImpl();
            entity.setUiFunctionNm(uiFunctionNm);
            entity.setUpdateDt(updateDt);
            entity.setPmfmStrategies(pmfmStrategies);
            entity.setStatus(status);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(UiFunction o)
    {
        int cmp = 0;
        if (this.getUiFunctionCd() != null)
        {
            cmp = this.getUiFunctionCd().compareTo(o.getUiFunctionCd());
        }
        else
        {
            if (this.getUiFunctionNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUiFunctionNm().compareTo(o.getUiFunctionNm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// UiFunction.java merge-point
}