// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.user;

import fr.ifremer.quadrige3.core.dao.data.aquaculture.HistoricalAccount;
import fr.ifremer.quadrige3.core.dao.data.aquaculture.InitialPopulation;
import fr.ifremer.quadrige3.core.dao.referential.Privilege;
import fr.ifremer.quadrige3.core.dao.referential.Status;
import fr.ifremer.quadrige3.core.dao.system.MapProject;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste les départements ou services auxquels sont rattachés les agents
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Department
    implements Serializable, Comparable<Department>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 8498561055401687476L;

    // Generate 10 attributes
    private Integer depId;

    /**
     * Identifiant interne d'un service
     * @return this.depId Integer
     */
    public Integer getDepId()
    {
        return this.depId;
    }

    /**
     * Identifiant interne d'un service
     * @param depIdIn Integer
     */
    public void setDepId(Integer depIdIn)
    {
        this.depId = depIdIn;
    }

    private String depCd;

    /**
     * Code (sigle dans LDAP : identifie de manière unique un service dans LDAP, attribut
     * obligatoire dans LDAP).
     * @return this.depCd String
     */
    public String getDepCd()
    {
        return this.depCd;
    }

    /**
     * Code (sigle dans LDAP : identifie de manière unique un service dans LDAP, attribut
     * obligatoire dans LDAP).
     * @param depCdIn String
     */
    public void setDepCd(String depCdIn)
    {
        this.depCd = depCdIn;
    }

    private String depNm;

    /**
     * Libellé du service issue de l'intitulé dans le LDAP si existant (taillé comme une description
     * car les infos venant de LDAP dépassent les 100 caractères)
     * @return this.depNm String
     */
    public String getDepNm()
    {
        return this.depNm;
    }

    /**
     * Libellé du service issue de l'intitulé dans le LDAP si existant (taillé comme une description
     * car les infos venant de LDAP dépassent les 100 caractères)
     * @param depNmIn String
     */
    public void setDepNm(String depNmIn)
    {
        this.depNm = depNmIn;
    }

    private String depDc;

    /**
     * Description issue de l'activité LDAP
     * @return this.depDc String
     */
    public String getDepDc()
    {
        return this.depDc;
    }

    /**
     * Description issue de l'activité LDAP
     * @param depDcIn String
     */
    public void setDepDc(String depDcIn)
    {
        this.depDc = depDcIn;
    }

    private String depEMail;

    /**
     * Mail associé au service
     * @return this.depEMail String
     */
    public String getDepEMail()
    {
        return this.depEMail;
    }

    /**
     * Mail associé au service
     * @param depEMailIn String
     */
    public void setDepEMail(String depEMailIn)
    {
        this.depEMail = depEMailIn;
    }

    private String depAddress;

    /**
     * Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     * @return this.depAddress String
     */
    public String getDepAddress()
    {
        return this.depAddress;
    }

    /**
     * Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     * @param depAddressIn String
     */
    public void setDepAddress(String depAddressIn)
    {
        this.depAddress = depAddressIn;
    }

    private String depPhone;

    /**
     * Les téléphones du service.
     * @return this.depPhone String
     */
    public String getDepPhone()
    {
        return this.depPhone;
    }

    /**
     * Les téléphones du service.
     * @param depPhoneIn String
     */
    public void setDepPhone(String depPhoneIn)
    {
        this.depPhone = depPhoneIn;
    }

    private String depLdapPresent;

    /**
     * Oui, si le service est présent dans le LDAP
     * @return this.depLdapPresent String
     */
    public String getDepLdapPresent()
    {
        return this.depLdapPresent;
    }

    /**
     * Oui, si le service est présent dans le LDAP
     * @param depLdapPresentIn String
     */
    public void setDepLdapPresent(String depLdapPresentIn)
    {
        this.depLdapPresent = depLdapPresentIn;
    }

    private Date depCreationDt;

    /**
     * Date de création de l'objet
     * @return this.depCreationDt Date
     */
    public Date getDepCreationDt()
    {
        return this.depCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param depCreationDtIn Date
     */
    public void setDepCreationDt(Date depCreationDtIn)
    {
        this.depCreationDt = depCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 37 associations
    private Collection<InitialPopulation> initialPopulations = new HashSet<InitialPopulation>();

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @return this.initialPopulations Collection<InitialPopulation>
     */
    public Collection<InitialPopulation> getInitialPopulations()
    {
        return this.initialPopulations;
    }

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @param initialPopulationsIn Collection<InitialPopulation>
     */
    public void setInitialPopulations(Collection<InitialPopulation> initialPopulationsIn)
    {
        this.initialPopulations = initialPopulationsIn;
    }

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @param elementToAdd InitialPopulation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addInitialPopulations(InitialPopulation elementToAdd)
    {
        return this.initialPopulations.add(elementToAdd);
    }

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @param elementToRemove InitialPopulation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeInitialPopulations(InitialPopulation elementToRemove)
    {
        return this.initialPopulations.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<MapProject> mapProjectIds = new HashSet<MapProject>();

    /**
     * Projet cartographique
     * @return this.mapProjectIds Collection<MapProject>
     */
    public Collection<MapProject> getMapProjectIds()
    {
        return this.mapProjectIds;
    }

    /**
     * Projet cartographique
     * @param mapProjectIdsIn Collection<MapProject>
     */
    public void setMapProjectIds(Collection<MapProject> mapProjectIdsIn)
    {
        this.mapProjectIds = mapProjectIdsIn;
    }

    /**
     * Projet cartographique
     * @param elementToAdd MapProject
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addMapProjectIds(MapProject elementToAdd)
    {
        return this.mapProjectIds.add(elementToAdd);
    }

    /**
     * Projet cartographique
     * @param elementToRemove MapProject
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeMapProjectIds(MapProject elementToRemove)
    {
        return this.mapProjectIds.remove(elementToRemove);
    }

    private Collection<HistoricalAccount> historicalAccounts = new HashSet<HistoricalAccount>();

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @return this.historicalAccounts Collection<HistoricalAccount>
     */
    public Collection<HistoricalAccount> getHistoricalAccounts()
    {
        return this.historicalAccounts;
    }

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @param historicalAccountsIn Collection<HistoricalAccount>
     */
    public void setHistoricalAccounts(Collection<HistoricalAccount> historicalAccountsIn)
    {
        this.historicalAccounts = historicalAccountsIn;
    }

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @param elementToAdd HistoricalAccount
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addHistoricalAccounts(HistoricalAccount elementToAdd)
    {
        return this.historicalAccounts.add(elementToAdd);
    }

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @param elementToRemove HistoricalAccount
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeHistoricalAccounts(HistoricalAccount elementToRemove)
    {
        return this.historicalAccounts.remove(elementToRemove);
    }

    private Collection<PrivilegeTransfer> privilegeTransfers = new HashSet<PrivilegeTransfer>();

    /**
     * Transfert des droits entre un service et un autre service
     * @return this.privilegeTransfers Collection<PrivilegeTransfer>
     */
    public Collection<PrivilegeTransfer> getPrivilegeTransfers()
    {
        return this.privilegeTransfers;
    }

    /**
     * Transfert des droits entre un service et un autre service
     * @param privilegeTransfersIn Collection<PrivilegeTransfer>
     */
    public void setPrivilegeTransfers(Collection<PrivilegeTransfer> privilegeTransfersIn)
    {
        this.privilegeTransfers = privilegeTransfersIn;
    }

    /**
     * Transfert des droits entre un service et un autre service
     * @param elementToAdd PrivilegeTransfer
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPrivilegeTransfers(PrivilegeTransfer elementToAdd)
    {
        return this.privilegeTransfers.add(elementToAdd);
    }

    /**
     * Transfert des droits entre un service et un autre service
     * @param elementToRemove PrivilegeTransfer
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePrivilegeTransfers(PrivilegeTransfer elementToRemove)
    {
        return this.privilegeTransfers.remove(elementToRemove);
    }

    private Collection<Department> departments = new HashSet<Department>();

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.departments Collection<Department>
     */
    public Collection<Department> getDepartments()
    {
        return this.departments;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param departmentsIn Collection<Department>
     */
    public void setDepartments(Collection<Department> departmentsIn)
    {
        this.departments = departmentsIn;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param elementToAdd Department
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addDepartments(Department elementToAdd)
    {
        return this.departments.add(elementToAdd);
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param elementToRemove Department
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeDepartments(Department elementToRemove)
    {
        return this.departments.remove(elementToRemove);
    }

    private Department parentDepartment;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.parentDepartment Department
     */
    public Department getParentDepartment()
    {
        return this.parentDepartment;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param parentDepartmentIn Department
     */
    public void setParentDepartment(Department parentDepartmentIn)
    {
        this.parentDepartment = parentDepartmentIn;
    }

    private Collection<Privilege> privileges = new HashSet<Privilege>();

    /**
     * Ensemble des privilèges utilisateurs.
     * @return this.privileges Collection<Privilege>
     */
    public Collection<Privilege> getPrivileges()
    {
        return this.privileges;
    }

    /**
     * Ensemble des privilèges utilisateurs.
     * @param privilegesIn Collection<Privilege>
     */
    public void setPrivileges(Collection<Privilege> privilegesIn)
    {
        this.privileges = privilegesIn;
    }

    /**
     * Ensemble des privilèges utilisateurs.
     * @param elementToAdd Privilege
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPrivileges(Privilege elementToAdd)
    {
        return this.privileges.add(elementToAdd);
    }

    /**
     * Ensemble des privilèges utilisateurs.
     * @param elementToRemove Privilege
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePrivileges(Privilege elementToRemove)
    {
        return this.privileges.remove(elementToRemove);
    }

    private Collection<Quser> qusers = new HashSet<Quser>();

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @return this.qusers Collection<Quser>
     */
    public Collection<Quser> getQusers()
    {
        return this.qusers;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param qusersIn Collection<Quser>
     */
    public void setQusers(Collection<Quser> qusersIn)
    {
        this.qusers = qusersIn;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param elementToAdd Quser
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addQusers(Quser elementToAdd)
    {
        return this.qusers.add(elementToAdd);
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param elementToRemove Quser
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeQusers(Quser elementToRemove)
    {
        return this.qusers.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an Department instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Department))
        {
            return false;
        }
        final Department that = (Department)object;
        if (this.depId == null || that.getDepId() == null || !this.depId.equals(that.getDepId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.depId == null ? 0 : this.depId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Department}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Department}.
         * @return new DepartmentImpl()
         */
        public static Department newInstance()
        {
            return new DepartmentImpl();
        }

        /**
         * Constructs a new instance of {@link Department}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param depCd String
         * @param depNm String
         * @param status Status
         * @return newInstance
         */
        public static Department newInstance(String depCd, String depNm, Status status)
        {
            final Department entity = new DepartmentImpl();
            entity.setDepCd(depCd);
            entity.setDepNm(depNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Department}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param depCd String
         * @param depNm String
         * @param depDc String
         * @param depEMail String
         * @param depAddress String
         * @param depPhone String
         * @param depLdapPresent String
         * @param depCreationDt Date
         * @param updateDt Timestamp
         * @param initialPopulations Collection<InitialPopulation>
         * @param status Status
         * @param mapProjectIds Collection<MapProject>
         * @param historicalAccounts Collection<HistoricalAccount>
         * @param privilegeTransfers Collection<PrivilegeTransfer>
         * @param departments Collection<Department>
         * @param parentDepartment Department
         * @param privileges Collection<Privilege>
         * @param qusers Collection<Quser>
         * @return newInstance Department
         */
        public static Department newInstance(String depCd, String depNm, String depDc, String depEMail, String depAddress, String depPhone, String depLdapPresent, Date depCreationDt, Timestamp updateDt, Collection<InitialPopulation> initialPopulations, Status status, Collection<MapProject> mapProjectIds, Collection<HistoricalAccount> historicalAccounts, Collection<PrivilegeTransfer> privilegeTransfers, Collection<Department> departments, Department parentDepartment, Collection<Privilege> privileges, Collection<Quser> qusers)
        {
            final Department entity = new DepartmentImpl();
            entity.setDepCd(depCd);
            entity.setDepNm(depNm);
            entity.setDepDc(depDc);
            entity.setDepEMail(depEMail);
            entity.setDepAddress(depAddress);
            entity.setDepPhone(depPhone);
            entity.setDepLdapPresent(depLdapPresent);
            entity.setDepCreationDt(depCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setInitialPopulations(initialPopulations);
            entity.setStatus(status);
            entity.setMapProjectIds(mapProjectIds);
            entity.setHistoricalAccounts(historicalAccounts);
            entity.setPrivilegeTransfers(privilegeTransfers);
            entity.setDepartments(departments);
            entity.setParentDepartment(parentDepartment);
            entity.setPrivileges(privileges);
            entity.setQusers(qusers);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Department o)
    {
        int cmp = 0;
        if (this.getDepId() != null)
        {
            cmp = this.getDepId().compareTo(o.getDepId());
        }
        else
        {
            if (this.getDepCd() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepCd().compareTo(o.getDepCd()));
            }
            if (this.getDepNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepNm().compareTo(o.getDepNm()));
            }
            if (this.getDepDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepDc().compareTo(o.getDepDc()));
            }
            if (this.getDepEMail() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepEMail().compareTo(o.getDepEMail()));
            }
            if (this.getDepAddress() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepAddress().compareTo(o.getDepAddress()));
            }
            if (this.getDepPhone() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepPhone().compareTo(o.getDepPhone()));
            }
            if (this.getDepLdapPresent() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepLdapPresent().compareTo(o.getDepLdapPresent()));
            }
            if (this.getDepCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepCreationDt().compareTo(o.getDepCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Department.java merge-point
}