// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.user;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.Status;
import fr.ifremer.quadrige3.core.vo.administration.user.DepartmentVO;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Liste les départements ou services auxquels sont rattachés les agents
 * @see Department
 */
public interface DepartmentDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Department}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link DepartmentVO}.
     */
    public static final int TRANSFORM_DEPARTMENTVO = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toDepartmentVO(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toDepartmentVO(
        Department source,
        DepartmentVO target);

    /**
     * Converts this DAO's entity to an object of type {@link DepartmentVO}.
     * @param entity
     * @return DepartmentVO
     */
    public DepartmentVO toDepartmentVO(Department entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link DepartmentVO}.
     * @param entities
     */
    public Collection<DepartmentVO> toDepartmentVOCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link DepartmentVO}.
     * @param entities
     * @return DepartmentVO[]
     */
    public DepartmentVO[] toDepartmentVOArray(Collection<?> entities);

    /**
     * Copies the fields of {@link DepartmentVO} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void departmentVOToEntity(
        DepartmentVO source,
        Department target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link DepartmentVO} to this DAO's entity.
     * @param departmentVO
     * @return Department
     */
    public Department departmentVOToEntity(DepartmentVO departmentVO);

    /**
     * Converts a Collection of instances of type {@link DepartmentVO} to this
     * DAO's entity.
     * @param instances
     */
    public void departmentVOToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of Department from the persistent store.
     * @param depId
     * @return Department
     */
    public Department get(Integer depId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param depId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer depId);

    /**
     * Loads an instance of Department from the persistent store.
     * @param depId
     * @return Department
     */
    public Department load(Integer depId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param depId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer depId);

    /**
     * Loads all entities of type {@link Department}.
     *
     * @return the loaded entities.
     */
    public Collection<Department> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Department and adds it to the persistent store.
     * @param department
     * @return Department
     */
    public Department create(Department department);

    /**
     * <p>
     * Does the same thing as {@link #create(Department)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param department
     * @return Object
     */
    public Object create(int transform, Department department);

    /**
     * Creates a new instance of Department and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Department
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Department> create(Collection<Department> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Department)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Department> entities);

    /**
     * <p>
     * Creates a new <code>Department</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param depCd Code (sigle dans LDAP : identifie de manière unique un service dans LDAP, attribut obligatoire dans
LDAP).
     * @param depNm Libellé du service issue de l'intitulé dans le LDAP si existant (taillé comme une description car
les infos venant de LDAP dépassent les 100 caractères)
     * @param depDc Description issue de l'activité LDAP
     * @param depEMail Mail associé au service
     * @param depAddress Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     * @param depPhone Les téléphones du service.
     * @param depLdapPresent Oui, si le service est présent dans le LDAP
     * @param depCreationDt Date de création de l'objet
     * @param updateDt Date de modification de l'objet
     * @return Department
     */
    public Department create(
        String depCd,
        String depNm,
        String depDc,
        String depEMail,
        String depAddress,
        String depPhone,
        String depLdapPresent,
        Date depCreationDt,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, String, String, String, String, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param depCd Code (sigle dans LDAP : identifie de manière unique un service dans LDAP, attribut obligatoire dans
LDAP).
     * @param depNm Libellé du service issue de l'intitulé dans le LDAP si existant (taillé comme une description car
les infos venant de LDAP dépassent les 100 caractères)
     * @param depDc Description issue de l'activité LDAP
     * @param depEMail Mail associé au service
     * @param depAddress Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     * @param depPhone Les téléphones du service.
     * @param depLdapPresent Oui, si le service est présent dans le LDAP
     * @param depCreationDt Date de création de l'objet
     * @param updateDt Date de modification de l'objet
     * @return Department
     */
    public Object create(
        int transform,
        String depCd,
        String depNm,
        String depDc,
        String depEMail,
        String depAddress,
        String depPhone,
        String depLdapPresent,
        Date depCreationDt,
        Timestamp updateDt);

    /**
     * <p>
     * Creates a new <code>Department</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param depCd
     * @param depNm
     * @param status
     * @return Department
     */
    public Department create(
        String depCd,
        String depNm,
        Status status);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param depCd
     * @param depNm
     * @param status
     * @return Object
     */
    public Object create(
        int transform,
        String depCd,
        String depNm,
        Status status);

    /**
     * Updates the <code>department</code> instance in the persistent store.
     * @param department
     */
    public void update(Department department);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Department> entities);

    /**
     * Removes the instance of Department from the persistent store.
     * @param department
     */
    public void remove(Department department);

    /**
     * Removes the instance of Department having the given
     * <code>identifier</code> from the persistent store.
     * @param depId
     */
    public void remove(Integer depId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Department> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Department> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.administration.user.DepartmentDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link Department} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link DepartmentVO} - {@link #TRANSFORM_DEPARTMENTVO}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.administration.user.DepartmentDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Department entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Department)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.administration.user.DepartmentDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Department)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}