// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.user;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Transfert des droits entre un service et un autre service
 */
// HibernateEntity.vsl annotations merge-point
public abstract class PrivilegeTransfer
    implements Serializable, Comparable<PrivilegeTransfer>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1864781534107863371L;

    private PrivilegeTransferPK privilegeTransferPk;

    /**
     * Get the composite primary key identifier class
     * @return privilegeTransferPk
     */
    public PrivilegeTransferPK getPrivilegeTransferPk()
    {
        return this.privilegeTransferPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param privilegeTransferPkIn
     */
    public void setPrivilegeTransferPk(PrivilegeTransferPK privilegeTransferPkIn) {
        this.privilegeTransferPk = privilegeTransferPkIn;
    }

    // Generate 2 attributes
    private Date privTransferDt;

    /**
     * Date du transfert des droits entre service
     * Cette date est mise à jours directement par le système (trigger car gestion sous SQL)
     * @return this.privTransferDt Date
     */
    public Date getPrivTransferDt()
    {
        return this.privTransferDt;
    }

    /**
     * Date du transfert des droits entre service
     * Cette date est mise à jours directement par le système (trigger car gestion sous SQL)
     * @param privTransferDtIn Date
     */
    public void setPrivTransferDt(Date privTransferDtIn)
    {
        this.privTransferDt = privTransferDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 3 associations
    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Department toDepartment;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.toDepartment Department
     */
    public Department getToDepartment()
    {
        return this.toDepartment;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param toDepartmentIn Department
     */
    public void setToDepartment(Department toDepartmentIn)
    {
        this.toDepartment = toDepartmentIn;
    }

    private Department fromDepartment;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.fromDepartment Department
     */
    public Department getFromDepartment()
    {
        return this.fromDepartment;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param fromDepartmentIn Department
     */
    public void setFromDepartment(Department fromDepartmentIn)
    {
        this.fromDepartment = fromDepartmentIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link PrivilegeTransfer}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link PrivilegeTransfer}.
         * @return new PrivilegeTransferImpl()
         */
        public static PrivilegeTransfer newInstance()
        {
            return new PrivilegeTransferImpl();
        }

        /**
         * Constructs a new instance of {@link PrivilegeTransfer}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param privTransferDt Date
         * @param status Status
         * @param toDepartment Department
         * @param fromDepartment Department
         * @return newInstance
         */
        public static PrivilegeTransfer newInstance(Date privTransferDt, Status status, Department toDepartment, Department fromDepartment)
        {
            final PrivilegeTransfer entity = new PrivilegeTransferImpl();
            entity.setPrivTransferDt(privTransferDt);
            entity.setStatus(status);
            entity.setToDepartment(toDepartment);
            entity.setFromDepartment(fromDepartment);
            return entity;
        }

        /**
         * Constructs a new instance of {@link PrivilegeTransfer}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param privTransferDt Date
         * @param updateDt Timestamp
         * @param status Status
         * @param toDepartment Department
         * @param fromDepartment Department
         * @return newInstance PrivilegeTransfer
         */
        public static PrivilegeTransfer newInstance(Date privTransferDt, Timestamp updateDt, Status status, Department toDepartment, Department fromDepartment)
        {
            final PrivilegeTransfer entity = new PrivilegeTransferImpl();
            entity.setPrivTransferDt(privTransferDt);
            entity.setUpdateDt(updateDt);
            entity.setStatus(status);
            entity.setToDepartment(toDepartment);
            entity.setFromDepartment(fromDepartment);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(PrivilegeTransfer o)
    {
        int cmp = 0;
        if (this.getPrivilegeTransferPk() != null)
        {
            cmp = this.getPrivilegeTransferPk().compareTo(o.getPrivilegeTransferPk());
        }
            if (this.getPrivTransferDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPrivTransferDt().compareTo(o.getPrivTransferDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// PrivilegeTransfer.java merge-point
}