// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.administration.user;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Transfert des droits entre un service et un autre service
 * @see PrivilegeTransfer
 */
public interface PrivilegeTransferDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link PrivilegeTransfer}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of PrivilegeTransfer from the persistent store.
     * @param privilegeTransferPk
     * @return PrivilegeTransfer
     */
    public PrivilegeTransfer get(PrivilegeTransferPK privilegeTransferPk);

    /**
     * <p>
     * Does the same thing as {@link #get(PrivilegeTransferPK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param privilegeTransferPk the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, PrivilegeTransferPK privilegeTransferPk);

    /**
     * Loads an instance of PrivilegeTransfer from the persistent store.
     * @param privilegeTransferPk
     * @return PrivilegeTransfer
     */
    public PrivilegeTransfer load(PrivilegeTransferPK privilegeTransferPk);

    /**
     * <p>
     * Does the same thing as {@link #load(PrivilegeTransferPK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param privilegeTransferPk the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, PrivilegeTransferPK privilegeTransferPk);

    /**
     * Loads all entities of type {@link PrivilegeTransfer}.
     *
     * @return the loaded entities.
     */
    public Collection<PrivilegeTransfer> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of PrivilegeTransfer and adds it to the persistent store.
     * @param privilegeTransfer
     * @return PrivilegeTransfer
     */
    public PrivilegeTransfer create(PrivilegeTransfer privilegeTransfer);

    /**
     * <p>
     * Does the same thing as {@link #create(PrivilegeTransfer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param privilegeTransfer
     * @return Object
     */
    public Object create(int transform, PrivilegeTransfer privilegeTransfer);

    /**
     * Creates a new instance of PrivilegeTransfer and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of PrivilegeTransfer
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<PrivilegeTransfer> create(Collection<PrivilegeTransfer> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(PrivilegeTransfer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<PrivilegeTransfer> entities);

    /**
     * <p>
     * Creates a new <code>PrivilegeTransfer</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param privTransferDt Date du transfert des droits entre service
Cette date est mise à jours directement par le système (trigger car gestion sous SQL)
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return PrivilegeTransfer
     */
    public PrivilegeTransfer create(
        Date privTransferDt,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param privTransferDt Date du transfert des droits entre service
Cette date est mise à jours directement par le système (trigger car gestion sous SQL)
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return PrivilegeTransfer
     */
    public Object create(
        int transform,
        Date privTransferDt,
        Timestamp updateDt);

    /**
     * <p>
     * Creates a new <code>PrivilegeTransfer</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param privTransferDt
     * @param toDepartment
     * @param status
     * @param fromDepartment
     * @return PrivilegeTransfer
     */
    public PrivilegeTransfer create(
        Date privTransferDt,
        Department toDepartment,
        Status status,
        Department fromDepartment);

    /**
     * <p>
     * Does the same thing as {@link #create(Date)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param privTransferDt
     * @param toDepartment
     * @param status
     * @param fromDepartment
     * @return Object
     */
    public Object create(
        int transform,
        Date privTransferDt,
        Department toDepartment,
        Status status,
        Department fromDepartment);

    /**
     * Updates the <code>privilegeTransfer</code> instance in the persistent store.
     * @param privilegeTransfer
     */
    public void update(PrivilegeTransfer privilegeTransfer);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<PrivilegeTransfer> entities);

    /**
     * Removes the instance of PrivilegeTransfer from the persistent store.
     * @param privilegeTransfer
     */
    public void remove(PrivilegeTransfer privilegeTransfer);

    /**
     * Removes the instance of PrivilegeTransfer having the given
     * <code>identifier</code> from the persistent store.
     * @param privilegeTransferPk
     */
    public void remove(PrivilegeTransferPK privilegeTransferPk);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<PrivilegeTransfer> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<PrivilegeTransfer> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.administration.user.PrivilegeTransferDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.administration.user.PrivilegeTransferDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final PrivilegeTransfer entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,PrivilegeTransfer)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.administration.user.PrivilegeTransferDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,PrivilegeTransfer)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}