// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.aquaculture;

import fr.ifremer.quadrige3.core.dao.data.samplingoperation.SamplingOperation;
import fr.ifremer.quadrige3.core.dao.referential.DepthLevel;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocation;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
 * dans des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
 * une population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
 * structure) * un niveau Ce lot de mollusques est positionné sur le terrain.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Batch
    implements Serializable, Comparable<Batch>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 789657765537097220L;

    // Generate 13 attributes
    private Integer batchId;

    /**
     * Identifiant interne du lot
     * @return this.batchId Integer
     */
    public Integer getBatchId()
    {
        return this.batchId;
    }

    /**
     * Identifiant interne du lot
     * @param batchIdIn Integer
     */
    public void setBatchId(Integer batchIdIn)
    {
        this.batchId = batchIdIn;
    }

    private String batchNm;

    /**
     * Libellé du lot
     * @return this.batchNm String
     */
    public String getBatchNm()
    {
        return this.batchNm;
    }

    /**
     * Libellé du lot
     * @param batchNmIn String
     */
    public void setBatchNm(String batchNmIn)
    {
        this.batchNm = batchNmIn;
    }

    private String batchLb;

    /**
     * Mnémonique du lot
     * @return this.batchLb String
     */
    public String getBatchLb()
    {
        return this.batchLb;
    }

    /**
     * Mnémonique du lot
     * @param batchLbIn String
     */
    public void setBatchLb(String batchLbIn)
    {
        this.batchLb = batchLbIn;
    }

    private String batchExperCond;

    /**
     * Conditions d'expérimentation
     * @return this.batchExperCond String
     */
    public String getBatchExperCond()
    {
        return this.batchExperCond;
    }

    /**
     * Conditions d'expérimentation
     * @param batchExperCondIn String
     */
    public void setBatchExperCond(String batchExperCondIn)
    {
        this.batchExperCond = batchExperCondIn;
    }

    private Integer batchBreedingStructurUnit;

    /**
     * Nombre d'occurences de la structure d'élevage
     * @return this.batchBreedingStructurUnit Integer
     */
    public Integer getBatchBreedingStructurUnit()
    {
        return this.batchBreedingStructurUnit;
    }

    /**
     * Nombre d'occurences de la structure d'élevage
     * @param batchBreedingStructurUnitIn Integer
     */
    public void setBatchBreedingStructurUnit(Integer batchBreedingStructurUnitIn)
    {
        this.batchBreedingStructurUnit = batchBreedingStructurUnitIn;
    }

    private Integer batchBreedingSystemUnit;

    /**
     * Nombre d'occurences du système d'élevage
     * @return this.batchBreedingSystemUnit Integer
     */
    public Integer getBatchBreedingSystemUnit()
    {
        return this.batchBreedingSystemUnit;
    }

    /**
     * Nombre d'occurences du système d'élevage
     * @param batchBreedingSystemUnitIn Integer
     */
    public void setBatchBreedingSystemUnit(Integer batchBreedingSystemUnitIn)
    {
        this.batchBreedingSystemUnit = batchBreedingSystemUnitIn;
    }

    private String batchCm;

    /**
     * Commentaire sur le lot
     * @return this.batchCm String
     */
    public String getBatchCm()
    {
        return this.batchCm;
    }

    /**
     * Commentaire sur le lot
     * @param batchCmIn String
     */
    public void setBatchCm(String batchCmIn)
    {
        this.batchCm = batchCmIn;
    }

    private Date batchControlDt;

    /**
     * Date de contrôle du lot
     * @return this.batchControlDt Date
     */
    public Date getBatchControlDt()
    {
        return this.batchControlDt;
    }

    /**
     * Date de contrôle du lot
     * @param batchControlDtIn Date
     */
    public void setBatchControlDt(Date batchControlDtIn)
    {
        this.batchControlDt = batchControlDtIn;
    }

    private Date batchValidDt;

    /**
     * Date de validation du lot
     * @return this.batchValidDt Date
     */
    public Date getBatchValidDt()
    {
        return this.batchValidDt;
    }

    /**
     * Date de validation du lot
     * @param batchValidDtIn Date
     */
    public void setBatchValidDt(Date batchValidDtIn)
    {
        this.batchValidDt = batchValidDtIn;
    }

    private Date batchQualifDt;

    /**
     * Date de qualification du lot
     * @return this.batchQualifDt Date
     */
    public Date getBatchQualifDt()
    {
        return this.batchQualifDt;
    }

    /**
     * Date de qualification du lot
     * @param batchQualifDtIn Date
     */
    public void setBatchQualifDt(Date batchQualifDtIn)
    {
        this.batchQualifDt = batchQualifDtIn;
    }

    private String batchQualifCm;

    /**
     * Commentaire de qualifcation du lot
     * @return this.batchQualifCm String
     */
    public String getBatchQualifCm()
    {
        return this.batchQualifCm;
    }

    /**
     * Commentaire de qualifcation du lot
     * @param batchQualifCmIn String
     */
    public void setBatchQualifCm(String batchQualifCmIn)
    {
        this.batchQualifCm = batchQualifCmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de maj
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de maj
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 8 associations
    private MonitoringLocation monitoringLocation;

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @return this.monitoringLocation MonitoringLocation
     */
    public MonitoringLocation getMonitoringLocation()
    {
        return this.monitoringLocation;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param monitoringLocationIn MonitoringLocation
     */
    public void setMonitoringLocation(MonitoringLocation monitoringLocationIn)
    {
        this.monitoringLocation = monitoringLocationIn;
    }

    private BreedingSystem breedingSystem;

    /**
     * Système d'élevage
     * C'est l'ensemble des contenants (des enceintes) ou des supports de mollusques.  Exemple = la
     * poche,
     * la corde, le casier, etc..
     * @return this.breedingSystem BreedingSystem
     */
    public BreedingSystem getBreedingSystem()
    {
        return this.breedingSystem;
    }

    /**
     * Système d'élevage
     * C'est l'ensemble des contenants (des enceintes) ou des supports de mollusques.  Exemple = la
     * poche,
     * la corde, le casier, etc..
     * @param breedingSystemIn BreedingSystem
     */
    public void setBreedingSystem(BreedingSystem breedingSystemIn)
    {
        this.breedingSystem = breedingSystemIn;
    }

    private Collection<SamplingOperation> samplingOperations = new HashSet<SamplingOperation>();

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @return this.samplingOperations Collection<SamplingOperation>
     */
    public Collection<SamplingOperation> getSamplingOperations()
    {
        return this.samplingOperations;
    }

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @param samplingOperationsIn Collection<SamplingOperation>
     */
    public void setSamplingOperations(Collection<SamplingOperation> samplingOperationsIn)
    {
        this.samplingOperations = samplingOperationsIn;
    }

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @param elementToAdd SamplingOperation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingOperations(SamplingOperation elementToAdd)
    {
        return this.samplingOperations.add(elementToAdd);
    }

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @param elementToRemove SamplingOperation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingOperations(SamplingOperation elementToRemove)
    {
        return this.samplingOperations.remove(elementToRemove);
    }

    private BreedingStructure breedingStructure;

    /**
     * Structure d'élevage
     * C'est l'ensemble des structures qui tiennent les systèmes.  Exemple : la filière, la table,
     * le
     * bouchot, etc..
     * @return this.breedingStructure BreedingStructure
     */
    public BreedingStructure getBreedingStructure()
    {
        return this.breedingStructure;
    }

    /**
     * Structure d'élevage
     * C'est l'ensemble des structures qui tiennent les systèmes.  Exemple : la filière, la table,
     * le
     * bouchot, etc..
     * @param breedingStructureIn BreedingStructure
     */
    public void setBreedingStructure(BreedingStructure breedingStructureIn)
    {
        this.breedingStructure = breedingStructureIn;
    }

    private DepthLevel depthLevel;

    /**
     * Liste des niveaux auxquels les prélèvements peuvent être effectués.
     * @return this.depthLevel DepthLevel
     */
    public DepthLevel getDepthLevel()
    {
        return this.depthLevel;
    }

    /**
     * Liste des niveaux auxquels les prélèvements peuvent être effectués.
     * @param depthLevelIn DepthLevel
     */
    public void setDepthLevel(DepthLevel depthLevelIn)
    {
        this.depthLevel = depthLevelIn;
    }

    private InitialPopulation initialPopulation;

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @return this.initialPopulation InitialPopulation
     */
    public InitialPopulation getInitialPopulation()
    {
        return this.initialPopulation;
    }

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @param initialPopulationIn InitialPopulation
     */
    public void setInitialPopulation(InitialPopulation initialPopulationIn)
    {
        this.initialPopulation = initialPopulationIn;
    }

    private Collection<InitialPopulation> initialPopulations = new HashSet<InitialPopulation>();

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @return this.initialPopulations Collection<InitialPopulation>
     */
    public Collection<InitialPopulation> getInitialPopulations()
    {
        return this.initialPopulations;
    }

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @param initialPopulationsIn Collection<InitialPopulation>
     */
    public void setInitialPopulations(Collection<InitialPopulation> initialPopulationsIn)
    {
        this.initialPopulations = initialPopulationsIn;
    }

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @param elementToAdd InitialPopulation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addInitialPopulations(InitialPopulation elementToAdd)
    {
        return this.initialPopulations.add(elementToAdd);
    }

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @param elementToRemove InitialPopulation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeInitialPopulations(InitialPopulation elementToRemove)
    {
        return this.initialPopulations.remove(elementToRemove);
    }

    private QualityFlag qualityFlag;

    /**
     * Liste des niveaux de qualification.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Liste des niveaux de qualification.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Batch instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Batch))
        {
            return false;
        }
        final Batch that = (Batch)object;
        if (this.batchId == null || that.getBatchId() == null || !this.batchId.equals(that.getBatchId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.batchId == null ? 0 : this.batchId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Batch}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Batch}.
         * @return new BatchImpl()
         */
        public static Batch newInstance()
        {
            return new BatchImpl();
        }

        /**
         * Constructs a new instance of {@link Batch}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param batchNm String
         * @param batchLb String
         * @param monitoringLocation MonitoringLocation
         * @param breedingSystem BreedingSystem
         * @param breedingStructure BreedingStructure
         * @param initialPopulation InitialPopulation
         * @param qualityFlag QualityFlag
         * @return newInstance
         */
        public static Batch newInstance(String batchNm, String batchLb, MonitoringLocation monitoringLocation, BreedingSystem breedingSystem, BreedingStructure breedingStructure, InitialPopulation initialPopulation, QualityFlag qualityFlag)
        {
            final Batch entity = new BatchImpl();
            entity.setBatchNm(batchNm);
            entity.setBatchLb(batchLb);
            entity.setMonitoringLocation(monitoringLocation);
            entity.setBreedingSystem(breedingSystem);
            entity.setBreedingStructure(breedingStructure);
            entity.setInitialPopulation(initialPopulation);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Batch}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param batchNm String
         * @param batchLb String
         * @param batchExperCond String
         * @param batchBreedingStructurUnit Integer
         * @param batchBreedingSystemUnit Integer
         * @param batchCm String
         * @param batchControlDt Date
         * @param batchValidDt Date
         * @param batchQualifDt Date
         * @param batchQualifCm String
         * @param updateDt Timestamp
         * @param remoteId Integer
         * @param monitoringLocation MonitoringLocation
         * @param breedingSystem BreedingSystem
         * @param samplingOperations Collection<SamplingOperation>
         * @param breedingStructure BreedingStructure
         * @param depthLevel DepthLevel
         * @param initialPopulation InitialPopulation
         * @param initialPopulations Collection<InitialPopulation>
         * @param qualityFlag QualityFlag
         * @return newInstance Batch
         */
        public static Batch newInstance(String batchNm, String batchLb, String batchExperCond, Integer batchBreedingStructurUnit, Integer batchBreedingSystemUnit, String batchCm, Date batchControlDt, Date batchValidDt, Date batchQualifDt, String batchQualifCm, Timestamp updateDt, Integer remoteId, MonitoringLocation monitoringLocation, BreedingSystem breedingSystem, Collection<SamplingOperation> samplingOperations, BreedingStructure breedingStructure, DepthLevel depthLevel, InitialPopulation initialPopulation, Collection<InitialPopulation> initialPopulations, QualityFlag qualityFlag)
        {
            final Batch entity = new BatchImpl();
            entity.setBatchNm(batchNm);
            entity.setBatchLb(batchLb);
            entity.setBatchExperCond(batchExperCond);
            entity.setBatchBreedingStructurUnit(batchBreedingStructurUnit);
            entity.setBatchBreedingSystemUnit(batchBreedingSystemUnit);
            entity.setBatchCm(batchCm);
            entity.setBatchControlDt(batchControlDt);
            entity.setBatchValidDt(batchValidDt);
            entity.setBatchQualifDt(batchQualifDt);
            entity.setBatchQualifCm(batchQualifCm);
            entity.setUpdateDt(updateDt);
            entity.setRemoteId(remoteId);
            entity.setMonitoringLocation(monitoringLocation);
            entity.setBreedingSystem(breedingSystem);
            entity.setSamplingOperations(samplingOperations);
            entity.setBreedingStructure(breedingStructure);
            entity.setDepthLevel(depthLevel);
            entity.setInitialPopulation(initialPopulation);
            entity.setInitialPopulations(initialPopulations);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Batch o)
    {
        int cmp = 0;
        if (this.getBatchId() != null)
        {
            cmp = this.getBatchId().compareTo(o.getBatchId());
        }
        else
        {
            if (this.getBatchNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchNm().compareTo(o.getBatchNm()));
            }
            if (this.getBatchLb() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchLb().compareTo(o.getBatchLb()));
            }
            if (this.getBatchExperCond() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchExperCond().compareTo(o.getBatchExperCond()));
            }
            if (this.getBatchBreedingStructurUnit() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchBreedingStructurUnit().compareTo(o.getBatchBreedingStructurUnit()));
            }
            if (this.getBatchBreedingSystemUnit() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchBreedingSystemUnit().compareTo(o.getBatchBreedingSystemUnit()));
            }
            if (this.getBatchCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchCm().compareTo(o.getBatchCm()));
            }
            if (this.getBatchControlDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchControlDt().compareTo(o.getBatchControlDt()));
            }
            if (this.getBatchValidDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchValidDt().compareTo(o.getBatchValidDt()));
            }
            if (this.getBatchQualifDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchQualifDt().compareTo(o.getBatchQualifDt()));
            }
            if (this.getBatchQualifCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBatchQualifCm().compareTo(o.getBatchQualifCm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Batch.java merge-point
}