// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.aquaculture;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocation;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
 * dans des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
 * une population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
 * structure) * un niveau Ce lot de mollusques est positionné sur le terrain.
 * @see Batch
 */
public interface BatchDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Batch}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of Batch from the persistent store.
     * @param batchId
     * @return Batch
     */
    public Batch get(Integer batchId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param batchId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer batchId);

    /**
     * Loads an instance of Batch from the persistent store.
     * @param batchId
     * @return Batch
     */
    public Batch load(Integer batchId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param batchId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer batchId);

    /**
     * Loads all entities of type {@link Batch}.
     *
     * @return the loaded entities.
     */
    public Collection<Batch> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Batch and adds it to the persistent store.
     * @param batch
     * @return Batch
     */
    public Batch create(Batch batch);

    /**
     * <p>
     * Does the same thing as {@link #create(Batch)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param batch
     * @return Object
     */
    public Object create(int transform, Batch batch);

    /**
     * Creates a new instance of Batch and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Batch
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Batch> create(Collection<Batch> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Batch)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Batch> entities);

    /**
     * <p>
     * Creates a new <code>Batch</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param batchNm Libellé du lot
     * @param batchLb Mnémonique du lot
     * @param batchExperCond Conditions d'expérimentation
     * @param batchBreedingStructurUnit Nombre d'occurences de la structure d'élevage
     * @param batchBreedingSystemUnit Nombre d'occurences du système d'élevage
     * @param batchCm Commentaire sur le lot
     * @param batchControlDt Date de contrôle du lot
     * @param batchValidDt Date de validation du lot
     * @param batchQualifDt Date de qualification du lot
     * @param batchQualifCm Commentaire de qualifcation du lot
     * @param updateDt Date de maj
     * @param remoteId 
     * @return Batch
     */
    public Batch create(
        String batchNm,
        String batchLb,
        String batchExperCond,
        Integer batchBreedingStructurUnit,
        Integer batchBreedingSystemUnit,
        String batchCm,
        Date batchControlDt,
        Date batchValidDt,
        Date batchQualifDt,
        String batchQualifCm,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, Integer, Integer, String, Date, Date, Date, String, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param batchNm Libellé du lot
     * @param batchLb Mnémonique du lot
     * @param batchExperCond Conditions d'expérimentation
     * @param batchBreedingStructurUnit Nombre d'occurences de la structure d'élevage
     * @param batchBreedingSystemUnit Nombre d'occurences du système d'élevage
     * @param batchCm Commentaire sur le lot
     * @param batchControlDt Date de contrôle du lot
     * @param batchValidDt Date de validation du lot
     * @param batchQualifDt Date de qualification du lot
     * @param batchQualifCm Commentaire de qualifcation du lot
     * @param updateDt Date de maj
     * @param remoteId 
     * @return Batch
     */
    public Object create(
        int transform,
        String batchNm,
        String batchLb,
        String batchExperCond,
        Integer batchBreedingStructurUnit,
        Integer batchBreedingSystemUnit,
        String batchCm,
        Date batchControlDt,
        Date batchValidDt,
        Date batchQualifDt,
        String batchQualifCm,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>Batch</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param batchLb
     * @param batchNm
     * @param breedingStructure
     * @param breedingSystem
     * @param initialPopulation
     * @param monitoringLocation
     * @param qualityFlag
     * @return Batch
     */
    public Batch create(
        String batchLb,
        String batchNm,
        BreedingStructure breedingStructure,
        BreedingSystem breedingSystem,
        InitialPopulation initialPopulation,
        MonitoringLocation monitoringLocation,
        QualityFlag qualityFlag);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param batchLb
     * @param batchNm
     * @param breedingStructure
     * @param breedingSystem
     * @param initialPopulation
     * @param monitoringLocation
     * @param qualityFlag
     * @return Object
     */
    public Object create(
        int transform,
        String batchLb,
        String batchNm,
        BreedingStructure breedingStructure,
        BreedingSystem breedingSystem,
        InitialPopulation initialPopulation,
        MonitoringLocation monitoringLocation,
        QualityFlag qualityFlag);

    /**
     * Updates the <code>batch</code> instance in the persistent store.
     * @param batch
     */
    public void update(Batch batch);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Batch> entities);

    /**
     * Removes the instance of Batch from the persistent store.
     * @param batch
     */
    public void remove(Batch batch);

    /**
     * Removes the instance of Batch having the given
     * <code>identifier</code> from the persistent store.
     * @param batchId
     */
    public void remove(Integer batchId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Batch> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Batch> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.data.aquaculture.BatchDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.data.aquaculture.BatchDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Batch entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Batch)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.data.aquaculture.BatchDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Batch)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}