// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.aquaculture;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Structure d'élevage
 * C'est l'ensemble des structures qui tiennent les systèmes.  Exemple : la filière, la table, le
 * bouchot, etc..
 */
// HibernateEntity.vsl annotations merge-point
public abstract class BreedingStructure
    implements Serializable, Comparable<BreedingStructure>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1192222427068277120L;

    // Generate 3 attributes
    private String breedingStructCd;

    /**
     * Code de la structure d'élevage
     * @return this.breedingStructCd String
     */
    public String getBreedingStructCd()
    {
        return this.breedingStructCd;
    }

    /**
     * Code de la structure d'élevage
     * @param breedingStructCdIn String
     */
    public void setBreedingStructCd(String breedingStructCdIn)
    {
        this.breedingStructCd = breedingStructCdIn;
    }

    private String breedingStructNm;

    /**
     * Libellé de la structure d'élevage
     * @return this.breedingStructNm String
     */
    public String getBreedingStructNm()
    {
        return this.breedingStructNm;
    }

    /**
     * Libellé de la structure d'élevage
     * @param breedingStructNmIn String
     */
    public void setBreedingStructNm(String breedingStructNmIn)
    {
        this.breedingStructNm = breedingStructNmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de maj
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de maj
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 3 associations
    private Collection<Batch> batches = new HashSet<Batch>();

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @return this.batches Collection<Batch>
     */
    public Collection<Batch> getBatches()
    {
        return this.batches;
    }

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @param batchesIn Collection<Batch>
     */
    public void setBatches(Collection<Batch> batchesIn)
    {
        this.batches = batchesIn;
    }

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @param elementToAdd Batch
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addBatches(Batch elementToAdd)
    {
        return this.batches.add(elementToAdd);
    }

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @param elementToRemove Batch
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeBatches(Batch elementToRemove)
    {
        return this.batches.remove(elementToRemove);
    }

    private Collection<HistoricalAccount> historicalAccounts = new HashSet<HistoricalAccount>();

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @return this.historicalAccounts Collection<HistoricalAccount>
     */
    public Collection<HistoricalAccount> getHistoricalAccounts()
    {
        return this.historicalAccounts;
    }

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @param historicalAccountsIn Collection<HistoricalAccount>
     */
    public void setHistoricalAccounts(Collection<HistoricalAccount> historicalAccountsIn)
    {
        this.historicalAccounts = historicalAccountsIn;
    }

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @param elementToAdd HistoricalAccount
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addHistoricalAccounts(HistoricalAccount elementToAdd)
    {
        return this.historicalAccounts.add(elementToAdd);
    }

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @param elementToRemove HistoricalAccount
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeHistoricalAccounts(HistoricalAccount elementToRemove)
    {
        return this.historicalAccounts.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    /**
     * Returns <code>true</code> if the argument is an BreedingStructure instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof BreedingStructure))
        {
            return false;
        }
        final BreedingStructure that = (BreedingStructure)object;
        if (this.breedingStructCd == null || that.getBreedingStructCd() == null || !this.breedingStructCd.equals(that.getBreedingStructCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.breedingStructCd == null ? 0 : this.breedingStructCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link BreedingStructure}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link BreedingStructure}.
         * @return new BreedingStructureImpl()
         */
        public static BreedingStructure newInstance()
        {
            return new BreedingStructureImpl();
        }

        /**
         * Constructs a new instance of {@link BreedingStructure}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param breedingStructNm String
         * @param status Status
         * @return newInstance
         */
        public static BreedingStructure newInstance(String breedingStructNm, Status status)
        {
            final BreedingStructure entity = new BreedingStructureImpl();
            entity.setBreedingStructNm(breedingStructNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link BreedingStructure}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param breedingStructNm String
         * @param updateDt Timestamp
         * @param batches Collection<Batch>
         * @param historicalAccounts Collection<HistoricalAccount>
         * @param status Status
         * @return newInstance BreedingStructure
         */
        public static BreedingStructure newInstance(String breedingStructNm, Timestamp updateDt, Collection<Batch> batches, Collection<HistoricalAccount> historicalAccounts, Status status)
        {
            final BreedingStructure entity = new BreedingStructureImpl();
            entity.setBreedingStructNm(breedingStructNm);
            entity.setUpdateDt(updateDt);
            entity.setBatches(batches);
            entity.setHistoricalAccounts(historicalAccounts);
            entity.setStatus(status);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(BreedingStructure o)
    {
        int cmp = 0;
        if (this.getBreedingStructCd() != null)
        {
            cmp = this.getBreedingStructCd().compareTo(o.getBreedingStructCd());
        }
        else
        {
            if (this.getBreedingStructNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBreedingStructNm().compareTo(o.getBreedingStructNm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// BreedingStructure.java merge-point
}