// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.aquaculture;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Système d'élevage
 * C'est l'ensemble des contenants (des enceintes) ou des supports de mollusques.  Exemple = la
 * poche, la corde, le casier, etc..
 */
// HibernateEntity.vsl annotations merge-point
public abstract class BreedingSystem
    implements Serializable, Comparable<BreedingSystem>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 6758967807618915978L;

    // Generate 3 attributes
    private String breedingSystemCd;

    /**
     * Code du système d'élevage
     * @return this.breedingSystemCd String
     */
    public String getBreedingSystemCd()
    {
        return this.breedingSystemCd;
    }

    /**
     * Code du système d'élevage
     * @param breedingSystemCdIn String
     */
    public void setBreedingSystemCd(String breedingSystemCdIn)
    {
        this.breedingSystemCd = breedingSystemCdIn;
    }

    private String breedingSystemNm;

    /**
     * Libellé du système d'élevage
     * @return this.breedingSystemNm String
     */
    public String getBreedingSystemNm()
    {
        return this.breedingSystemNm;
    }

    /**
     * Libellé du système d'élevage
     * @param breedingSystemNmIn String
     */
    public void setBreedingSystemNm(String breedingSystemNmIn)
    {
        this.breedingSystemNm = breedingSystemNmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de maj
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de maj
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 3 associations
    private Collection<Batch> batches = new HashSet<Batch>();

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @return this.batches Collection<Batch>
     */
    public Collection<Batch> getBatches()
    {
        return this.batches;
    }

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @param batchesIn Collection<Batch>
     */
    public void setBatches(Collection<Batch> batchesIn)
    {
        this.batches = batchesIn;
    }

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @param elementToAdd Batch
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addBatches(Batch elementToAdd)
    {
        return this.batches.add(elementToAdd);
    }

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @param elementToRemove Batch
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeBatches(Batch elementToRemove)
    {
        return this.batches.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<HistoricalAccount> historicalAccounts = new HashSet<HistoricalAccount>();

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @return this.historicalAccounts Collection<HistoricalAccount>
     */
    public Collection<HistoricalAccount> getHistoricalAccounts()
    {
        return this.historicalAccounts;
    }

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @param historicalAccountsIn Collection<HistoricalAccount>
     */
    public void setHistoricalAccounts(Collection<HistoricalAccount> historicalAccountsIn)
    {
        this.historicalAccounts = historicalAccountsIn;
    }

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @param elementToAdd HistoricalAccount
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addHistoricalAccounts(HistoricalAccount elementToAdd)
    {
        return this.historicalAccounts.add(elementToAdd);
    }

    /**
     * Ligne d'historique
     * Une population de mollusques a subit différents transferts avant d'être utilisée pour une
     * étude. Ce
     * sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une
     * ligne
     * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de
     * début de
     * phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
     * type de
     * phase d'élevag
     * @param elementToRemove HistoricalAccount
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeHistoricalAccounts(HistoricalAccount elementToRemove)
    {
        return this.historicalAccounts.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an BreedingSystem instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof BreedingSystem))
        {
            return false;
        }
        final BreedingSystem that = (BreedingSystem)object;
        if (this.breedingSystemCd == null || that.getBreedingSystemCd() == null || !this.breedingSystemCd.equals(that.getBreedingSystemCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.breedingSystemCd == null ? 0 : this.breedingSystemCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link BreedingSystem}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link BreedingSystem}.
         * @return new BreedingSystemImpl()
         */
        public static BreedingSystem newInstance()
        {
            return new BreedingSystemImpl();
        }

        /**
         * Constructs a new instance of {@link BreedingSystem}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param breedingSystemNm String
         * @param status Status
         * @return newInstance
         */
        public static BreedingSystem newInstance(String breedingSystemNm, Status status)
        {
            final BreedingSystem entity = new BreedingSystemImpl();
            entity.setBreedingSystemNm(breedingSystemNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link BreedingSystem}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param breedingSystemNm String
         * @param updateDt Timestamp
         * @param batches Collection<Batch>
         * @param status Status
         * @param historicalAccounts Collection<HistoricalAccount>
         * @return newInstance BreedingSystem
         */
        public static BreedingSystem newInstance(String breedingSystemNm, Timestamp updateDt, Collection<Batch> batches, Status status, Collection<HistoricalAccount> historicalAccounts)
        {
            final BreedingSystem entity = new BreedingSystemImpl();
            entity.setBreedingSystemNm(breedingSystemNm);
            entity.setUpdateDt(updateDt);
            entity.setBatches(batches);
            entity.setStatus(status);
            entity.setHistoricalAccounts(historicalAccounts);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(BreedingSystem o)
    {
        int cmp = 0;
        if (this.getBreedingSystemCd() != null)
        {
            cmp = this.getBreedingSystemCd().compareTo(o.getBreedingSystemCd());
        }
        else
        {
            if (this.getBreedingSystemNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBreedingSystemNm().compareTo(o.getBreedingSystemNm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// BreedingSystem.java merge-point
}