// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.aquaculture;

import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocation;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Ligne d'historique
 * Une population de mollusques a subit différents transferts avant d'être utilisée pour une étude.
 * Ce sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une ligne
 * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de début
 * de phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
 * type de phase d'élevag
 */
// HibernateEntity.vsl annotations merge-point
public abstract class HistoricalAccount
    implements Serializable, Comparable<HistoricalAccount>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -3894232205107907178L;

    // Generate 6 attributes
    private Integer histAccountId;

    /**
     * Identifiant de la ligne d'historique
     * @return this.histAccountId Integer
     */
    public Integer getHistAccountId()
    {
        return this.histAccountId;
    }

    /**
     * Identifiant de la ligne d'historique
     * @param histAccountIdIn Integer
     */
    public void setHistAccountId(Integer histAccountIdIn)
    {
        this.histAccountId = histAccountIdIn;
    }

    private Date histAccountStartDt;

    /**
     * Date de début de phase
     * @return this.histAccountStartDt Date
     */
    public Date getHistAccountStartDt()
    {
        return this.histAccountStartDt;
    }

    /**
     * Date de début de phase
     * @param histAccountStartDtIn Date
     */
    public void setHistAccountStartDt(Date histAccountStartDtIn)
    {
        this.histAccountStartDt = histAccountStartDtIn;
    }

    private Date histAccountEndDt;

    /**
     * Date de fin de phase
     * @return this.histAccountEndDt Date
     */
    public Date getHistAccountEndDt()
    {
        return this.histAccountEndDt;
    }

    /**
     * Date de fin de phase
     * @param histAccountEndDtIn Date
     */
    public void setHistAccountEndDt(Date histAccountEndDtIn)
    {
        this.histAccountEndDt = histAccountEndDtIn;
    }

    private String histAccountCm;

    /**
     * Observations de la ligne d'historique
     * @return this.histAccountCm String
     */
    public String getHistAccountCm()
    {
        return this.histAccountCm;
    }

    /**
     * Observations de la ligne d'historique
     * @param histAccountCmIn String
     */
    public void setHistAccountCm(String histAccountCmIn)
    {
        this.histAccountCm = histAccountCmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de maj
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de maj
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 7 associations
    private BreedingPhaseType breedingPhaseType;

    /**
     * Type de phase d'élevage
     * ponte, élevage, captage, etc..
     * @return this.breedingPhaseType BreedingPhaseType
     */
    public BreedingPhaseType getBreedingPhaseType()
    {
        return this.breedingPhaseType;
    }

    /**
     * Type de phase d'élevage
     * ponte, élevage, captage, etc..
     * @param breedingPhaseTypeIn BreedingPhaseType
     */
    public void setBreedingPhaseType(BreedingPhaseType breedingPhaseTypeIn)
    {
        this.breedingPhaseType = breedingPhaseTypeIn;
    }

    private Department department;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.department Department
     */
    public Department getDepartment()
    {
        return this.department;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param departmentIn Department
     */
    public void setDepartment(Department departmentIn)
    {
        this.department = departmentIn;
    }

    private InitialPopulation initialPopulation;

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @return this.initialPopulation InitialPopulation
     */
    public InitialPopulation getInitialPopulation()
    {
        return this.initialPopulation;
    }

    /**
     * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
     * paramètres sur une même population de mollusques répartis en lots sur le littoral français.
     * Cela
     * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de
     * mollusques, que
     * l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
     * sur
     * différents lieux de mesures.
     * @param initialPopulationIn InitialPopulation
     */
    public void setInitialPopulation(InitialPopulation initialPopulationIn)
    {
        this.initialPopulation = initialPopulationIn;
    }

    private ProductionSector productionSector;

    /**
     * Secteur de production conchylicole
     * @return this.productionSector ProductionSector
     */
    public ProductionSector getProductionSector()
    {
        return this.productionSector;
    }

    /**
     * Secteur de production conchylicole
     * @param productionSectorIn ProductionSector
     */
    public void setProductionSector(ProductionSector productionSectorIn)
    {
        this.productionSector = productionSectorIn;
    }

    private BreedingStructure breedingStructure;

    /**
     * Structure d'élevage
     * C'est l'ensemble des structures qui tiennent les systèmes.  Exemple : la filière, la table,
     * le
     * bouchot, etc..
     * @return this.breedingStructure BreedingStructure
     */
    public BreedingStructure getBreedingStructure()
    {
        return this.breedingStructure;
    }

    /**
     * Structure d'élevage
     * C'est l'ensemble des structures qui tiennent les systèmes.  Exemple : la filière, la table,
     * le
     * bouchot, etc..
     * @param breedingStructureIn BreedingStructure
     */
    public void setBreedingStructure(BreedingStructure breedingStructureIn)
    {
        this.breedingStructure = breedingStructureIn;
    }

    private MonitoringLocation monitoringLocation;

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @return this.monitoringLocation MonitoringLocation
     */
    public MonitoringLocation getMonitoringLocation()
    {
        return this.monitoringLocation;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param monitoringLocationIn MonitoringLocation
     */
    public void setMonitoringLocation(MonitoringLocation monitoringLocationIn)
    {
        this.monitoringLocation = monitoringLocationIn;
    }

    private BreedingSystem breedingSystem;

    /**
     * Système d'élevage
     * C'est l'ensemble des contenants (des enceintes) ou des supports de mollusques.  Exemple = la
     * poche,
     * la corde, le casier, etc..
     * @return this.breedingSystem BreedingSystem
     */
    public BreedingSystem getBreedingSystem()
    {
        return this.breedingSystem;
    }

    /**
     * Système d'élevage
     * C'est l'ensemble des contenants (des enceintes) ou des supports de mollusques.  Exemple = la
     * poche,
     * la corde, le casier, etc..
     * @param breedingSystemIn BreedingSystem
     */
    public void setBreedingSystem(BreedingSystem breedingSystemIn)
    {
        this.breedingSystem = breedingSystemIn;
    }

    /**
     * Returns <code>true</code> if the argument is an HistoricalAccount instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof HistoricalAccount))
        {
            return false;
        }
        final HistoricalAccount that = (HistoricalAccount)object;
        if (this.histAccountId == null || that.getHistAccountId() == null || !this.histAccountId.equals(that.getHistAccountId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.histAccountId == null ? 0 : this.histAccountId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link HistoricalAccount}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link HistoricalAccount}.
         * @return new HistoricalAccountImpl()
         */
        public static HistoricalAccount newInstance()
        {
            return new HistoricalAccountImpl();
        }

        /**
         * Constructs a new instance of {@link HistoricalAccount}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param histAccountStartDt Date
         * @param histAccountEndDt Date
         * @param breedingPhaseType BreedingPhaseType
         * @param initialPopulation InitialPopulation
         * @param breedingStructure BreedingStructure
         * @param breedingSystem BreedingSystem
         * @return newInstance
         */
        public static HistoricalAccount newInstance(Date histAccountStartDt, Date histAccountEndDt, BreedingPhaseType breedingPhaseType, InitialPopulation initialPopulation, BreedingStructure breedingStructure, BreedingSystem breedingSystem)
        {
            final HistoricalAccount entity = new HistoricalAccountImpl();
            entity.setHistAccountStartDt(histAccountStartDt);
            entity.setHistAccountEndDt(histAccountEndDt);
            entity.setBreedingPhaseType(breedingPhaseType);
            entity.setInitialPopulation(initialPopulation);
            entity.setBreedingStructure(breedingStructure);
            entity.setBreedingSystem(breedingSystem);
            return entity;
        }

        /**
         * Constructs a new instance of {@link HistoricalAccount}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param histAccountStartDt Date
         * @param histAccountEndDt Date
         * @param histAccountCm String
         * @param updateDt Timestamp
         * @param remoteId Integer
         * @param breedingPhaseType BreedingPhaseType
         * @param department Department
         * @param initialPopulation InitialPopulation
         * @param productionSector ProductionSector
         * @param breedingStructure BreedingStructure
         * @param monitoringLocation MonitoringLocation
         * @param breedingSystem BreedingSystem
         * @return newInstance HistoricalAccount
         */
        public static HistoricalAccount newInstance(Date histAccountStartDt, Date histAccountEndDt, String histAccountCm, Timestamp updateDt, Integer remoteId, BreedingPhaseType breedingPhaseType, Department department, InitialPopulation initialPopulation, ProductionSector productionSector, BreedingStructure breedingStructure, MonitoringLocation monitoringLocation, BreedingSystem breedingSystem)
        {
            final HistoricalAccount entity = new HistoricalAccountImpl();
            entity.setHistAccountStartDt(histAccountStartDt);
            entity.setHistAccountEndDt(histAccountEndDt);
            entity.setHistAccountCm(histAccountCm);
            entity.setUpdateDt(updateDt);
            entity.setRemoteId(remoteId);
            entity.setBreedingPhaseType(breedingPhaseType);
            entity.setDepartment(department);
            entity.setInitialPopulation(initialPopulation);
            entity.setProductionSector(productionSector);
            entity.setBreedingStructure(breedingStructure);
            entity.setMonitoringLocation(monitoringLocation);
            entity.setBreedingSystem(breedingSystem);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(HistoricalAccount o)
    {
        int cmp = 0;
        if (this.getHistAccountId() != null)
        {
            cmp = this.getHistAccountId().compareTo(o.getHistAccountId());
        }
        else
        {
            if (this.getHistAccountStartDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getHistAccountStartDt().compareTo(o.getHistAccountStartDt()));
            }
            if (this.getHistAccountEndDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getHistAccountEndDt().compareTo(o.getHistAccountEndDt()));
            }
            if (this.getHistAccountCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getHistAccountCm().compareTo(o.getHistAccountCm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// HistoricalAccount.java merge-point
}