// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.aquaculture;

import fr.ifremer.quadrige3.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Ligne d'historique
 * Une population de mollusques a subit différents transferts avant d'être utilisée pour une étude.
 * Ce sont ces transferts entre secteurs conchylicoles, par exemple, que l'on veut tracer. Une ligne
 * d'historique c'est : * un lieu de surveillance ou * un secteur conchylicole  * une date de début
 * de phase * une date de fin de phase * des caractéristiques d'élevage (système + structure) * un
 * type de phase d'élevag
 * @see HistoricalAccount
 */
public interface HistoricalAccountDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link HistoricalAccount}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of HistoricalAccount from the persistent store.
     * @param histAccountId
     * @return HistoricalAccount
     */
    public HistoricalAccount get(Integer histAccountId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param histAccountId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer histAccountId);

    /**
     * Loads an instance of HistoricalAccount from the persistent store.
     * @param histAccountId
     * @return HistoricalAccount
     */
    public HistoricalAccount load(Integer histAccountId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param histAccountId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer histAccountId);

    /**
     * Loads all entities of type {@link HistoricalAccount}.
     *
     * @return the loaded entities.
     */
    public Collection<HistoricalAccount> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of HistoricalAccount and adds it to the persistent store.
     * @param historicalAccount
     * @return HistoricalAccount
     */
    public HistoricalAccount create(HistoricalAccount historicalAccount);

    /**
     * <p>
     * Does the same thing as {@link #create(HistoricalAccount)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param historicalAccount
     * @return Object
     */
    public Object create(int transform, HistoricalAccount historicalAccount);

    /**
     * Creates a new instance of HistoricalAccount and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of HistoricalAccount
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<HistoricalAccount> create(Collection<HistoricalAccount> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(HistoricalAccount)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<HistoricalAccount> entities);

    /**
     * <p>
     * Creates a new <code>HistoricalAccount</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param histAccountStartDt Date de début de phase
     * @param histAccountEndDt Date de fin de phase
     * @param histAccountCm Observations de la ligne d'historique
     * @param updateDt Date de maj
     * @param remoteId 
     * @return HistoricalAccount
     */
    public HistoricalAccount create(
        Date histAccountStartDt,
        Date histAccountEndDt,
        String histAccountCm,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, Date, String, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param histAccountStartDt Date de début de phase
     * @param histAccountEndDt Date de fin de phase
     * @param histAccountCm Observations de la ligne d'historique
     * @param updateDt Date de maj
     * @param remoteId 
     * @return HistoricalAccount
     */
    public Object create(
        int transform,
        Date histAccountStartDt,
        Date histAccountEndDt,
        String histAccountCm,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>HistoricalAccount</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param histAccountEndDt
     * @param histAccountStartDt
     * @param breedingPhaseType
     * @param breedingStructure
     * @param breedingSystem
     * @param initialPopulation
     * @return HistoricalAccount
     */
    public HistoricalAccount create(
        Date histAccountEndDt,
        Date histAccountStartDt,
        BreedingPhaseType breedingPhaseType,
        BreedingStructure breedingStructure,
        BreedingSystem breedingSystem,
        InitialPopulation initialPopulation);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, Date)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param histAccountEndDt
     * @param histAccountStartDt
     * @param breedingPhaseType
     * @param breedingStructure
     * @param breedingSystem
     * @param initialPopulation
     * @return Object
     */
    public Object create(
        int transform,
        Date histAccountEndDt,
        Date histAccountStartDt,
        BreedingPhaseType breedingPhaseType,
        BreedingStructure breedingStructure,
        BreedingSystem breedingSystem,
        InitialPopulation initialPopulation);

    /**
     * Updates the <code>historicalAccount</code> instance in the persistent store.
     * @param historicalAccount
     */
    public void update(HistoricalAccount historicalAccount);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<HistoricalAccount> entities);

    /**
     * Removes the instance of HistoricalAccount from the persistent store.
     * @param historicalAccount
     */
    public void remove(HistoricalAccount historicalAccount);

    /**
     * Removes the instance of HistoricalAccount having the given
     * <code>identifier</code> from the persistent store.
     * @param histAccountId
     */
    public void remove(Integer histAccountId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<HistoricalAccount> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<HistoricalAccount> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.data.aquaculture.HistoricalAccountDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.data.aquaculture.HistoricalAccountDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final HistoricalAccount entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,HistoricalAccount)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.data.aquaculture.HistoricalAccountDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,HistoricalAccount)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}