// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.aquaculture;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.taxon.ReferenceTaxon;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Pour les données aquacoles de nombreuses études consiste à voir les évolutions de plusieurs
 * paramètres sur une même population de mollusques répartis en lots sur le littoral français. Cela
 * permet de comparer les évolutions liées seulement au site. On part d'un ensemble de mollusques,
 * que l'on appelle population initiale, au niveau national et l'on repartit cet ensemble en lots
 * sur différents lieux de mesures.
 * @see InitialPopulation
 */
public interface InitialPopulationDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link InitialPopulation}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of InitialPopulation from the persistent store.
     * @param initPopId
     * @return InitialPopulation
     */
    public InitialPopulation get(Integer initPopId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param initPopId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer initPopId);

    /**
     * Loads an instance of InitialPopulation from the persistent store.
     * @param initPopId
     * @return InitialPopulation
     */
    public InitialPopulation load(Integer initPopId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param initPopId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer initPopId);

    /**
     * Loads all entities of type {@link InitialPopulation}.
     *
     * @return the loaded entities.
     */
    public Collection<InitialPopulation> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of InitialPopulation and adds it to the persistent store.
     * @param initialPopulation
     * @return InitialPopulation
     */
    public InitialPopulation create(InitialPopulation initialPopulation);

    /**
     * <p>
     * Does the same thing as {@link #create(InitialPopulation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param initialPopulation
     * @return Object
     */
    public Object create(int transform, InitialPopulation initialPopulation);

    /**
     * Creates a new instance of InitialPopulation and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of InitialPopulation
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<InitialPopulation> create(Collection<InitialPopulation> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(InitialPopulation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<InitialPopulation> entities);

    /**
     * <p>
     * Creates a new <code>InitialPopulation</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param initPopNm Libellé de la population initiale
     * @param initPopLb Mnémonique de la population initiale
     * @param initPopCm Commentaire sur la population initiale
     * @param initPopQualifDt Date de qualification de la population initiale
     * @param initPopQualifCm Commentaire de qualification de la population initiale
     * @param initPopValidDt Date de validation de la population initiale
     * @param initPopControlDt Date de controle de la population initiale
     * @param initPopStartDt Date de mise à disposition de la population initiale
     * @param initPopBiometricIndivNb Nombre d'individus pour les mesures de biométrie
     * @param updateDt Date de maj
     * @param remoteId 
     * @return InitialPopulation
     */
    public InitialPopulation create(
        String initPopNm,
        String initPopLb,
        String initPopCm,
        Date initPopQualifDt,
        String initPopQualifCm,
        Date initPopValidDt,
        Date initPopControlDt,
        Date initPopStartDt,
        Integer initPopBiometricIndivNb,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, Date, String, Date, Date, Date, Integer, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param initPopNm Libellé de la population initiale
     * @param initPopLb Mnémonique de la population initiale
     * @param initPopCm Commentaire sur la population initiale
     * @param initPopQualifDt Date de qualification de la population initiale
     * @param initPopQualifCm Commentaire de qualification de la population initiale
     * @param initPopValidDt Date de validation de la population initiale
     * @param initPopControlDt Date de controle de la population initiale
     * @param initPopStartDt Date de mise à disposition de la population initiale
     * @param initPopBiometricIndivNb Nombre d'individus pour les mesures de biométrie
     * @param updateDt Date de maj
     * @param remoteId 
     * @return InitialPopulation
     */
    public Object create(
        int transform,
        String initPopNm,
        String initPopLb,
        String initPopCm,
        Date initPopQualifDt,
        String initPopQualifCm,
        Date initPopValidDt,
        Date initPopControlDt,
        Date initPopStartDt,
        Integer initPopBiometricIndivNb,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>InitialPopulation</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param initPopBiometricIndivNb
     * @param initPopLb
     * @param initPopNm
     * @param initPopStartDt
     * @param ageGroup
     * @param qualityFlag
     * @param referenceTaxon
     * @return InitialPopulation
     */
    public InitialPopulation create(
        Integer initPopBiometricIndivNb,
        String initPopLb,
        String initPopNm,
        Date initPopStartDt,
        AgeGroup ageGroup,
        QualityFlag qualityFlag,
        ReferenceTaxon referenceTaxon);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Date, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param initPopBiometricIndivNb
     * @param initPopLb
     * @param initPopNm
     * @param initPopStartDt
     * @param ageGroup
     * @param qualityFlag
     * @param referenceTaxon
     * @return Object
     */
    public Object create(
        int transform,
        Integer initPopBiometricIndivNb,
        String initPopLb,
        String initPopNm,
        Date initPopStartDt,
        AgeGroup ageGroup,
        QualityFlag qualityFlag,
        ReferenceTaxon referenceTaxon);

    /**
     * Updates the <code>initialPopulation</code> instance in the persistent store.
     * @param initialPopulation
     */
    public void update(InitialPopulation initialPopulation);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<InitialPopulation> entities);

    /**
     * Removes the instance of InitialPopulation from the persistent store.
     * @param initialPopulation
     */
    public void remove(InitialPopulation initialPopulation);

    /**
     * Removes the instance of InitialPopulation having the given
     * <code>identifier</code> from the persistent store.
     * @param initPopId
     */
    public void remove(Integer initPopId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<InitialPopulation> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<InitialPopulation> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.data.aquaculture.InitialPopulationDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.data.aquaculture.InitialPopulationDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final InitialPopulation entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,InitialPopulation)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.data.aquaculture.InitialPopulationDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,InitialPopulation)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}