// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.event;

import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.data.survey.Survey;
import fr.ifremer.quadrige3.core.dao.referential.EventType;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.PositionningSystem;
import fr.ifremer.quadrige3.core.dao.system.EventArea;
import fr.ifremer.quadrige3.core.dao.system.EventLine;
import fr.ifremer.quadrige3.core.dao.system.EventPoint;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste les événements qui peuvent avoir ou non un rapport avec un passage.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Event
    implements Serializable, Comparable<Event>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 909796630594870265L;

    // Generate 9 attributes
    private Integer eventId;

    /**
     * Identifiant interne de l'évènement
     * @return this.eventId Integer
     */
    public Integer getEventId()
    {
        return this.eventId;
    }

    /**
     * Identifiant interne de l'évènement
     * @param eventIdIn Integer
     */
    public void setEventId(Integer eventIdIn)
    {
        this.eventId = eventIdIn;
    }

    private String eventDc;

    /**
     * Description de l'évènement
     * @return this.eventDc String
     */
    public String getEventDc()
    {
        return this.eventDc;
    }

    /**
     * Description de l'évènement
     * @param eventDcIn String
     */
    public void setEventDc(String eventDcIn)
    {
        this.eventDc = eventDcIn;
    }

    private String eventCm;

    /**
     * Commentaire sur l'évènement
     * @return this.eventCm String
     */
    public String getEventCm()
    {
        return this.eventCm;
    }

    /**
     * Commentaire sur l'évènement
     * @param eventCmIn String
     */
    public void setEventCm(String eventCmIn)
    {
        this.eventCm = eventCmIn;
    }

    private Date eventStartDt;

    /**
     * Date de début de l'évèvnement
     * @return this.eventStartDt Date
     */
    public Date getEventStartDt()
    {
        return this.eventStartDt;
    }

    /**
     * Date de début de l'évèvnement
     * @param eventStartDtIn Date
     */
    public void setEventStartDt(Date eventStartDtIn)
    {
        this.eventStartDt = eventStartDtIn;
    }

    private Date eventEndDt;

    /**
     * Date de fin de l'évènement.
     * @return this.eventEndDt Date
     */
    public Date getEventEndDt()
    {
        return this.eventEndDt;
    }

    /**
     * Date de fin de l'évènement.
     * @param eventEndDtIn Date
     */
    public void setEventEndDt(Date eventEndDtIn)
    {
        this.eventEndDt = eventEndDtIn;
    }

    private String eventPositionCm;

    /**
     * Commentaire sur la localisation
     * @return this.eventPositionCm String
     */
    public String getEventPositionCm()
    {
        return this.eventPositionCm;
    }

    /**
     * Commentaire sur la localisation
     * @param eventPositionCmIn String
     */
    public void setEventPositionCm(String eventPositionCmIn)
    {
        this.eventPositionCm = eventPositionCmIn;
    }

    private Date eventCreationDt;

    /**
     * Date de création de l'objet, mise à jour par le système
     * @return this.eventCreationDt Date
     */
    public Date getEventCreationDt()
    {
        return this.eventCreationDt;
    }

    /**
     * Date de création de l'objet, mise à jour par le système
     * @param eventCreationDtIn Date
     */
    public void setEventCreationDt(Date eventCreationDtIn)
    {
        this.eventCreationDt = eventCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 7 associations
    private EventType eventType;

    /**
     * Liste des types d'évènement observables.
     * @return this.eventType EventType
     */
    public EventType getEventType()
    {
        return this.eventType;
    }

    /**
     * Liste des types d'évènement observables.
     * @param eventTypeIn EventType
     */
    public void setEventType(EventType eventTypeIn)
    {
        this.eventType = eventTypeIn;
    }

    private Collection<EventLine> eventLines = new HashSet<EventLine>();

    /**
     * Gestion de la géométrie linéaire des évènements.
     * @return this.eventLines Collection<EventLine>
     */
    public Collection<EventLine> getEventLines()
    {
        return this.eventLines;
    }

    /**
     * Gestion de la géométrie linéaire des évènements.
     * @param eventLinesIn Collection<EventLine>
     */
    public void setEventLines(Collection<EventLine> eventLinesIn)
    {
        this.eventLines = eventLinesIn;
    }

    /**
     * Gestion de la géométrie linéaire des évènements.
     * @param elementToAdd EventLine
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addEventLines(EventLine elementToAdd)
    {
        return this.eventLines.add(elementToAdd);
    }

    /**
     * Gestion de la géométrie linéaire des évènements.
     * @param elementToRemove EventLine
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeEventLines(EventLine elementToRemove)
    {
        return this.eventLines.remove(elementToRemove);
    }

    private Collection<EventPoint> eventPoints = new HashSet<EventPoint>();

    /**
     * Gestion de la géométrie ponctuelle des évènements.
     * @return this.eventPoints Collection<EventPoint>
     */
    public Collection<EventPoint> getEventPoints()
    {
        return this.eventPoints;
    }

    /**
     * Gestion de la géométrie ponctuelle des évènements.
     * @param eventPointsIn Collection<EventPoint>
     */
    public void setEventPoints(Collection<EventPoint> eventPointsIn)
    {
        this.eventPoints = eventPointsIn;
    }

    /**
     * Gestion de la géométrie ponctuelle des évènements.
     * @param elementToAdd EventPoint
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addEventPoints(EventPoint elementToAdd)
    {
        return this.eventPoints.add(elementToAdd);
    }

    /**
     * Gestion de la géométrie ponctuelle des évènements.
     * @param elementToRemove EventPoint
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeEventPoints(EventPoint elementToRemove)
    {
        return this.eventPoints.remove(elementToRemove);
    }

    private PositionningSystem positionningSystem;

    /**
     * Informations complémentaires sur le positionnement d'un objet.
     * @return this.positionningSystem PositionningSystem
     */
    public PositionningSystem getPositionningSystem()
    {
        return this.positionningSystem;
    }

    /**
     * Informations complémentaires sur le positionnement d'un objet.
     * @param positionningSystemIn PositionningSystem
     */
    public void setPositionningSystem(PositionningSystem positionningSystemIn)
    {
        this.positionningSystem = positionningSystemIn;
    }

    private Department recorderDepartment;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.recorderDepartment Department
     */
    public Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param recorderDepartmentIn Department
     */
    public void setRecorderDepartment(Department recorderDepartmentIn)
    {
        this.recorderDepartment = recorderDepartmentIn;
    }

    private Collection<Survey> surveys = new HashSet<Survey>();

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @return this.surveys Collection<Survey>
     */
    public Collection<Survey> getSurveys()
    {
        return this.surveys;
    }

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @param surveysIn Collection<Survey>
     */
    public void setSurveys(Collection<Survey> surveysIn)
    {
        this.surveys = surveysIn;
    }

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @param elementToAdd Survey
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSurveys(Survey elementToAdd)
    {
        return this.surveys.add(elementToAdd);
    }

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @param elementToRemove Survey
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSurveys(Survey elementToRemove)
    {
        return this.surveys.remove(elementToRemove);
    }

    private Collection<EventArea> eventAreas = new HashSet<EventArea>();

    /**
     * Gestion de la géométrie surfacique des évènements.
     * @return this.eventAreas Collection<EventArea>
     */
    public Collection<EventArea> getEventAreas()
    {
        return this.eventAreas;
    }

    /**
     * Gestion de la géométrie surfacique des évènements.
     * @param eventAreasIn Collection<EventArea>
     */
    public void setEventAreas(Collection<EventArea> eventAreasIn)
    {
        this.eventAreas = eventAreasIn;
    }

    /**
     * Gestion de la géométrie surfacique des évènements.
     * @param elementToAdd EventArea
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addEventAreas(EventArea elementToAdd)
    {
        return this.eventAreas.add(elementToAdd);
    }

    /**
     * Gestion de la géométrie surfacique des évènements.
     * @param elementToRemove EventArea
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeEventAreas(EventArea elementToRemove)
    {
        return this.eventAreas.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an Event instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Event))
        {
            return false;
        }
        final Event that = (Event)object;
        if (this.eventId == null || that.getEventId() == null || !this.eventId.equals(that.getEventId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.eventId == null ? 0 : this.eventId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Event}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Event}.
         * @return new EventImpl()
         */
        public static Event newInstance()
        {
            return new EventImpl();
        }

        /**
         * Constructs a new instance of {@link Event}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param eventDc String
         * @param eventStartDt Date
         * @param eventType EventType
         * @param recorderDepartment Department
         * @return newInstance
         */
        public static Event newInstance(String eventDc, Date eventStartDt, EventType eventType, Department recorderDepartment)
        {
            final Event entity = new EventImpl();
            entity.setEventDc(eventDc);
            entity.setEventStartDt(eventStartDt);
            entity.setEventType(eventType);
            entity.setRecorderDepartment(recorderDepartment);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Event}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param eventDc String
         * @param eventCm String
         * @param eventStartDt Date
         * @param eventEndDt Date
         * @param eventPositionCm String
         * @param eventCreationDt Date
         * @param updateDt Timestamp
         * @param remoteId Integer
         * @param eventType EventType
         * @param eventLines Collection<EventLine>
         * @param eventPoints Collection<EventPoint>
         * @param positionningSystem PositionningSystem
         * @param recorderDepartment Department
         * @param surveys Collection<Survey>
         * @param eventAreas Collection<EventArea>
         * @return newInstance Event
         */
        public static Event newInstance(String eventDc, String eventCm, Date eventStartDt, Date eventEndDt, String eventPositionCm, Date eventCreationDt, Timestamp updateDt, Integer remoteId, EventType eventType, Collection<EventLine> eventLines, Collection<EventPoint> eventPoints, PositionningSystem positionningSystem, Department recorderDepartment, Collection<Survey> surveys, Collection<EventArea> eventAreas)
        {
            final Event entity = new EventImpl();
            entity.setEventDc(eventDc);
            entity.setEventCm(eventCm);
            entity.setEventStartDt(eventStartDt);
            entity.setEventEndDt(eventEndDt);
            entity.setEventPositionCm(eventPositionCm);
            entity.setEventCreationDt(eventCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setRemoteId(remoteId);
            entity.setEventType(eventType);
            entity.setEventLines(eventLines);
            entity.setEventPoints(eventPoints);
            entity.setPositionningSystem(positionningSystem);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setSurveys(surveys);
            entity.setEventAreas(eventAreas);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Event o)
    {
        int cmp = 0;
        if (this.getEventId() != null)
        {
            cmp = this.getEventId().compareTo(o.getEventId());
        }
        else
        {
            if (this.getEventDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEventDc().compareTo(o.getEventDc()));
            }
            if (this.getEventCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEventCm().compareTo(o.getEventCm()));
            }
            if (this.getEventStartDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEventStartDt().compareTo(o.getEventStartDt()));
            }
            if (this.getEventEndDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEventEndDt().compareTo(o.getEventEndDt()));
            }
            if (this.getEventPositionCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEventPositionCm().compareTo(o.getEventPositionCm()));
            }
            if (this.getEventCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEventCreationDt().compareTo(o.getEventCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Event.java merge-point
}