// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/SpringHibernateDaoBase.vsl in <project>/mda/src/main/cartridge/custom/...
//
package fr.ifremer.quadrige3.core.dao.data.event;

import fr.ifremer.quadrige3.core.dao.PrincipalStore;
import fr.ifremer.quadrige3.core.dao.PropertySearch;
import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.referential.EventType;
import fr.ifremer.quadrige3.core.dao.technical.hibernate.HibernateDaoSupport;
import java.security.Principal;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import javax.annotation.Resource;
import org.andromda.spring.PaginationResult;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.Transformer;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.ScrollableResults;

/**
 * <p>
 * Base Spring DAO Class: is able to create, update, remove, load, and find
 * objects of type <code>Event</code>.
 * </p>
 *
 * @see Event
 */
public abstract class EventDaoBase
    extends HibernateDaoSupport    
    implements EventDao
{
    /**
     * {@inheritDoc}
     */
    @Override
    public Object get(final int transform, final Integer eventId)
    {
        if (eventId == null)
        {
            throw new IllegalArgumentException(
                "Event.get - 'eventId' can not be null");
        }
        final Event entity = get(EventImpl.class, eventId);
        return transformEntity(transform, entity);
    }
    /**
     * {@inheritDoc}
     */
    @Override
    public Event get(Integer eventId)
    {
        return (Event)this.get(TRANSFORM_NONE, eventId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object load(final int transform, final Integer eventId)
    {
        if (eventId == null)
        {
            throw new IllegalArgumentException(
                "Event.load - 'eventId' can not be null");
        }
        final Event entity = get(EventImpl.class, eventId);
        return transformEntity(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Event load(Integer eventId)
    {
        return (Event)this.load(TRANSFORM_NONE, eventId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<Event> loadAll()
    {
        return (Collection<Event>) this.loadAll(EventDao.TRANSFORM_NONE);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform)
    {
        return this.loadAll(transform, -1, -1);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int pageNumber, final int pageSize)
    {
        return this.loadAll(EventDao.TRANSFORM_NONE, pageNumber, pageSize);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize)
    {
        try
        {
            final Criteria criteria = this.getSession().createCriteria(EventImpl.class);
            if (pageNumber > 0 && pageSize > 0)
            {
                criteria.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                criteria.setMaxResults(pageSize);
            }
            final Collection<?> results = criteria.list();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex;
        }
    }

    /**
     * firstResult = (pageNumber - 1) * pageSize
     * @param pageNumber
     * @param pageSize
     * @return firstResult
     */
    protected int calculateFirstResult(int pageNumber, int pageSize)
    {
        int firstResult = 0;
        if (pageNumber > 0)
        {
            firstResult = (pageNumber - 1) * pageSize;
        }
        return firstResult;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Event create(Event event)
    {
        return (Event)this.create(EventDao.TRANSFORM_NONE, event);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(final int transform, final Event event)
    {
        if (event == null)
        {
            throw new IllegalArgumentException(
                "Event.create - 'event' can not be null");
        }
        this.getSessionFactory().getCurrentSession().save(event);
        return this.transformEntity(transform, event);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<Event> create(final Collection<Event> entities)
    {
        return (Collection<Event>) create(EventDao.TRANSFORM_NONE, entities);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> create(final int transform, final Collection<Event> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "Event.create - 'entities' can not be null");
        }
                    for (Event entity : entities)
                    {
                        create(transform, entity);
                    }
        return entities;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Event create(
        String eventDc,
        String eventCm,
        Date eventStartDt,
        Date eventEndDt,
        String eventPositionCm,
        Date eventCreationDt,
        Timestamp updateDt,
        Integer remoteId)
    {
        return (Event)this.create(EventDao.TRANSFORM_NONE, eventDc, eventCm, eventStartDt, eventEndDt, eventPositionCm, eventCreationDt, updateDt, remoteId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(
        final int transform,
        String eventDc,
        String eventCm,
        Date eventStartDt,
        Date eventEndDt,
        String eventPositionCm,
        Date eventCreationDt,
        Timestamp updateDt,
        Integer remoteId)
    {
        Event entity = new EventImpl();
        entity.setEventDc(eventDc);
        entity.setEventCm(eventCm);
        entity.setEventStartDt(eventStartDt);
        entity.setEventEndDt(eventEndDt);
        entity.setEventPositionCm(eventPositionCm);
        entity.setEventCreationDt(eventCreationDt);
        entity.setUpdateDt(updateDt);
        entity.setRemoteId(remoteId);
        return this.create(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Event create(
        String eventDc,
        Date eventStartDt,
        EventType eventType,
        Department recorderDepartment)
    {
        return (Event)this.create(EventDao.TRANSFORM_NONE, eventDc, eventStartDt, eventType, recorderDepartment);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(
        final int transform,
        String eventDc,
        Date eventStartDt,
        EventType eventType,
        Department recorderDepartment)
    {
        Event entity = new EventImpl();
        entity.setEventDc(eventDc);
        entity.setEventStartDt(eventStartDt);
        entity.setEventType(eventType);
        entity.setRecorderDepartment(recorderDepartment);
        return this.create(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(Event event)
    {
        if (event == null)
        {
            throw new IllegalArgumentException(
                "Event.update - 'event' can not be null");
        }
        this.getSessionFactory().getCurrentSession().update(event);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(final Collection<Event> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "Event.update - 'entities' can not be null");
        }
                    for (Event entity : entities)
                    {
                        update(entity);
                    }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Event event)
    {
        if (event == null)
        {
            throw new IllegalArgumentException(
                "Event.remove - 'event' can not be null");
        }
        this.getSessionFactory().getCurrentSession().delete(event);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Integer eventId)
    {
        if (eventId == null)
        {
            throw new IllegalArgumentException(
                "Event.remove - 'eventId' can not be null");
        }
        Event entity = this.get(eventId);
        if (entity != null)
        {
            this.remove(entity);
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Collection<Event> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "Event.remove - 'entities' can not be null");
        }
        deleteAll(entities);
    }
    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>EventDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link EventDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see EventDao#transformEntity(int, Event)
     */
    public Object transformEntity(final int transform, final Event entity)
    {
        Object target = null;
        if (entity != null)
        {
            switch (transform)
            {
                case EventDao.TRANSFORM_NONE : // fall-through
                default:
                    target = entity;
            }
        }
        return target;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void transformEntities(final int transform, final Collection<?> entities)
    {
        switch (transform)
        {
            case EventDao.TRANSFORM_NONE : // fall-through
                default:
                // do nothing;
        }
    }

    /**
     * @see EventDao#toEntities(Collection)
     */
    public void toEntities(final Collection<?> results)
    {
        if (results != null)
        {
            CollectionUtils.transform(results, this.ENTITYTRANSFORMER);
        }
    }

    /**
     * This anonymous transformer is designed to transform report query results
     * (which result in an array of entities) to {@link Event}
     * using the Jakarta Commons-Collections Transformation API.
     */
    private Transformer ENTITYTRANSFORMER =
        new Transformer()
        {
            public Object transform(Object input)
            {
                Object result = null;
                if (input instanceof Object[])
                {
                    result = toEntity((Object[])input);
                }
                else if (input instanceof Event)
                {
                    result = input;
                }
                return result;
            }
        };

    /**
     * @param row
     * @return Event
     */
    protected Event toEntity(Object[] row)
    {
        Event target = null;
        if (row != null)
        {
            final int numberOfObjects = row.length;
            for (int ctr = 0; ctr < numberOfObjects; ctr++)
            {
                final Object object = row[ctr];
                if (object instanceof Event)
                {
                    target = (Event)object;
                    break;
                }
            }
        }
        return target;
    }

    /**
     * Gets the current <code>principal</code> if one has been set,
     * otherwise returns <code>null</code>.
     *
     * @return the current principal
     */
    protected Principal getPrincipal()
    {
        return PrincipalStore.get();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({ "unchecked" })
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search)
    {
        try
        {
            search.setPageNumber(pageNumber);
            search.setPageSize(pageSize);
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), EventImpl.class, search);
            final List results = propertySearch.executeAsList();
            this.transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), propertySearch.getTotalCount());
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search)
    {
        return this.search(EventDao.TRANSFORM_NONE, pageNumber, pageSize, search);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Set<?> search(final int transform, final Search search)
    {
        try
        {
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), EventImpl.class, search);
            final Set<?> results = propertySearch.executeAsSet();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings("unchecked")
    public Set<Event> search(final Search search)
    {
        return (Set<Event>) this.search(EventDao.TRANSFORM_NONE, search);
    }

    /**
     * Executes and returns the given Hibernate queryObject as a {@link PaginationResult} instance.
     * @param queryObject
     * @param transform
     * @param pageNumber
     * @param pageSize
     * @return PaginationResult
     */
    @SuppressWarnings({ "unchecked" })
    protected PaginationResult getPaginationResult(
        final Query queryObject,
        final int transform, int pageNumber, int pageSize)
    {
        try
        {
            final ScrollableResults scrollableResults = queryObject.scroll();
            scrollableResults.last();
            int totalCount = scrollableResults.getRowNumber();
            totalCount = totalCount >= 0 ? totalCount + 1 : 0;
            if (pageNumber > 0 && pageSize > 0)
            {
                queryObject.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                queryObject.setMaxResults(pageSize);
            }
            // Unchecked transformation because Set object is reused, cannot be strongly typed.
            Set results = new LinkedHashSet(queryObject.list());
            transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), totalCount);
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    // spring-hibernate-dao-base merge-point
}