// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.measurement;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.ObjectType;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Pmfm;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Résultat de mesure faisant l'objet d'une mesure unique pour un taxon, ou un regroupement de taxon
 * particulier.
 * @see TaxonMeasurement
 */
public interface TaxonMeasurementDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link TaxonMeasurement}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of TaxonMeasurement from the persistent store.
     * @param taxonMeasId
     * @return TaxonMeasurement
     */
    public TaxonMeasurement get(Integer taxonMeasId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param taxonMeasId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer taxonMeasId);

    /**
     * Loads an instance of TaxonMeasurement from the persistent store.
     * @param taxonMeasId
     * @return TaxonMeasurement
     */
    public TaxonMeasurement load(Integer taxonMeasId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param taxonMeasId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer taxonMeasId);

    /**
     * Loads all entities of type {@link TaxonMeasurement}.
     *
     * @return the loaded entities.
     */
    public Collection<TaxonMeasurement> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of TaxonMeasurement and adds it to the persistent store.
     * @param taxonMeasurement
     * @return TaxonMeasurement
     */
    public TaxonMeasurement create(TaxonMeasurement taxonMeasurement);

    /**
     * <p>
     * Does the same thing as {@link #create(TaxonMeasurement)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param taxonMeasurement
     * @return Object
     */
    public Object create(int transform, TaxonMeasurement taxonMeasurement);

    /**
     * Creates a new instance of TaxonMeasurement and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of TaxonMeasurement
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<TaxonMeasurement> create(Collection<TaxonMeasurement> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(TaxonMeasurement)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<TaxonMeasurement> entities);

    /**
     * <p>
     * Creates a new <code>TaxonMeasurement</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param objectId Identifiant interne de donnnée in situ de référence (passage, prélèvement, prélèvement)
     * @param taxonMeasIndivId Le numéro de l'individu mesuré pour les résultats sur taxon ayant plusieurs individus
     * @param taxonMeasNumerValue La valeur du résultat si elle n'est pas qualitative
     * @param taxonMeasPrecisionValue La valeur de l'incertitude. Ex : 2 (%) ou 0,01 (dégrés)
     * @param taxonMeasDigitNumber Nombre de chiffre après la virgule du résulat. Ex : si on saisit 10.00, il faut conserver 2 comme
information
     * @param taxonMeasControlDt Date de contrôle
     * @param taxonMeasValidDt Date de validation
     * @param taxonMeasQualifDt Date de la qualification du résultat
     * @param taxonMeasQualifCm Commentaire sur la qualification du résultat
Un commentaire de qualification est obligatoire si la mesure est douteuse ou mauvaise.
     * @param taxonMeasCm Commentaire sur le résultat sur taxon
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param taxonNameId Identifiant interne du taxon cité (Utilisé par BD Recif pour stocker l'identifiant du taxon saisi
par l'utilisateur)
     * @param taxonNameNm Nom scientifique du taxon cité (Utilisé par BD Recif pour stocker le libellé du taxon saisi par
l'utilisateur)
     * @param remoteId 
     * @return TaxonMeasurement
     */
    public TaxonMeasurement create(
        Integer objectId,
        Integer taxonMeasIndivId,
        Float taxonMeasNumerValue,
        Float taxonMeasPrecisionValue,
        Integer taxonMeasDigitNumber,
        Date taxonMeasControlDt,
        Date taxonMeasValidDt,
        Date taxonMeasQualifDt,
        String taxonMeasQualifCm,
        String taxonMeasCm,
        Timestamp updateDt,
        Integer taxonNameId,
        String taxonNameNm,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(Integer, Integer, Float, Float, Integer, Date, Date, Date, String, String, Timestamp, Integer, String, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param objectId Identifiant interne de donnnée in situ de référence (passage, prélèvement, prélèvement)
     * @param taxonMeasIndivId Le numéro de l'individu mesuré pour les résultats sur taxon ayant plusieurs individus
     * @param taxonMeasNumerValue La valeur du résultat si elle n'est pas qualitative
     * @param taxonMeasPrecisionValue La valeur de l'incertitude. Ex : 2 (%) ou 0,01 (dégrés)
     * @param taxonMeasDigitNumber Nombre de chiffre après la virgule du résulat. Ex : si on saisit 10.00, il faut conserver 2 comme
information
     * @param taxonMeasControlDt Date de contrôle
     * @param taxonMeasValidDt Date de validation
     * @param taxonMeasQualifDt Date de la qualification du résultat
     * @param taxonMeasQualifCm Commentaire sur la qualification du résultat
Un commentaire de qualification est obligatoire si la mesure est douteuse ou mauvaise.
     * @param taxonMeasCm Commentaire sur le résultat sur taxon
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param taxonNameId Identifiant interne du taxon cité (Utilisé par BD Recif pour stocker l'identifiant du taxon saisi
par l'utilisateur)
     * @param taxonNameNm Nom scientifique du taxon cité (Utilisé par BD Recif pour stocker le libellé du taxon saisi par
l'utilisateur)
     * @param remoteId 
     * @return TaxonMeasurement
     */
    public Object create(
        int transform,
        Integer objectId,
        Integer taxonMeasIndivId,
        Float taxonMeasNumerValue,
        Float taxonMeasPrecisionValue,
        Integer taxonMeasDigitNumber,
        Date taxonMeasControlDt,
        Date taxonMeasValidDt,
        Date taxonMeasQualifDt,
        String taxonMeasQualifCm,
        String taxonMeasCm,
        Timestamp updateDt,
        Integer taxonNameId,
        String taxonNameNm,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>TaxonMeasurement</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param objectId
     * @param objectType
     * @param pmfm
     * @param qualityFlag
     * @return TaxonMeasurement
     */
    public TaxonMeasurement create(
        Integer objectId,
        ObjectType objectType,
        Pmfm pmfm,
        QualityFlag qualityFlag);

    /**
     * <p>
     * Does the same thing as {@link #create(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param objectId
     * @param objectType
     * @param pmfm
     * @param qualityFlag
     * @return Object
     */
    public Object create(
        int transform,
        Integer objectId,
        ObjectType objectType,
        Pmfm pmfm,
        QualityFlag qualityFlag);

    /**
     * Updates the <code>taxonMeasurement</code> instance in the persistent store.
     * @param taxonMeasurement
     */
    public void update(TaxonMeasurement taxonMeasurement);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<TaxonMeasurement> entities);

    /**
     * Removes the instance of TaxonMeasurement from the persistent store.
     * @param taxonMeasurement
     */
    public void remove(TaxonMeasurement taxonMeasurement);

    /**
     * Removes the instance of TaxonMeasurement having the given
     * <code>identifier</code> from the persistent store.
     * @param taxonMeasId
     */
    public void remove(Integer taxonMeasId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<TaxonMeasurement> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<TaxonMeasurement> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.data.measurement.TaxonMeasurementDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.data.measurement.TaxonMeasurementDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final TaxonMeasurement entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,TaxonMeasurement)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.data.measurement.TaxonMeasurementDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,TaxonMeasurement)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}