// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/SpringHibernateDaoBase.vsl in <project>/mda/src/main/cartridge/custom/...
//
package fr.ifremer.quadrige3.core.dao.data.measurement;

import fr.ifremer.quadrige3.core.dao.PrincipalStore;
import fr.ifremer.quadrige3.core.dao.PropertySearch;
import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.ObjectType;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.quadrige3.core.dao.technical.hibernate.HibernateDaoSupport;
import java.security.Principal;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import javax.annotation.Resource;
import org.andromda.spring.PaginationResult;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.Transformer;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.ScrollableResults;

/**
 * <p>
 * Base Spring DAO Class: is able to create, update, remove, load, and find
 * objects of type <code>TaxonMeasurement</code>.
 * </p>
 *
 * @see TaxonMeasurement
 */
public abstract class TaxonMeasurementDaoBase
    extends HibernateDaoSupport    
    implements TaxonMeasurementDao
{
    /**
     * {@inheritDoc}
     */
    @Override
    public Object get(final int transform, final Integer taxonMeasId)
    {
        if (taxonMeasId == null)
        {
            throw new IllegalArgumentException(
                "TaxonMeasurement.get - 'taxonMeasId' can not be null");
        }
        final TaxonMeasurement entity = get(TaxonMeasurementImpl.class, taxonMeasId);
        return transformEntity(transform, entity);
    }
    /**
     * {@inheritDoc}
     */
    @Override
    public TaxonMeasurement get(Integer taxonMeasId)
    {
        return (TaxonMeasurement)this.get(TRANSFORM_NONE, taxonMeasId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object load(final int transform, final Integer taxonMeasId)
    {
        if (taxonMeasId == null)
        {
            throw new IllegalArgumentException(
                "TaxonMeasurement.load - 'taxonMeasId' can not be null");
        }
        final TaxonMeasurement entity = get(TaxonMeasurementImpl.class, taxonMeasId);
        return transformEntity(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TaxonMeasurement load(Integer taxonMeasId)
    {
        return (TaxonMeasurement)this.load(TRANSFORM_NONE, taxonMeasId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<TaxonMeasurement> loadAll()
    {
        return (Collection<TaxonMeasurement>) this.loadAll(TaxonMeasurementDao.TRANSFORM_NONE);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform)
    {
        return this.loadAll(transform, -1, -1);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int pageNumber, final int pageSize)
    {
        return this.loadAll(TaxonMeasurementDao.TRANSFORM_NONE, pageNumber, pageSize);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize)
    {
        try
        {
            final Criteria criteria = this.getSession().createCriteria(TaxonMeasurementImpl.class);
            if (pageNumber > 0 && pageSize > 0)
            {
                criteria.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                criteria.setMaxResults(pageSize);
            }
            final Collection<?> results = criteria.list();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex;
        }
    }

    /**
     * firstResult = (pageNumber - 1) * pageSize
     * @param pageNumber
     * @param pageSize
     * @return firstResult
     */
    protected int calculateFirstResult(int pageNumber, int pageSize)
    {
        int firstResult = 0;
        if (pageNumber > 0)
        {
            firstResult = (pageNumber - 1) * pageSize;
        }
        return firstResult;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TaxonMeasurement create(TaxonMeasurement taxonMeasurement)
    {
        return (TaxonMeasurement)this.create(TaxonMeasurementDao.TRANSFORM_NONE, taxonMeasurement);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(final int transform, final TaxonMeasurement taxonMeasurement)
    {
        if (taxonMeasurement == null)
        {
            throw new IllegalArgumentException(
                "TaxonMeasurement.create - 'taxonMeasurement' can not be null");
        }
        this.getSessionFactory().getCurrentSession().save(taxonMeasurement);
        return this.transformEntity(transform, taxonMeasurement);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<TaxonMeasurement> create(final Collection<TaxonMeasurement> entities)
    {
        return (Collection<TaxonMeasurement>) create(TaxonMeasurementDao.TRANSFORM_NONE, entities);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> create(final int transform, final Collection<TaxonMeasurement> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "TaxonMeasurement.create - 'entities' can not be null");
        }
                    for (TaxonMeasurement entity : entities)
                    {
                        create(transform, entity);
                    }
        return entities;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TaxonMeasurement create(
        Integer objectId,
        Integer taxonMeasIndivId,
        Float taxonMeasNumerValue,
        Float taxonMeasPrecisionValue,
        Integer taxonMeasDigitNumber,
        Date taxonMeasControlDt,
        Date taxonMeasValidDt,
        Date taxonMeasQualifDt,
        String taxonMeasQualifCm,
        String taxonMeasCm,
        Timestamp updateDt,
        Integer taxonNameId,
        String taxonNameNm,
        Integer remoteId)
    {
        return (TaxonMeasurement)this.create(TaxonMeasurementDao.TRANSFORM_NONE, objectId, taxonMeasIndivId, taxonMeasNumerValue, taxonMeasPrecisionValue, taxonMeasDigitNumber, taxonMeasControlDt, taxonMeasValidDt, taxonMeasQualifDt, taxonMeasQualifCm, taxonMeasCm, updateDt, taxonNameId, taxonNameNm, remoteId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(
        final int transform,
        Integer objectId,
        Integer taxonMeasIndivId,
        Float taxonMeasNumerValue,
        Float taxonMeasPrecisionValue,
        Integer taxonMeasDigitNumber,
        Date taxonMeasControlDt,
        Date taxonMeasValidDt,
        Date taxonMeasQualifDt,
        String taxonMeasQualifCm,
        String taxonMeasCm,
        Timestamp updateDt,
        Integer taxonNameId,
        String taxonNameNm,
        Integer remoteId)
    {
        TaxonMeasurement entity = new TaxonMeasurementImpl();
        entity.setObjectId(objectId);
        entity.setTaxonMeasIndivId(taxonMeasIndivId);
        entity.setTaxonMeasNumerValue(taxonMeasNumerValue);
        entity.setTaxonMeasPrecisionValue(taxonMeasPrecisionValue);
        entity.setTaxonMeasDigitNumber(taxonMeasDigitNumber);
        entity.setTaxonMeasControlDt(taxonMeasControlDt);
        entity.setTaxonMeasValidDt(taxonMeasValidDt);
        entity.setTaxonMeasQualifDt(taxonMeasQualifDt);
        entity.setTaxonMeasQualifCm(taxonMeasQualifCm);
        entity.setTaxonMeasCm(taxonMeasCm);
        entity.setUpdateDt(updateDt);
        entity.setTaxonNameId(taxonNameId);
        entity.setTaxonNameNm(taxonNameNm);
        entity.setRemoteId(remoteId);
        return this.create(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TaxonMeasurement create(
        Integer objectId,
        ObjectType objectType,
        Pmfm pmfm,
        QualityFlag qualityFlag)
    {
        return (TaxonMeasurement)this.create(TaxonMeasurementDao.TRANSFORM_NONE, objectId, objectType, pmfm, qualityFlag);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(
        final int transform,
        Integer objectId,
        ObjectType objectType,
        Pmfm pmfm,
        QualityFlag qualityFlag)
    {
        TaxonMeasurement entity = new TaxonMeasurementImpl();
        entity.setObjectId(objectId);
        entity.setObjectType(objectType);
        entity.setPmfm(pmfm);
        entity.setQualityFlag(qualityFlag);
        return this.create(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(TaxonMeasurement taxonMeasurement)
    {
        if (taxonMeasurement == null)
        {
            throw new IllegalArgumentException(
                "TaxonMeasurement.update - 'taxonMeasurement' can not be null");
        }
        this.getSessionFactory().getCurrentSession().update(taxonMeasurement);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(final Collection<TaxonMeasurement> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "TaxonMeasurement.update - 'entities' can not be null");
        }
                    for (TaxonMeasurement entity : entities)
                    {
                        update(entity);
                    }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(TaxonMeasurement taxonMeasurement)
    {
        if (taxonMeasurement == null)
        {
            throw new IllegalArgumentException(
                "TaxonMeasurement.remove - 'taxonMeasurement' can not be null");
        }
        this.getSessionFactory().getCurrentSession().delete(taxonMeasurement);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Integer taxonMeasId)
    {
        if (taxonMeasId == null)
        {
            throw new IllegalArgumentException(
                "TaxonMeasurement.remove - 'taxonMeasId' can not be null");
        }
        TaxonMeasurement entity = this.get(taxonMeasId);
        if (entity != null)
        {
            this.remove(entity);
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Collection<TaxonMeasurement> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "TaxonMeasurement.remove - 'entities' can not be null");
        }
        deleteAll(entities);
    }
    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>TaxonMeasurementDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link TaxonMeasurementDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see TaxonMeasurementDao#transformEntity(int, TaxonMeasurement)
     */
    public Object transformEntity(final int transform, final TaxonMeasurement entity)
    {
        Object target = null;
        if (entity != null)
        {
            switch (transform)
            {
                case TaxonMeasurementDao.TRANSFORM_NONE : // fall-through
                default:
                    target = entity;
            }
        }
        return target;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void transformEntities(final int transform, final Collection<?> entities)
    {
        switch (transform)
        {
            case TaxonMeasurementDao.TRANSFORM_NONE : // fall-through
                default:
                // do nothing;
        }
    }

    /**
     * @see TaxonMeasurementDao#toEntities(Collection)
     */
    public void toEntities(final Collection<?> results)
    {
        if (results != null)
        {
            CollectionUtils.transform(results, this.ENTITYTRANSFORMER);
        }
    }

    /**
     * This anonymous transformer is designed to transform report query results
     * (which result in an array of entities) to {@link TaxonMeasurement}
     * using the Jakarta Commons-Collections Transformation API.
     */
    private Transformer ENTITYTRANSFORMER =
        new Transformer()
        {
            public Object transform(Object input)
            {
                Object result = null;
                if (input instanceof Object[])
                {
                    result = toEntity((Object[])input);
                }
                else if (input instanceof TaxonMeasurement)
                {
                    result = input;
                }
                return result;
            }
        };

    /**
     * @param row
     * @return TaxonMeasurement
     */
    protected TaxonMeasurement toEntity(Object[] row)
    {
        TaxonMeasurement target = null;
        if (row != null)
        {
            final int numberOfObjects = row.length;
            for (int ctr = 0; ctr < numberOfObjects; ctr++)
            {
                final Object object = row[ctr];
                if (object instanceof TaxonMeasurement)
                {
                    target = (TaxonMeasurement)object;
                    break;
                }
            }
        }
        return target;
    }

    /**
     * Gets the current <code>principal</code> if one has been set,
     * otherwise returns <code>null</code>.
     *
     * @return the current principal
     */
    protected Principal getPrincipal()
    {
        return PrincipalStore.get();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({ "unchecked" })
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search)
    {
        try
        {
            search.setPageNumber(pageNumber);
            search.setPageSize(pageSize);
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), TaxonMeasurementImpl.class, search);
            final List results = propertySearch.executeAsList();
            this.transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), propertySearch.getTotalCount());
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search)
    {
        return this.search(TaxonMeasurementDao.TRANSFORM_NONE, pageNumber, pageSize, search);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Set<?> search(final int transform, final Search search)
    {
        try
        {
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), TaxonMeasurementImpl.class, search);
            final Set<?> results = propertySearch.executeAsSet();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings("unchecked")
    public Set<TaxonMeasurement> search(final Search search)
    {
        return (Set<TaxonMeasurement>) this.search(TaxonMeasurementDao.TRANSFORM_NONE, search);
    }

    /**
     * Executes and returns the given Hibernate queryObject as a {@link PaginationResult} instance.
     * @param queryObject
     * @param transform
     * @param pageNumber
     * @param pageSize
     * @return PaginationResult
     */
    @SuppressWarnings({ "unchecked" })
    protected PaginationResult getPaginationResult(
        final Query queryObject,
        final int transform, int pageNumber, int pageSize)
    {
        try
        {
            final ScrollableResults scrollableResults = queryObject.scroll();
            scrollableResults.last();
            int totalCount = scrollableResults.getRowNumber();
            totalCount = totalCount >= 0 ? totalCount + 1 : 0;
            if (pageNumber > 0 && pageSize > 0)
            {
                queryObject.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                queryObject.setMaxResults(pageSize);
            }
            // Unchecked transformation because Set object is reused, cannot be strongly typed.
            Set results = new LinkedHashSet(queryObject.list());
            transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), totalCount);
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    // spring-hibernate-dao-base merge-point
}