// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.photo;

import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.data.sample.Sample;
import fr.ifremer.quadrige3.core.dao.data.samplingoperation.SamplingOperation;
import fr.ifremer.quadrige3.core.dao.data.survey.Survey;
import fr.ifremer.quadrige3.core.dao.referential.ObjectType;
import fr.ifremer.quadrige3.core.dao.referential.PhotoType;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Liste les photos illustrant les passages, prélèvement, échantillon, taxon, .
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Photo
    implements Serializable, Comparable<Photo>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1034938653766129666L;

    // Generate 12 attributes
    private Integer photoId;

    /**
     * Identifiant interne de la photo
     * @return this.photoId Integer
     */
    public Integer getPhotoId()
    {
        return this.photoId;
    }

    /**
     * Identifiant interne de la photo
     * @param photoIdIn Integer
     */
    public void setPhotoId(Integer photoIdIn)
    {
        this.photoId = photoIdIn;
    }

    private Integer objectId;

    /**
     * Identifiant de l'objet photographié
     * @return this.objectId Integer
     */
    public Integer getObjectId()
    {
        return this.objectId;
    }

    /**
     * Identifiant de l'objet photographié
     * @param objectIdIn Integer
     */
    public void setObjectId(Integer objectIdIn)
    {
        this.objectId = objectIdIn;
    }

    private String photoNm;

    /**
     * Libellé de la photo
     * @return this.photoNm String
     */
    public String getPhotoNm()
    {
        return this.photoNm;
    }

    /**
     * Libellé de la photo
     * @param photoNmIn String
     */
    public void setPhotoNm(String photoNmIn)
    {
        this.photoNm = photoNmIn;
    }

    private String photoDirDc;

    /**
     * Description de la direction de la photo
     * @return this.photoDirDc String
     */
    public String getPhotoDirDc()
    {
        return this.photoDirDc;
    }

    /**
     * Description de la direction de la photo
     * @param photoDirDcIn String
     */
    public void setPhotoDirDc(String photoDirDcIn)
    {
        this.photoDirDc = photoDirDcIn;
    }

    private String photoCm;

    /**
     * Commentaire associé à la photo
     * @return this.photoCm String
     */
    public String getPhotoCm()
    {
        return this.photoCm;
    }

    /**
     * Commentaire associé à la photo
     * @param photoCmIn String
     */
    public void setPhotoCm(String photoCmIn)
    {
        this.photoCm = photoCmIn;
    }

    private String photoLk;

    /**
     * Adresse du fichier photo, cette adresse est une adresse relative par rapport à une racine
     * définie dans l'environnement Quadrige. Cette adresse est renseignée par le système et n'est
     * pas modifiable par l'utilisateur.
     * @return this.photoLk String
     */
    public String getPhotoLk()
    {
        return this.photoLk;
    }

    /**
     * Adresse du fichier photo, cette adresse est une adresse relative par rapport à une racine
     * définie dans l'environnement Quadrige. Cette adresse est renseignée par le système et n'est
     * pas modifiable par l'utilisateur.
     * @param photoLkIn String
     */
    public void setPhotoLk(String photoLkIn)
    {
        this.photoLk = photoLkIn;
    }

    private Date photoDt;

    /**
     * Date de prise de la photo optionnel
     * @return this.photoDt Date
     */
    public Date getPhotoDt()
    {
        return this.photoDt;
    }

    /**
     * Date de prise de la photo optionnel
     * @param photoDtIn Date
     */
    public void setPhotoDt(Date photoDtIn)
    {
        this.photoDt = photoDtIn;
    }

    private Date photoValidDt;

    /**
     * Date de validation
     * @return this.photoValidDt Date
     */
    public Date getPhotoValidDt()
    {
        return this.photoValidDt;
    }

    /**
     * Date de validation
     * @param photoValidDtIn Date
     */
    public void setPhotoValidDt(Date photoValidDtIn)
    {
        this.photoValidDt = photoValidDtIn;
    }

    private Date photoQualifDt;

    /**
     * Date de qualification de la photo
     * @return this.photoQualifDt Date
     */
    public Date getPhotoQualifDt()
    {
        return this.photoQualifDt;
    }

    /**
     * Date de qualification de la photo
     * @param photoQualifDtIn Date
     */
    public void setPhotoQualifDt(Date photoQualifDtIn)
    {
        this.photoQualifDt = photoQualifDtIn;
    }

    private String photoQualifCm;

    /**
     * Commentaire sur la qualification de la photo
     * @return this.photoQualifCm String
     */
    public String getPhotoQualifCm()
    {
        return this.photoQualifCm;
    }

    /**
     * Commentaire sur la qualification de la photo
     * @param photoQualifCmIn String
     */
    public void setPhotoQualifCm(String photoQualifCmIn)
    {
        this.photoQualifCm = photoQualifCmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 7 associations
    private Sample sample;

    /**
     * Liste les échantillons prélevés lors d'un passage sur un lieu de surveillance.
     * @return this.sample Sample
     */
    public Sample getSample()
    {
        return this.sample;
    }

    /**
     * Liste les échantillons prélevés lors d'un passage sur un lieu de surveillance.
     * @param sampleIn Sample
     */
    public void setSample(Sample sampleIn)
    {
        this.sample = sampleIn;
    }

    private PhotoType photoType;

    /**
     * Liste les types des photo (voir avec niveau saisie).
     * @return this.photoType PhotoType
     */
    public PhotoType getPhotoType()
    {
        return this.photoType;
    }

    /**
     * Liste les types des photo (voir avec niveau saisie).
     * @param photoTypeIn PhotoType
     */
    public void setPhotoType(PhotoType photoTypeIn)
    {
        this.photoType = photoTypeIn;
    }

    private QualityFlag qualityFlag;

    /**
     * Liste des niveaux de qualification.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Liste des niveaux de qualification.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private ObjectType objectType;

    /**
     * Liste des types d'objets qui peuvent être associés à la photo ou à un résultat. Cette liste
     * ne peut
     * pas être modifiée par l'utilisateur.
     * @return this.objectType ObjectType
     */
    public ObjectType getObjectType()
    {
        return this.objectType;
    }

    /**
     * Liste des types d'objets qui peuvent être associés à la photo ou à un résultat. Cette liste
     * ne peut
     * pas être modifiée par l'utilisateur.
     * @param objectTypeIn ObjectType
     */
    public void setObjectType(ObjectType objectTypeIn)
    {
        this.objectType = objectTypeIn;
    }

    private Department recorderDepartment;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.recorderDepartment Department
     */
    public Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param recorderDepartmentIn Department
     */
    public void setRecorderDepartment(Department recorderDepartmentIn)
    {
        this.recorderDepartment = recorderDepartmentIn;
    }

    private Survey survey;

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @return this.survey Survey
     */
    public Survey getSurvey()
    {
        return this.survey;
    }

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @param surveyIn Survey
     */
    public void setSurvey(Survey surveyIn)
    {
        this.survey = surveyIn;
    }

    private SamplingOperation samplingOperation;

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @return this.samplingOperation SamplingOperation
     */
    public SamplingOperation getSamplingOperation()
    {
        return this.samplingOperation;
    }

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @param samplingOperationIn SamplingOperation
     */
    public void setSamplingOperation(SamplingOperation samplingOperationIn)
    {
        this.samplingOperation = samplingOperationIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Photo instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Photo))
        {
            return false;
        }
        final Photo that = (Photo)object;
        if (this.photoId == null || that.getPhotoId() == null || !this.photoId.equals(that.getPhotoId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.photoId == null ? 0 : this.photoId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Photo}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Photo}.
         * @return new PhotoImpl()
         */
        public static Photo newInstance()
        {
            return new PhotoImpl();
        }

        /**
         * Constructs a new instance of {@link Photo}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param objectId Integer
         * @param objectType ObjectType
         * @param recorderDepartment Department
         * @return newInstance
         */
        public static Photo newInstance(Integer objectId, ObjectType objectType, Department recorderDepartment)
        {
            final Photo entity = new PhotoImpl();
            entity.setObjectId(objectId);
            entity.setObjectType(objectType);
            entity.setRecorderDepartment(recorderDepartment);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Photo}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param objectId Integer
         * @param photoNm String
         * @param photoDirDc String
         * @param photoCm String
         * @param photoLk String
         * @param photoDt Date
         * @param photoValidDt Date
         * @param photoQualifDt Date
         * @param photoQualifCm String
         * @param updateDt Timestamp
         * @param remoteId Integer
         * @param sample Sample
         * @param photoType PhotoType
         * @param qualityFlag QualityFlag
         * @param objectType ObjectType
         * @param recorderDepartment Department
         * @param survey Survey
         * @param samplingOperation SamplingOperation
         * @return newInstance Photo
         */
        public static Photo newInstance(Integer objectId, String photoNm, String photoDirDc, String photoCm, String photoLk, Date photoDt, Date photoValidDt, Date photoQualifDt, String photoQualifCm, Timestamp updateDt, Integer remoteId, Sample sample, PhotoType photoType, QualityFlag qualityFlag, ObjectType objectType, Department recorderDepartment, Survey survey, SamplingOperation samplingOperation)
        {
            final Photo entity = new PhotoImpl();
            entity.setObjectId(objectId);
            entity.setPhotoNm(photoNm);
            entity.setPhotoDirDc(photoDirDc);
            entity.setPhotoCm(photoCm);
            entity.setPhotoLk(photoLk);
            entity.setPhotoDt(photoDt);
            entity.setPhotoValidDt(photoValidDt);
            entity.setPhotoQualifDt(photoQualifDt);
            entity.setPhotoQualifCm(photoQualifCm);
            entity.setUpdateDt(updateDt);
            entity.setRemoteId(remoteId);
            entity.setSample(sample);
            entity.setPhotoType(photoType);
            entity.setQualityFlag(qualityFlag);
            entity.setObjectType(objectType);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setSurvey(survey);
            entity.setSamplingOperation(samplingOperation);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Photo o)
    {
        int cmp = 0;
        if (this.getPhotoId() != null)
        {
            cmp = this.getPhotoId().compareTo(o.getPhotoId());
        }
        else
        {
            if (this.getObjectId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectId().compareTo(o.getObjectId()));
            }
            if (this.getPhotoNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPhotoNm().compareTo(o.getPhotoNm()));
            }
            if (this.getPhotoDirDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPhotoDirDc().compareTo(o.getPhotoDirDc()));
            }
            if (this.getPhotoCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPhotoCm().compareTo(o.getPhotoCm()));
            }
            if (this.getPhotoLk() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPhotoLk().compareTo(o.getPhotoLk()));
            }
            if (this.getPhotoDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPhotoDt().compareTo(o.getPhotoDt()));
            }
            if (this.getPhotoValidDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPhotoValidDt().compareTo(o.getPhotoValidDt()));
            }
            if (this.getPhotoQualifDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPhotoQualifDt().compareTo(o.getPhotoQualifDt()));
            }
            if (this.getPhotoQualifCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPhotoQualifCm().compareTo(o.getPhotoQualifCm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Photo.java merge-point
}