// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.sample;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.data.samplingoperation.SamplingOperation;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Matrix;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Liste les échantillons prélevés lors d'un passage sur un lieu de surveillance.
 * @see Sample
 */
public interface SampleDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Sample}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of Sample from the persistent store.
     * @param sampleId
     * @return Sample
     */
    public Sample get(Integer sampleId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param sampleId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer sampleId);

    /**
     * Loads an instance of Sample from the persistent store.
     * @param sampleId
     * @return Sample
     */
    public Sample load(Integer sampleId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param sampleId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer sampleId);

    /**
     * Loads all entities of type {@link Sample}.
     *
     * @return the loaded entities.
     */
    public Collection<Sample> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Sample and adds it to the persistent store.
     * @param sample
     * @return Sample
     */
    public Sample create(Sample sample);

    /**
     * <p>
     * Does the same thing as {@link #create(Sample)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param sample
     * @return Object
     */
    public Object create(int transform, Sample sample);

    /**
     * Creates a new instance of Sample and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Sample
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Sample> create(Collection<Sample> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Sample)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Sample> entities);

    /**
     * <p>
     * Creates a new <code>Sample</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param sampleLb Mmnémonique de l'échantillon
     * @param sampleNumberIndiv Nombre d'individus constituant l'échantillon. Ce nombre permet de connaître le nombre d'individus
constituant la grille de saisie.
     * @param sampleSize La taille de l'échantillon peut représenter une surface ou un volume suivant les cas. Il peut aussi
s'agir du nombre d'individus entrant dans l'homogénat.
     * @param sampleCm Commentaire de l'échantillon
     * @param sampleControlDt Date de contrôle de l'échantillon
     * @param sampleValidDt Date de validation de l'échantillon
     * @param sampleQualifDt Date de qualification de l'échantillon
     * @param sampleQualifCm Commentaire de qualification
     * @param sampleScope Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont pas la
même étape
     * @param sampleHasMeas Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param remoteId 
     * @return Sample
     */
    public Sample create(
        String sampleLb,
        Integer sampleNumberIndiv,
        Float sampleSize,
        String sampleCm,
        Date sampleControlDt,
        Date sampleValidDt,
        Date sampleQualifDt,
        String sampleQualifCm,
        String sampleScope,
        String sampleHasMeas,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Integer, Float, String, Date, Date, Date, String, String, String, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param sampleLb Mmnémonique de l'échantillon
     * @param sampleNumberIndiv Nombre d'individus constituant l'échantillon. Ce nombre permet de connaître le nombre d'individus
constituant la grille de saisie.
     * @param sampleSize La taille de l'échantillon peut représenter une surface ou un volume suivant les cas. Il peut aussi
s'agir du nombre d'individus entrant dans l'homogénat.
     * @param sampleCm Commentaire de l'échantillon
     * @param sampleControlDt Date de contrôle de l'échantillon
     * @param sampleValidDt Date de validation de l'échantillon
     * @param sampleQualifDt Date de qualification de l'échantillon
     * @param sampleQualifCm Commentaire de qualification
     * @param sampleScope Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont pas la
même étape
     * @param sampleHasMeas Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param remoteId 
     * @return Sample
     */
    public Object create(
        int transform,
        String sampleLb,
        Integer sampleNumberIndiv,
        Float sampleSize,
        String sampleCm,
        Date sampleControlDt,
        Date sampleValidDt,
        Date sampleQualifDt,
        String sampleQualifCm,
        String sampleScope,
        String sampleHasMeas,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>Sample</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param recorderDepartment
     * @param matrix
     * @param qualityFlag
     * @param samplingOperation
     * @return Sample
     */
    public Sample create(
        Department recorderDepartment,
        Matrix matrix,
        QualityFlag qualityFlag,
        SamplingOperation samplingOperation);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param recorderDepartment
     * @param matrix
     * @param qualityFlag
     * @param samplingOperation
     * @return Object
     */
    public Object create(
        int transform,
        Department recorderDepartment,
        Matrix matrix,
        QualityFlag qualityFlag,
        SamplingOperation samplingOperation);

    /**
     * Updates the <code>sample</code> instance in the persistent store.
     * @param sample
     */
    public void update(Sample sample);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Sample> entities);

    /**
     * Removes the instance of Sample from the persistent store.
     * @param sample
     */
    public void remove(Sample sample);

    /**
     * Removes the instance of Sample having the given
     * <code>identifier</code> from the persistent store.
     * @param sampleId
     */
    public void remove(Integer sampleId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Sample> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Sample> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.data.sample.SampleDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.data.sample.SampleDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Sample entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Sample)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.data.sample.SampleDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Sample)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}