// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.samplingoperation;

import fr.ifremer.quadrige3.core.dao.administration.program.Program;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.data.aquaculture.Batch;
import fr.ifremer.quadrige3.core.dao.data.survey.Survey;
import fr.ifremer.quadrige3.core.dao.referential.DepthLevel;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.SamplingEquipment;
import fr.ifremer.quadrige3.core.dao.referential.Unit;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.PositionningSystem;
import fr.ifremer.quadrige3.core.dao.system.SamplingOperArea;
import fr.ifremer.quadrige3.core.dao.system.SamplingOperLine;
import fr.ifremer.quadrige3.core.dao.system.SamplingOperPoint;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste les prélévements effectués lors d'un passage.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class SamplingOperation
    implements Serializable, Comparable<SamplingOperation>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -5919684139702926187L;

    // Generate 21 attributes
    private Integer samplingOperId;

    /**
     * Identifiant interne du prélèvement
     * @return this.samplingOperId Integer
     */
    public Integer getSamplingOperId()
    {
        return this.samplingOperId;
    }

    /**
     * Identifiant interne du prélèvement
     * @param samplingOperIdIn Integer
     */
    public void setSamplingOperId(Integer samplingOperIdIn)
    {
        this.samplingOperId = samplingOperIdIn;
    }

    private String samplingOperLb;

    /**
     * Mnémonique du prélèvement.
     * @return this.samplingOperLb String
     */
    public String getSamplingOperLb()
    {
        return this.samplingOperLb;
    }

    /**
     * Mnémonique du prélèvement.
     * @param samplingOperLbIn String
     */
    public void setSamplingOperLb(String samplingOperLbIn)
    {
        this.samplingOperLb = samplingOperLbIn;
    }

    private Float samplingOperDepth;

    /**
     * Immersion du prélèvement. Cette valeur est exclusive de la fourchette min max d'immersion.
     * Elle n'est pas obligatoire.
     * @return this.samplingOperDepth Float
     */
    public Float getSamplingOperDepth()
    {
        return this.samplingOperDepth;
    }

    /**
     * Immersion du prélèvement. Cette valeur est exclusive de la fourchette min max d'immersion.
     * Elle n'est pas obligatoire.
     * @param samplingOperDepthIn Float
     */
    public void setSamplingOperDepth(Float samplingOperDepthIn)
    {
        this.samplingOperDepth = samplingOperDepthIn;
    }

    private Float samplingOperMaxDepth;

    /**
     * Valeur max de la fourchette d'immersion
     * @return this.samplingOperMaxDepth Float
     */
    public Float getSamplingOperMaxDepth()
    {
        return this.samplingOperMaxDepth;
    }

    /**
     * Valeur max de la fourchette d'immersion
     * @param samplingOperMaxDepthIn Float
     */
    public void setSamplingOperMaxDepth(Float samplingOperMaxDepthIn)
    {
        this.samplingOperMaxDepth = samplingOperMaxDepthIn;
    }

    private Float samplingOperMinDepth;

    /**
     * Valeur min de la fourchette d'immersion
     * @return this.samplingOperMinDepth Float
     */
    public Float getSamplingOperMinDepth()
    {
        return this.samplingOperMinDepth;
    }

    /**
     * Valeur min de la fourchette d'immersion
     * @param samplingOperMinDepthIn Float
     */
    public void setSamplingOperMinDepth(Float samplingOperMinDepthIn)
    {
        this.samplingOperMinDepth = samplingOperMinDepthIn;
    }

    private Float samplingOperSize;

    /**
     * Taille du prélèvement (surface, volume, poids, ¿ prélevé).
     * @return this.samplingOperSize Float
     */
    public Float getSamplingOperSize()
    {
        return this.samplingOperSize;
    }

    /**
     * Taille du prélèvement (surface, volume, poids, ¿ prélevé).
     * @param samplingOperSizeIn Float
     */
    public void setSamplingOperSize(Float samplingOperSizeIn)
    {
        this.samplingOperSize = samplingOperSizeIn;
    }

    private Integer samplingOperTime;

    /**
     * Heure à laquelle le prélèvement est effectué (HH24:MM). Pas de seconde a priori, mais exprimé
     * en seconde pour être homogène.
     * @return this.samplingOperTime Integer
     */
    public Integer getSamplingOperTime()
    {
        return this.samplingOperTime;
    }

    /**
     * Heure à laquelle le prélèvement est effectué (HH24:MM). Pas de seconde a priori, mais exprimé
     * en seconde pour être homogène.
     * @param samplingOperTimeIn Integer
     */
    public void setSamplingOperTime(Integer samplingOperTimeIn)
    {
        this.samplingOperTime = samplingOperTimeIn;
    }

    private Integer samplingOperNumberIndiv;

    /**
     * Nombre d'individus, par exemple il y a une vingtaine d'huitre dans le prélèvement.
     * Il est à noter que cette quantité n'est pas redondante avec la somme des individus des
     * résultats de mesures.
     * @return this.samplingOperNumberIndiv Integer
     */
    public Integer getSamplingOperNumberIndiv()
    {
        return this.samplingOperNumberIndiv;
    }

    /**
     * Nombre d'individus, par exemple il y a une vingtaine d'huitre dans le prélèvement.
     * Il est à noter que cette quantité n'est pas redondante avec la somme des individus des
     * résultats de mesures.
     * @param samplingOperNumberIndivIn Integer
     */
    public void setSamplingOperNumberIndiv(Integer samplingOperNumberIndivIn)
    {
        this.samplingOperNumberIndiv = samplingOperNumberIndivIn;
    }

    private String samplingOperCm;

    /**
     * Commentaire sur le prélèvement
     * @return this.samplingOperCm String
     */
    public String getSamplingOperCm()
    {
        return this.samplingOperCm;
    }

    /**
     * Commentaire sur le prélèvement
     * @param samplingOperCmIn String
     */
    public void setSamplingOperCm(String samplingOperCmIn)
    {
        this.samplingOperCm = samplingOperCmIn;
    }

    private Double samplingOperUtFormat;

    /**
     * Format UT de l'heure pour le prélèvement [-12;12]
     * @return this.samplingOperUtFormat Double
     */
    public Double getSamplingOperUtFormat()
    {
        return this.samplingOperUtFormat;
    }

    /**
     * Format UT de l'heure pour le prélèvement [-12;12]
     * @param samplingOperUtFormatIn Double
     */
    public void setSamplingOperUtFormat(Double samplingOperUtFormatIn)
    {
        this.samplingOperUtFormat = samplingOperUtFormatIn;
    }

    private Date samplingOperQualifDt;

    /**
     * Date de qualification du prélèvement
     * @return this.samplingOperQualifDt Date
     */
    public Date getSamplingOperQualifDt()
    {
        return this.samplingOperQualifDt;
    }

    /**
     * Date de qualification du prélèvement
     * @param samplingOperQualifDtIn Date
     */
    public void setSamplingOperQualifDt(Date samplingOperQualifDtIn)
    {
        this.samplingOperQualifDt = samplingOperQualifDtIn;
    }

    private String samplingOperQualifCm;

    /**
     * Commentaire sur la qualification du prélèvement
     * @return this.samplingOperQualifCm String
     */
    public String getSamplingOperQualifCm()
    {
        return this.samplingOperQualifCm;
    }

    /**
     * Commentaire sur la qualification du prélèvement
     * @param samplingOperQualifCmIn String
     */
    public void setSamplingOperQualifCm(String samplingOperQualifCmIn)
    {
        this.samplingOperQualifCm = samplingOperQualifCmIn;
    }

    private Date samplingOperControlDt;

    /**
     * Date de contrôle du prélèvement
     * @return this.samplingOperControlDt Date
     */
    public Date getSamplingOperControlDt()
    {
        return this.samplingOperControlDt;
    }

    /**
     * Date de contrôle du prélèvement
     * @param samplingOperControlDtIn Date
     */
    public void setSamplingOperControlDt(Date samplingOperControlDtIn)
    {
        this.samplingOperControlDt = samplingOperControlDtIn;
    }

    private Date samplingOperValidDt;

    /**
     * Date de validation du prélèvement
     * @return this.samplingOperValidDt Date
     */
    public Date getSamplingOperValidDt()
    {
        return this.samplingOperValidDt;
    }

    /**
     * Date de validation du prélèvement
     * @param samplingOperValidDtIn Date
     */
    public void setSamplingOperValidDt(Date samplingOperValidDtIn)
    {
        this.samplingOperValidDt = samplingOperValidDtIn;
    }

    private String samplingOperActualPosition;

    /**
     * Vrai s'il s'agit dune géométrie définie par l'utilisateur, faux si la géométrie est héritée
     * @return this.samplingOperActualPosition String
     */
    public String getSamplingOperActualPosition()
    {
        return this.samplingOperActualPosition;
    }

    /**
     * Vrai s'il s'agit dune géométrie définie par l'utilisateur, faux si la géométrie est héritée
     * @param samplingOperActualPositionIn String
     */
    public void setSamplingOperActualPosition(String samplingOperActualPositionIn)
    {
        this.samplingOperActualPosition = samplingOperActualPositionIn;
    }

    private String samplingOperPositionCm;

    /**
     * Commentaire associé à la localisation
     * @return this.samplingOperPositionCm String
     */
    public String getSamplingOperPositionCm()
    {
        return this.samplingOperPositionCm;
    }

    /**
     * Commentaire associé à la localisation
     * @param samplingOperPositionCmIn String
     */
    public void setSamplingOperPositionCm(String samplingOperPositionCmIn)
    {
        this.samplingOperPositionCm = samplingOperPositionCmIn;
    }

    private Date samplingOperGeomValidDt;

    /**
     * Date de validation de la géométrie du prélèvement
     * @return this.samplingOperGeomValidDt Date
     */
    public Date getSamplingOperGeomValidDt()
    {
        return this.samplingOperGeomValidDt;
    }

    /**
     * Date de validation de la géométrie du prélèvement
     * @param samplingOperGeomValidDtIn Date
     */
    public void setSamplingOperGeomValidDt(Date samplingOperGeomValidDtIn)
    {
        this.samplingOperGeomValidDt = samplingOperGeomValidDtIn;
    }

    private String samplingOperScope;

    /**
     * Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont
     * pas la même étape
     * @return this.samplingOperScope String
     */
    public String getSamplingOperScope()
    {
        return this.samplingOperScope;
    }

    /**
     * Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont
     * pas la même étape
     * @param samplingOperScopeIn String
     */
    public void setSamplingOperScope(String samplingOperScopeIn)
    {
        this.samplingOperScope = samplingOperScopeIn;
    }

    private String samplingOperHasMeas;

    /**
     * Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @return this.samplingOperHasMeas String
     */
    public String getSamplingOperHasMeas()
    {
        return this.samplingOperHasMeas;
    }

    /**
     * Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @param samplingOperHasMeasIn String
     */
    public void setSamplingOperHasMeas(String samplingOperHasMeasIn)
    {
        this.samplingOperHasMeas = samplingOperHasMeasIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 19 associations
    private DepthLevel depthLevel;

    /**
     * Liste des niveaux auxquels les prélèvements peuvent être effectués.
     * @return this.depthLevel DepthLevel
     */
    public DepthLevel getDepthLevel()
    {
        return this.depthLevel;
    }

    /**
     * Liste des niveaux auxquels les prélèvements peuvent être effectués.
     * @param depthLevelIn DepthLevel
     */
    public void setDepthLevel(DepthLevel depthLevelIn)
    {
        this.depthLevel = depthLevelIn;
    }

    private Collection<SamplingOperPoint> samplingOperPoints = new HashSet<SamplingOperPoint>();

    /**
     * Gestion de la géométrie ponctuelle des prélèvements.
     * @return this.samplingOperPoints Collection<SamplingOperPoint>
     */
    public Collection<SamplingOperPoint> getSamplingOperPoints()
    {
        return this.samplingOperPoints;
    }

    /**
     * Gestion de la géométrie ponctuelle des prélèvements.
     * @param samplingOperPointsIn Collection<SamplingOperPoint>
     */
    public void setSamplingOperPoints(Collection<SamplingOperPoint> samplingOperPointsIn)
    {
        this.samplingOperPoints = samplingOperPointsIn;
    }

    /**
     * Gestion de la géométrie ponctuelle des prélèvements.
     * @param elementToAdd SamplingOperPoint
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingOperPoints(SamplingOperPoint elementToAdd)
    {
        return this.samplingOperPoints.add(elementToAdd);
    }

    /**
     * Gestion de la géométrie ponctuelle des prélèvements.
     * @param elementToRemove SamplingOperPoint
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingOperPoints(SamplingOperPoint elementToRemove)
    {
        return this.samplingOperPoints.remove(elementToRemove);
    }

    private QualityFlag qualityFlag;

    /**
     * Liste des niveaux de qualification.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Liste des niveaux de qualification.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private Collection<SamplingOperArea> samplingOperAreas = new HashSet<SamplingOperArea>();

    /**
     * Gestion de la géométrie surfacique des prélèvements.
     * @return this.samplingOperAreas Collection<SamplingOperArea>
     */
    public Collection<SamplingOperArea> getSamplingOperAreas()
    {
        return this.samplingOperAreas;
    }

    /**
     * Gestion de la géométrie surfacique des prélèvements.
     * @param samplingOperAreasIn Collection<SamplingOperArea>
     */
    public void setSamplingOperAreas(Collection<SamplingOperArea> samplingOperAreasIn)
    {
        this.samplingOperAreas = samplingOperAreasIn;
    }

    /**
     * Gestion de la géométrie surfacique des prélèvements.
     * @param elementToAdd SamplingOperArea
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingOperAreas(SamplingOperArea elementToAdd)
    {
        return this.samplingOperAreas.add(elementToAdd);
    }

    /**
     * Gestion de la géométrie surfacique des prélèvements.
     * @param elementToRemove SamplingOperArea
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingOperAreas(SamplingOperArea elementToRemove)
    {
        return this.samplingOperAreas.remove(elementToRemove);
    }

    private Collection<Program> programs = new HashSet<Program>();

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @return this.programs Collection<Program>
     */
    public Collection<Program> getPrograms()
    {
        return this.programs;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param programsIn Collection<Program>
     */
    public void setPrograms(Collection<Program> programsIn)
    {
        this.programs = programsIn;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToAdd Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPrograms(Program elementToAdd)
    {
        return this.programs.add(elementToAdd);
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToRemove Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePrograms(Program elementToRemove)
    {
        return this.programs.remove(elementToRemove);
    }

    private Unit depthUnit;

    /**
     * Liste l'ensemble des unités de mesure.
     * @return this.depthUnit Unit
     */
    public Unit getDepthUnit()
    {
        return this.depthUnit;
    }

    /**
     * Liste l'ensemble des unités de mesure.
     * @param depthUnitIn Unit
     */
    public void setDepthUnit(Unit depthUnitIn)
    {
        this.depthUnit = depthUnitIn;
    }

    private Batch batch;

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @return this.batch Batch
     */
    public Batch getBatch()
    {
        return this.batch;
    }

    /**
     * Un lot est un groupe d'animaux issu d'une même population initiale et suivi sur un même point
     * dans
     * des conditions d'élevage similaires  (conditions expérimentales).  Un lot est défini par : *
     * une
     * population initiale * un lieu de surveillance * des caractéristiques d'élevage (système +
     * structure)
     * * un niveau Ce lot de mollusques est positionné sur le terrain.
     * @param batchIn Batch
     */
    public void setBatch(Batch batchIn)
    {
        this.batch = batchIn;
    }

    private Survey survey;

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @return this.survey Survey
     */
    public Survey getSurvey()
    {
        return this.survey;
    }

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @param surveyIn Survey
     */
    public void setSurvey(Survey surveyIn)
    {
        this.survey = surveyIn;
    }

    private Department recorderDepartment;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.recorderDepartment Department
     */
    public Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param recorderDepartmentIn Department
     */
    public void setRecorderDepartment(Department recorderDepartmentIn)
    {
        this.recorderDepartment = recorderDepartmentIn;
    }

    private Collection<SamplingOperLine> samplingOperLines = new HashSet<SamplingOperLine>();

    /**
     * Gestion de la géométrie linéaire des prélèvements.
     * @return this.samplingOperLines Collection<SamplingOperLine>
     */
    public Collection<SamplingOperLine> getSamplingOperLines()
    {
        return this.samplingOperLines;
    }

    /**
     * Gestion de la géométrie linéaire des prélèvements.
     * @param samplingOperLinesIn Collection<SamplingOperLine>
     */
    public void setSamplingOperLines(Collection<SamplingOperLine> samplingOperLinesIn)
    {
        this.samplingOperLines = samplingOperLinesIn;
    }

    /**
     * Gestion de la géométrie linéaire des prélèvements.
     * @param elementToAdd SamplingOperLine
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingOperLines(SamplingOperLine elementToAdd)
    {
        return this.samplingOperLines.add(elementToAdd);
    }

    /**
     * Gestion de la géométrie linéaire des prélèvements.
     * @param elementToRemove SamplingOperLine
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingOperLines(SamplingOperLine elementToRemove)
    {
        return this.samplingOperLines.remove(elementToRemove);
    }

    private Unit sizeUnit;

    /**
     * Liste l'ensemble des unités de mesure.
     * @return this.sizeUnit Unit
     */
    public Unit getSizeUnit()
    {
        return this.sizeUnit;
    }

    /**
     * Liste l'ensemble des unités de mesure.
     * @param sizeUnitIn Unit
     */
    public void setSizeUnit(Unit sizeUnitIn)
    {
        this.sizeUnit = sizeUnitIn;
    }

    private SamplingEquipment samplingEquipment;

    /**
     * Liste les engins de prélèvement (au sens marque/modèle et non numéro de série).
     * @return this.samplingEquipment SamplingEquipment
     */
    public SamplingEquipment getSamplingEquipment()
    {
        return this.samplingEquipment;
    }

    /**
     * Liste les engins de prélèvement (au sens marque/modèle et non numéro de série).
     * @param samplingEquipmentIn SamplingEquipment
     */
    public void setSamplingEquipment(SamplingEquipment samplingEquipmentIn)
    {
        this.samplingEquipment = samplingEquipmentIn;
    }

    private PositionningSystem positionningSystem;

    /**
     * Informations complémentaires sur le positionnement d'un objet.
     * @return this.positionningSystem PositionningSystem
     */
    public PositionningSystem getPositionningSystem()
    {
        return this.positionningSystem;
    }

    /**
     * Informations complémentaires sur le positionnement d'un objet.
     * @param positionningSystemIn PositionningSystem
     */
    public void setPositionningSystem(PositionningSystem positionningSystemIn)
    {
        this.positionningSystem = positionningSystemIn;
    }

    private Department department;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.department Department
     */
    public Department getDepartment()
    {
        return this.department;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param departmentIn Department
     */
    public void setDepartment(Department departmentIn)
    {
        this.department = departmentIn;
    }

    /**
     * Returns <code>true</code> if the argument is an SamplingOperation instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof SamplingOperation))
        {
            return false;
        }
        final SamplingOperation that = (SamplingOperation)object;
        if (this.samplingOperId == null || that.getSamplingOperId() == null || !this.samplingOperId.equals(that.getSamplingOperId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.samplingOperId == null ? 0 : this.samplingOperId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link SamplingOperation}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link SamplingOperation}.
         * @return new SamplingOperationImpl()
         */
        public static SamplingOperation newInstance()
        {
            return new SamplingOperationImpl();
        }

        /**
         * Constructs a new instance of {@link SamplingOperation}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param qualityFlag QualityFlag
         * @param survey Survey
         * @param recorderDepartment Department
         * @param samplingEquipment SamplingEquipment
         * @param department Department
         * @return newInstance
         */
        public static SamplingOperation newInstance(QualityFlag qualityFlag, Survey survey, Department recorderDepartment, SamplingEquipment samplingEquipment, Department department)
        {
            final SamplingOperation entity = new SamplingOperationImpl();
            entity.setQualityFlag(qualityFlag);
            entity.setSurvey(survey);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setSamplingEquipment(samplingEquipment);
            entity.setDepartment(department);
            return entity;
        }

        /**
         * Constructs a new instance of {@link SamplingOperation}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param samplingOperLb String
         * @param samplingOperDepth Float
         * @param samplingOperMaxDepth Float
         * @param samplingOperMinDepth Float
         * @param samplingOperSize Float
         * @param samplingOperTime Integer
         * @param samplingOperNumberIndiv Integer
         * @param samplingOperCm String
         * @param samplingOperUtFormat Double
         * @param samplingOperQualifDt Date
         * @param samplingOperQualifCm String
         * @param samplingOperControlDt Date
         * @param samplingOperValidDt Date
         * @param samplingOperActualPosition String
         * @param samplingOperPositionCm String
         * @param samplingOperGeomValidDt Date
         * @param samplingOperScope String
         * @param samplingOperHasMeas String
         * @param updateDt Timestamp
         * @param remoteId Integer
         * @param depthLevel DepthLevel
         * @param samplingOperPoints Collection<SamplingOperPoint>
         * @param qualityFlag QualityFlag
         * @param samplingOperAreas Collection<SamplingOperArea>
         * @param programs Collection<Program>
         * @param depthUnit Unit
         * @param batch Batch
         * @param survey Survey
         * @param recorderDepartment Department
         * @param samplingOperLines Collection<SamplingOperLine>
         * @param sizeUnit Unit
         * @param samplingEquipment SamplingEquipment
         * @param positionningSystem PositionningSystem
         * @param department Department
         * @return newInstance SamplingOperation
         */
        public static SamplingOperation newInstance(String samplingOperLb, Float samplingOperDepth, Float samplingOperMaxDepth, Float samplingOperMinDepth, Float samplingOperSize, Integer samplingOperTime, Integer samplingOperNumberIndiv, String samplingOperCm, Double samplingOperUtFormat, Date samplingOperQualifDt, String samplingOperQualifCm, Date samplingOperControlDt, Date samplingOperValidDt, String samplingOperActualPosition, String samplingOperPositionCm, Date samplingOperGeomValidDt, String samplingOperScope, String samplingOperHasMeas, Timestamp updateDt, Integer remoteId, DepthLevel depthLevel, Collection<SamplingOperPoint> samplingOperPoints, QualityFlag qualityFlag, Collection<SamplingOperArea> samplingOperAreas, Collection<Program> programs, Unit depthUnit, Batch batch, Survey survey, Department recorderDepartment, Collection<SamplingOperLine> samplingOperLines, Unit sizeUnit, SamplingEquipment samplingEquipment, PositionningSystem positionningSystem, Department department)
        {
            final SamplingOperation entity = new SamplingOperationImpl();
            entity.setSamplingOperLb(samplingOperLb);
            entity.setSamplingOperDepth(samplingOperDepth);
            entity.setSamplingOperMaxDepth(samplingOperMaxDepth);
            entity.setSamplingOperMinDepth(samplingOperMinDepth);
            entity.setSamplingOperSize(samplingOperSize);
            entity.setSamplingOperTime(samplingOperTime);
            entity.setSamplingOperNumberIndiv(samplingOperNumberIndiv);
            entity.setSamplingOperCm(samplingOperCm);
            entity.setSamplingOperUtFormat(samplingOperUtFormat);
            entity.setSamplingOperQualifDt(samplingOperQualifDt);
            entity.setSamplingOperQualifCm(samplingOperQualifCm);
            entity.setSamplingOperControlDt(samplingOperControlDt);
            entity.setSamplingOperValidDt(samplingOperValidDt);
            entity.setSamplingOperActualPosition(samplingOperActualPosition);
            entity.setSamplingOperPositionCm(samplingOperPositionCm);
            entity.setSamplingOperGeomValidDt(samplingOperGeomValidDt);
            entity.setSamplingOperScope(samplingOperScope);
            entity.setSamplingOperHasMeas(samplingOperHasMeas);
            entity.setUpdateDt(updateDt);
            entity.setRemoteId(remoteId);
            entity.setDepthLevel(depthLevel);
            entity.setSamplingOperPoints(samplingOperPoints);
            entity.setQualityFlag(qualityFlag);
            entity.setSamplingOperAreas(samplingOperAreas);
            entity.setPrograms(programs);
            entity.setDepthUnit(depthUnit);
            entity.setBatch(batch);
            entity.setSurvey(survey);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setSamplingOperLines(samplingOperLines);
            entity.setSizeUnit(sizeUnit);
            entity.setSamplingEquipment(samplingEquipment);
            entity.setPositionningSystem(positionningSystem);
            entity.setDepartment(department);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(SamplingOperation o)
    {
        int cmp = 0;
        if (this.getSamplingOperId() != null)
        {
            cmp = this.getSamplingOperId().compareTo(o.getSamplingOperId());
        }
        else
        {
            if (this.getSamplingOperLb() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperLb().compareTo(o.getSamplingOperLb()));
            }
            if (this.getSamplingOperDepth() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperDepth().compareTo(o.getSamplingOperDepth()));
            }
            if (this.getSamplingOperMaxDepth() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperMaxDepth().compareTo(o.getSamplingOperMaxDepth()));
            }
            if (this.getSamplingOperMinDepth() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperMinDepth().compareTo(o.getSamplingOperMinDepth()));
            }
            if (this.getSamplingOperSize() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperSize().compareTo(o.getSamplingOperSize()));
            }
            if (this.getSamplingOperTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperTime().compareTo(o.getSamplingOperTime()));
            }
            if (this.getSamplingOperNumberIndiv() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperNumberIndiv().compareTo(o.getSamplingOperNumberIndiv()));
            }
            if (this.getSamplingOperCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperCm().compareTo(o.getSamplingOperCm()));
            }
            if (this.getSamplingOperUtFormat() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperUtFormat().compareTo(o.getSamplingOperUtFormat()));
            }
            if (this.getSamplingOperQualifDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperQualifDt().compareTo(o.getSamplingOperQualifDt()));
            }
            if (this.getSamplingOperQualifCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperQualifCm().compareTo(o.getSamplingOperQualifCm()));
            }
            if (this.getSamplingOperControlDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperControlDt().compareTo(o.getSamplingOperControlDt()));
            }
            if (this.getSamplingOperValidDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperValidDt().compareTo(o.getSamplingOperValidDt()));
            }
            if (this.getSamplingOperActualPosition() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperActualPosition().compareTo(o.getSamplingOperActualPosition()));
            }
            if (this.getSamplingOperPositionCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperPositionCm().compareTo(o.getSamplingOperPositionCm()));
            }
            if (this.getSamplingOperGeomValidDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperGeomValidDt().compareTo(o.getSamplingOperGeomValidDt()));
            }
            if (this.getSamplingOperScope() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperScope().compareTo(o.getSamplingOperScope()));
            }
            if (this.getSamplingOperHasMeas() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingOperHasMeas().compareTo(o.getSamplingOperHasMeas()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// SamplingOperation.java merge-point
}