// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.samplingoperation;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.data.survey.Survey;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.SamplingEquipment;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Liste les prélévements effectués lors d'un passage.
 * @see SamplingOperation
 */
public interface SamplingOperationDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link SamplingOperation}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of SamplingOperation from the persistent store.
     * @param samplingOperId
     * @return SamplingOperation
     */
    public SamplingOperation get(Integer samplingOperId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param samplingOperId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer samplingOperId);

    /**
     * Loads an instance of SamplingOperation from the persistent store.
     * @param samplingOperId
     * @return SamplingOperation
     */
    public SamplingOperation load(Integer samplingOperId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param samplingOperId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer samplingOperId);

    /**
     * Loads all entities of type {@link SamplingOperation}.
     *
     * @return the loaded entities.
     */
    public Collection<SamplingOperation> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of SamplingOperation and adds it to the persistent store.
     * @param samplingOperation
     * @return SamplingOperation
     */
    public SamplingOperation create(SamplingOperation samplingOperation);

    /**
     * <p>
     * Does the same thing as {@link #create(SamplingOperation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param samplingOperation
     * @return Object
     */
    public Object create(int transform, SamplingOperation samplingOperation);

    /**
     * Creates a new instance of SamplingOperation and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of SamplingOperation
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<SamplingOperation> create(Collection<SamplingOperation> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(SamplingOperation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<SamplingOperation> entities);

    /**
     * <p>
     * Creates a new <code>SamplingOperation</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param samplingOperLb Mnémonique du prélèvement.
     * @param samplingOperDepth Immersion du prélèvement. Cette valeur est exclusive de la fourchette min max d'immersion. Elle
n'est pas obligatoire.
     * @param samplingOperMaxDepth Valeur max de la fourchette d'immersion
     * @param samplingOperMinDepth Valeur min de la fourchette d'immersion
     * @param samplingOperSize Taille du prélèvement (surface, volume, poids, ¿ prélevé).
     * @param samplingOperTime Heure à laquelle le prélèvement est effectué (HH24:MM). Pas de seconde a priori, mais exprimé en
seconde pour être homogène.
     * @param samplingOperNumberIndiv Nombre d'individus, par exemple il y a une vingtaine d'huitre dans le prélèvement.
Il est à noter que cette quantité n'est pas redondante avec la somme des individus des résultats de
mesures.
     * @param samplingOperCm Commentaire sur le prélèvement
     * @param samplingOperUtFormat Format UT de l'heure pour le prélèvement [-12;12]
     * @param samplingOperQualifDt Date de qualification du prélèvement
     * @param samplingOperQualifCm Commentaire sur la qualification du prélèvement
     * @param samplingOperControlDt Date de contrôle du prélèvement
     * @param samplingOperValidDt Date de validation du prélèvement
     * @param samplingOperActualPosition Vrai s'il s'agit dune géométrie définie par l'utilisateur, faux si la géométrie est héritée
     * @param samplingOperPositionCm Commentaire associé à la localisation
     * @param samplingOperGeomValidDt Date de validation de la géométrie du prélèvement
     * @param samplingOperScope Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont pas la
même étape
     * @param samplingOperHasMeas Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param remoteId 
     * @return SamplingOperation
     */
    public SamplingOperation create(
        String samplingOperLb,
        Float samplingOperDepth,
        Float samplingOperMaxDepth,
        Float samplingOperMinDepth,
        Float samplingOperSize,
        Integer samplingOperTime,
        Integer samplingOperNumberIndiv,
        String samplingOperCm,
        Double samplingOperUtFormat,
        Date samplingOperQualifDt,
        String samplingOperQualifCm,
        Date samplingOperControlDt,
        Date samplingOperValidDt,
        String samplingOperActualPosition,
        String samplingOperPositionCm,
        Date samplingOperGeomValidDt,
        String samplingOperScope,
        String samplingOperHasMeas,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Float, Float, Float, Float, Integer, Integer, String, Double, Date, String, Date, Date, String, String, Date, String, String, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param samplingOperLb Mnémonique du prélèvement.
     * @param samplingOperDepth Immersion du prélèvement. Cette valeur est exclusive de la fourchette min max d'immersion. Elle
n'est pas obligatoire.
     * @param samplingOperMaxDepth Valeur max de la fourchette d'immersion
     * @param samplingOperMinDepth Valeur min de la fourchette d'immersion
     * @param samplingOperSize Taille du prélèvement (surface, volume, poids, ¿ prélevé).
     * @param samplingOperTime Heure à laquelle le prélèvement est effectué (HH24:MM). Pas de seconde a priori, mais exprimé en
seconde pour être homogène.
     * @param samplingOperNumberIndiv Nombre d'individus, par exemple il y a une vingtaine d'huitre dans le prélèvement.
Il est à noter que cette quantité n'est pas redondante avec la somme des individus des résultats de
mesures.
     * @param samplingOperCm Commentaire sur le prélèvement
     * @param samplingOperUtFormat Format UT de l'heure pour le prélèvement [-12;12]
     * @param samplingOperQualifDt Date de qualification du prélèvement
     * @param samplingOperQualifCm Commentaire sur la qualification du prélèvement
     * @param samplingOperControlDt Date de contrôle du prélèvement
     * @param samplingOperValidDt Date de validation du prélèvement
     * @param samplingOperActualPosition Vrai s'il s'agit dune géométrie définie par l'utilisateur, faux si la géométrie est héritée
     * @param samplingOperPositionCm Commentaire associé à la localisation
     * @param samplingOperGeomValidDt Date de validation de la géométrie du prélèvement
     * @param samplingOperScope Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont pas la
même étape
     * @param samplingOperHasMeas Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param remoteId 
     * @return SamplingOperation
     */
    public Object create(
        int transform,
        String samplingOperLb,
        Float samplingOperDepth,
        Float samplingOperMaxDepth,
        Float samplingOperMinDepth,
        Float samplingOperSize,
        Integer samplingOperTime,
        Integer samplingOperNumberIndiv,
        String samplingOperCm,
        Double samplingOperUtFormat,
        Date samplingOperQualifDt,
        String samplingOperQualifCm,
        Date samplingOperControlDt,
        Date samplingOperValidDt,
        String samplingOperActualPosition,
        String samplingOperPositionCm,
        Date samplingOperGeomValidDt,
        String samplingOperScope,
        String samplingOperHasMeas,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>SamplingOperation</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param recorderDepartment
     * @param department
     * @param qualityFlag
     * @param survey
     * @param samplingEquipment
     * @return SamplingOperation
     */
    public SamplingOperation create(
        Department recorderDepartment,
        Department department,
        QualityFlag qualityFlag,
        Survey survey,
        SamplingEquipment samplingEquipment);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param recorderDepartment
     * @param department
     * @param qualityFlag
     * @param survey
     * @param samplingEquipment
     * @return Object
     */
    public Object create(
        int transform,
        Department recorderDepartment,
        Department department,
        QualityFlag qualityFlag,
        Survey survey,
        SamplingEquipment samplingEquipment);

    /**
     * Updates the <code>samplingOperation</code> instance in the persistent store.
     * @param samplingOperation
     */
    public void update(SamplingOperation samplingOperation);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<SamplingOperation> entities);

    /**
     * Removes the instance of SamplingOperation from the persistent store.
     * @param samplingOperation
     */
    public void remove(SamplingOperation samplingOperation);

    /**
     * Removes the instance of SamplingOperation having the given
     * <code>identifier</code> from the persistent store.
     * @param samplingOperId
     */
    public void remove(Integer samplingOperId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<SamplingOperation> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<SamplingOperation> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.data.samplingoperation.SamplingOperationDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.data.samplingoperation.SamplingOperationDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final SamplingOperation entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,SamplingOperation)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.data.samplingoperation.SamplingOperationDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,SamplingOperation)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}