// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.survey;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.administration.user.Quser;
import fr.ifremer.quadrige3.core.vo.data.survey.CampaignVO;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Liste des campagnes.
 * @see Campaign
 */
public interface CampaignDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Campaign}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link CampaignVO}.
     */
    public static final int TRANSFORM_CAMPAIGNVO = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toCampaignVO(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toCampaignVO(
        Campaign source,
        CampaignVO target);

    /**
     * Converts this DAO's entity to an object of type {@link CampaignVO}.
     * @param entity
     * @return CampaignVO
     */
    public CampaignVO toCampaignVO(Campaign entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link CampaignVO}.
     * @param entities
     */
    public Collection<CampaignVO> toCampaignVOCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link CampaignVO}.
     * @param entities
     * @return CampaignVO[]
     */
    public CampaignVO[] toCampaignVOArray(Collection<?> entities);

    /**
     * Copies the fields of {@link CampaignVO} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void campaignVOToEntity(
        CampaignVO source,
        Campaign target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link CampaignVO} to this DAO's entity.
     * @param campaignVO
     * @return Campaign
     */
    public Campaign campaignVOToEntity(CampaignVO campaignVO);

    /**
     * Converts a Collection of instances of type {@link CampaignVO} to this
     * DAO's entity.
     * @param instances
     */
    public void campaignVOToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of Campaign from the persistent store.
     * @param campaignId
     * @return Campaign
     */
    public Campaign get(Integer campaignId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param campaignId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer campaignId);

    /**
     * Loads an instance of Campaign from the persistent store.
     * @param campaignId
     * @return Campaign
     */
    public Campaign load(Integer campaignId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param campaignId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer campaignId);

    /**
     * Loads all entities of type {@link Campaign}.
     *
     * @return the loaded entities.
     */
    public Collection<Campaign> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Campaign and adds it to the persistent store.
     * @param campaign
     * @return Campaign
     */
    public Campaign create(Campaign campaign);

    /**
     * <p>
     * Does the same thing as {@link #create(Campaign)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param campaign
     * @return Object
     */
    public Object create(int transform, Campaign campaign);

    /**
     * Creates a new instance of Campaign and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Campaign
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Campaign> create(Collection<Campaign> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Campaign)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Campaign> entities);

    /**
     * <p>
     * Creates a new <code>Campaign</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param campaignSismerLk Lien vers le serveur SISMER. Probablement la référence SISMER de la campagne CAM_CAMREF
(FI351997020020 par exemple)
     * @param campaignStartDt Date de début de la campagne. ne pas renseigner si SISMER
     * @param campaignEndDt Date de fin de la campagne. Ne pas renseigner si SISMER.
     * @param campaignNm Llibellé décrivant la campagne. Ne pas renseigner si SISMER.
     * @param campaignCm Commentaire sur la campagne. Ne pas renseigner si SISMER.
     * @param campaignPositionCm Commentaire associé à la localisation
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param remoteId 
     * @return Campaign
     */
    public Campaign create(
        String campaignSismerLk,
        Date campaignStartDt,
        Date campaignEndDt,
        String campaignNm,
        String campaignCm,
        String campaignPositionCm,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Date, Date, String, String, String, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param campaignSismerLk Lien vers le serveur SISMER. Probablement la référence SISMER de la campagne CAM_CAMREF
(FI351997020020 par exemple)
     * @param campaignStartDt Date de début de la campagne. ne pas renseigner si SISMER
     * @param campaignEndDt Date de fin de la campagne. Ne pas renseigner si SISMER.
     * @param campaignNm Llibellé décrivant la campagne. Ne pas renseigner si SISMER.
     * @param campaignCm Commentaire sur la campagne. Ne pas renseigner si SISMER.
     * @param campaignPositionCm Commentaire associé à la localisation
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param remoteId 
     * @return Campaign
     */
    public Object create(
        int transform,
        String campaignSismerLk,
        Date campaignStartDt,
        Date campaignEndDt,
        String campaignNm,
        String campaignCm,
        String campaignPositionCm,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>Campaign</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param campaignNm
     * @param campaignStartDt
     * @param recorderDepartment
     * @param quser
     * @return Campaign
     */
    public Campaign create(
        String campaignNm,
        Date campaignStartDt,
        Department recorderDepartment,
        Quser quser);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param campaignNm
     * @param campaignStartDt
     * @param recorderDepartment
     * @param quser
     * @return Object
     */
    public Object create(
        int transform,
        String campaignNm,
        Date campaignStartDt,
        Department recorderDepartment,
        Quser quser);

    /**
     * Updates the <code>campaign</code> instance in the persistent store.
     * @param campaign
     */
    public void update(Campaign campaign);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Campaign> entities);

    /**
     * Removes the instance of Campaign from the persistent store.
     * @param campaign
     */
    public void remove(Campaign campaign);

    /**
     * Removes the instance of Campaign having the given
     * <code>identifier</code> from the persistent store.
     * @param campaignId
     */
    public void remove(Integer campaignId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Campaign> entities);

    /**
     * 
     * @param campaign 
     * @return CampaignVO
     */
    public CampaignVO save(CampaignVO campaign);

    /**
     * 
     * @param campaignId 
     * @return Long
     */
    public Long countSurveyUsage(int campaignId);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Campaign> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.data.survey.CampaignDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link Campaign} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link CampaignVO} - {@link #TRANSFORM_CAMPAIGNVO}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.data.survey.CampaignDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Campaign entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Campaign)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.data.survey.CampaignDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Campaign)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}