// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.survey;

import fr.ifremer.quadrige3.core.dao.administration.program.Program;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Profil mesuré envoyé à Coriolis
 * La référence des profils est QUADRIGE-DDMMYYYY-XXXX
 * Elle est générée à partir de l'identifiant, de la date de création et d'une chaine en dur.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class MeasuredProfile
    implements Serializable, Comparable<MeasuredProfile>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1776400112077976569L;

    // Generate 9 attributes
    private Integer measProfId;

    /**
     * Identifiant du profil. Cet identifiant permet de faire le lien vers les autres systèmes
     * d'information de l'Ifremer.
     * @return this.measProfId Integer
     */
    public Integer getMeasProfId()
    {
        return this.measProfId;
    }

    /**
     * Identifiant du profil. Cet identifiant permet de faire le lien vers les autres systèmes
     * d'information de l'Ifremer.
     * @param measProfIdIn Integer
     */
    public void setMeasProfId(Integer measProfIdIn)
    {
        this.measProfId = measProfIdIn;
    }

    private String measProfDc;

    /**
     * Description du profil
     * @return this.measProfDc String
     */
    public String getMeasProfDc()
    {
        return this.measProfDc;
    }

    /**
     * Description du profil
     * @param measProfDcIn String
     */
    public void setMeasProfDc(String measProfDcIn)
    {
        this.measProfDc = measProfDcIn;
    }

    private String measProfUpload;

    /**
     * Vrai si le traitement CORIOLIS du profil s'est bien passé
     * @return this.measProfUpload String
     */
    public String getMeasProfUpload()
    {
        return this.measProfUpload;
    }

    /**
     * Vrai si le traitement CORIOLIS du profil s'est bien passé
     * @param measProfUploadIn String
     */
    public void setMeasProfUpload(String measProfUploadIn)
    {
        this.measProfUpload = measProfUploadIn;
    }

    private Date measProfCreationDt;

    /**
     * Date de création de l'objet
     * @return this.measProfCreationDt Date
     */
    public Date getMeasProfCreationDt()
    {
        return this.measProfCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param measProfCreationDtIn Date
     */
    public void setMeasProfCreationDt(Date measProfCreationDtIn)
    {
        this.measProfCreationDt = measProfCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de mise à jour de l'objet
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de mise à jour de l'objet
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private Date measProfValidDt;

    /**
     * Date de validation
     * @return this.measProfValidDt Date
     */
    public Date getMeasProfValidDt()
    {
        return this.measProfValidDt;
    }

    /**
     * Date de validation
     * @param measProfValidDtIn Date
     */
    public void setMeasProfValidDt(Date measProfValidDtIn)
    {
        this.measProfValidDt = measProfValidDtIn;
    }

    private Date measProfQualifDt;

    /**
     * Date de qualification
     * @return this.measProfQualifDt Date
     */
    public Date getMeasProfQualifDt()
    {
        return this.measProfQualifDt;
    }

    /**
     * Date de qualification
     * @param measProfQualifDtIn Date
     */
    public void setMeasProfQualifDt(Date measProfQualifDtIn)
    {
        this.measProfQualifDt = measProfQualifDtIn;
    }

    private String measProfQualifCm;

    /**
     * Commentaire de qualification
     * @return this.measProfQualifCm String
     */
    public String getMeasProfQualifCm()
    {
        return this.measProfQualifCm;
    }

    /**
     * Commentaire de qualification
     * @param measProfQualifCmIn String
     */
    public void setMeasProfQualifCm(String measProfQualifCmIn)
    {
        this.measProfQualifCm = measProfQualifCmIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 4 associations
    private Collection<Program> programs = new HashSet<Program>();

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @return this.programs Collection<Program>
     */
    public Collection<Program> getPrograms()
    {
        return this.programs;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param programsIn Collection<Program>
     */
    public void setPrograms(Collection<Program> programsIn)
    {
        this.programs = programsIn;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToAdd Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPrograms(Program elementToAdd)
    {
        return this.programs.add(elementToAdd);
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToRemove Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePrograms(Program elementToRemove)
    {
        return this.programs.remove(elementToRemove);
    }

    private Survey survey;

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @return this.survey Survey
     */
    public Survey getSurvey()
    {
        return this.survey;
    }

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @param surveyIn Survey
     */
    public void setSurvey(Survey surveyIn)
    {
        this.survey = surveyIn;
    }

    private QualityFlag qualityFlag;

    /**
     * Liste des niveaux de qualification.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Liste des niveaux de qualification.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private Department recorderDepartment;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.recorderDepartment Department
     */
    public Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param recorderDepartmentIn Department
     */
    public void setRecorderDepartment(Department recorderDepartmentIn)
    {
        this.recorderDepartment = recorderDepartmentIn;
    }

    /**
     * Returns <code>true</code> if the argument is an MeasuredProfile instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof MeasuredProfile))
        {
            return false;
        }
        final MeasuredProfile that = (MeasuredProfile)object;
        if (this.measProfId == null || that.getMeasProfId() == null || !this.measProfId.equals(that.getMeasProfId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.measProfId == null ? 0 : this.measProfId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link MeasuredProfile}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link MeasuredProfile}.
         * @return new MeasuredProfileImpl()
         */
        public static MeasuredProfile newInstance()
        {
            return new MeasuredProfileImpl();
        }

        /**
         * Constructs a new instance of {@link MeasuredProfile}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param measProfCreationDt Date
         * @param recorderDepartment Department
         * @return newInstance
         */
        public static MeasuredProfile newInstance(Date measProfCreationDt, Department recorderDepartment)
        {
            final MeasuredProfile entity = new MeasuredProfileImpl();
            entity.setMeasProfCreationDt(measProfCreationDt);
            entity.setRecorderDepartment(recorderDepartment);
            return entity;
        }

        /**
         * Constructs a new instance of {@link MeasuredProfile}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param measProfDc String
         * @param measProfUpload String
         * @param measProfCreationDt Date
         * @param updateDt Timestamp
         * @param measProfValidDt Date
         * @param measProfQualifDt Date
         * @param measProfQualifCm String
         * @param remoteId Integer
         * @param programs Collection<Program>
         * @param survey Survey
         * @param qualityFlag QualityFlag
         * @param recorderDepartment Department
         * @return newInstance MeasuredProfile
         */
        public static MeasuredProfile newInstance(String measProfDc, String measProfUpload, Date measProfCreationDt, Timestamp updateDt, Date measProfValidDt, Date measProfQualifDt, String measProfQualifCm, Integer remoteId, Collection<Program> programs, Survey survey, QualityFlag qualityFlag, Department recorderDepartment)
        {
            final MeasuredProfile entity = new MeasuredProfileImpl();
            entity.setMeasProfDc(measProfDc);
            entity.setMeasProfUpload(measProfUpload);
            entity.setMeasProfCreationDt(measProfCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setMeasProfValidDt(measProfValidDt);
            entity.setMeasProfQualifDt(measProfQualifDt);
            entity.setMeasProfQualifCm(measProfQualifCm);
            entity.setRemoteId(remoteId);
            entity.setPrograms(programs);
            entity.setSurvey(survey);
            entity.setQualityFlag(qualityFlag);
            entity.setRecorderDepartment(recorderDepartment);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(MeasuredProfile o)
    {
        int cmp = 0;
        if (this.getMeasProfId() != null)
        {
            cmp = this.getMeasProfId().compareTo(o.getMeasProfId());
        }
        else
        {
            if (this.getMeasProfDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMeasProfDc().compareTo(o.getMeasProfDc()));
            }
            if (this.getMeasProfUpload() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMeasProfUpload().compareTo(o.getMeasProfUpload()));
            }
            if (this.getMeasProfCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMeasProfCreationDt().compareTo(o.getMeasProfCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
            if (this.getMeasProfValidDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMeasProfValidDt().compareTo(o.getMeasProfValidDt()));
            }
            if (this.getMeasProfQualifDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMeasProfQualifDt().compareTo(o.getMeasProfQualifDt()));
            }
            if (this.getMeasProfQualifCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMeasProfQualifCm().compareTo(o.getMeasProfQualifCm()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// MeasuredProfile.java merge-point
}