// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.survey;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.eunis.EunisTypology;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Commentaire sur l'habitat observé.
 * @see ObservedHabitat
 */
public interface ObservedHabitatDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link ObservedHabitat}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of ObservedHabitat from the persistent store.
     * @param observedHabitatId
     * @return ObservedHabitat
     */
    public ObservedHabitat get(Integer observedHabitatId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param observedHabitatId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer observedHabitatId);

    /**
     * Loads an instance of ObservedHabitat from the persistent store.
     * @param observedHabitatId
     * @return ObservedHabitat
     */
    public ObservedHabitat load(Integer observedHabitatId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param observedHabitatId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer observedHabitatId);

    /**
     * Loads all entities of type {@link ObservedHabitat}.
     *
     * @return the loaded entities.
     */
    public Collection<ObservedHabitat> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of ObservedHabitat and adds it to the persistent store.
     * @param observedHabitat
     * @return ObservedHabitat
     */
    public ObservedHabitat create(ObservedHabitat observedHabitat);

    /**
     * <p>
     * Does the same thing as {@link #create(ObservedHabitat)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param observedHabitat
     * @return Object
     */
    public Object create(int transform, ObservedHabitat observedHabitat);

    /**
     * Creates a new instance of ObservedHabitat and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of ObservedHabitat
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<ObservedHabitat> create(Collection<ObservedHabitat> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(ObservedHabitat)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<ObservedHabitat> entities);

    /**
     * <p>
     * Creates a new <code>ObservedHabitat</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param observHabCm Commentaire sur l'habitat observé
     * @param observHabValidDt Date de validation de la données
     * @param observHabQualifDt Date de qualification de la données
     * @param observHabQualifCm Commentaire sur la qualification du passage
D'une façon générale, il faut vérifier que les données de controle, qualification et validation,
dates ou commentaires sont bien du ressort de la classe courante et ne doivent pas être gérées dans
une super classe de type métadonnées, et plus particulièrement dans ce cas avec les données
géométriques et la norme ISO 19115.
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param remoteId 
     * @return ObservedHabitat
     */
    public ObservedHabitat create(
        String observHabCm,
        Date observHabValidDt,
        Date observHabQualifDt,
        String observHabQualifCm,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Date, Date, String, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param observHabCm Commentaire sur l'habitat observé
     * @param observHabValidDt Date de validation de la données
     * @param observHabQualifDt Date de qualification de la données
     * @param observHabQualifCm Commentaire sur la qualification du passage
D'une façon générale, il faut vérifier que les données de controle, qualification et validation,
dates ou commentaires sont bien du ressort de la classe courante et ne doivent pas être gérées dans
une super classe de type métadonnées, et plus particulièrement dans ce cas avec les données
géométriques et la norme ISO 19115.
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param remoteId 
     * @return ObservedHabitat
     */
    public Object create(
        int transform,
        String observHabCm,
        Date observHabValidDt,
        Date observHabQualifDt,
        String observHabQualifCm,
        Timestamp updateDt,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>ObservedHabitat</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param eunisTypology
     * @param qualityFlag
     * @param survey
     * @return ObservedHabitat
     */
    public ObservedHabitat create(
        EunisTypology eunisTypology,
        QualityFlag qualityFlag,
        Survey survey);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param eunisTypology
     * @param qualityFlag
     * @param survey
     * @return Object
     */
    public Object create(
        int transform,
        EunisTypology eunisTypology,
        QualityFlag qualityFlag,
        Survey survey);

    /**
     * Updates the <code>observedHabitat</code> instance in the persistent store.
     * @param observedHabitat
     */
    public void update(ObservedHabitat observedHabitat);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<ObservedHabitat> entities);

    /**
     * Removes the instance of ObservedHabitat from the persistent store.
     * @param observedHabitat
     */
    public void remove(ObservedHabitat observedHabitat);

    /**
     * Removes the instance of ObservedHabitat having the given
     * <code>identifier</code> from the persistent store.
     * @param observedHabitatId
     */
    public void remove(Integer observedHabitatId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<ObservedHabitat> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<ObservedHabitat> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.data.survey.ObservedHabitatDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.data.survey.ObservedHabitatDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final ObservedHabitat entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,ObservedHabitat)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.data.survey.ObservedHabitatDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,ObservedHabitat)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}