// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.survey;

import fr.ifremer.quadrige3.core.dao.administration.program.Program;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.administration.user.Quser;
import fr.ifremer.quadrige3.core.dao.data.event.Event;
import fr.ifremer.quadrige3.core.dao.data.samplingoperation.SamplingOperation;
import fr.ifremer.quadrige3.core.dao.referential.DredgingTargetArea;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.Unit;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocation;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.PositionningSystem;
import fr.ifremer.quadrige3.core.dao.system.SurveyArea;
import fr.ifremer.quadrige3.core.dao.system.SurveyLine;
import fr.ifremer.quadrige3.core.dao.system.SurveyPoint;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste les différents passages effectués sur un lieu de surveillance.
 * Liste les différents passages effectués sur un lieu de surveillance.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Survey
    implements Serializable, Comparable<Survey>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -914063244937660291L;

    // Generate 21 attributes
    private Integer surveyId;

    /**
     * Identifiant interne du passage
     * @return this.surveyId Integer
     */
    public Integer getSurveyId()
    {
        return this.surveyId;
    }

    /**
     * Identifiant interne du passage
     * @param surveyIdIn Integer
     */
    public void setSurveyId(Integer surveyIdIn)
    {
        this.surveyId = surveyIdIn;
    }

    private Date surveyDt;

    /**
     * Date du passage
     * Cette date ne comprend pas les heures, minutes, secondes du passage qui sont renseignés
     * séparément.
     * @return this.surveyDt Date
     */
    public Date getSurveyDt()
    {
        return this.surveyDt;
    }

    /**
     * Date du passage
     * Cette date ne comprend pas les heures, minutes, secondes du passage qui sont renseignés
     * séparément.
     * @param surveyDtIn Date
     */
    public void setSurveyDt(Date surveyDtIn)
    {
        this.surveyDt = surveyDtIn;
    }

    private Integer surveyTime;

    /**
     * Heure du passage.
     * Cette heure est indépendante de la date, car elle n'est pas obligatoire et il faut être
     * capable de séparer un passage à minuit et une heure non renseignée.
     * L'heure renseignée par l'utilisateur est l'heure locale, ie UT+1 ou UT+2
     * @return this.surveyTime Integer
     */
    public Integer getSurveyTime()
    {
        return this.surveyTime;
    }

    /**
     * Heure du passage.
     * Cette heure est indépendante de la date, car elle n'est pas obligatoire et il faut être
     * capable de séparer un passage à minuit et une heure non renseignée.
     * L'heure renseignée par l'utilisateur est l'heure locale, ie UT+1 ou UT+2
     * @param surveyTimeIn Integer
     */
    public void setSurveyTime(Integer surveyTimeIn)
    {
        this.surveyTime = surveyTimeIn;
    }

    private Integer surveyNumberIndiv;

    /**
     * Nombre d¿¿individus sur le passage
     * @return this.surveyNumberIndiv Integer
     */
    public Integer getSurveyNumberIndiv()
    {
        return this.surveyNumberIndiv;
    }

    /**
     * Nombre d¿¿individus sur le passage
     * @param surveyNumberIndivIn Integer
     */
    public void setSurveyNumberIndiv(Integer surveyNumberIndivIn)
    {
        this.surveyNumberIndiv = surveyNumberIndivIn;
    }

    private Float surveyBottomDepth;

    /**
     * Valeur de la sonde à l'endroit du passage.
     * Cette valeur n'a de sens que lorsque le passage est de type ponctuel.
     * Elle n'est pas obligatoire, car il il y a des passages à terre (rebent intertidal)
     * @return this.surveyBottomDepth Float
     */
    public Float getSurveyBottomDepth()
    {
        return this.surveyBottomDepth;
    }

    /**
     * Valeur de la sonde à l'endroit du passage.
     * Cette valeur n'a de sens que lorsque le passage est de type ponctuel.
     * Elle n'est pas obligatoire, car il il y a des passages à terre (rebent intertidal)
     * @param surveyBottomDepthIn Float
     */
    public void setSurveyBottomDepth(Float surveyBottomDepthIn)
    {
        this.surveyBottomDepth = surveyBottomDepthIn;
    }

    private String surveyLb;

    /**
     * Chaine de caractères contenant une suite de mots clefs connus de l'utilisateur et servant à
     * identifier le passage (lors d'une sélection par exemple?)
     * @return this.surveyLb String
     */
    public String getSurveyLb()
    {
        return this.surveyLb;
    }

    /**
     * Chaine de caractères contenant une suite de mots clefs connus de l'utilisateur et servant à
     * identifier le passage (lors d'une sélection par exemple?)
     * @param surveyLbIn String
     */
    public void setSurveyLb(String surveyLbIn)
    {
        this.surveyLb = surveyLbIn;
    }

    private String surveyCm;

    /**
     * Commentaire sur le passage. (les commentaires en général ne servent pas à décrire mais à
     * donner des informations diverses et variées, et surtout accessoires, pas capitales).
     * @return this.surveyCm String
     */
    public String getSurveyCm()
    {
        return this.surveyCm;
    }

    /**
     * Commentaire sur le passage. (les commentaires en général ne servent pas à décrire mais à
     * donner des informations diverses et variées, et surtout accessoires, pas capitales).
     * @param surveyCmIn String
     */
    public void setSurveyCm(String surveyCmIn)
    {
        this.surveyCm = surveyCmIn;
    }

    private Double surveyUtFormat;

    /**
     * Format UT de l'heure pour le passage [-12;12]
     * @return this.surveyUtFormat Double
     */
    public Double getSurveyUtFormat()
    {
        return this.surveyUtFormat;
    }

    /**
     * Format UT de l'heure pour le passage [-12;12]
     * @param surveyUtFormatIn Double
     */
    public void setSurveyUtFormat(Double surveyUtFormatIn)
    {
        this.surveyUtFormat = surveyUtFormatIn;
    }

    private Date surveyControlDt;

    /**
     * Date des contrôles les caractéristiques du passage
     * Cette date ainsi que celle de qualification, et validation ne sont pas renseignées par
     * l'utilisateur, mais par les fonctions associées.
     * @return this.surveyControlDt Date
     */
    public Date getSurveyControlDt()
    {
        return this.surveyControlDt;
    }

    /**
     * Date des contrôles les caractéristiques du passage
     * Cette date ainsi que celle de qualification, et validation ne sont pas renseignées par
     * l'utilisateur, mais par les fonctions associées.
     * @param surveyControlDtIn Date
     */
    public void setSurveyControlDt(Date surveyControlDtIn)
    {
        this.surveyControlDt = surveyControlDtIn;
    }

    private Date surveyValidDt;

    /**
     * Date de validation de la données
     * @return this.surveyValidDt Date
     */
    public Date getSurveyValidDt()
    {
        return this.surveyValidDt;
    }

    /**
     * Date de validation de la données
     * @param surveyValidDtIn Date
     */
    public void setSurveyValidDt(Date surveyValidDtIn)
    {
        this.surveyValidDt = surveyValidDtIn;
    }

    private String surveyValidCm;

    /**
     * 
     * @return this.surveyValidCm String
     */
    public String getSurveyValidCm()
    {
        return this.surveyValidCm;
    }

    /**
     * 
     * @param surveyValidCmIn String
     */
    public void setSurveyValidCm(String surveyValidCmIn)
    {
        this.surveyValidCm = surveyValidCmIn;
    }

    private Date surveyQualifDt;

    /**
     * Date de qualification de la données
     * @return this.surveyQualifDt Date
     */
    public Date getSurveyQualifDt()
    {
        return this.surveyQualifDt;
    }

    /**
     * Date de qualification de la données
     * @param surveyQualifDtIn Date
     */
    public void setSurveyQualifDt(Date surveyQualifDtIn)
    {
        this.surveyQualifDt = surveyQualifDtIn;
    }

    private String surveyQualifCm;

    /**
     * Commentaires sur la qualification du passage. Ces commentaires sont obligatoires si le niveau
     * de qualification est douteux ou faux. On peut par exemple noter dans le commentaire que
     * l¿engin d¿analyse utilisé était déficient.
     * @return this.surveyQualifCm String
     */
    public String getSurveyQualifCm()
    {
        return this.surveyQualifCm;
    }

    /**
     * Commentaires sur la qualification du passage. Ces commentaires sont obligatoires si le niveau
     * de qualification est douteux ou faux. On peut par exemple noter dans le commentaire que
     * l¿engin d¿analyse utilisé était déficient.
     * @param surveyQualifCmIn String
     */
    public void setSurveyQualifCm(String surveyQualifCmIn)
    {
        this.surveyQualifCm = surveyQualifCmIn;
    }

    private String surveyActualPosition;

    /**
     * Vrai si la géométrie est définie par l'utilisateur, faux si elle est héritée du lieu.
     * Cette information est renseignée par le système et permet par la suite une thématique
     * d'affichage.
     * @return this.surveyActualPosition String
     */
    public String getSurveyActualPosition()
    {
        return this.surveyActualPosition;
    }

    /**
     * Vrai si la géométrie est définie par l'utilisateur, faux si elle est héritée du lieu.
     * Cette information est renseignée par le système et permet par la suite une thématique
     * d'affichage.
     * @param surveyActualPositionIn String
     */
    public void setSurveyActualPosition(String surveyActualPositionIn)
    {
        this.surveyActualPosition = surveyActualPositionIn;
    }

    private String surveyPositionCm;

    /**
     * Commentaire associé à la localisation
     * @return this.surveyPositionCm String
     */
    public String getSurveyPositionCm()
    {
        return this.surveyPositionCm;
    }

    /**
     * Commentaire associé à la localisation
     * @param surveyPositionCmIn String
     */
    public void setSurveyPositionCm(String surveyPositionCmIn)
    {
        this.surveyPositionCm = surveyPositionCmIn;
    }

    private Date surveyGeometryValidDt;

    /**
     * Date de validation de la géométrie de l'objet
     * @return this.surveyGeometryValidDt Date
     */
    public Date getSurveyGeometryValidDt()
    {
        return this.surveyGeometryValidDt;
    }

    /**
     * Date de validation de la géométrie de l'objet
     * @param surveyGeometryValidDtIn Date
     */
    public void setSurveyGeometryValidDt(Date surveyGeometryValidDtIn)
    {
        this.surveyGeometryValidDt = surveyGeometryValidDtIn;
    }

    private String surveyScope;

    /**
     * Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont
     * pas la même étape
     * @return this.surveyScope String
     */
    public String getSurveyScope()
    {
        return this.surveyScope;
    }

    /**
     * Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont
     * pas la même étape
     * @param surveyScopeIn String
     */
    public void setSurveyScope(String surveyScopeIn)
    {
        this.surveyScope = surveyScopeIn;
    }

    private String surveyHasMeas;

    /**
     * Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @return this.surveyHasMeas String
     */
    public String getSurveyHasMeas()
    {
        return this.surveyHasMeas;
    }

    /**
     * Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @param surveyHasMeasIn String
     */
    public void setSurveyHasMeas(String surveyHasMeasIn)
    {
        this.surveyHasMeas = surveyHasMeasIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private String synchronizationStatus;

    /**
     * 
     * @return this.synchronizationStatus String
     */
    public String getSynchronizationStatus()
    {
        return this.synchronizationStatus;
    }

    /**
     * 
     * @param synchronizationStatusIn String
     */
    public void setSynchronizationStatus(String synchronizationStatusIn)
    {
        this.synchronizationStatus = synchronizationStatusIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 23 associations
    private Collection<Quser> qusers = new HashSet<Quser>();

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @return this.qusers Collection<Quser>
     */
    public Collection<Quser> getQusers()
    {
        return this.qusers;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param qusersIn Collection<Quser>
     */
    public void setQusers(Collection<Quser> qusersIn)
    {
        this.qusers = qusersIn;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param elementToAdd Quser
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addQusers(Quser elementToAdd)
    {
        return this.qusers.add(elementToAdd);
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param elementToRemove Quser
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeQusers(Quser elementToRemove)
    {
        return this.qusers.remove(elementToRemove);
    }

    private Collection<FieldObservation> fieldObservations = new HashSet<FieldObservation>();

    /**
     * Liste des observations terrain
     * @return this.fieldObservations Collection<FieldObservation>
     */
    public Collection<FieldObservation> getFieldObservations()
    {
        return this.fieldObservations;
    }

    /**
     * Liste des observations terrain
     * @param fieldObservationsIn Collection<FieldObservation>
     */
    public void setFieldObservations(Collection<FieldObservation> fieldObservationsIn)
    {
        this.fieldObservations = fieldObservationsIn;
    }

    /**
     * Liste des observations terrain
     * @param elementToAdd FieldObservation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addFieldObservations(FieldObservation elementToAdd)
    {
        return this.fieldObservations.add(elementToAdd);
    }

    /**
     * Liste des observations terrain
     * @param elementToRemove FieldObservation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeFieldObservations(FieldObservation elementToRemove)
    {
        return this.fieldObservations.remove(elementToRemove);
    }

    private Unit bottomDepthUnit;

    /**
     * Liste l'ensemble des unités de mesure.
     * @return this.bottomDepthUnit Unit
     */
    public Unit getBottomDepthUnit()
    {
        return this.bottomDepthUnit;
    }

    /**
     * Liste l'ensemble des unités de mesure.
     * @param bottomDepthUnitIn Unit
     */
    public void setBottomDepthUnit(Unit bottomDepthUnitIn)
    {
        this.bottomDepthUnit = bottomDepthUnitIn;
    }

    private MonitoringLocation monitoringLocation;

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @return this.monitoringLocation MonitoringLocation
     */
    public MonitoringLocation getMonitoringLocation()
    {
        return this.monitoringLocation;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param monitoringLocationIn MonitoringLocation
     */
    public void setMonitoringLocation(MonitoringLocation monitoringLocationIn)
    {
        this.monitoringLocation = monitoringLocationIn;
    }

    private PositionningSystem positionningSystem;

    /**
     * Informations complémentaires sur le positionnement d'un objet.
     * @return this.positionningSystem PositionningSystem
     */
    public PositionningSystem getPositionningSystem()
    {
        return this.positionningSystem;
    }

    /**
     * Informations complémentaires sur le positionnement d'un objet.
     * @param positionningSystemIn PositionningSystem
     */
    public void setPositionningSystem(PositionningSystem positionningSystemIn)
    {
        this.positionningSystem = positionningSystemIn;
    }

    private Collection<Program> programs = new HashSet<Program>();

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @return this.programs Collection<Program>
     */
    public Collection<Program> getPrograms()
    {
        return this.programs;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param programsIn Collection<Program>
     */
    public void setPrograms(Collection<Program> programsIn)
    {
        this.programs = programsIn;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToAdd Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPrograms(Program elementToAdd)
    {
        return this.programs.add(elementToAdd);
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToRemove Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePrograms(Program elementToRemove)
    {
        return this.programs.remove(elementToRemove);
    }

    private Collection<MeasuredProfile> measuredProfiles = new HashSet<MeasuredProfile>();

    /**
     * Profil mesuré envoyé à Coriolis
     * La référence des profils est QUADRIGE-DDMMYYYY-XXXX
     * Elle est générée à partir de l'identifiant, de la date de création et d'une chaine en dur.
     * @return this.measuredProfiles Collection<MeasuredProfile>
     */
    public Collection<MeasuredProfile> getMeasuredProfiles()
    {
        return this.measuredProfiles;
    }

    /**
     * Profil mesuré envoyé à Coriolis
     * La référence des profils est QUADRIGE-DDMMYYYY-XXXX
     * Elle est générée à partir de l'identifiant, de la date de création et d'une chaine en dur.
     * @param measuredProfilesIn Collection<MeasuredProfile>
     */
    public void setMeasuredProfiles(Collection<MeasuredProfile> measuredProfilesIn)
    {
        this.measuredProfiles = measuredProfilesIn;
    }

    /**
     * Profil mesuré envoyé à Coriolis
     * La référence des profils est QUADRIGE-DDMMYYYY-XXXX
     * Elle est générée à partir de l'identifiant, de la date de création et d'une chaine en dur.
     * @param elementToAdd MeasuredProfile
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addMeasuredProfiles(MeasuredProfile elementToAdd)
    {
        return this.measuredProfiles.add(elementToAdd);
    }

    /**
     * Profil mesuré envoyé à Coriolis
     * La référence des profils est QUADRIGE-DDMMYYYY-XXXX
     * Elle est générée à partir de l'identifiant, de la date de création et d'une chaine en dur.
     * @param elementToRemove MeasuredProfile
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeMeasuredProfiles(MeasuredProfile elementToRemove)
    {
        return this.measuredProfiles.remove(elementToRemove);
    }

    private Collection<SamplingOperation> samplingOperations = new HashSet<SamplingOperation>();

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @return this.samplingOperations Collection<SamplingOperation>
     */
    public Collection<SamplingOperation> getSamplingOperations()
    {
        return this.samplingOperations;
    }

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @param samplingOperationsIn Collection<SamplingOperation>
     */
    public void setSamplingOperations(Collection<SamplingOperation> samplingOperationsIn)
    {
        this.samplingOperations = samplingOperationsIn;
    }

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @param elementToAdd SamplingOperation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingOperations(SamplingOperation elementToAdd)
    {
        return this.samplingOperations.add(elementToAdd);
    }

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @param elementToRemove SamplingOperation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingOperations(SamplingOperation elementToRemove)
    {
        return this.samplingOperations.remove(elementToRemove);
    }

    private Collection<SurveyArea> surveyAreas = new HashSet<SurveyArea>();

    /**
     * Gestion de la géométrie surfacique des passages.
     * @return this.surveyAreas Collection<SurveyArea>
     */
    public Collection<SurveyArea> getSurveyAreas()
    {
        return this.surveyAreas;
    }

    /**
     * Gestion de la géométrie surfacique des passages.
     * @param surveyAreasIn Collection<SurveyArea>
     */
    public void setSurveyAreas(Collection<SurveyArea> surveyAreasIn)
    {
        this.surveyAreas = surveyAreasIn;
    }

    /**
     * Gestion de la géométrie surfacique des passages.
     * @param elementToAdd SurveyArea
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSurveyAreas(SurveyArea elementToAdd)
    {
        return this.surveyAreas.add(elementToAdd);
    }

    /**
     * Gestion de la géométrie surfacique des passages.
     * @param elementToRemove SurveyArea
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSurveyAreas(SurveyArea elementToRemove)
    {
        return this.surveyAreas.remove(elementToRemove);
    }

    private Campaign campaign;

    /**
     * Liste des campagnes.
     * @return this.campaign Campaign
     */
    public Campaign getCampaign()
    {
        return this.campaign;
    }

    /**
     * Liste des campagnes.
     * @param campaignIn Campaign
     */
    public void setCampaign(Campaign campaignIn)
    {
        this.campaign = campaignIn;
    }

    private Collection<SurveyLine> surveyLines = new HashSet<SurveyLine>();

    /**
     * Gestino de la géométrie linéaire des passages.
     * @return this.surveyLines Collection<SurveyLine>
     */
    public Collection<SurveyLine> getSurveyLines()
    {
        return this.surveyLines;
    }

    /**
     * Gestino de la géométrie linéaire des passages.
     * @param surveyLinesIn Collection<SurveyLine>
     */
    public void setSurveyLines(Collection<SurveyLine> surveyLinesIn)
    {
        this.surveyLines = surveyLinesIn;
    }

    /**
     * Gestino de la géométrie linéaire des passages.
     * @param elementToAdd SurveyLine
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSurveyLines(SurveyLine elementToAdd)
    {
        return this.surveyLines.add(elementToAdd);
    }

    /**
     * Gestino de la géométrie linéaire des passages.
     * @param elementToRemove SurveyLine
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSurveyLines(SurveyLine elementToRemove)
    {
        return this.surveyLines.remove(elementToRemove);
    }

    private Department recorderDepartment;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.recorderDepartment Department
     */
    public Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param recorderDepartmentIn Department
     */
    public void setRecorderDepartment(Department recorderDepartmentIn)
    {
        this.recorderDepartment = recorderDepartmentIn;
    }

    private Collection<SurveyPoint> surveyPoints = new HashSet<SurveyPoint>();

    /**
     * Gestino de la géométrie ponctuelle des passages.
     * @return this.surveyPoints Collection<SurveyPoint>
     */
    public Collection<SurveyPoint> getSurveyPoints()
    {
        return this.surveyPoints;
    }

    /**
     * Gestino de la géométrie ponctuelle des passages.
     * @param surveyPointsIn Collection<SurveyPoint>
     */
    public void setSurveyPoints(Collection<SurveyPoint> surveyPointsIn)
    {
        this.surveyPoints = surveyPointsIn;
    }

    /**
     * Gestino de la géométrie ponctuelle des passages.
     * @param elementToAdd SurveyPoint
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSurveyPoints(SurveyPoint elementToAdd)
    {
        return this.surveyPoints.add(elementToAdd);
    }

    /**
     * Gestino de la géométrie ponctuelle des passages.
     * @param elementToRemove SurveyPoint
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSurveyPoints(SurveyPoint elementToRemove)
    {
        return this.surveyPoints.remove(elementToRemove);
    }

    private Collection<Video> videos = new HashSet<Video>();

    /**
     * Liste des vidéos sur un passage.
     * @return this.videos Collection<Video>
     */
    public Collection<Video> getVideos()
    {
        return this.videos;
    }

    /**
     * Liste des vidéos sur un passage.
     * @param videosIn Collection<Video>
     */
    public void setVideos(Collection<Video> videosIn)
    {
        this.videos = videosIn;
    }

    /**
     * Liste des vidéos sur un passage.
     * @param elementToAdd Video
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addVideos(Video elementToAdd)
    {
        return this.videos.add(elementToAdd);
    }

    /**
     * Liste des vidéos sur un passage.
     * @param elementToRemove Video
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeVideos(Video elementToRemove)
    {
        return this.videos.remove(elementToRemove);
    }

    private DredgingTargetArea dredgingTargetArea;

    /**
     * Description des zones de destination de dragage.
     * @return this.dredgingTargetArea DredgingTargetArea
     */
    public DredgingTargetArea getDredgingTargetArea()
    {
        return this.dredgingTargetArea;
    }

    /**
     * Description des zones de destination de dragage.
     * @param dredgingTargetAreaIn DredgingTargetArea
     */
    public void setDredgingTargetArea(DredgingTargetArea dredgingTargetAreaIn)
    {
        this.dredgingTargetArea = dredgingTargetAreaIn;
    }

    private QualityFlag qualityFlag;

    /**
     * Liste des niveaux de qualification.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Liste des niveaux de qualification.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private Collection<Event> events = new HashSet<Event>();

    /**
     * Liste les événements qui peuvent avoir ou non un rapport avec un passage.
     * @return this.events Collection<Event>
     */
    public Collection<Event> getEvents()
    {
        return this.events;
    }

    /**
     * Liste les événements qui peuvent avoir ou non un rapport avec un passage.
     * @param eventsIn Collection<Event>
     */
    public void setEvents(Collection<Event> eventsIn)
    {
        this.events = eventsIn;
    }

    /**
     * Liste les événements qui peuvent avoir ou non un rapport avec un passage.
     * @param elementToAdd Event
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addEvents(Event elementToAdd)
    {
        return this.events.add(elementToAdd);
    }

    /**
     * Liste les événements qui peuvent avoir ou non un rapport avec un passage.
     * @param elementToRemove Event
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeEvents(Event elementToRemove)
    {
        return this.events.remove(elementToRemove);
    }

    private Collection<ObservedHabitat> observedHabitats = new HashSet<ObservedHabitat>();

    /**
     * Commentaire sur l'habitat observé.
     * @return this.observedHabitats Collection<ObservedHabitat>
     */
    public Collection<ObservedHabitat> getObservedHabitats()
    {
        return this.observedHabitats;
    }

    /**
     * Commentaire sur l'habitat observé.
     * @param observedHabitatsIn Collection<ObservedHabitat>
     */
    public void setObservedHabitats(Collection<ObservedHabitat> observedHabitatsIn)
    {
        this.observedHabitats = observedHabitatsIn;
    }

    /**
     * Commentaire sur l'habitat observé.
     * @param elementToAdd ObservedHabitat
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addObservedHabitats(ObservedHabitat elementToAdd)
    {
        return this.observedHabitats.add(elementToAdd);
    }

    /**
     * Commentaire sur l'habitat observé.
     * @param elementToRemove ObservedHabitat
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeObservedHabitats(ObservedHabitat elementToRemove)
    {
        return this.observedHabitats.remove(elementToRemove);
    }

    private Occasion occasion;

    /**
     * Liste des sorties effectuées lors d'une campagne.
     * @return this.occasion Occasion
     */
    public Occasion getOccasion()
    {
        return this.occasion;
    }

    /**
     * Liste des sorties effectuées lors d'une campagne.
     * @param occasionIn Occasion
     */
    public void setOccasion(Occasion occasionIn)
    {
        this.occasion = occasionIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Survey instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Survey))
        {
            return false;
        }
        final Survey that = (Survey)object;
        if (this.surveyId == null || that.getSurveyId() == null || !this.surveyId.equals(that.getSurveyId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.surveyId == null ? 0 : this.surveyId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Survey}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Survey}.
         * @return new SurveyImpl()
         */
        public static Survey newInstance()
        {
            return new SurveyImpl();
        }

        /**
         * Constructs a new instance of {@link Survey}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param surveyDt Date
         * @param synchronizationStatus String
         * @param monitoringLocation MonitoringLocation
         * @param recorderDepartment Department
         * @param qualityFlag QualityFlag
         * @return newInstance
         */
        public static Survey newInstance(Date surveyDt, String synchronizationStatus, MonitoringLocation monitoringLocation, Department recorderDepartment, QualityFlag qualityFlag)
        {
            final Survey entity = new SurveyImpl();
            entity.setSurveyDt(surveyDt);
            entity.setSynchronizationStatus(synchronizationStatus);
            entity.setMonitoringLocation(monitoringLocation);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Survey}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param surveyDt Date
         * @param surveyTime Integer
         * @param surveyNumberIndiv Integer
         * @param surveyBottomDepth Float
         * @param surveyLb String
         * @param surveyCm String
         * @param surveyUtFormat Double
         * @param surveyControlDt Date
         * @param surveyValidDt Date
         * @param surveyValidCm String
         * @param surveyQualifDt Date
         * @param surveyQualifCm String
         * @param surveyActualPosition String
         * @param surveyPositionCm String
         * @param surveyGeometryValidDt Date
         * @param surveyScope String
         * @param surveyHasMeas String
         * @param updateDt Timestamp
         * @param synchronizationStatus String
         * @param remoteId Integer
         * @param qusers Collection<Quser>
         * @param fieldObservations Collection<FieldObservation>
         * @param bottomDepthUnit Unit
         * @param monitoringLocation MonitoringLocation
         * @param positionningSystem PositionningSystem
         * @param programs Collection<Program>
         * @param measuredProfiles Collection<MeasuredProfile>
         * @param samplingOperations Collection<SamplingOperation>
         * @param surveyAreas Collection<SurveyArea>
         * @param campaign Campaign
         * @param surveyLines Collection<SurveyLine>
         * @param recorderDepartment Department
         * @param surveyPoints Collection<SurveyPoint>
         * @param videos Collection<Video>
         * @param dredgingTargetArea DredgingTargetArea
         * @param qualityFlag QualityFlag
         * @param events Collection<Event>
         * @param observedHabitats Collection<ObservedHabitat>
         * @param occasion Occasion
         * @return newInstance Survey
         */
        public static Survey newInstance(Date surveyDt, Integer surveyTime, Integer surveyNumberIndiv, Float surveyBottomDepth, String surveyLb, String surveyCm, Double surveyUtFormat, Date surveyControlDt, Date surveyValidDt, String surveyValidCm, Date surveyQualifDt, String surveyQualifCm, String surveyActualPosition, String surveyPositionCm, Date surveyGeometryValidDt, String surveyScope, String surveyHasMeas, Timestamp updateDt, String synchronizationStatus, Integer remoteId, Collection<Quser> qusers, Collection<FieldObservation> fieldObservations, Unit bottomDepthUnit, MonitoringLocation monitoringLocation, PositionningSystem positionningSystem, Collection<Program> programs, Collection<MeasuredProfile> measuredProfiles, Collection<SamplingOperation> samplingOperations, Collection<SurveyArea> surveyAreas, Campaign campaign, Collection<SurveyLine> surveyLines, Department recorderDepartment, Collection<SurveyPoint> surveyPoints, Collection<Video> videos, DredgingTargetArea dredgingTargetArea, QualityFlag qualityFlag, Collection<Event> events, Collection<ObservedHabitat> observedHabitats, Occasion occasion)
        {
            final Survey entity = new SurveyImpl();
            entity.setSurveyDt(surveyDt);
            entity.setSurveyTime(surveyTime);
            entity.setSurveyNumberIndiv(surveyNumberIndiv);
            entity.setSurveyBottomDepth(surveyBottomDepth);
            entity.setSurveyLb(surveyLb);
            entity.setSurveyCm(surveyCm);
            entity.setSurveyUtFormat(surveyUtFormat);
            entity.setSurveyControlDt(surveyControlDt);
            entity.setSurveyValidDt(surveyValidDt);
            entity.setSurveyValidCm(surveyValidCm);
            entity.setSurveyQualifDt(surveyQualifDt);
            entity.setSurveyQualifCm(surveyQualifCm);
            entity.setSurveyActualPosition(surveyActualPosition);
            entity.setSurveyPositionCm(surveyPositionCm);
            entity.setSurveyGeometryValidDt(surveyGeometryValidDt);
            entity.setSurveyScope(surveyScope);
            entity.setSurveyHasMeas(surveyHasMeas);
            entity.setUpdateDt(updateDt);
            entity.setSynchronizationStatus(synchronizationStatus);
            entity.setRemoteId(remoteId);
            entity.setQusers(qusers);
            entity.setFieldObservations(fieldObservations);
            entity.setBottomDepthUnit(bottomDepthUnit);
            entity.setMonitoringLocation(monitoringLocation);
            entity.setPositionningSystem(positionningSystem);
            entity.setPrograms(programs);
            entity.setMeasuredProfiles(measuredProfiles);
            entity.setSamplingOperations(samplingOperations);
            entity.setSurveyAreas(surveyAreas);
            entity.setCampaign(campaign);
            entity.setSurveyLines(surveyLines);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setSurveyPoints(surveyPoints);
            entity.setVideos(videos);
            entity.setDredgingTargetArea(dredgingTargetArea);
            entity.setQualityFlag(qualityFlag);
            entity.setEvents(events);
            entity.setObservedHabitats(observedHabitats);
            entity.setOccasion(occasion);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Survey o)
    {
        int cmp = 0;
        if (this.getSurveyId() != null)
        {
            cmp = this.getSurveyId().compareTo(o.getSurveyId());
        }
        else
        {
            if (this.getSurveyDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyDt().compareTo(o.getSurveyDt()));
            }
            if (this.getSurveyTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyTime().compareTo(o.getSurveyTime()));
            }
            if (this.getSurveyNumberIndiv() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyNumberIndiv().compareTo(o.getSurveyNumberIndiv()));
            }
            if (this.getSurveyBottomDepth() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyBottomDepth().compareTo(o.getSurveyBottomDepth()));
            }
            if (this.getSurveyLb() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyLb().compareTo(o.getSurveyLb()));
            }
            if (this.getSurveyCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyCm().compareTo(o.getSurveyCm()));
            }
            if (this.getSurveyUtFormat() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyUtFormat().compareTo(o.getSurveyUtFormat()));
            }
            if (this.getSurveyControlDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyControlDt().compareTo(o.getSurveyControlDt()));
            }
            if (this.getSurveyValidDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyValidDt().compareTo(o.getSurveyValidDt()));
            }
            if (this.getSurveyValidCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyValidCm().compareTo(o.getSurveyValidCm()));
            }
            if (this.getSurveyQualifDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyQualifDt().compareTo(o.getSurveyQualifDt()));
            }
            if (this.getSurveyQualifCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyQualifCm().compareTo(o.getSurveyQualifCm()));
            }
            if (this.getSurveyActualPosition() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyActualPosition().compareTo(o.getSurveyActualPosition()));
            }
            if (this.getSurveyPositionCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyPositionCm().compareTo(o.getSurveyPositionCm()));
            }
            if (this.getSurveyGeometryValidDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyGeometryValidDt().compareTo(o.getSurveyGeometryValidDt()));
            }
            if (this.getSurveyScope() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyScope().compareTo(o.getSurveyScope()));
            }
            if (this.getSurveyHasMeas() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSurveyHasMeas().compareTo(o.getSurveyHasMeas()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
            if (this.getSynchronizationStatus() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSynchronizationStatus().compareTo(o.getSynchronizationStatus()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Survey.java merge-point
}