// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.data.survey;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocation;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Liste les différents passages effectués sur un lieu de surveillance.
 * Liste les différents passages effectués sur un lieu de surveillance.
 * @see Survey
 */
public interface SurveyDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Survey}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of Survey from the persistent store.
     * @param surveyId
     * @return Survey
     */
    public Survey get(Integer surveyId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param surveyId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer surveyId);

    /**
     * Loads an instance of Survey from the persistent store.
     * @param surveyId
     * @return Survey
     */
    public Survey load(Integer surveyId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param surveyId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer surveyId);

    /**
     * Loads all entities of type {@link Survey}.
     *
     * @return the loaded entities.
     */
    public Collection<Survey> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Survey and adds it to the persistent store.
     * @param survey
     * @return Survey
     */
    public Survey create(Survey survey);

    /**
     * <p>
     * Does the same thing as {@link #create(Survey)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param survey
     * @return Object
     */
    public Object create(int transform, Survey survey);

    /**
     * Creates a new instance of Survey and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Survey
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Survey> create(Collection<Survey> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Survey)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Survey> entities);

    /**
     * <p>
     * Creates a new <code>Survey</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param surveyDt Date du passage
Cette date ne comprend pas les heures, minutes, secondes du passage qui sont renseignés séparément.
     * @param surveyTime Heure du passage.
Cette heure est indépendante de la date, car elle n'est pas obligatoire et il faut être capable de
séparer un passage à minuit et une heure non renseignée.
L'heure renseignée par l'utilisateur est l'heure locale, ie UT+1 ou UT+2
     * @param surveyNumberIndiv Nombre d¿¿individus sur le passage
     * @param surveyBottomDepth Valeur de la sonde à l'endroit du passage.
Cette valeur n'a de sens que lorsque le passage est de type ponctuel.
Elle n'est pas obligatoire, car il il y a des passages à terre (rebent intertidal)
     * @param surveyLb Chaine de caractères contenant une suite de mots clefs connus de l'utilisateur et servant à
identifier le passage (lors d'une sélection par exemple?)
     * @param surveyCm Commentaire sur le passage. (les commentaires en général ne servent pas à décrire mais à donner des
informations diverses et variées, et surtout accessoires, pas capitales).
     * @param surveyUtFormat Format UT de l'heure pour le passage [-12;12]
     * @param surveyControlDt Date des contrôles les caractéristiques du passage
Cette date ainsi que celle de qualification, et validation ne sont pas renseignées par
l'utilisateur, mais par les fonctions associées.
     * @param surveyValidDt Date de validation de la données
     * @param surveyValidCm 
     * @param surveyQualifDt Date de qualification de la données
     * @param surveyQualifCm Commentaires sur la qualification du passage. Ces commentaires sont obligatoires si le niveau de
qualification est douteux ou faux. On peut par exemple noter dans le commentaire que l¿engin
d¿analyse utilisé était déficient.
     * @param surveyActualPosition Vrai si la géométrie est définie par l'utilisateur, faux si elle est héritée du lieu.
Cette information est renseignée par le système et permet par la suite une thématique d'affichage.
     * @param surveyPositionCm Commentaire associé à la localisation
     * @param surveyGeometryValidDt Date de validation de la géométrie de l'objet
     * @param surveyScope Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont pas la
même étape
     * @param surveyHasMeas Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param synchronizationStatus 
     * @param remoteId 
     * @return Survey
     */
    public Survey create(
        Date surveyDt,
        Integer surveyTime,
        Integer surveyNumberIndiv,
        Float surveyBottomDepth,
        String surveyLb,
        String surveyCm,
        Double surveyUtFormat,
        Date surveyControlDt,
        Date surveyValidDt,
        String surveyValidCm,
        Date surveyQualifDt,
        String surveyQualifCm,
        String surveyActualPosition,
        String surveyPositionCm,
        Date surveyGeometryValidDt,
        String surveyScope,
        String surveyHasMeas,
        Timestamp updateDt,
        String synchronizationStatus,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, Integer, Integer, Float, String, String, Double, Date, Date, String, Date, String, String, String, Date, String, String, Timestamp, String, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param surveyDt Date du passage
Cette date ne comprend pas les heures, minutes, secondes du passage qui sont renseignés séparément.
     * @param surveyTime Heure du passage.
Cette heure est indépendante de la date, car elle n'est pas obligatoire et il faut être capable de
séparer un passage à minuit et une heure non renseignée.
L'heure renseignée par l'utilisateur est l'heure locale, ie UT+1 ou UT+2
     * @param surveyNumberIndiv Nombre d¿¿individus sur le passage
     * @param surveyBottomDepth Valeur de la sonde à l'endroit du passage.
Cette valeur n'a de sens que lorsque le passage est de type ponctuel.
Elle n'est pas obligatoire, car il il y a des passages à terre (rebent intertidal)
     * @param surveyLb Chaine de caractères contenant une suite de mots clefs connus de l'utilisateur et servant à
identifier le passage (lors d'une sélection par exemple?)
     * @param surveyCm Commentaire sur le passage. (les commentaires en général ne servent pas à décrire mais à donner des
informations diverses et variées, et surtout accessoires, pas capitales).
     * @param surveyUtFormat Format UT de l'heure pour le passage [-12;12]
     * @param surveyControlDt Date des contrôles les caractéristiques du passage
Cette date ainsi que celle de qualification, et validation ne sont pas renseignées par
l'utilisateur, mais par les fonctions associées.
     * @param surveyValidDt Date de validation de la données
     * @param surveyValidCm 
     * @param surveyQualifDt Date de qualification de la données
     * @param surveyQualifCm Commentaires sur la qualification du passage. Ces commentaires sont obligatoires si le niveau de
qualification est douteux ou faux. On peut par exemple noter dans le commentaire que l¿engin
d¿analyse utilisé était déficient.
     * @param surveyActualPosition Vrai si la géométrie est définie par l'utilisateur, faux si elle est héritée du lieu.
Cette information est renseignée par le système et permet par la suite une thématique d'affichage.
     * @param surveyPositionCm Commentaire associé à la localisation
     * @param surveyGeometryValidDt Date de validation de la géométrie de l'objet
     * @param surveyScope Vrai si l'étape de qualification est globale, faux si des éléments fils ou résultats n'ont pas la
même étape
     * @param surveyHasMeas Vrai si l'élément a des résultats de mesure, dénombrement ou fichier
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @param synchronizationStatus 
     * @param remoteId 
     * @return Survey
     */
    public Object create(
        int transform,
        Date surveyDt,
        Integer surveyTime,
        Integer surveyNumberIndiv,
        Float surveyBottomDepth,
        String surveyLb,
        String surveyCm,
        Double surveyUtFormat,
        Date surveyControlDt,
        Date surveyValidDt,
        String surveyValidCm,
        Date surveyQualifDt,
        String surveyQualifCm,
        String surveyActualPosition,
        String surveyPositionCm,
        Date surveyGeometryValidDt,
        String surveyScope,
        String surveyHasMeas,
        Timestamp updateDt,
        String synchronizationStatus,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>Survey</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param surveyDt
     * @param synchronizationStatus
     * @param recorderDepartment
     * @param monitoringLocation
     * @param qualityFlag
     * @return Survey
     */
    public Survey create(
        Date surveyDt,
        String synchronizationStatus,
        Department recorderDepartment,
        MonitoringLocation monitoringLocation,
        QualityFlag qualityFlag);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param surveyDt
     * @param synchronizationStatus
     * @param recorderDepartment
     * @param monitoringLocation
     * @param qualityFlag
     * @return Object
     */
    public Object create(
        int transform,
        Date surveyDt,
        String synchronizationStatus,
        Department recorderDepartment,
        MonitoringLocation monitoringLocation,
        QualityFlag qualityFlag);

    /**
     * Updates the <code>survey</code> instance in the persistent store.
     * @param survey
     */
    public void update(Survey survey);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Survey> entities);

    /**
     * Removes the instance of Survey from the persistent store.
     * @param survey
     */
    public void remove(Survey survey);

    /**
     * Removes the instance of Survey having the given
     * <code>identifier</code> from the persistent store.
     * @param surveyId
     */
    public void remove(Integer surveyId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Survey> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Survey> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.data.survey.SurveyDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.data.survey.SurveyDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Survey entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Survey)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.data.survey.SurveyDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Survey)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}