/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
// Attention: Generated code! Do not modify by hand!
// Generated by: TypeSafeEnumeration.vsl in andromda-java-cartridge.
// Model Class:  Données::fr.ifremer.quadrige3.core::dao::referential::AcquisitionLevelCode
// Metafacade:   org.andromda.metafacades.uml.Enumeration
// Stereotype:  Enumeration
//
package fr.ifremer.quadrige3.core.dao.referential;

import fr.ifremer.quadrige3.core.dao.technical.QuadrigeEnumerationDef;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import static org.nuiton.i18n.I18n.n;

/**
 * 
 */
public enum AcquisitionLevelCode
    implements Serializable, QuadrigeEnumerationDef<String>
{
    SURVEY (
			"quadrige3.enumeration.AcquisitionLevelCode.SURVEY",
			n("quadrige3.enumeration.AcquisitionLevelCode.SURVEY.description"),
			"PASS"),
    SAMPLE (
			"quadrige3.enumeration.AcquisitionLevelCode.SAMPLE",
			n("quadrige3.enumeration.AcquisitionLevelCode.SAMPLE.description"),
			"ECHANT"),
    SAMPLING_OPERATION (
			"quadrige3.enumeration.AcquisitionLevelCode.SAMPLING_OPERATION",
			n("quadrige3.enumeration.AcquisitionLevelCode.SAMPLING_OPERATION.description"),
			"PREL");

    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -727653841763645900L;

    private String key;
    private String description;
    private String enumValue;

    /**
     * The constructor with enumeration literal value allowing
     * super classes to access it.
     */
    private AcquisitionLevelCode(String key, String description, String value)
    {
    	this.key = key;
    	this.description = description;
        this.enumValue = value;
    }
    
    @Override
     /**
      * Setter for value. Use to override value, from configuration
      */
     public void setValue(String newValue) {
		if (newValue != null && !this.enumValue.equals(newValue)) {
			// Update static lists
	    	values.remove(this.enumValue);
	    	literals.remove(this.enumValue);
	    	this.enumValue = newValue;
	    	values.put(this.enumValue, this);
	    	literals.add(this.enumValue);
		}
    }
    

    @Override
    public String getValueAsString()
    {
        return String.valueOf(this.enumValue);
    }

    /**
     * Retrieves an instance of AcquisitionLevelCode from <code>its name</code>.
     *
     * @param name the name to create the AcquisitionLevelCode from.
     * @return The enumeration literal named after the 'name' argument
     */
    public static AcquisitionLevelCode fromString(String name)
    {
        return AcquisitionLevelCode.valueOf(name);
    }

    /**
     * Returns an enumeration literal String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @return String with corresponding value
     */
    public String value()
    {
        return this.enumValue;
    }

    /**
     * Returns an instance of AcquisitionLevelCode from String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @param value the value to create the AcquisitionLevelCode from.
     * @return static Enumeration with corresponding value
     */
    public static AcquisitionLevelCode fromValue(String value)
    {
        for (AcquisitionLevelCode enumName: AcquisitionLevelCode.values())
        {
            if (enumName.getValue().equals(value))
            {
                return enumName;
            }
        }
        throw new IllegalArgumentException("AcquisitionLevelCode.fromValue(" + value + ')');
    }

    /**
     * Gets the underlying value of this type safe enumeration.
     * This method is necessary to comply with DaoBase implementation.
     * @return The name of this literal.
     */
    public String getValue()
    {
        return this.enumValue;
    }
    
    @Override
    public String getDescription() {
    	return description;
    }
    
    @Override
    public String getKey() {
    	return key;
    }
    
    @Override
    public Class<?> getType() {
    	return String.class;
    }
    
    /**
     * Returns an unmodifiable list containing the literals that are known by this enumeration.
     *
     * @return A List containing the actual literals defined by this enumeration, this list
     *         can not be modified.
     */
    public static List<String> literals()
    {
        return AcquisitionLevelCode.literals;
    }

    /**
     * Returns an unmodifiable list containing the names of the literals that are known
     * by this enumeration.
     *
     * @return A List containing the actual names of the literals defined by this
     *         enumeration, this list can not be modified.
     */
    public static List<String> names()
    {
        return AcquisitionLevelCode.names;
    }

    private static Map<String, AcquisitionLevelCode> values = new LinkedHashMap<String, AcquisitionLevelCode>(3, 1);
    private static List<String> literals = new ArrayList<String>(3);
    private static List<String> names = new ArrayList<String>(3);
    private static List<AcquisitionLevelCode> valueList = new ArrayList<AcquisitionLevelCode>(3);

    /**
     * Initializes the values.
     */
    static
    {
        synchronized (AcquisitionLevelCode.values)
        {
            AcquisitionLevelCode.values.put(SURVEY.enumValue, SURVEY);
            AcquisitionLevelCode.values.put(SAMPLE.enumValue, SAMPLE);
            AcquisitionLevelCode.values.put(SAMPLING_OPERATION.enumValue, SAMPLING_OPERATION);
        }
        synchronized (AcquisitionLevelCode.valueList)
        {
            AcquisitionLevelCode.valueList.add(SURVEY);
            AcquisitionLevelCode.valueList.add(SAMPLE);
            AcquisitionLevelCode.valueList.add(SAMPLING_OPERATION);
            // For Quadrige3, lists could be reload from configuration (see method 'setValue')
            //AcquisitionLevelCode.valueList = Collections.unmodifiableList(valueList);
        }
        synchronized (AcquisitionLevelCode.literals)
        {
            AcquisitionLevelCode.literals.add(SURVEY.enumValue);
            AcquisitionLevelCode.literals.add(SAMPLE.enumValue);
            AcquisitionLevelCode.literals.add(SAMPLING_OPERATION.enumValue);
            // For Quadrige3, lists could be reload from configuration (see method 'setValue')
            //AcquisitionLevelCode.literals = Collections.unmodifiableList(literals);
        }
        synchronized (AcquisitionLevelCode.names)
        {
            AcquisitionLevelCode.names.add("SURVEY");
            AcquisitionLevelCode.names.add("SAMPLE");
            AcquisitionLevelCode.names.add("SAMPLING_OPERATION");
            AcquisitionLevelCode.names = Collections.unmodifiableList(names);
        }
    }
    // type-safe-enumeration-object java merge-point
}