// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential;

import fr.ifremer.quadrige3.core.dao.system.Selection;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Liste des types d'objets qui peuvent être associés à la photo ou à un résultat. Cette liste ne
 * peut pas être modifiée par l'utilisateur.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ObjectType
    implements Serializable, Comparable<ObjectType>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -2257411843304445516L;

    // Generate 4 attributes
    private String objectTypeCd;

    /**
     * Code du type d'objet associé
     * @return this.objectTypeCd String
     */
    public String getObjectTypeCd()
    {
        return this.objectTypeCd;
    }

    /**
     * Code du type d'objet associé
     * @param objectTypeCdIn String
     */
    public void setObjectTypeCd(String objectTypeCdIn)
    {
        this.objectTypeCd = objectTypeCdIn;
    }

    private String objectTypeNm;

    /**
     * Libellé du type d'objet
     * @return this.objectTypeNm String
     */
    public String getObjectTypeNm()
    {
        return this.objectTypeNm;
    }

    /**
     * Libellé du type d'objet
     * @param objectTypeNmIn String
     */
    public void setObjectTypeNm(String objectTypeNmIn)
    {
        this.objectTypeNm = objectTypeNmIn;
    }

    private String objectTypeDc;

    /**
     * Description du type d'objet
     * @return this.objectTypeDc String
     */
    public String getObjectTypeDc()
    {
        return this.objectTypeDc;
    }

    /**
     * Description du type d'objet
     * @param objectTypeDcIn String
     */
    public void setObjectTypeDc(String objectTypeDcIn)
    {
        this.objectTypeDc = objectTypeDcIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 10 associations
    private Collection<Selection> selIds = new HashSet<Selection>();

    /**
     * Liste des sélections cartographique.
     * @return this.selIds Collection<Selection>
     */
    public Collection<Selection> getSelIds()
    {
        return this.selIds;
    }

    /**
     * Liste des sélections cartographique.
     * @param selIdsIn Collection<Selection>
     */
    public void setSelIds(Collection<Selection> selIdsIn)
    {
        this.selIds = selIdsIn;
    }

    /**
     * Liste des sélections cartographique.
     * @param elementToAdd Selection
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSelIds(Selection elementToAdd)
    {
        return this.selIds.add(elementToAdd);
    }

    /**
     * Liste des sélections cartographique.
     * @param elementToRemove Selection
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSelIds(Selection elementToRemove)
    {
        return this.selIds.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an ObjectType instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ObjectType))
        {
            return false;
        }
        final ObjectType that = (ObjectType)object;
        if (this.objectTypeCd == null || that.getObjectTypeCd() == null || !this.objectTypeCd.equals(that.getObjectTypeCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.objectTypeCd == null ? 0 : this.objectTypeCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link ObjectType}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ObjectType}.
         * @return new ObjectTypeImpl()
         */
        public static ObjectType newInstance()
        {
            return new ObjectTypeImpl();
        }

        /**
         * Constructs a new instance of {@link ObjectType}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param objectTypeNm String
         * @return newInstance
         */
        public static ObjectType newInstance(String objectTypeNm)
        {
            final ObjectType entity = new ObjectTypeImpl();
            entity.setObjectTypeNm(objectTypeNm);
            return entity;
        }

        /**
         * Constructs a new instance of {@link ObjectType}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param objectTypeNm String
         * @param objectTypeDc String
         * @param updateDt Timestamp
         * @param selIds Collection<Selection>
         * @return newInstance ObjectType
         */
        public static ObjectType newInstance(String objectTypeNm, String objectTypeDc, Timestamp updateDt, Collection<Selection> selIds)
        {
            final ObjectType entity = new ObjectTypeImpl();
            entity.setObjectTypeNm(objectTypeNm);
            entity.setObjectTypeDc(objectTypeDc);
            entity.setUpdateDt(updateDt);
            entity.setSelIds(selIds);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ObjectType o)
    {
        int cmp = 0;
        if (this.getObjectTypeCd() != null)
        {
            cmp = this.getObjectTypeCd().compareTo(o.getObjectTypeCd());
        }
        else
        {
            if (this.getObjectTypeNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectTypeNm().compareTo(o.getObjectTypeNm()));
            }
            if (this.getObjectTypeDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectTypeDc().compareTo(o.getObjectTypeDc()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ObjectType.java merge-point
}