/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
// Attention: Generated code! Do not modify by hand!
// Generated by: TypeSafeEnumeration.vsl in andromda-java-cartridge.
// Model Class:  Données::fr.ifremer.quadrige3.core::dao::referential::ObjectTypeCode
// Metafacade:   org.andromda.metafacades.uml.Enumeration
// Stereotype:  Enumeration
//
package fr.ifremer.quadrige3.core.dao.referential;

import fr.ifremer.quadrige3.core.dao.technical.QuadrigeEnumerationDef;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import static org.nuiton.i18n.I18n.n;

/**
 * 
 */
public enum ObjectTypeCode
    implements Serializable, QuadrigeEnumerationDef<String>
{
    SURVEY (
			"quadrige3.enumeration.ObjectTypeCode.SURVEY",
			n("quadrige3.enumeration.ObjectTypeCode.SURVEY.description"),
			"PASS"),
    SAMPLING_OPERATION (
			"quadrige3.enumeration.ObjectTypeCode.SAMPLING_OPERATION",
			n("quadrige3.enumeration.ObjectTypeCode.SAMPLING_OPERATION.description"),
			"PREL"),
    SAMPLE (
			"quadrige3.enumeration.ObjectTypeCode.SAMPLE",
			n("quadrige3.enumeration.ObjectTypeCode.SAMPLE.description"),
			"ECHANT"),
    EVENT (
			"quadrige3.enumeration.ObjectTypeCode.EVENT",
			n("quadrige3.enumeration.ObjectTypeCode.EVENT.description"),
			"EVEN"),
    SCIENTIFIC_CRUISE (
			"quadrige3.enumeration.ObjectTypeCode.SCIENTIFIC_CRUISE",
			n("quadrige3.enumeration.ObjectTypeCode.SCIENTIFIC_CRUISE.description"),
			"CAMP"),
    FIELD_OBSERVATION (
			"quadrige3.enumeration.ObjectTypeCode.FIELD_OBSERVATION",
			n("quadrige3.enumeration.ObjectTypeCode.FIELD_OBSERVATION.description"),
			"FIELD_OBS"),
    INITIAL_POPULATION (
			"quadrige3.enumeration.ObjectTypeCode.INITIAL_POPULATION",
			n("quadrige3.enumeration.ObjectTypeCode.INITIAL_POPULATION.description"),
			"INIT_POP"),
    MONITORING_LOCATION (
			"quadrige3.enumeration.ObjectTypeCode.MONITORING_LOCATION",
			n("quadrige3.enumeration.ObjectTypeCode.MONITORING_LOCATION.description"),
			"LIEU"),
    BATCH (
			"quadrige3.enumeration.ObjectTypeCode.BATCH",
			n("quadrige3.enumeration.ObjectTypeCode.BATCH.description"),
			"LOT"),
    MEASUREMENT (
			"quadrige3.enumeration.ObjectTypeCode.MEASUREMENT",
			n("quadrige3.enumeration.ObjectTypeCode.MEASUREMENT.description"),
			"MEAS"),
    MEASUREMENT_FILE (
			"quadrige3.enumeration.ObjectTypeCode.MEASUREMENT_FILE",
			n("quadrige3.enumeration.ObjectTypeCode.MEASUREMENT_FILE.description"),
			"MEAS_FILE"),
    TAXON_MEASUREMENT (
			"quadrige3.enumeration.ObjectTypeCode.TAXON_MEASUREMENT",
			n("quadrige3.enumeration.ObjectTypeCode.TAXON_MEASUREMENT.description"),
			"TAXON_MEAS"),
    MEASURED_PROFILE (
			"quadrige3.enumeration.ObjectTypeCode.MEASURED_PROFILE",
			n("quadrige3.enumeration.ObjectTypeCode.MEASURED_PROFILE.description"),
			"MEAS_PROF"),
    OBSERVED_HABITAT (
			"quadrige3.enumeration.ObjectTypeCode.OBSERVED_HABITAT",
			n("quadrige3.enumeration.ObjectTypeCode.OBSERVED_HABITAT.description"),
			"OBS_HAB"),
    OCCASION (
			"quadrige3.enumeration.ObjectTypeCode.OCCASION",
			n("quadrige3.enumeration.ObjectTypeCode.OCCASION.description"),
			"SORTIE"),
    VIDEO (
			"quadrige3.enumeration.ObjectTypeCode.VIDEO",
			n("quadrige3.enumeration.ObjectTypeCode.VIDEO.description"),
			"VIDEO"),
    PHOTO (
			"quadrige3.enumeration.ObjectTypeCode.PHOTO",
			n("quadrige3.enumeration.ObjectTypeCode.PHOTO.description"),
			"PHOTO");

    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 6475468724709160997L;

    private String key;
    private String description;
    private String enumValue;

    /**
     * The constructor with enumeration literal value allowing
     * super classes to access it.
     */
    private ObjectTypeCode(String key, String description, String value)
    {
    	this.key = key;
    	this.description = description;
        this.enumValue = value;
    }
    
    @Override
     /**
      * Setter for value. Use to override value, from configuration
      */
     public void setValue(String newValue) {
		if (newValue != null && !this.enumValue.equals(newValue)) {
			// Update static lists
	    	values.remove(this.enumValue);
	    	literals.remove(this.enumValue);
	    	this.enumValue = newValue;
	    	values.put(this.enumValue, this);
	    	literals.add(this.enumValue);
		}
    }
    

    @Override
    public String getValueAsString()
    {
        return String.valueOf(this.enumValue);
    }

    /**
     * Retrieves an instance of ObjectTypeCode from <code>its name</code>.
     *
     * @param name the name to create the ObjectTypeCode from.
     * @return The enumeration literal named after the 'name' argument
     */
    public static ObjectTypeCode fromString(String name)
    {
        return ObjectTypeCode.valueOf(name);
    }

    /**
     * Returns an enumeration literal String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @return String with corresponding value
     */
    public String value()
    {
        return this.enumValue;
    }

    /**
     * Returns an instance of ObjectTypeCode from String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @param value the value to create the ObjectTypeCode from.
     * @return static Enumeration with corresponding value
     */
    public static ObjectTypeCode fromValue(String value)
    {
        for (ObjectTypeCode enumName: ObjectTypeCode.values())
        {
            if (enumName.getValue().equals(value))
            {
                return enumName;
            }
        }
        throw new IllegalArgumentException("ObjectTypeCode.fromValue(" + value + ')');
    }

    /**
     * Gets the underlying value of this type safe enumeration.
     * This method is necessary to comply with DaoBase implementation.
     * @return The name of this literal.
     */
    public String getValue()
    {
        return this.enumValue;
    }
    
    @Override
    public String getDescription() {
    	return description;
    }
    
    @Override
    public String getKey() {
    	return key;
    }
    
    @Override
    public Class<?> getType() {
    	return String.class;
    }
    
    /**
     * Returns an unmodifiable list containing the literals that are known by this enumeration.
     *
     * @return A List containing the actual literals defined by this enumeration, this list
     *         can not be modified.
     */
    public static List<String> literals()
    {
        return ObjectTypeCode.literals;
    }

    /**
     * Returns an unmodifiable list containing the names of the literals that are known
     * by this enumeration.
     *
     * @return A List containing the actual names of the literals defined by this
     *         enumeration, this list can not be modified.
     */
    public static List<String> names()
    {
        return ObjectTypeCode.names;
    }

    private static Map<String, ObjectTypeCode> values = new LinkedHashMap<String, ObjectTypeCode>(17, 1);
    private static List<String> literals = new ArrayList<String>(17);
    private static List<String> names = new ArrayList<String>(17);
    private static List<ObjectTypeCode> valueList = new ArrayList<ObjectTypeCode>(17);

    /**
     * Initializes the values.
     */
    static
    {
        synchronized (ObjectTypeCode.values)
        {
            ObjectTypeCode.values.put(SURVEY.enumValue, SURVEY);
            ObjectTypeCode.values.put(SAMPLING_OPERATION.enumValue, SAMPLING_OPERATION);
            ObjectTypeCode.values.put(SAMPLE.enumValue, SAMPLE);
            ObjectTypeCode.values.put(EVENT.enumValue, EVENT);
            ObjectTypeCode.values.put(SCIENTIFIC_CRUISE.enumValue, SCIENTIFIC_CRUISE);
            ObjectTypeCode.values.put(FIELD_OBSERVATION.enumValue, FIELD_OBSERVATION);
            ObjectTypeCode.values.put(INITIAL_POPULATION.enumValue, INITIAL_POPULATION);
            ObjectTypeCode.values.put(MONITORING_LOCATION.enumValue, MONITORING_LOCATION);
            ObjectTypeCode.values.put(BATCH.enumValue, BATCH);
            ObjectTypeCode.values.put(MEASUREMENT.enumValue, MEASUREMENT);
            ObjectTypeCode.values.put(MEASUREMENT_FILE.enumValue, MEASUREMENT_FILE);
            ObjectTypeCode.values.put(TAXON_MEASUREMENT.enumValue, TAXON_MEASUREMENT);
            ObjectTypeCode.values.put(MEASURED_PROFILE.enumValue, MEASURED_PROFILE);
            ObjectTypeCode.values.put(OBSERVED_HABITAT.enumValue, OBSERVED_HABITAT);
            ObjectTypeCode.values.put(OCCASION.enumValue, OCCASION);
            ObjectTypeCode.values.put(VIDEO.enumValue, VIDEO);
            ObjectTypeCode.values.put(PHOTO.enumValue, PHOTO);
        }
        synchronized (ObjectTypeCode.valueList)
        {
            ObjectTypeCode.valueList.add(SURVEY);
            ObjectTypeCode.valueList.add(SAMPLING_OPERATION);
            ObjectTypeCode.valueList.add(SAMPLE);
            ObjectTypeCode.valueList.add(EVENT);
            ObjectTypeCode.valueList.add(SCIENTIFIC_CRUISE);
            ObjectTypeCode.valueList.add(FIELD_OBSERVATION);
            ObjectTypeCode.valueList.add(INITIAL_POPULATION);
            ObjectTypeCode.valueList.add(MONITORING_LOCATION);
            ObjectTypeCode.valueList.add(BATCH);
            ObjectTypeCode.valueList.add(MEASUREMENT);
            ObjectTypeCode.valueList.add(MEASUREMENT_FILE);
            ObjectTypeCode.valueList.add(TAXON_MEASUREMENT);
            ObjectTypeCode.valueList.add(MEASURED_PROFILE);
            ObjectTypeCode.valueList.add(OBSERVED_HABITAT);
            ObjectTypeCode.valueList.add(OCCASION);
            ObjectTypeCode.valueList.add(VIDEO);
            ObjectTypeCode.valueList.add(PHOTO);
            // For Quadrige3, lists could be reload from configuration (see method 'setValue')
            //ObjectTypeCode.valueList = Collections.unmodifiableList(valueList);
        }
        synchronized (ObjectTypeCode.literals)
        {
            ObjectTypeCode.literals.add(SURVEY.enumValue);
            ObjectTypeCode.literals.add(SAMPLING_OPERATION.enumValue);
            ObjectTypeCode.literals.add(SAMPLE.enumValue);
            ObjectTypeCode.literals.add(EVENT.enumValue);
            ObjectTypeCode.literals.add(SCIENTIFIC_CRUISE.enumValue);
            ObjectTypeCode.literals.add(FIELD_OBSERVATION.enumValue);
            ObjectTypeCode.literals.add(INITIAL_POPULATION.enumValue);
            ObjectTypeCode.literals.add(MONITORING_LOCATION.enumValue);
            ObjectTypeCode.literals.add(BATCH.enumValue);
            ObjectTypeCode.literals.add(MEASUREMENT.enumValue);
            ObjectTypeCode.literals.add(MEASUREMENT_FILE.enumValue);
            ObjectTypeCode.literals.add(TAXON_MEASUREMENT.enumValue);
            ObjectTypeCode.literals.add(MEASURED_PROFILE.enumValue);
            ObjectTypeCode.literals.add(OBSERVED_HABITAT.enumValue);
            ObjectTypeCode.literals.add(OCCASION.enumValue);
            ObjectTypeCode.literals.add(VIDEO.enumValue);
            ObjectTypeCode.literals.add(PHOTO.enumValue);
            // For Quadrige3, lists could be reload from configuration (see method 'setValue')
            //ObjectTypeCode.literals = Collections.unmodifiableList(literals);
        }
        synchronized (ObjectTypeCode.names)
        {
            ObjectTypeCode.names.add("SURVEY");
            ObjectTypeCode.names.add("SAMPLING_OPERATION");
            ObjectTypeCode.names.add("SAMPLE");
            ObjectTypeCode.names.add("EVENT");
            ObjectTypeCode.names.add("SCIENTIFIC_CRUISE");
            ObjectTypeCode.names.add("FIELD_OBSERVATION");
            ObjectTypeCode.names.add("INITIAL_POPULATION");
            ObjectTypeCode.names.add("MONITORING_LOCATION");
            ObjectTypeCode.names.add("BATCH");
            ObjectTypeCode.names.add("MEASUREMENT");
            ObjectTypeCode.names.add("MEASUREMENT_FILE");
            ObjectTypeCode.names.add("TAXON_MEASUREMENT");
            ObjectTypeCode.names.add("MEASURED_PROFILE");
            ObjectTypeCode.names.add("OBSERVED_HABITAT");
            ObjectTypeCode.names.add("OCCASION");
            ObjectTypeCode.names.add("VIDEO");
            ObjectTypeCode.names.add("PHOTO");
            ObjectTypeCode.names = Collections.unmodifiableList(names);
        }
    }
    // type-safe-enumeration-object java merge-point
}