// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential;

import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.TaxonGroupPosition;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Caractéristique de la façon dont un taxon ou un groupe de taxon est géré en un lieu
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ResourceType
    implements Serializable, Comparable<ResourceType>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -5674554241216922469L;

    // Generate 4 attributes
    private Integer resTypeId;

    /**
     * Identifiant du type de ressource
     * @return this.resTypeId Integer
     */
    public Integer getResTypeId()
    {
        return this.resTypeId;
    }

    /**
     * Identifiant du type de ressource
     * @param resTypeIdIn Integer
     */
    public void setResTypeId(Integer resTypeIdIn)
    {
        this.resTypeId = resTypeIdIn;
    }

    private String resTypeNm;

    /**
     * Llibellé du type de ressource
     * @return this.resTypeNm String
     */
    public String getResTypeNm()
    {
        return this.resTypeNm;
    }

    /**
     * Llibellé du type de ressource
     * @param resTypeNmIn String
     */
    public void setResTypeNm(String resTypeNmIn)
    {
        this.resTypeNm = resTypeNmIn;
    }

    private String resTypeDc;

    /**
     * Description du type de ressource
     * @return this.resTypeDc String
     */
    public String getResTypeDc()
    {
        return this.resTypeDc;
    }

    /**
     * Description du type de ressource
     * @param resTypeDcIn String
     */
    public void setResTypeDc(String resTypeDcIn)
    {
        this.resTypeDc = resTypeDcIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 3 associations
    private Collection<TaxonGroupPosition> taxonGroupPositionIds = new HashSet<TaxonGroupPosition>();

    /**
     * Groupe de taxon en un lieu pour un type de ressource.
     * @return this.taxonGroupPositionIds Collection<TaxonGroupPosition>
     */
    public Collection<TaxonGroupPosition> getTaxonGroupPositionIds()
    {
        return this.taxonGroupPositionIds;
    }

    /**
     * Groupe de taxon en un lieu pour un type de ressource.
     * @param taxonGroupPositionIdsIn Collection<TaxonGroupPosition>
     */
    public void setTaxonGroupPositionIds(Collection<TaxonGroupPosition> taxonGroupPositionIdsIn)
    {
        this.taxonGroupPositionIds = taxonGroupPositionIdsIn;
    }

    /**
     * Groupe de taxon en un lieu pour un type de ressource.
     * @param elementToAdd TaxonGroupPosition
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addTaxonGroupPositionIds(TaxonGroupPosition elementToAdd)
    {
        return this.taxonGroupPositionIds.add(elementToAdd);
    }

    /**
     * Groupe de taxon en un lieu pour un type de ressource.
     * @param elementToRemove TaxonGroupPosition
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeTaxonGroupPositionIds(TaxonGroupPosition elementToRemove)
    {
        return this.taxonGroupPositionIds.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    /**
     * Returns <code>true</code> if the argument is an ResourceType instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ResourceType))
        {
            return false;
        }
        final ResourceType that = (ResourceType)object;
        if (this.resTypeId == null || that.getResTypeId() == null || !this.resTypeId.equals(that.getResTypeId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.resTypeId == null ? 0 : this.resTypeId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link ResourceType}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ResourceType}.
         * @return new ResourceTypeImpl()
         */
        public static ResourceType newInstance()
        {
            return new ResourceTypeImpl();
        }

        /**
         * Constructs a new instance of {@link ResourceType}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param resTypeNm String
         * @param status Status
         * @return newInstance
         */
        public static ResourceType newInstance(String resTypeNm, Status status)
        {
            final ResourceType entity = new ResourceTypeImpl();
            entity.setResTypeNm(resTypeNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link ResourceType}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param resTypeNm String
         * @param resTypeDc String
         * @param updateDt Timestamp
         * @param taxonGroupPositionIds Collection<TaxonGroupPosition>
         * @param status Status
         * @return newInstance ResourceType
         */
        public static ResourceType newInstance(String resTypeNm, String resTypeDc, Timestamp updateDt, Collection<TaxonGroupPosition> taxonGroupPositionIds, Status status)
        {
            final ResourceType entity = new ResourceTypeImpl();
            entity.setResTypeNm(resTypeNm);
            entity.setResTypeDc(resTypeDc);
            entity.setUpdateDt(updateDt);
            entity.setTaxonGroupPositionIds(taxonGroupPositionIds);
            entity.setStatus(status);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ResourceType o)
    {
        int cmp = 0;
        if (this.getResTypeId() != null)
        {
            cmp = this.getResTypeId().compareTo(o.getResTypeId());
        }
        else
        {
            if (this.getResTypeNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getResTypeNm().compareTo(o.getResTypeNm()));
            }
            if (this.getResTypeDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getResTypeDc().compareTo(o.getResTypeDc()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ResourceType.java merge-point
}