// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Liste des états possibles d'un objet.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Status
    implements Serializable, Comparable<Status>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 2413971720867301580L;

    // Generate 4 attributes
    private String statusCd;

    /**
     * Code de l'état de l'objet (actif ou inactif)
     * @return this.statusCd String
     */
    public String getStatusCd()
    {
        return this.statusCd;
    }

    /**
     * Code de l'état de l'objet (actif ou inactif)
     * @param statusCdIn String
     */
    public void setStatusCd(String statusCdIn)
    {
        this.statusCd = statusCdIn;
    }

    private String statusNm;

    /**
     * Libellé de l'état.
     * @return this.statusNm String
     */
    public String getStatusNm()
    {
        return this.statusNm;
    }

    /**
     * Libellé de l'état.
     * @param statusNmIn String
     */
    public void setStatusNm(String statusNmIn)
    {
        this.statusNm = statusNmIn;
    }

    private String statusDc;

    /**
     * Description de l'état
     * @return this.statusDc String
     */
    public String getStatusDc()
    {
        return this.statusDc;
    }

    /**
     * Description de l'état
     * @param statusDcIn String
     */
    public void setStatusDc(String statusDcIn)
    {
        this.statusDc = statusDcIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 50 associations
    private Collection<PrecisionType> precisionTypes = new HashSet<PrecisionType>();

    /**
     * type d'incertitude des mesures d'un paramètre dans une stratégie.
     * @return this.precisionTypes Collection<PrecisionType>
     */
    public Collection<PrecisionType> getPrecisionTypes()
    {
        return this.precisionTypes;
    }

    /**
     * type d'incertitude des mesures d'un paramètre dans une stratégie.
     * @param precisionTypesIn Collection<PrecisionType>
     */
    public void setPrecisionTypes(Collection<PrecisionType> precisionTypesIn)
    {
        this.precisionTypes = precisionTypesIn;
    }

    /**
     * type d'incertitude des mesures d'un paramètre dans une stratégie.
     * @param elementToAdd PrecisionType
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPrecisionTypes(PrecisionType elementToAdd)
    {
        return this.precisionTypes.add(elementToAdd);
    }

    /**
     * type d'incertitude des mesures d'un paramètre dans une stratégie.
     * @param elementToRemove PrecisionType
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePrecisionTypes(PrecisionType elementToRemove)
    {
        return this.precisionTypes.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an Status instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Status))
        {
            return false;
        }
        final Status that = (Status)object;
        if (this.statusCd == null || that.getStatusCd() == null || !this.statusCd.equals(that.getStatusCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.statusCd == null ? 0 : this.statusCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Status}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Status}.
         * @return new StatusImpl()
         */
        public static Status newInstance()
        {
            return new StatusImpl();
        }

        /**
         * Constructs a new instance of {@link Status}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param statusNm String
         * @return newInstance
         */
        public static Status newInstance(String statusNm)
        {
            final Status entity = new StatusImpl();
            entity.setStatusNm(statusNm);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Status}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param statusNm String
         * @param statusDc String
         * @param updateDt Timestamp
         * @param precisionTypes Collection<PrecisionType>
         * @return newInstance Status
         */
        public static Status newInstance(String statusNm, String statusDc, Timestamp updateDt, Collection<PrecisionType> precisionTypes)
        {
            final Status entity = new StatusImpl();
            entity.setStatusNm(statusNm);
            entity.setStatusDc(statusDc);
            entity.setUpdateDt(updateDt);
            entity.setPrecisionTypes(precisionTypes);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Status o)
    {
        int cmp = 0;
        if (this.getStatusCd() != null)
        {
            cmp = this.getStatusCd().compareTo(o.getStatusCd());
        }
        else
        {
            if (this.getStatusNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStatusNm().compareTo(o.getStatusNm()));
            }
            if (this.getStatusDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStatusDc().compareTo(o.getStatusDc()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Status.java merge-point
}