/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
// Attention: Generated code! Do not modify by hand!
// Generated by: TypeSafeEnumeration.vsl in andromda-java-cartridge.
// Model Class:  Données::fr.ifremer.quadrige3.core::dao::referential::StatusCode
// Metafacade:   org.andromda.metafacades.uml.Enumeration
// Stereotype:  Enumeration
//
package fr.ifremer.quadrige3.core.dao.referential;

import fr.ifremer.quadrige3.core.dao.technical.QuadrigeEnumerationDef;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import static org.nuiton.i18n.I18n.n;

/**
 * 
 */
public enum StatusCode
    implements Serializable, QuadrigeEnumerationDef<String>
{
    DISABLE (
			"quadrige3.enumeration.StatusCode.DISABLE",
			n("quadrige3.enumeration.StatusCode.DISABLE.description"),
			"0"),
    ENABLE (
			"quadrige3.enumeration.StatusCode.ENABLE",
			n("quadrige3.enumeration.StatusCode.ENABLE.description"),
			"1"),
    TEMPORARY (
			"quadrige3.enumeration.StatusCode.TEMPORARY",
			n("quadrige3.enumeration.StatusCode.TEMPORARY.description"),
			"2"),
    DELETED (
			"quadrige3.enumeration.StatusCode.DELETED",
			n("quadrige3.enumeration.StatusCode.DELETED.description"),
			"3"),
    LOCAL_DISABLE (
			"quadrige3.enumeration.StatusCode.LOCAL_DISABLE",
			n("quadrige3.enumeration.StatusCode.LOCAL_DISABLE.description"),
			"10"),
    LOCAL_ENABLE (
			"quadrige3.enumeration.StatusCode.LOCAL_ENABLE",
			n("quadrige3.enumeration.StatusCode.LOCAL_ENABLE.description"),
			"11");

    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1451593015808388931L;

    private String key;
    private String description;
    private String enumValue;

    /**
     * The constructor with enumeration literal value allowing
     * super classes to access it.
     */
    private StatusCode(String key, String description, String value)
    {
    	this.key = key;
    	this.description = description;
        this.enumValue = value;
    }
    
    @Override
     /**
      * Setter for value. Use to override value, from configuration
      */
     public void setValue(String newValue) {
		if (newValue != null && !this.enumValue.equals(newValue)) {
			// Update static lists
	    	values.remove(this.enumValue);
	    	literals.remove(this.enumValue);
	    	this.enumValue = newValue;
	    	values.put(this.enumValue, this);
	    	literals.add(this.enumValue);
		}
    }
    

    @Override
    public String getValueAsString()
    {
        return String.valueOf(this.enumValue);
    }

    /**
     * Retrieves an instance of StatusCode from <code>its name</code>.
     *
     * @param name the name to create the StatusCode from.
     * @return The enumeration literal named after the 'name' argument
     */
    public static StatusCode fromString(String name)
    {
        return StatusCode.valueOf(name);
    }

    /**
     * Returns an enumeration literal String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @return String with corresponding value
     */
    public String value()
    {
        return this.enumValue;
    }

    /**
     * Returns an instance of StatusCode from String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @param value the value to create the StatusCode from.
     * @return static Enumeration with corresponding value
     */
    public static StatusCode fromValue(String value)
    {
        for (StatusCode enumName: StatusCode.values())
        {
            if (enumName.getValue().equals(value))
            {
                return enumName;
            }
        }
        throw new IllegalArgumentException("StatusCode.fromValue(" + value + ')');
    }

    /**
     * Gets the underlying value of this type safe enumeration.
     * This method is necessary to comply with DaoBase implementation.
     * @return The name of this literal.
     */
    public String getValue()
    {
        return this.enumValue;
    }
    
    @Override
    public String getDescription() {
    	return description;
    }
    
    @Override
    public String getKey() {
    	return key;
    }
    
    @Override
    public Class<?> getType() {
    	return String.class;
    }
    
    /**
     * Returns an unmodifiable list containing the literals that are known by this enumeration.
     *
     * @return A List containing the actual literals defined by this enumeration, this list
     *         can not be modified.
     */
    public static List<String> literals()
    {
        return StatusCode.literals;
    }

    /**
     * Returns an unmodifiable list containing the names of the literals that are known
     * by this enumeration.
     *
     * @return A List containing the actual names of the literals defined by this
     *         enumeration, this list can not be modified.
     */
    public static List<String> names()
    {
        return StatusCode.names;
    }

    private static Map<String, StatusCode> values = new LinkedHashMap<String, StatusCode>(6, 1);
    private static List<String> literals = new ArrayList<String>(6);
    private static List<String> names = new ArrayList<String>(6);
    private static List<StatusCode> valueList = new ArrayList<StatusCode>(6);

    /**
     * Initializes the values.
     */
    static
    {
        synchronized (StatusCode.values)
        {
            StatusCode.values.put(DISABLE.enumValue, DISABLE);
            StatusCode.values.put(ENABLE.enumValue, ENABLE);
            StatusCode.values.put(TEMPORARY.enumValue, TEMPORARY);
            StatusCode.values.put(DELETED.enumValue, DELETED);
            StatusCode.values.put(LOCAL_DISABLE.enumValue, LOCAL_DISABLE);
            StatusCode.values.put(LOCAL_ENABLE.enumValue, LOCAL_ENABLE);
        }
        synchronized (StatusCode.valueList)
        {
            StatusCode.valueList.add(DISABLE);
            StatusCode.valueList.add(ENABLE);
            StatusCode.valueList.add(TEMPORARY);
            StatusCode.valueList.add(DELETED);
            StatusCode.valueList.add(LOCAL_DISABLE);
            StatusCode.valueList.add(LOCAL_ENABLE);
            // For Quadrige3, lists could be reload from configuration (see method 'setValue')
            //StatusCode.valueList = Collections.unmodifiableList(valueList);
        }
        synchronized (StatusCode.literals)
        {
            StatusCode.literals.add(DISABLE.enumValue);
            StatusCode.literals.add(ENABLE.enumValue);
            StatusCode.literals.add(TEMPORARY.enumValue);
            StatusCode.literals.add(DELETED.enumValue);
            StatusCode.literals.add(LOCAL_DISABLE.enumValue);
            StatusCode.literals.add(LOCAL_ENABLE.enumValue);
            // For Quadrige3, lists could be reload from configuration (see method 'setValue')
            //StatusCode.literals = Collections.unmodifiableList(literals);
        }
        synchronized (StatusCode.names)
        {
            StatusCode.names.add("DISABLE");
            StatusCode.names.add("ENABLE");
            StatusCode.names.add("TEMPORARY");
            StatusCode.names.add("DELETED");
            StatusCode.names.add("LOCAL_DISABLE");
            StatusCode.names.add("LOCAL_ENABLE");
            StatusCode.names = Collections.unmodifiableList(names);
        }
    }
    // type-safe-enumeration-object java merge-point
}