// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential;

import fr.ifremer.quadrige3.core.dao.referential.taxon.TaxonGroup;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Typologie des groupes de taxons
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TaxonGroupType
    implements Serializable, Comparable<TaxonGroupType>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 2978809518443954504L;

    // Generate 3 attributes
    private String taxonGroupTypeCd;

    /**
     * Code unique identifiant le type de regroupement de taxon
     * @return this.taxonGroupTypeCd String
     */
    public String getTaxonGroupTypeCd()
    {
        return this.taxonGroupTypeCd;
    }

    /**
     * Code unique identifiant le type de regroupement de taxon
     * @param taxonGroupTypeCdIn String
     */
    public void setTaxonGroupTypeCd(String taxonGroupTypeCdIn)
    {
        this.taxonGroupTypeCd = taxonGroupTypeCdIn;
    }

    private String taxonGroupTypeNm;

    /**
     * Nom du type de regroupement de taxons.
     * @return this.taxonGroupTypeNm String
     */
    public String getTaxonGroupTypeNm()
    {
        return this.taxonGroupTypeNm;
    }

    /**
     * Nom du type de regroupement de taxons.
     * @param taxonGroupTypeNmIn String
     */
    public void setTaxonGroupTypeNm(String taxonGroupTypeNmIn)
    {
        this.taxonGroupTypeNm = taxonGroupTypeNmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<TaxonGroup> taxonGroups = new HashSet<TaxonGroup>();

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @return this.taxonGroups Collection<TaxonGroup>
     */
    public Collection<TaxonGroup> getTaxonGroups()
    {
        return this.taxonGroups;
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param taxonGroupsIn Collection<TaxonGroup>
     */
    public void setTaxonGroups(Collection<TaxonGroup> taxonGroupsIn)
    {
        this.taxonGroups = taxonGroupsIn;
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param elementToAdd TaxonGroup
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addTaxonGroups(TaxonGroup elementToAdd)
    {
        return this.taxonGroups.add(elementToAdd);
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param elementToRemove TaxonGroup
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeTaxonGroups(TaxonGroup elementToRemove)
    {
        return this.taxonGroups.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an TaxonGroupType instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TaxonGroupType))
        {
            return false;
        }
        final TaxonGroupType that = (TaxonGroupType)object;
        if (this.taxonGroupTypeCd == null || that.getTaxonGroupTypeCd() == null || !this.taxonGroupTypeCd.equals(that.getTaxonGroupTypeCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.taxonGroupTypeCd == null ? 0 : this.taxonGroupTypeCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link TaxonGroupType}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TaxonGroupType}.
         * @return new TaxonGroupTypeImpl()
         */
        public static TaxonGroupType newInstance()
        {
            return new TaxonGroupTypeImpl();
        }

        /**
         * Constructs a new instance of {@link TaxonGroupType}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param taxonGroupTypeNm String
         * @param status Status
         * @return newInstance
         */
        public static TaxonGroupType newInstance(String taxonGroupTypeNm, Status status)
        {
            final TaxonGroupType entity = new TaxonGroupTypeImpl();
            entity.setTaxonGroupTypeNm(taxonGroupTypeNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TaxonGroupType}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param taxonGroupTypeNm String
         * @param updateDt Timestamp
         * @param status Status
         * @param taxonGroups Collection<TaxonGroup>
         * @return newInstance TaxonGroupType
         */
        public static TaxonGroupType newInstance(String taxonGroupTypeNm, Timestamp updateDt, Status status, Collection<TaxonGroup> taxonGroups)
        {
            final TaxonGroupType entity = new TaxonGroupTypeImpl();
            entity.setTaxonGroupTypeNm(taxonGroupTypeNm);
            entity.setUpdateDt(updateDt);
            entity.setStatus(status);
            entity.setTaxonGroups(taxonGroups);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TaxonGroupType o)
    {
        int cmp = 0;
        if (this.getTaxonGroupTypeCd() != null)
        {
            cmp = this.getTaxonGroupTypeCd().compareTo(o.getTaxonGroupTypeCd());
        }
        else
        {
            if (this.getTaxonGroupTypeNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonGroupTypeNm().compareTo(o.getTaxonGroupTypeNm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TaxonGroupType.java merge-point
}