// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.eunis;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Définit les différents type d'équivalence qui peuvent être fait entre code EUNIS
 */
// HibernateEntity.vsl annotations merge-point
public abstract class EunisEquivCodeTypology
    implements Serializable, Comparable<EunisEquivCodeTypology>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -244961654673950355L;

    // Generate 3 attributes
    private String eunisEquivCodeTypCd;

    /**
     * Identifiant interne de la typologie des codes équivalent (=, #, >, <)
     * @return this.eunisEquivCodeTypCd String
     */
    public String getEunisEquivCodeTypCd()
    {
        return this.eunisEquivCodeTypCd;
    }

    /**
     * Identifiant interne de la typologie des codes équivalent (=, #, >, <)
     * @param eunisEquivCodeTypCdIn String
     */
    public void setEunisEquivCodeTypCd(String eunisEquivCodeTypCdIn)
    {
        this.eunisEquivCodeTypCd = eunisEquivCodeTypCdIn;
    }

    private String eunisEquivCodeTypCm;

    /**
     * Commentaire concernant le code d'équivalence
     * @return this.eunisEquivCodeTypCm String
     */
    public String getEunisEquivCodeTypCm()
    {
        return this.eunisEquivCodeTypCm;
    }

    /**
     * Commentaire concernant le code d'équivalence
     * @param eunisEquivCodeTypCmIn String
     */
    public void setEunisEquivCodeTypCm(String eunisEquivCodeTypCmIn)
    {
        this.eunisEquivCodeTypCm = eunisEquivCodeTypCmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private Collection<EunisEquivalence> eunisEquivIds = new HashSet<EunisEquivalence>();

    /**
     * Permet de définir les différentes équivalences entre les typologie EUNIS.
     * @return this.eunisEquivIds Collection<EunisEquivalence>
     */
    public Collection<EunisEquivalence> getEunisEquivIds()
    {
        return this.eunisEquivIds;
    }

    /**
     * Permet de définir les différentes équivalences entre les typologie EUNIS.
     * @param eunisEquivIdsIn Collection<EunisEquivalence>
     */
    public void setEunisEquivIds(Collection<EunisEquivalence> eunisEquivIdsIn)
    {
        this.eunisEquivIds = eunisEquivIdsIn;
    }

    /**
     * Permet de définir les différentes équivalences entre les typologie EUNIS.
     * @param elementToAdd EunisEquivalence
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addEunisEquivIds(EunisEquivalence elementToAdd)
    {
        return this.eunisEquivIds.add(elementToAdd);
    }

    /**
     * Permet de définir les différentes équivalences entre les typologie EUNIS.
     * @param elementToRemove EunisEquivalence
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeEunisEquivIds(EunisEquivalence elementToRemove)
    {
        return this.eunisEquivIds.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    /**
     * Returns <code>true</code> if the argument is an EunisEquivCodeTypology instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof EunisEquivCodeTypology))
        {
            return false;
        }
        final EunisEquivCodeTypology that = (EunisEquivCodeTypology)object;
        if (this.eunisEquivCodeTypCd == null || that.getEunisEquivCodeTypCd() == null || !this.eunisEquivCodeTypCd.equals(that.getEunisEquivCodeTypCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.eunisEquivCodeTypCd == null ? 0 : this.eunisEquivCodeTypCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link EunisEquivCodeTypology}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link EunisEquivCodeTypology}.
         * @return new EunisEquivCodeTypologyImpl()
         */
        public static EunisEquivCodeTypology newInstance()
        {
            return new EunisEquivCodeTypologyImpl();
        }

        /**
         * Constructs a new instance of {@link EunisEquivCodeTypology}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param status Status
         * @return newInstance
         */
        public static EunisEquivCodeTypology newInstance(Status status)
        {
            final EunisEquivCodeTypology entity = new EunisEquivCodeTypologyImpl();
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link EunisEquivCodeTypology}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param eunisEquivCodeTypCm String
         * @param updateDt Timestamp
         * @param eunisEquivIds Collection<EunisEquivalence>
         * @param status Status
         * @return newInstance EunisEquivCodeTypology
         */
        public static EunisEquivCodeTypology newInstance(String eunisEquivCodeTypCm, Timestamp updateDt, Collection<EunisEquivalence> eunisEquivIds, Status status)
        {
            final EunisEquivCodeTypology entity = new EunisEquivCodeTypologyImpl();
            entity.setEunisEquivCodeTypCm(eunisEquivCodeTypCm);
            entity.setUpdateDt(updateDt);
            entity.setEunisEquivIds(eunisEquivIds);
            entity.setStatus(status);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(EunisEquivCodeTypology o)
    {
        int cmp = 0;
        if (this.getEunisEquivCodeTypCd() != null)
        {
            cmp = this.getEunisEquivCodeTypCd().compareTo(o.getEunisEquivCodeTypCd());
        }
        else
        {
            if (this.getEunisEquivCodeTypCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEunisEquivCodeTypCm().compareTo(o.getEunisEquivCodeTypCm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// EunisEquivCodeTypology.java merge-point
}