// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.eunis;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Permet de définir les différentes équivalences entre les typologie EUNIS.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class EunisEquivalence
    implements Serializable, Comparable<EunisEquivalence>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -6565558200307778057L;

    // Generate 3 attributes
    private Integer eunisEquivId;

    /**
     * Identifiant interne de l'équivalence
     * @return this.eunisEquivId Integer
     */
    public Integer getEunisEquivId()
    {
        return this.eunisEquivId;
    }

    /**
     * Identifiant interne de l'équivalence
     * @param eunisEquivIdIn Integer
     */
    public void setEunisEquivId(Integer eunisEquivIdIn)
    {
        this.eunisEquivId = eunisEquivIdIn;
    }

    private String eunisEquivCm;

    /**
     * Commentaire sur l'équivalence
     * @return this.eunisEquivCm String
     */
    public String getEunisEquivCm()
    {
        return this.eunisEquivCm;
    }

    /**
     * Commentaire sur l'équivalence
     * @param eunisEquivCmIn String
     */
    public void setEunisEquivCm(String eunisEquivCmIn)
    {
        this.eunisEquivCm = eunisEquivCmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 3 associations
    private EunisEquivCodeTypology eunisEquivCodeTypCd;

    /**
     * Définit les différents type d'équivalence qui peuvent être fait entre code EUNIS
     * @return this.eunisEquivCodeTypCd EunisEquivCodeTypology
     */
    public EunisEquivCodeTypology getEunisEquivCodeTypCd()
    {
        return this.eunisEquivCodeTypCd;
    }

    /**
     * Définit les différents type d'équivalence qui peuvent être fait entre code EUNIS
     * @param eunisEquivCodeTypCdIn EunisEquivCodeTypology
     */
    public void setEunisEquivCodeTypCd(EunisEquivCodeTypology eunisEquivCodeTypCdIn)
    {
        this.eunisEquivCodeTypCd = eunisEquivCodeTypCdIn;
    }

    private EunisTypology oldEunisTypId;

    /**
     * Typologie EUNIS
     * @return this.oldEunisTypId EunisTypology
     */
    public EunisTypology getOldEunisTypId()
    {
        return this.oldEunisTypId;
    }

    /**
     * Typologie EUNIS
     * @param oldEunisTypIdIn EunisTypology
     */
    public void setOldEunisTypId(EunisTypology oldEunisTypIdIn)
    {
        this.oldEunisTypId = oldEunisTypIdIn;
    }

    private EunisTypology newEunisTypId;

    /**
     * Typologie EUNIS
     * @return this.newEunisTypId EunisTypology
     */
    public EunisTypology getNewEunisTypId()
    {
        return this.newEunisTypId;
    }

    /**
     * Typologie EUNIS
     * @param newEunisTypIdIn EunisTypology
     */
    public void setNewEunisTypId(EunisTypology newEunisTypIdIn)
    {
        this.newEunisTypId = newEunisTypIdIn;
    }

    /**
     * Returns <code>true</code> if the argument is an EunisEquivalence instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof EunisEquivalence))
        {
            return false;
        }
        final EunisEquivalence that = (EunisEquivalence)object;
        if (this.eunisEquivId == null || that.getEunisEquivId() == null || !this.eunisEquivId.equals(that.getEunisEquivId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.eunisEquivId == null ? 0 : this.eunisEquivId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link EunisEquivalence}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link EunisEquivalence}.
         * @return new EunisEquivalenceImpl()
         */
        public static EunisEquivalence newInstance()
        {
            return new EunisEquivalenceImpl();
        }

        /**
         * Constructs a new instance of {@link EunisEquivalence}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param eunisEquivCodeTypCd EunisEquivCodeTypology
         * @param oldEunisTypId EunisTypology
         * @param newEunisTypId EunisTypology
         * @return newInstance
         */
        public static EunisEquivalence newInstance(EunisEquivCodeTypology eunisEquivCodeTypCd, EunisTypology oldEunisTypId, EunisTypology newEunisTypId)
        {
            final EunisEquivalence entity = new EunisEquivalenceImpl();
            entity.setEunisEquivCodeTypCd(eunisEquivCodeTypCd);
            entity.setOldEunisTypId(oldEunisTypId);
            entity.setNewEunisTypId(newEunisTypId);
            return entity;
        }

        /**
         * Constructs a new instance of {@link EunisEquivalence}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param eunisEquivCm String
         * @param updateDt Timestamp
         * @param eunisEquivCodeTypCd EunisEquivCodeTypology
         * @param oldEunisTypId EunisTypology
         * @param newEunisTypId EunisTypology
         * @return newInstance EunisEquivalence
         */
        public static EunisEquivalence newInstance(String eunisEquivCm, Timestamp updateDt, EunisEquivCodeTypology eunisEquivCodeTypCd, EunisTypology oldEunisTypId, EunisTypology newEunisTypId)
        {
            final EunisEquivalence entity = new EunisEquivalenceImpl();
            entity.setEunisEquivCm(eunisEquivCm);
            entity.setUpdateDt(updateDt);
            entity.setEunisEquivCodeTypCd(eunisEquivCodeTypCd);
            entity.setOldEunisTypId(oldEunisTypId);
            entity.setNewEunisTypId(newEunisTypId);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(EunisEquivalence o)
    {
        int cmp = 0;
        if (this.getEunisEquivId() != null)
        {
            cmp = this.getEunisEquivId().compareTo(o.getEunisEquivId());
        }
        else
        {
            if (this.getEunisEquivCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEunisEquivCm().compareTo(o.getEunisEquivCm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// EunisEquivalence.java merge-point
}