// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.eunis;

import fr.ifremer.quadrige3.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Permet de définir les différentes équivalences entre les typologie EUNIS.
 * @see EunisEquivalence
 */
public interface EunisEquivalenceDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link EunisEquivalence}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of EunisEquivalence from the persistent store.
     * @param eunisEquivId
     * @return EunisEquivalence
     */
    public EunisEquivalence get(Integer eunisEquivId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param eunisEquivId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer eunisEquivId);

    /**
     * Loads an instance of EunisEquivalence from the persistent store.
     * @param eunisEquivId
     * @return EunisEquivalence
     */
    public EunisEquivalence load(Integer eunisEquivId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param eunisEquivId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer eunisEquivId);

    /**
     * Loads all entities of type {@link EunisEquivalence}.
     *
     * @return the loaded entities.
     */
    public Collection<EunisEquivalence> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of EunisEquivalence and adds it to the persistent store.
     * @param eunisEquivalence
     * @return EunisEquivalence
     */
    public EunisEquivalence create(EunisEquivalence eunisEquivalence);

    /**
     * <p>
     * Does the same thing as {@link #create(EunisEquivalence)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param eunisEquivalence
     * @return Object
     */
    public Object create(int transform, EunisEquivalence eunisEquivalence);

    /**
     * Creates a new instance of EunisEquivalence and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of EunisEquivalence
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<EunisEquivalence> create(Collection<EunisEquivalence> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(EunisEquivalence)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<EunisEquivalence> entities);

    /**
     * <p>
     * Creates a new <code>EunisEquivalence</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param eunisEquivCm Commentaire sur l'équivalence
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return EunisEquivalence
     */
    public EunisEquivalence create(
        String eunisEquivCm,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param eunisEquivCm Commentaire sur l'équivalence
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return EunisEquivalence
     */
    public Object create(
        int transform,
        String eunisEquivCm,
        Timestamp updateDt);

    /**
     * <p>
     * Creates a new <code>EunisEquivalence</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param eunisEquivCodeTypCd
     * @param oldEunisTypId
     * @param newEunisTypId
     * @return EunisEquivalence
     */
    public EunisEquivalence create(
        EunisEquivCodeTypology eunisEquivCodeTypCd,
        EunisTypology oldEunisTypId,
        EunisTypology newEunisTypId);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param eunisEquivCodeTypCd
     * @param oldEunisTypId
     * @param newEunisTypId
     * @return Object
     */
    public Object create(
        int transform,
        EunisEquivCodeTypology eunisEquivCodeTypCd,
        EunisTypology oldEunisTypId,
        EunisTypology newEunisTypId);

    /**
     * Updates the <code>eunisEquivalence</code> instance in the persistent store.
     * @param eunisEquivalence
     */
    public void update(EunisEquivalence eunisEquivalence);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<EunisEquivalence> entities);

    /**
     * Removes the instance of EunisEquivalence from the persistent store.
     * @param eunisEquivalence
     */
    public void remove(EunisEquivalence eunisEquivalence);

    /**
     * Removes the instance of EunisEquivalence having the given
     * <code>identifier</code> from the persistent store.
     * @param eunisEquivId
     */
    public void remove(Integer eunisEquivId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<EunisEquivalence> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<EunisEquivalence> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.referential.eunis.EunisEquivalenceDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.referential.eunis.EunisEquivalenceDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final EunisEquivalence entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,EunisEquivalence)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.referential.eunis.EunisEquivalenceDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,EunisEquivalence)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}