// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.eunis;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste des versions des différentes typologies EUNIS.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class EunisVersion
    implements Serializable, Comparable<EunisVersion>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -7366798727008104837L;

    // Generate 6 attributes
    private Integer eunisVersionId;

    /**
     * Identifiant interne de la version EUNIS
     * @return this.eunisVersionId Integer
     */
    public Integer getEunisVersionId()
    {
        return this.eunisVersionId;
    }

    /**
     * Identifiant interne de la version EUNIS
     * @param eunisVersionIdIn Integer
     */
    public void setEunisVersionId(Integer eunisVersionIdIn)
    {
        this.eunisVersionId = eunisVersionIdIn;
    }

    private Date eunisVersionDt;

    /**
     * Date de réception de la version
     * @return this.eunisVersionDt Date
     */
    public Date getEunisVersionDt()
    {
        return this.eunisVersionDt;
    }

    /**
     * Date de réception de la version
     * @param eunisVersionDtIn Date
     */
    public void setEunisVersionDt(Date eunisVersionDtIn)
    {
        this.eunisVersionDt = eunisVersionDtIn;
    }

    private String eunisVersionNm;

    /**
     * Libellé de la version
     * @return this.eunisVersionNm String
     */
    public String getEunisVersionNm()
    {
        return this.eunisVersionNm;
    }

    /**
     * Libellé de la version
     * @param eunisVersionNmIn String
     */
    public void setEunisVersionNm(String eunisVersionNmIn)
    {
        this.eunisVersionNm = eunisVersionNmIn;
    }

    private String eunisVersionCm;

    /**
     * Description de la version
     * @return this.eunisVersionCm String
     */
    public String getEunisVersionCm()
    {
        return this.eunisVersionCm;
    }

    /**
     * Description de la version
     * @param eunisVersionCmIn String
     */
    public void setEunisVersionCm(String eunisVersionCmIn)
    {
        this.eunisVersionCm = eunisVersionCmIn;
    }

    private String eunisVersionIsCurrent;

    /**
     * Indique s'il s'agit de la dernière version ou non
     * @return this.eunisVersionIsCurrent String
     */
    public String getEunisVersionIsCurrent()
    {
        return this.eunisVersionIsCurrent;
    }

    /**
     * Indique s'il s'agit de la dernière version ou non
     * @param eunisVersionIsCurrentIn String
     */
    public void setEunisVersionIsCurrent(String eunisVersionIsCurrentIn)
    {
        this.eunisVersionIsCurrent = eunisVersionIsCurrentIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 1 associations
    private Collection<EunisTypology> eunisTypIds = new HashSet<EunisTypology>();

    /**
     * Typologie EUNIS
     * @return this.eunisTypIds Collection<EunisTypology>
     */
    public Collection<EunisTypology> getEunisTypIds()
    {
        return this.eunisTypIds;
    }

    /**
     * Typologie EUNIS
     * @param eunisTypIdsIn Collection<EunisTypology>
     */
    public void setEunisTypIds(Collection<EunisTypology> eunisTypIdsIn)
    {
        this.eunisTypIds = eunisTypIdsIn;
    }

    /**
     * Typologie EUNIS
     * @param elementToAdd EunisTypology
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addEunisTypIds(EunisTypology elementToAdd)
    {
        return this.eunisTypIds.add(elementToAdd);
    }

    /**
     * Typologie EUNIS
     * @param elementToRemove EunisTypology
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeEunisTypIds(EunisTypology elementToRemove)
    {
        return this.eunisTypIds.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an EunisVersion instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof EunisVersion))
        {
            return false;
        }
        final EunisVersion that = (EunisVersion)object;
        if (this.eunisVersionId == null || that.getEunisVersionId() == null || !this.eunisVersionId.equals(that.getEunisVersionId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.eunisVersionId == null ? 0 : this.eunisVersionId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link EunisVersion}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link EunisVersion}.
         * @return new EunisVersionImpl()
         */
        public static EunisVersion newInstance()
        {
            return new EunisVersionImpl();
        }

        /**
         * Constructs a new instance of {@link EunisVersion}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param eunisVersionNm String
         * @return newInstance
         */
        public static EunisVersion newInstance(String eunisVersionNm)
        {
            final EunisVersion entity = new EunisVersionImpl();
            entity.setEunisVersionNm(eunisVersionNm);
            return entity;
        }

        /**
         * Constructs a new instance of {@link EunisVersion}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param eunisVersionDt Date
         * @param eunisVersionNm String
         * @param eunisVersionCm String
         * @param eunisVersionIsCurrent String
         * @param updateDt Timestamp
         * @param eunisTypIds Collection<EunisTypology>
         * @return newInstance EunisVersion
         */
        public static EunisVersion newInstance(Date eunisVersionDt, String eunisVersionNm, String eunisVersionCm, String eunisVersionIsCurrent, Timestamp updateDt, Collection<EunisTypology> eunisTypIds)
        {
            final EunisVersion entity = new EunisVersionImpl();
            entity.setEunisVersionDt(eunisVersionDt);
            entity.setEunisVersionNm(eunisVersionNm);
            entity.setEunisVersionCm(eunisVersionCm);
            entity.setEunisVersionIsCurrent(eunisVersionIsCurrent);
            entity.setUpdateDt(updateDt);
            entity.setEunisTypIds(eunisTypIds);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(EunisVersion o)
    {
        int cmp = 0;
        if (this.getEunisVersionId() != null)
        {
            cmp = this.getEunisVersionId().compareTo(o.getEunisVersionId());
        }
        else
        {
            if (this.getEunisVersionDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEunisVersionDt().compareTo(o.getEunisVersionDt()));
            }
            if (this.getEunisVersionNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEunisVersionNm().compareTo(o.getEunisVersionNm()));
            }
            if (this.getEunisVersionCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEunisVersionCm().compareTo(o.getEunisVersionCm()));
            }
            if (this.getEunisVersionIsCurrent() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEunisVersionIsCurrent().compareTo(o.getEunisVersionIsCurrent()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// EunisVersion.java merge-point
}