// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.monitoringLocation;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Liste des ports maritimes.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Harbour
    implements Serializable, Comparable<Harbour>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -6647041785591335991L;

    // Generate 3 attributes
    private String harbourCd;

    /**
     * Code unique identifiant le port
     * @return this.harbourCd String
     */
    public String getHarbourCd()
    {
        return this.harbourCd;
    }

    /**
     * Code unique identifiant le port
     * @param harbourCdIn String
     */
    public void setHarbourCd(String harbourCdIn)
    {
        this.harbourCd = harbourCdIn;
    }

    private String harbourNm;

    /**
     * Libellé décrivant le port
     * @return this.harbourNm String
     */
    public String getHarbourNm()
    {
        return this.harbourNm;
    }

    /**
     * Libellé décrivant le port
     * @param harbourNmIn String
     */
    public void setHarbourNm(String harbourNmIn)
    {
        this.harbourNm = harbourNmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private Collection<MonitoringLocation> monitoringLocations = new HashSet<MonitoringLocation>();

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @return this.monitoringLocations Collection<MonitoringLocation>
     */
    public Collection<MonitoringLocation> getMonitoringLocations()
    {
        return this.monitoringLocations;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param monitoringLocationsIn Collection<MonitoringLocation>
     */
    public void setMonitoringLocations(Collection<MonitoringLocation> monitoringLocationsIn)
    {
        this.monitoringLocations = monitoringLocationsIn;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param elementToAdd MonitoringLocation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addMonitoringLocations(MonitoringLocation elementToAdd)
    {
        return this.monitoringLocations.add(elementToAdd);
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param elementToRemove MonitoringLocation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeMonitoringLocations(MonitoringLocation elementToRemove)
    {
        return this.monitoringLocations.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Harbour instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Harbour))
        {
            return false;
        }
        final Harbour that = (Harbour)object;
        if (this.harbourCd == null || that.getHarbourCd() == null || !this.harbourCd.equals(that.getHarbourCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.harbourCd == null ? 0 : this.harbourCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Harbour}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Harbour}.
         * @return new HarbourImpl()
         */
        public static Harbour newInstance()
        {
            return new HarbourImpl();
        }

        /**
         * Constructs a new instance of {@link Harbour}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param harbourNm String
         * @param status Status
         * @return newInstance
         */
        public static Harbour newInstance(String harbourNm, Status status)
        {
            final Harbour entity = new HarbourImpl();
            entity.setHarbourNm(harbourNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Harbour}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param harbourNm String
         * @param updateDt Timestamp
         * @param monitoringLocations Collection<MonitoringLocation>
         * @param status Status
         * @return newInstance Harbour
         */
        public static Harbour newInstance(String harbourNm, Timestamp updateDt, Collection<MonitoringLocation> monitoringLocations, Status status)
        {
            final Harbour entity = new HarbourImpl();
            entity.setHarbourNm(harbourNm);
            entity.setUpdateDt(updateDt);
            entity.setMonitoringLocations(monitoringLocations);
            entity.setStatus(status);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Harbour o)
    {
        int cmp = 0;
        if (this.getHarbourCd() != null)
        {
            cmp = this.getHarbourCd().compareTo(o.getHarbourCd());
        }
        else
        {
            if (this.getHarbourNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getHarbourNm().compareTo(o.getHarbourNm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Harbour.java merge-point
}