// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.monitoringLocation;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Liste les lieux associés aux programmes de surveillance.
 * @see MonitoringLocation
 */
public interface MonitoringLocationDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link MonitoringLocation}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of MonitoringLocation from the persistent store.
     * @param monLocId
     * @return MonitoringLocation
     */
    public MonitoringLocation get(Integer monLocId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param monLocId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer monLocId);

    /**
     * Loads an instance of MonitoringLocation from the persistent store.
     * @param monLocId
     * @return MonitoringLocation
     */
    public MonitoringLocation load(Integer monLocId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param monLocId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer monLocId);

    /**
     * Loads all entities of type {@link MonitoringLocation}.
     *
     * @return the loaded entities.
     */
    public Collection<MonitoringLocation> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of MonitoringLocation and adds it to the persistent store.
     * @param monitoringLocation
     * @return MonitoringLocation
     */
    public MonitoringLocation create(MonitoringLocation monitoringLocation);

    /**
     * <p>
     * Does the same thing as {@link #create(MonitoringLocation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param monitoringLocation
     * @return Object
     */
    public Object create(int transform, MonitoringLocation monitoringLocation);

    /**
     * Creates a new instance of MonitoringLocation and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of MonitoringLocation
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<MonitoringLocation> create(Collection<MonitoringLocation> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(MonitoringLocation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<MonitoringLocation> entities);

    /**
     * <p>
     * Creates a new <code>MonitoringLocation</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param monLocNm Libellé du lieu de surveillance
     * @param monLocBathym Valeur de la bathymétrie sur le lieu (optionnel). La bathymétrie peut être positive ou négative
     * @param monLocCm Commentaire décrivant le lieu de surveillance
     * @param monLocLb Mnémonique du lieu. Permet entre autre de conserver l'information sur le positionnement Q1 :
Bassin/Site.
Cette information n'est pas prévue pour faire une recherche.
     * @param monLocUtFormat Format UT de l'heure pour le lieu (0, +1, -4...). +1 par défaut
     * @param monLocDaylightSavingTime Indique s'il faut opérer le changement d'heure hiver-été, vrai par défaut
     * @param monLocPositionPathNm Lien vers le fichier décrivant le lieu
     * @param monLocCreationDt Date de création du lieu de surveillance.
     * @param updateDt Date de mise à jour
     * @return MonitoringLocation
     */
    public MonitoringLocation create(
        String monLocNm,
        Float monLocBathym,
        String monLocCm,
        String monLocLb,
        Double monLocUtFormat,
        String monLocDaylightSavingTime,
        String monLocPositionPathNm,
        Date monLocCreationDt,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Float, String, String, Double, String, String, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param monLocNm Libellé du lieu de surveillance
     * @param monLocBathym Valeur de la bathymétrie sur le lieu (optionnel). La bathymétrie peut être positive ou négative
     * @param monLocCm Commentaire décrivant le lieu de surveillance
     * @param monLocLb Mnémonique du lieu. Permet entre autre de conserver l'information sur le positionnement Q1 :
Bassin/Site.
Cette information n'est pas prévue pour faire une recherche.
     * @param monLocUtFormat Format UT de l'heure pour le lieu (0, +1, -4...). +1 par défaut
     * @param monLocDaylightSavingTime Indique s'il faut opérer le changement d'heure hiver-été, vrai par défaut
     * @param monLocPositionPathNm Lien vers le fichier décrivant le lieu
     * @param monLocCreationDt Date de création du lieu de surveillance.
     * @param updateDt Date de mise à jour
     * @return MonitoringLocation
     */
    public Object create(
        int transform,
        String monLocNm,
        Float monLocBathym,
        String monLocCm,
        String monLocLb,
        Double monLocUtFormat,
        String monLocDaylightSavingTime,
        String monLocPositionPathNm,
        Date monLocCreationDt,
        Timestamp updateDt);

    /**
     * <p>
     * Creates a new <code>MonitoringLocation</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param monLocNm
     * @param status
     * @param positionningSystem
     * @return MonitoringLocation
     */
    public MonitoringLocation create(
        String monLocNm,
        Status status,
        PositionningSystem positionningSystem);

    /**
     * <p>
     * Does the same thing as {@link #create(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param monLocNm
     * @param status
     * @param positionningSystem
     * @return Object
     */
    public Object create(
        int transform,
        String monLocNm,
        Status status,
        PositionningSystem positionningSystem);

    /**
     * Updates the <code>monitoringLocation</code> instance in the persistent store.
     * @param monitoringLocation
     */
    public void update(MonitoringLocation monitoringLocation);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<MonitoringLocation> entities);

    /**
     * Removes the instance of MonitoringLocation from the persistent store.
     * @param monitoringLocation
     */
    public void remove(MonitoringLocation monitoringLocation);

    /**
     * Removes the instance of MonitoringLocation having the given
     * <code>identifier</code> from the persistent store.
     * @param monLocId
     */
    public void remove(Integer monLocId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<MonitoringLocation> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<MonitoringLocation> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocationDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocationDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final MonitoringLocation entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,MonitoringLocation)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocationDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,MonitoringLocation)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}