// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.monitoringLocation;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import fr.ifremer.quadrige3.core.dao.referential.Unit;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Système de projection utilisé pour une transformation de coordonnées
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ProjectionSystem
    implements Serializable, Comparable<ProjectionSystem>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1365263544747926892L;

    // Generate 7 attributes
    private String projSystemCd;

    /**
     * Code du système de projection utilisé (initialisé à partir des informations de l'EPSG)
     * @return this.projSystemCd String
     */
    public String getProjSystemCd()
    {
        return this.projSystemCd;
    }

    /**
     * Code du système de projection utilisé (initialisé à partir des informations de l'EPSG)
     * @param projSystemCdIn String
     */
    public void setProjSystemCd(String projSystemCdIn)
    {
        this.projSystemCd = projSystemCdIn;
    }

    private String projSystemNm;

    /**
     * Libellé du système de projection utilisé (initialisé à partir des informations de l'EPSG)
     * @return this.projSystemNm String
     */
    public String getProjSystemNm()
    {
        return this.projSystemNm;
    }

    /**
     * Libellé du système de projection utilisé (initialisé à partir des informations de l'EPSG)
     * @param projSystemNmIn String
     */
    public void setProjSystemNm(String projSystemNmIn)
    {
        this.projSystemNm = projSystemNmIn;
    }

    private Float projSystemMinX;

    /**
     * Borne minimale de la longitude de l'extent
     * @return this.projSystemMinX Float
     */
    public Float getProjSystemMinX()
    {
        return this.projSystemMinX;
    }

    /**
     * Borne minimale de la longitude de l'extent
     * @param projSystemMinXIn Float
     */
    public void setProjSystemMinX(Float projSystemMinXIn)
    {
        this.projSystemMinX = projSystemMinXIn;
    }

    private Float projSystemMaxX;

    /**
     * Borne maximale de la longitude de l'extent
     * @return this.projSystemMaxX Float
     */
    public Float getProjSystemMaxX()
    {
        return this.projSystemMaxX;
    }

    /**
     * Borne maximale de la longitude de l'extent
     * @param projSystemMaxXIn Float
     */
    public void setProjSystemMaxX(Float projSystemMaxXIn)
    {
        this.projSystemMaxX = projSystemMaxXIn;
    }

    private Float projSystemMinY;

    /**
     * Borne minimale de la latitude de l'extent
     * @return this.projSystemMinY Float
     */
    public Float getProjSystemMinY()
    {
        return this.projSystemMinY;
    }

    /**
     * Borne minimale de la latitude de l'extent
     * @param projSystemMinYIn Float
     */
    public void setProjSystemMinY(Float projSystemMinYIn)
    {
        this.projSystemMinY = projSystemMinYIn;
    }

    private Float projSystemMaxY;

    /**
     * Borne maximale de la latitude de l'extent
     * @return this.projSystemMaxY Float
     */
    public Float getProjSystemMaxY()
    {
        return this.projSystemMaxY;
    }

    /**
     * Borne maximale de la latitude de l'extent
     * @param projSystemMaxYIn Float
     */
    public void setProjSystemMaxY(Float projSystemMaxYIn)
    {
        this.projSystemMaxY = projSystemMaxYIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 5 associations
    private Unit unitId;

    /**
     * Liste l'ensemble des unités de mesure.
     * @return this.unitId Unit
     */
    public Unit getUnitId()
    {
        return this.unitId;
    }

    /**
     * Liste l'ensemble des unités de mesure.
     * @param unitIdIn Unit
     */
    public void setUnitId(Unit unitIdIn)
    {
        this.unitId = unitIdIn;
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    /**
     * Returns <code>true</code> if the argument is an ProjectionSystem instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ProjectionSystem))
        {
            return false;
        }
        final ProjectionSystem that = (ProjectionSystem)object;
        if (this.projSystemCd == null || that.getProjSystemCd() == null || !this.projSystemCd.equals(that.getProjSystemCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.projSystemCd == null ? 0 : this.projSystemCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link ProjectionSystem}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ProjectionSystem}.
         * @return new ProjectionSystemImpl()
         */
        public static ProjectionSystem newInstance()
        {
            return new ProjectionSystemImpl();
        }

        /**
         * Constructs a new instance of {@link ProjectionSystem}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param projSystemNm String
         * @param projSystemMinX Float
         * @param projSystemMaxX Float
         * @param projSystemMinY Float
         * @param projSystemMaxY Float
         * @param unitId Unit
         * @param status Status
         * @return newInstance
         */
        public static ProjectionSystem newInstance(String projSystemNm, Float projSystemMinX, Float projSystemMaxX, Float projSystemMinY, Float projSystemMaxY, Unit unitId, Status status)
        {
            final ProjectionSystem entity = new ProjectionSystemImpl();
            entity.setProjSystemNm(projSystemNm);
            entity.setProjSystemMinX(projSystemMinX);
            entity.setProjSystemMaxX(projSystemMaxX);
            entity.setProjSystemMinY(projSystemMinY);
            entity.setProjSystemMaxY(projSystemMaxY);
            entity.setUnitId(unitId);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link ProjectionSystem}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param projSystemNm String
         * @param projSystemMinX Float
         * @param projSystemMaxX Float
         * @param projSystemMinY Float
         * @param projSystemMaxY Float
         * @param updateDt Timestamp
         * @param unitId Unit
         * @param status Status
         * @return newInstance ProjectionSystem
         */
        public static ProjectionSystem newInstance(String projSystemNm, Float projSystemMinX, Float projSystemMaxX, Float projSystemMinY, Float projSystemMaxY, Timestamp updateDt, Unit unitId, Status status)
        {
            final ProjectionSystem entity = new ProjectionSystemImpl();
            entity.setProjSystemNm(projSystemNm);
            entity.setProjSystemMinX(projSystemMinX);
            entity.setProjSystemMaxX(projSystemMaxX);
            entity.setProjSystemMinY(projSystemMinY);
            entity.setProjSystemMaxY(projSystemMaxY);
            entity.setUpdateDt(updateDt);
            entity.setUnitId(unitId);
            entity.setStatus(status);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ProjectionSystem o)
    {
        int cmp = 0;
        if (this.getProjSystemCd() != null)
        {
            cmp = this.getProjSystemCd().compareTo(o.getProjSystemCd());
        }
        else
        {
            if (this.getProjSystemNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getProjSystemNm().compareTo(o.getProjSystemNm()));
            }
            if (this.getProjSystemMinX() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getProjSystemMinX().compareTo(o.getProjSystemMinX()));
            }
            if (this.getProjSystemMaxX() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getProjSystemMaxX().compareTo(o.getProjSystemMaxX()));
            }
            if (this.getProjSystemMinY() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getProjSystemMinY().compareTo(o.getProjSystemMinY()));
            }
            if (this.getProjSystemMaxY() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getProjSystemMaxY().compareTo(o.getProjSystemMaxY()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ProjectionSystem.java merge-point
}