// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.monitoringLocation;

import fr.ifremer.quadrige3.core.dao.referential.ResourceType;
import fr.ifremer.quadrige3.core.dao.referential.taxon.TaxonGroup;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Groupe de taxon en un lieu pour un type de ressource.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TaxonGroupPosition
    implements Serializable, Comparable<TaxonGroupPosition>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -208630944041419852L;

    private TaxonGroupPositionPK taxonGroupPositionPk;

    /**
     * Get the composite primary key identifier class
     * @return taxonGroupPositionPk
     */
    public TaxonGroupPositionPK getTaxonGroupPositionPk()
    {
        return this.taxonGroupPositionPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param taxonGroupPositionPkIn
     */
    public void setTaxonGroupPositionPk(TaxonGroupPositionPK taxonGroupPositionPkIn) {
        this.taxonGroupPositionPk = taxonGroupPositionPkIn;
    }

    // Generate 1 attributes
    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 3 associations
    private TaxonGroup taxonGroup;

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @return this.taxonGroup TaxonGroup
     */
    public TaxonGroup getTaxonGroup()
    {
        return this.taxonGroup;
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param taxonGroupIn TaxonGroup
     */
    public void setTaxonGroup(TaxonGroup taxonGroupIn)
    {
        this.taxonGroup = taxonGroupIn;
    }

    private ResourceType resTypeId;

    /**
     * Caractéristique de la façon dont un taxon ou un groupe de taxon est géré en un lieu
     * @return this.resTypeId ResourceType
     */
    public ResourceType getResTypeId()
    {
        return this.resTypeId;
    }

    /**
     * Caractéristique de la façon dont un taxon ou un groupe de taxon est géré en un lieu
     * @param resTypeIdIn ResourceType
     */
    public void setResTypeId(ResourceType resTypeIdIn)
    {
        this.resTypeId = resTypeIdIn;
    }

    private MonitoringLocation monitoringLocation;

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @return this.monitoringLocation MonitoringLocation
     */
    public MonitoringLocation getMonitoringLocation()
    {
        return this.monitoringLocation;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param monitoringLocationIn MonitoringLocation
     */
    public void setMonitoringLocation(MonitoringLocation monitoringLocationIn)
    {
        this.monitoringLocation = monitoringLocationIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link TaxonGroupPosition}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TaxonGroupPosition}.
         * @return new TaxonGroupPositionImpl()
         */
        public static TaxonGroupPosition newInstance()
        {
            return new TaxonGroupPositionImpl();
        }

        /**
         * Constructs a new instance of {@link TaxonGroupPosition}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param taxonGroup TaxonGroup
         * @param monitoringLocation MonitoringLocation
         * @return newInstance
         */
        public static TaxonGroupPosition newInstance(TaxonGroup taxonGroup, MonitoringLocation monitoringLocation)
        {
            final TaxonGroupPosition entity = new TaxonGroupPositionImpl();
            entity.setTaxonGroup(taxonGroup);
            entity.setMonitoringLocation(monitoringLocation);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TaxonGroupPosition}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param taxonGroup TaxonGroup
         * @param resTypeId ResourceType
         * @param monitoringLocation MonitoringLocation
         * @return newInstance TaxonGroupPosition
         */
        public static TaxonGroupPosition newInstance(Timestamp updateDt, TaxonGroup taxonGroup, ResourceType resTypeId, MonitoringLocation monitoringLocation)
        {
            final TaxonGroupPosition entity = new TaxonGroupPositionImpl();
            entity.setUpdateDt(updateDt);
            entity.setTaxonGroup(taxonGroup);
            entity.setResTypeId(resTypeId);
            entity.setMonitoringLocation(monitoringLocation);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TaxonGroupPosition o)
    {
        int cmp = 0;
        if (this.getTaxonGroupPositionPk() != null)
        {
            cmp = this.getTaxonGroupPositionPk().compareTo(o.getTaxonGroupPositionPk());
        }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TaxonGroupPosition.java merge-point
}