// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.monitoringLocation;

import fr.ifremer.quadrige3.core.dao.referential.ResourceType;
import fr.ifremer.quadrige3.core.dao.referential.taxon.ReferenceTaxon;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Taxon lieu pour un type de ressource
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TaxonPosition
    implements Serializable, Comparable<TaxonPosition>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 2247403626943273000L;

    private TaxonPositionPK taxonPositionPk;

    /**
     * Get the composite primary key identifier class
     * @return taxonPositionPk
     */
    public TaxonPositionPK getTaxonPositionPk()
    {
        return this.taxonPositionPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param taxonPositionPkIn
     */
    public void setTaxonPositionPk(TaxonPositionPK taxonPositionPkIn) {
        this.taxonPositionPk = taxonPositionPkIn;
    }

    // Generate 1 attributes
    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 3 associations
    private ReferenceTaxon referenceTaxon;

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @return this.referenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getReferenceTaxon()
    {
        return this.referenceTaxon;
    }

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @param referenceTaxonIn ReferenceTaxon
     */
    public void setReferenceTaxon(ReferenceTaxon referenceTaxonIn)
    {
        this.referenceTaxon = referenceTaxonIn;
    }

    private MonitoringLocation monitoringLocation;

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @return this.monitoringLocation MonitoringLocation
     */
    public MonitoringLocation getMonitoringLocation()
    {
        return this.monitoringLocation;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param monitoringLocationIn MonitoringLocation
     */
    public void setMonitoringLocation(MonitoringLocation monitoringLocationIn)
    {
        this.monitoringLocation = monitoringLocationIn;
    }

    private ResourceType resourceType;

    /**
     * Caractéristique de la façon dont un taxon ou un groupe de taxon est géré en un lieu
     * @return this.resourceType ResourceType
     */
    public ResourceType getResourceType()
    {
        return this.resourceType;
    }

    /**
     * Caractéristique de la façon dont un taxon ou un groupe de taxon est géré en un lieu
     * @param resourceTypeIn ResourceType
     */
    public void setResourceType(ResourceType resourceTypeIn)
    {
        this.resourceType = resourceTypeIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link TaxonPosition}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TaxonPosition}.
         * @return new TaxonPositionImpl()
         */
        public static TaxonPosition newInstance()
        {
            return new TaxonPositionImpl();
        }

        /**
         * Constructs a new instance of {@link TaxonPosition}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param referenceTaxon ReferenceTaxon
         * @param monitoringLocation MonitoringLocation
         * @return newInstance
         */
        public static TaxonPosition newInstance(ReferenceTaxon referenceTaxon, MonitoringLocation monitoringLocation)
        {
            final TaxonPosition entity = new TaxonPositionImpl();
            entity.setReferenceTaxon(referenceTaxon);
            entity.setMonitoringLocation(monitoringLocation);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TaxonPosition}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param referenceTaxon ReferenceTaxon
         * @param monitoringLocation MonitoringLocation
         * @param resourceType ResourceType
         * @return newInstance TaxonPosition
         */
        public static TaxonPosition newInstance(Timestamp updateDt, ReferenceTaxon referenceTaxon, MonitoringLocation monitoringLocation, ResourceType resourceType)
        {
            final TaxonPosition entity = new TaxonPositionImpl();
            entity.setUpdateDt(updateDt);
            entity.setReferenceTaxon(referenceTaxon);
            entity.setMonitoringLocation(monitoringLocation);
            entity.setResourceType(resourceType);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TaxonPosition o)
    {
        int cmp = 0;
        if (this.getTaxonPositionPk() != null)
        {
            cmp = this.getTaxonPositionPk().compareTo(o.getTaxonPositionPk());
        }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TaxonPosition.java merge-point
}