// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.order;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Entités géographiques utilisées pour trier les lieux de surveillance (masse d'eau, zone classée,
 * zone conchylicole...)
 */
// HibernateEntity.vsl annotations merge-point
public abstract class OrderItem
    implements Serializable, Comparable<OrderItem>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -2053787532999269089L;

    // Generate 5 attributes
    private String orderItemCd;

    /**
     * Code de l'entité géographique de tri
     * Ex : Code d'une masse d'eau, Code d'une zone classée, Identifiant d'un secteur conchylicole
     * @return this.orderItemCd String
     */
    public String getOrderItemCd()
    {
        return this.orderItemCd;
    }

    /**
     * Code de l'entité géographique de tri
     * Ex : Code d'une masse d'eau, Code d'une zone classée, Identifiant d'un secteur conchylicole
     * @param orderItemCdIn String
     */
    public void setOrderItemCd(String orderItemCdIn)
    {
        this.orderItemCd = orderItemCdIn;
    }

    private String orderItemNm;

    /**
     * Libellé de l'entité géographique de tri
     * Ex : Code d'une masse d'eau, Code d'une zone classée, Identifiant d'un secteur conchylicole
     * @return this.orderItemNm String
     */
    public String getOrderItemNm()
    {
        return this.orderItemNm;
    }

    /**
     * Libellé de l'entité géographique de tri
     * Ex : Code d'une masse d'eau, Code d'une zone classée, Identifiant d'un secteur conchylicole
     * @param orderItemNmIn String
     */
    public void setOrderItemNm(String orderItemNmIn)
    {
        this.orderItemNm = orderItemNmIn;
    }

    private Integer orderItemNumber;

    /**
     * Numéro d'ordre de l'entité de tri au sein d'un même type d'entité
     * @return this.orderItemNumber Integer
     */
    public Integer getOrderItemNumber()
    {
        return this.orderItemNumber;
    }

    /**
     * Numéro d'ordre de l'entité de tri au sein d'un même type d'entité
     * @param orderItemNumberIn Integer
     */
    public void setOrderItemNumber(Integer orderItemNumberIn)
    {
        this.orderItemNumber = orderItemNumberIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private Integer orderItemId;

    /**
     * 
     * @return this.orderItemId Integer
     */
    public Integer getOrderItemId()
    {
        return this.orderItemId;
    }

    /**
     * 
     * @param orderItemIdIn Integer
     */
    public void setOrderItemId(Integer orderItemIdIn)
    {
        this.orderItemId = orderItemIdIn;
    }

    // Generate 2 associations
    private OrderItemType orderItemTypeCd;

    /**
     * Type d'entités géographiques utilisées pour trier les lieux de surveillance (masse d'eau,
     * zone
     * classée, zone conchylicole...)
     * @return this.orderItemTypeCd OrderItemType
     */
    public OrderItemType getOrderItemTypeCd()
    {
        return this.orderItemTypeCd;
    }

    /**
     * Type d'entités géographiques utilisées pour trier les lieux de surveillance (masse d'eau,
     * zone
     * classée, zone conchylicole...)
     * @param orderItemTypeCdIn OrderItemType
     */
    public void setOrderItemTypeCd(OrderItemType orderItemTypeCdIn)
    {
        this.orderItemTypeCd = orderItemTypeCdIn;
    }

    /**
     * Returns <code>true</code> if the argument is an OrderItem instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof OrderItem))
        {
            return false;
        }
        final OrderItem that = (OrderItem)object;
        if (this.orderItemId == null || that.getOrderItemId() == null || !this.orderItemId.equals(that.getOrderItemId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.orderItemId == null ? 0 : this.orderItemId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link OrderItem}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link OrderItem}.
         * @return new OrderItemImpl()
         */
        public static OrderItem newInstance()
        {
            return new OrderItemImpl();
        }

        /**
         * Constructs a new instance of {@link OrderItem}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param orderItemCd String
         * @param orderItemNm String
         * @param orderItemNumber Integer
         * @param orderItemTypeCd OrderItemType
         * @return newInstance
         */
        public static OrderItem newInstance(String orderItemCd, String orderItemNm, Integer orderItemNumber, OrderItemType orderItemTypeCd)
        {
            final OrderItem entity = new OrderItemImpl();
            entity.setOrderItemCd(orderItemCd);
            entity.setOrderItemNm(orderItemNm);
            entity.setOrderItemNumber(orderItemNumber);
            entity.setOrderItemTypeCd(orderItemTypeCd);
            return entity;
        }

        /**
         * Constructs a new instance of {@link OrderItem}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param orderItemCd String
         * @param orderItemNm String
         * @param orderItemNumber Integer
         * @param updateDt Timestamp
         * @param orderItemTypeCd OrderItemType
         * @return newInstance OrderItem
         */
        public static OrderItem newInstance(String orderItemCd, String orderItemNm, Integer orderItemNumber, Timestamp updateDt, OrderItemType orderItemTypeCd)
        {
            final OrderItem entity = new OrderItemImpl();
            entity.setOrderItemCd(orderItemCd);
            entity.setOrderItemNm(orderItemNm);
            entity.setOrderItemNumber(orderItemNumber);
            entity.setUpdateDt(updateDt);
            entity.setOrderItemTypeCd(orderItemTypeCd);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(OrderItem o)
    {
        int cmp = 0;
        if (this.getOrderItemId() != null)
        {
            cmp = this.getOrderItemId().compareTo(o.getOrderItemId());
        }
        else
        {
            if (this.getOrderItemCd() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getOrderItemCd().compareTo(o.getOrderItemCd()));
            }
            if (this.getOrderItemNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getOrderItemNm().compareTo(o.getOrderItemNm()));
            }
            if (this.getOrderItemNumber() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getOrderItemNumber().compareTo(o.getOrderItemNumber()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// OrderItem.java merge-point
}