// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.order;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Type d'entités géographiques utilisées pour trier les lieux de surveillance (masse d'eau, zone
 * classée, zone conchylicole...)
 */
// HibernateEntity.vsl annotations merge-point
public abstract class OrderItemType
    implements Serializable, Comparable<OrderItemType>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -2652624721077914571L;

    // Generate 3 attributes
    private String orderItemTypeCd;

    /**
     * Code du type d'entité géographique de tri
     * @return this.orderItemTypeCd String
     */
    public String getOrderItemTypeCd()
    {
        return this.orderItemTypeCd;
    }

    /**
     * Code du type d'entité géographique de tri
     * @param orderItemTypeCdIn String
     */
    public void setOrderItemTypeCd(String orderItemTypeCdIn)
    {
        this.orderItemTypeCd = orderItemTypeCdIn;
    }

    private String orderItemTypeNm;

    /**
     * Libellé du type d'entité géographique de tri
     * @return this.orderItemTypeNm String
     */
    public String getOrderItemTypeNm()
    {
        return this.orderItemTypeNm;
    }

    /**
     * Libellé du type d'entité géographique de tri
     * @param orderItemTypeNmIn String
     */
    public void setOrderItemTypeNm(String orderItemTypeNmIn)
    {
        this.orderItemTypeNm = orderItemTypeNmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 3 associations
    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<OrderItem> orderItemIds = new HashSet<OrderItem>();

    /**
     * Entités géographiques utilisées pour trier les lieux de surveillance (masse d'eau, zone
     * classée,
     * zone conchylicole...)
     * @return this.orderItemIds Collection<OrderItem>
     */
    public Collection<OrderItem> getOrderItemIds()
    {
        return this.orderItemIds;
    }

    /**
     * Entités géographiques utilisées pour trier les lieux de surveillance (masse d'eau, zone
     * classée,
     * zone conchylicole...)
     * @param orderItemIdsIn Collection<OrderItem>
     */
    public void setOrderItemIds(Collection<OrderItem> orderItemIdsIn)
    {
        this.orderItemIds = orderItemIdsIn;
    }

    /**
     * Entités géographiques utilisées pour trier les lieux de surveillance (masse d'eau, zone
     * classée,
     * zone conchylicole...)
     * @param elementToAdd OrderItem
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addOrderItemIds(OrderItem elementToAdd)
    {
        return this.orderItemIds.add(elementToAdd);
    }

    /**
     * Entités géographiques utilisées pour trier les lieux de surveillance (masse d'eau, zone
     * classée,
     * zone conchylicole...)
     * @param elementToRemove OrderItem
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeOrderItemIds(OrderItem elementToRemove)
    {
        return this.orderItemIds.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an OrderItemType instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof OrderItemType))
        {
            return false;
        }
        final OrderItemType that = (OrderItemType)object;
        if (this.orderItemTypeCd == null || that.getOrderItemTypeCd() == null || !this.orderItemTypeCd.equals(that.getOrderItemTypeCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.orderItemTypeCd == null ? 0 : this.orderItemTypeCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link OrderItemType}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link OrderItemType}.
         * @return new OrderItemTypeImpl()
         */
        public static OrderItemType newInstance()
        {
            return new OrderItemTypeImpl();
        }

        /**
         * Constructs a new instance of {@link OrderItemType}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param orderItemTypeNm String
         * @param status Status
         * @return newInstance
         */
        public static OrderItemType newInstance(String orderItemTypeNm, Status status)
        {
            final OrderItemType entity = new OrderItemTypeImpl();
            entity.setOrderItemTypeNm(orderItemTypeNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link OrderItemType}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param orderItemTypeNm String
         * @param updateDt Timestamp
         * @param status Status
         * @param orderItemIds Collection<OrderItem>
         * @return newInstance OrderItemType
         */
        public static OrderItemType newInstance(String orderItemTypeNm, Timestamp updateDt, Status status, Collection<OrderItem> orderItemIds)
        {
            final OrderItemType entity = new OrderItemTypeImpl();
            entity.setOrderItemTypeNm(orderItemTypeNm);
            entity.setUpdateDt(updateDt);
            entity.setStatus(status);
            entity.setOrderItemIds(orderItemIds);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(OrderItemType o)
    {
        int cmp = 0;
        if (this.getOrderItemTypeCd() != null)
        {
            cmp = this.getOrderItemTypeCd().compareTo(o.getOrderItemTypeCd());
        }
        else
        {
            if (this.getOrderItemTypeNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getOrderItemTypeNm().compareTo(o.getOrderItemTypeNm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// OrderItemType.java merge-point
}