// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.pmfm;

import fr.ifremer.quadrige3.core.dao.administration.program.PmfmMor;
import fr.ifremer.quadrige3.core.dao.referential.Status;
import fr.ifremer.quadrige3.core.dao.system.ComputeFunction;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste les différents paramètres mesurés. Attention, voir PARAMETRE SISMER.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Parameter
    implements Serializable, Comparable<Parameter>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -8905351031329538785L;

    // Generate 8 attributes
    private String parCd;

    /**
     * Code du paramètre
     * @return this.parCd String
     */
    public String getParCd()
    {
        return this.parCd;
    }

    /**
     * Code du paramètre
     * @param parCdIn String
     */
    public void setParCd(String parCdIn)
    {
        this.parCd = parCdIn;
    }

    private String parNm;

    /**
     * Libellé du paramètre
     * @return this.parNm String
     */
    public String getParNm()
    {
        return this.parNm;
    }

    /**
     * Libellé du paramètre
     * @param parNmIn String
     */
    public void setParNm(String parNmIn)
    {
        this.parNm = parNmIn;
    }

    private String parDc;

    /**
     * Description du paramètre
     * @return this.parDc String
     */
    public String getParDc()
    {
        return this.parDc;
    }

    /**
     * Description du paramètre
     * @param parDcIn String
     */
    public void setParDc(String parDcIn)
    {
        this.parDc = parDcIn;
    }

    private String parIsQualitative;

    /**
     * Indique si pour le paramètre on saisit des valeurs numérique ou si on choisit dans une liste
     * de valeurs qualitatives
     * @return this.parIsQualitative String
     */
    public String getParIsQualitative()
    {
        return this.parIsQualitative;
    }

    /**
     * Indique si pour le paramètre on saisit des valeurs numérique ou si on choisit dans une liste
     * de valeurs qualitatives
     * @param parIsQualitativeIn String
     */
    public void setParIsQualitative(String parIsQualitativeIn)
    {
        this.parIsQualitative = parIsQualitativeIn;
    }

    private String parIsCalculated;

    /**
     * Indique si le paramètre est calculé
     * @return this.parIsCalculated String
     */
    public String getParIsCalculated()
    {
        return this.parIsCalculated;
    }

    /**
     * Indique si le paramètre est calculé
     * @param parIsCalculatedIn String
     */
    public void setParIsCalculated(String parIsCalculatedIn)
    {
        this.parIsCalculated = parIsCalculatedIn;
    }

    private String parIsTaxonomic;

    /**
     * Indique si le paramètre est utilisé pour des mesures de dénombrement
     * @return this.parIsTaxonomic String
     */
    public String getParIsTaxonomic()
    {
        return this.parIsTaxonomic;
    }

    /**
     * Indique si le paramètre est utilisé pour des mesures de dénombrement
     * @param parIsTaxonomicIn String
     */
    public void setParIsTaxonomic(String parIsTaxonomicIn)
    {
        this.parIsTaxonomic = parIsTaxonomicIn;
    }

    private Date parCreationDt;

    /**
     * Date de création
     * @return this.parCreationDt Date
     */
    public Date getParCreationDt()
    {
        return this.parCreationDt;
    }

    /**
     * Date de création
     * @param parCreationDtIn Date
     */
    public void setParCreationDt(Date parCreationDtIn)
    {
        this.parCreationDt = parCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de maj
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de maj
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 8 associations
    private Collection<QualitativeValue> qualitativeValues = new HashSet<QualitativeValue>();

    /**
     * Liste des valeurs qualitatives associées aux paramètres.
     * @return this.qualitativeValues Collection<QualitativeValue>
     */
    public Collection<QualitativeValue> getQualitativeValues()
    {
        return this.qualitativeValues;
    }

    /**
     * Liste des valeurs qualitatives associées aux paramètres.
     * @param qualitativeValuesIn Collection<QualitativeValue>
     */
    public void setQualitativeValues(Collection<QualitativeValue> qualitativeValuesIn)
    {
        this.qualitativeValues = qualitativeValuesIn;
    }

    /**
     * Liste des valeurs qualitatives associées aux paramètres.
     * @param elementToAdd QualitativeValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addQualitativeValues(QualitativeValue elementToAdd)
    {
        return this.qualitativeValues.add(elementToAdd);
    }

    /**
     * Liste des valeurs qualitatives associées aux paramètres.
     * @param elementToRemove QualitativeValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeQualitativeValues(QualitativeValue elementToRemove)
    {
        return this.qualitativeValues.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private ParameterGroup parGroupId;

    /**
     * Liste des groupes de paramètres.
     * @return this.parGroupId ParameterGroup
     */
    public ParameterGroup getParGroupId()
    {
        return this.parGroupId;
    }

    /**
     * Liste des groupes de paramètres.
     * @param parGroupIdIn ParameterGroup
     */
    public void setParGroupId(ParameterGroup parGroupIdIn)
    {
        this.parGroupId = parGroupIdIn;
    }

    private Collection<PmfmMor> pmfmMors = new HashSet<PmfmMor>();

    /**
     * Quadruplets ou éléments constitutifs de quadruplets concernés par le moratoire
     * @return this.pmfmMors Collection<PmfmMor>
     */
    public Collection<PmfmMor> getPmfmMors()
    {
        return this.pmfmMors;
    }

    /**
     * Quadruplets ou éléments constitutifs de quadruplets concernés par le moratoire
     * @param pmfmMorsIn Collection<PmfmMor>
     */
    public void setPmfmMors(Collection<PmfmMor> pmfmMorsIn)
    {
        this.pmfmMors = pmfmMorsIn;
    }

    /**
     * Quadruplets ou éléments constitutifs de quadruplets concernés par le moratoire
     * @param elementToAdd PmfmMor
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPmfmMors(PmfmMor elementToAdd)
    {
        return this.pmfmMors.add(elementToAdd);
    }

    /**
     * Quadruplets ou éléments constitutifs de quadruplets concernés par le moratoire
     * @param elementToRemove PmfmMor
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePmfmMors(PmfmMor elementToRemove)
    {
        return this.pmfmMors.remove(elementToRemove);
    }

    private Collection<ComputeFunction> compFunctionCds = new HashSet<ComputeFunction>();

    /**
     * Contient les différentes fonction de calcul pour les paramètres
     * @return this.compFunctionCds Collection<ComputeFunction>
     */
    public Collection<ComputeFunction> getCompFunctionCds()
    {
        return this.compFunctionCds;
    }

    /**
     * Contient les différentes fonction de calcul pour les paramètres
     * @param compFunctionCdsIn Collection<ComputeFunction>
     */
    public void setCompFunctionCds(Collection<ComputeFunction> compFunctionCdsIn)
    {
        this.compFunctionCds = compFunctionCdsIn;
    }

    /**
     * Contient les différentes fonction de calcul pour les paramètres
     * @param elementToAdd ComputeFunction
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addCompFunctionCds(ComputeFunction elementToAdd)
    {
        return this.compFunctionCds.add(elementToAdd);
    }

    /**
     * Contient les différentes fonction de calcul pour les paramètres
     * @param elementToRemove ComputeFunction
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeCompFunctionCds(ComputeFunction elementToRemove)
    {
        return this.compFunctionCds.remove(elementToRemove);
    }

    private Collection<Pmfm> pmfms = new HashSet<Pmfm>();

    /**
     * Liste les quadruplets paramètre, méthode, support, fraction.
     * @return this.pmfms Collection<Pmfm>
     */
    public Collection<Pmfm> getPmfms()
    {
        return this.pmfms;
    }

    /**
     * Liste les quadruplets paramètre, méthode, support, fraction.
     * @param pmfmsIn Collection<Pmfm>
     */
    public void setPmfms(Collection<Pmfm> pmfmsIn)
    {
        this.pmfms = pmfmsIn;
    }

    /**
     * Liste les quadruplets paramètre, méthode, support, fraction.
     * @param elementToAdd Pmfm
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPmfms(Pmfm elementToAdd)
    {
        return this.pmfms.add(elementToAdd);
    }

    /**
     * Liste les quadruplets paramètre, méthode, support, fraction.
     * @param elementToRemove Pmfm
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePmfms(Pmfm elementToRemove)
    {
        return this.pmfms.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an Parameter instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Parameter))
        {
            return false;
        }
        final Parameter that = (Parameter)object;
        if (this.parCd == null || that.getParCd() == null || !this.parCd.equals(that.getParCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.parCd == null ? 0 : this.parCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Parameter}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Parameter}.
         * @return new ParameterImpl()
         */
        public static Parameter newInstance()
        {
            return new ParameterImpl();
        }

        /**
         * Constructs a new instance of {@link Parameter}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param status Status
         * @param parGroupId ParameterGroup
         * @return newInstance
         */
        public static Parameter newInstance(Status status, ParameterGroup parGroupId)
        {
            final Parameter entity = new ParameterImpl();
            entity.setStatus(status);
            entity.setParGroupId(parGroupId);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Parameter}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param parNm String
         * @param parDc String
         * @param parIsQualitative String
         * @param parIsCalculated String
         * @param parIsTaxonomic String
         * @param parCreationDt Date
         * @param updateDt Timestamp
         * @param qualitativeValues Collection<QualitativeValue>
         * @param status Status
         * @param parGroupId ParameterGroup
         * @param pmfmMors Collection<PmfmMor>
         * @param compFunctionCds Collection<ComputeFunction>
         * @param pmfms Collection<Pmfm>
         * @return newInstance Parameter
         */
        public static Parameter newInstance(String parNm, String parDc, String parIsQualitative, String parIsCalculated, String parIsTaxonomic, Date parCreationDt, Timestamp updateDt, Collection<QualitativeValue> qualitativeValues, Status status, ParameterGroup parGroupId, Collection<PmfmMor> pmfmMors, Collection<ComputeFunction> compFunctionCds, Collection<Pmfm> pmfms)
        {
            final Parameter entity = new ParameterImpl();
            entity.setParNm(parNm);
            entity.setParDc(parDc);
            entity.setParIsQualitative(parIsQualitative);
            entity.setParIsCalculated(parIsCalculated);
            entity.setParIsTaxonomic(parIsTaxonomic);
            entity.setParCreationDt(parCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setQualitativeValues(qualitativeValues);
            entity.setStatus(status);
            entity.setParGroupId(parGroupId);
            entity.setPmfmMors(pmfmMors);
            entity.setCompFunctionCds(compFunctionCds);
            entity.setPmfms(pmfms);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Parameter o)
    {
        int cmp = 0;
        if (this.getParCd() != null)
        {
            cmp = this.getParCd().compareTo(o.getParCd());
        }
        else
        {
            if (this.getParNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getParNm().compareTo(o.getParNm()));
            }
            if (this.getParDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getParDc().compareTo(o.getParDc()));
            }
            if (this.getParIsQualitative() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getParIsQualitative().compareTo(o.getParIsQualitative()));
            }
            if (this.getParIsCalculated() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getParIsCalculated().compareTo(o.getParIsCalculated()));
            }
            if (this.getParIsTaxonomic() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getParIsTaxonomic().compareTo(o.getParIsTaxonomic()));
            }
            if (this.getParCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getParCreationDt().compareTo(o.getParCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Parameter.java merge-point
}