// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.pmfm;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import fr.ifremer.quadrige3.core.dao.referential.Unit;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Liste les quadruplets paramètre, méthode, support, fraction.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Pmfm
    implements Serializable, Comparable<Pmfm>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 575889188240889179L;

    // Generate 5 attributes
    private Float pmfmDetectionThreshold;

    /**
     * Seuil de détection du quadruplet PMSF
     * @return this.pmfmDetectionThreshold Float
     */
    public Float getPmfmDetectionThreshold()
    {
        return this.pmfmDetectionThreshold;
    }

    /**
     * Seuil de détection du quadruplet PMSF
     * @param pmfmDetectionThresholdIn Float
     */
    public void setPmfmDetectionThreshold(Float pmfmDetectionThresholdIn)
    {
        this.pmfmDetectionThreshold = pmfmDetectionThresholdIn;
    }

    private Short pmfmMaximumNumberDecimals;

    /**
     * Nombre maximal de décimal des mesures. Indication pour la saisie. Sert à initialiser les
     * valeurs des résultats.
     * @return this.pmfmMaximumNumberDecimals Short
     */
    public Short getPmfmMaximumNumberDecimals()
    {
        return this.pmfmMaximumNumberDecimals;
    }

    /**
     * Nombre maximal de décimal des mesures. Indication pour la saisie. Sert à initialiser les
     * valeurs des résultats.
     * @param pmfmMaximumNumberDecimalsIn Short
     */
    public void setPmfmMaximumNumberDecimals(Short pmfmMaximumNumberDecimalsIn)
    {
        this.pmfmMaximumNumberDecimals = pmfmMaximumNumberDecimalsIn;
    }

    private Short pmfmSignifFiguresNumber;

    /**
     * Nombre de chiffre significatif des mesures
     * @return this.pmfmSignifFiguresNumber Short
     */
    public Short getPmfmSignifFiguresNumber()
    {
        return this.pmfmSignifFiguresNumber;
    }

    /**
     * Nombre de chiffre significatif des mesures
     * @param pmfmSignifFiguresNumberIn Short
     */
    public void setPmfmSignifFiguresNumber(Short pmfmSignifFiguresNumberIn)
    {
        this.pmfmSignifFiguresNumber = pmfmSignifFiguresNumberIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private Integer pmfmId;

    /**
     * 
     * @return this.pmfmId Integer
     */
    public Integer getPmfmId()
    {
        return this.pmfmId;
    }

    /**
     * 
     * @param pmfmIdIn Integer
     */
    public void setPmfmId(Integer pmfmIdIn)
    {
        this.pmfmId = pmfmIdIn;
    }

    // Generate 12 associations
    private Unit unit;

    /**
     * Liste l'ensemble des unités de mesure.
     * @return this.unit Unit
     */
    public Unit getUnit()
    {
        return this.unit;
    }

    /**
     * Liste l'ensemble des unités de mesure.
     * @param unitIn Unit
     */
    public void setUnit(Unit unitIn)
    {
        this.unit = unitIn;
    }

    private Matrix matrix;

    /**
     * Support utilisé pour mesurer un paramètre.
     * @return this.matrix Matrix
     */
    public Matrix getMatrix()
    {
        return this.matrix;
    }

    /**
     * Support utilisé pour mesurer un paramètre.
     * @param matrixIn Matrix
     */
    public void setMatrix(Matrix matrixIn)
    {
        this.matrix = matrixIn;
    }

    private Fraction fraction;

    /**
     * Liste les fractions (compléter la description).
     * @return this.fraction Fraction
     */
    public Fraction getFraction()
    {
        return this.fraction;
    }

    /**
     * Liste les fractions (compléter la description).
     * @param fractionIn Fraction
     */
    public void setFraction(Fraction fractionIn)
    {
        this.fraction = fractionIn;
    }

    private Parameter parameter;

    /**
     * Liste les différents paramètres mesurés. Attention, voir PARAMETRE SISMER.
     * @return this.parameter Parameter
     */
    public Parameter getParameter()
    {
        return this.parameter;
    }

    /**
     * Liste les différents paramètres mesurés. Attention, voir PARAMETRE SISMER.
     * @param parameterIn Parameter
     */
    public void setParameter(Parameter parameterIn)
    {
        this.parameter = parameterIn;
    }

    private Method method;

    /**
     * Méthode utilisée pour mesurer un paramètre.
     * @return this.method Method
     */
    public Method getMethod()
    {
        return this.method;
    }

    /**
     * Méthode utilisée pour mesurer un paramètre.
     * @param methodIn Method
     */
    public void setMethod(Method methodIn)
    {
        this.method = methodIn;
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<PmfmQualValue> pmfmQualValues = new HashSet<PmfmQualValue>();

    /**
     * Liste des valeurs qualitatives pour un PSFM.
     * Sous-liste des valeurs qualitatives d'un paramètre
     * @return this.pmfmQualValues Collection<PmfmQualValue>
     */
    public Collection<PmfmQualValue> getPmfmQualValues()
    {
        return this.pmfmQualValues;
    }

    /**
     * Liste des valeurs qualitatives pour un PSFM.
     * Sous-liste des valeurs qualitatives d'un paramètre
     * @param pmfmQualValuesIn Collection<PmfmQualValue>
     */
    public void setPmfmQualValues(Collection<PmfmQualValue> pmfmQualValuesIn)
    {
        this.pmfmQualValues = pmfmQualValuesIn;
    }

    /**
     * Liste des valeurs qualitatives pour un PSFM.
     * Sous-liste des valeurs qualitatives d'un paramètre
     * @param elementToAdd PmfmQualValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPmfmQualValues(PmfmQualValue elementToAdd)
    {
        return this.pmfmQualValues.add(elementToAdd);
    }

    /**
     * Liste des valeurs qualitatives pour un PSFM.
     * Sous-liste des valeurs qualitatives d'un paramètre
     * @param elementToRemove PmfmQualValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePmfmQualValues(PmfmQualValue elementToRemove)
    {
        return this.pmfmQualValues.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an Pmfm instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Pmfm))
        {
            return false;
        }
        final Pmfm that = (Pmfm)object;
        if (this.pmfmId == null || that.getPmfmId() == null || !this.pmfmId.equals(that.getPmfmId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.pmfmId == null ? 0 : this.pmfmId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Pmfm}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Pmfm}.
         * @return new PmfmImpl()
         */
        public static Pmfm newInstance()
        {
            return new PmfmImpl();
        }

        /**
         * Constructs a new instance of {@link Pmfm}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param unit Unit
         * @param matrix Matrix
         * @param fraction Fraction
         * @param parameter Parameter
         * @param method Method
         * @param status Status
         * @return newInstance
         */
        public static Pmfm newInstance(Unit unit, Matrix matrix, Fraction fraction, Parameter parameter, Method method, Status status)
        {
            final Pmfm entity = new PmfmImpl();
            entity.setUnit(unit);
            entity.setMatrix(matrix);
            entity.setFraction(fraction);
            entity.setParameter(parameter);
            entity.setMethod(method);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Pmfm}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param pmfmDetectionThreshold Float
         * @param pmfmMaximumNumberDecimals Short
         * @param pmfmSignifFiguresNumber Short
         * @param updateDt Timestamp
         * @param unit Unit
         * @param matrix Matrix
         * @param fraction Fraction
         * @param parameter Parameter
         * @param method Method
         * @param status Status
         * @param pmfmQualValues Collection<PmfmQualValue>
         * @return newInstance Pmfm
         */
        public static Pmfm newInstance(Float pmfmDetectionThreshold, Short pmfmMaximumNumberDecimals, Short pmfmSignifFiguresNumber, Timestamp updateDt, Unit unit, Matrix matrix, Fraction fraction, Parameter parameter, Method method, Status status, Collection<PmfmQualValue> pmfmQualValues)
        {
            final Pmfm entity = new PmfmImpl();
            entity.setPmfmDetectionThreshold(pmfmDetectionThreshold);
            entity.setPmfmMaximumNumberDecimals(pmfmMaximumNumberDecimals);
            entity.setPmfmSignifFiguresNumber(pmfmSignifFiguresNumber);
            entity.setUpdateDt(updateDt);
            entity.setUnit(unit);
            entity.setMatrix(matrix);
            entity.setFraction(fraction);
            entity.setParameter(parameter);
            entity.setMethod(method);
            entity.setStatus(status);
            entity.setPmfmQualValues(pmfmQualValues);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Pmfm o)
    {
        int cmp = 0;
        if (this.getPmfmId() != null)
        {
            cmp = this.getPmfmId().compareTo(o.getPmfmId());
        }
        else
        {
            if (this.getPmfmDetectionThreshold() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPmfmDetectionThreshold().compareTo(o.getPmfmDetectionThreshold()));
            }
            if (this.getPmfmMaximumNumberDecimals() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPmfmMaximumNumberDecimals().compareTo(o.getPmfmMaximumNumberDecimals()));
            }
            if (this.getPmfmSignifFiguresNumber() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPmfmSignifFiguresNumber().compareTo(o.getPmfmSignifFiguresNumber()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Pmfm.java merge-point
}