// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Contient les correspondances entre les taxons du système et les codes alternatifs des taxons
 * provenant d'autres sources (autres systèmes, référentiels...)
 */
// HibernateEntity.vsl annotations merge-point
public abstract class AlternativeTaxon
    implements Serializable, Comparable<AlternativeTaxon>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1635825773334308653L;

    // Generate 3 attributes
    private Integer alternTaxonId;

    /**
     * 
     * @return this.alternTaxonId Integer
     */
    public Integer getAlternTaxonId()
    {
        return this.alternTaxonId;
    }

    /**
     * 
     * @param alternTaxonIdIn Integer
     */
    public void setAlternTaxonId(Integer alternTaxonIdIn)
    {
        this.alternTaxonId = alternTaxonIdIn;
    }

    private String alternTaxonCd;

    /**
     * Code du taxon dans le système alternatif
     * @return this.alternTaxonCd String
     */
    public String getAlternTaxonCd()
    {
        return this.alternTaxonCd;
    }

    /**
     * Code du taxon dans le système alternatif
     * @param alternTaxonCdIn String
     */
    public void setAlternTaxonCd(String alternTaxonCdIn)
    {
        this.alternTaxonCd = alternTaxonCdIn;
    }

    private Timestamp updateDt;

    /**
     * Date de mise à jour de l'objet
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de mise à jour de l'objet
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private AlternativeTaxonOrigin alternativeTaxonOrigin;

    /**
     * Contient les différentes sources (origines) des codes alternatifs des taxons (autres
     * systèmes,
     * référentiels...)
     * @return this.alternativeTaxonOrigin AlternativeTaxonOrigin
     */
    public AlternativeTaxonOrigin getAlternativeTaxonOrigin()
    {
        return this.alternativeTaxonOrigin;
    }

    /**
     * Contient les différentes sources (origines) des codes alternatifs des taxons (autres
     * systèmes,
     * référentiels...)
     * @param alternativeTaxonOriginIn AlternativeTaxonOrigin
     */
    public void setAlternativeTaxonOrigin(AlternativeTaxonOrigin alternativeTaxonOriginIn)
    {
        this.alternativeTaxonOrigin = alternativeTaxonOriginIn;
    }

    private TaxonName taxonName;

    /**
     * Liste les taxons (interface avec ERMS)
     * @return this.taxonName TaxonName
     */
    public TaxonName getTaxonName()
    {
        return this.taxonName;
    }

    /**
     * Liste les taxons (interface avec ERMS)
     * @param taxonNameIn TaxonName
     */
    public void setTaxonName(TaxonName taxonNameIn)
    {
        this.taxonName = taxonNameIn;
    }

    /**
     * Returns <code>true</code> if the argument is an AlternativeTaxon instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof AlternativeTaxon))
        {
            return false;
        }
        final AlternativeTaxon that = (AlternativeTaxon)object;
        if (this.alternTaxonId == null || that.getAlternTaxonId() == null || !this.alternTaxonId.equals(that.getAlternTaxonId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.alternTaxonId == null ? 0 : this.alternTaxonId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link AlternativeTaxon}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link AlternativeTaxon}.
         * @return new AlternativeTaxonImpl()
         */
        public static AlternativeTaxon newInstance()
        {
            return new AlternativeTaxonImpl();
        }

        /**
         * Constructs a new instance of {@link AlternativeTaxon}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param alternTaxonCd String
         * @param alternativeTaxonOrigin AlternativeTaxonOrigin
         * @param taxonName TaxonName
         * @return newInstance
         */
        public static AlternativeTaxon newInstance(String alternTaxonCd, AlternativeTaxonOrigin alternativeTaxonOrigin, TaxonName taxonName)
        {
            final AlternativeTaxon entity = new AlternativeTaxonImpl();
            entity.setAlternTaxonCd(alternTaxonCd);
            entity.setAlternativeTaxonOrigin(alternativeTaxonOrigin);
            entity.setTaxonName(taxonName);
            return entity;
        }

        /**
         * Constructs a new instance of {@link AlternativeTaxon}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param alternTaxonCd String
         * @param updateDt Timestamp
         * @param alternativeTaxonOrigin AlternativeTaxonOrigin
         * @param taxonName TaxonName
         * @return newInstance AlternativeTaxon
         */
        public static AlternativeTaxon newInstance(String alternTaxonCd, Timestamp updateDt, AlternativeTaxonOrigin alternativeTaxonOrigin, TaxonName taxonName)
        {
            final AlternativeTaxon entity = new AlternativeTaxonImpl();
            entity.setAlternTaxonCd(alternTaxonCd);
            entity.setUpdateDt(updateDt);
            entity.setAlternativeTaxonOrigin(alternativeTaxonOrigin);
            entity.setTaxonName(taxonName);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(AlternativeTaxon o)
    {
        int cmp = 0;
        if (this.getAlternTaxonId() != null)
        {
            cmp = this.getAlternTaxonId().compareTo(o.getAlternTaxonId());
        }
        else
        {
            if (this.getAlternTaxonCd() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAlternTaxonCd().compareTo(o.getAlternTaxonCd()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// AlternativeTaxon.java merge-point
}