// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Contient les différentes sources (origines) des codes alternatifs des taxons (autres systèmes,
 * référentiels...)
 */
// HibernateEntity.vsl annotations merge-point
public abstract class AlternativeTaxonOrigin
    implements Serializable, Comparable<AlternativeTaxonOrigin>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1398839530128379897L;

    // Generate 4 attributes
    private String alternTaxonOriginCd;

    /**
     * Code de l'origine des codes alternatifs des taxons
     * @return this.alternTaxonOriginCd String
     */
    public String getAlternTaxonOriginCd()
    {
        return this.alternTaxonOriginCd;
    }

    /**
     * Code de l'origine des codes alternatifs des taxons
     * @param alternTaxonOriginCdIn String
     */
    public void setAlternTaxonOriginCd(String alternTaxonOriginCdIn)
    {
        this.alternTaxonOriginCd = alternTaxonOriginCdIn;
    }

    private String alternTaxonOriginNm;

    /**
     * Libellé de l'origine des codes alternatifs des taxons
     * @return this.alternTaxonOriginNm String
     */
    public String getAlternTaxonOriginNm()
    {
        return this.alternTaxonOriginNm;
    }

    /**
     * Libellé de l'origine des codes alternatifs des taxons
     * @param alternTaxonOriginNmIn String
     */
    public void setAlternTaxonOriginNm(String alternTaxonOriginNmIn)
    {
        this.alternTaxonOriginNm = alternTaxonOriginNmIn;
    }

    private String alternTaxonOriginCm;

    /**
     * Commentaire sur l'origine des codes alternatifs des taxons
     * @return this.alternTaxonOriginCm String
     */
    public String getAlternTaxonOriginCm()
    {
        return this.alternTaxonOriginCm;
    }

    /**
     * Commentaire sur l'origine des codes alternatifs des taxons
     * @param alternTaxonOriginCmIn String
     */
    public void setAlternTaxonOriginCm(String alternTaxonOriginCmIn)
    {
        this.alternTaxonOriginCm = alternTaxonOriginCmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de mise à jour de l'objet
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de mise à jour de l'objet
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 1 associations
    private Collection<AlternativeTaxon> alternativeTaxons = new HashSet<AlternativeTaxon>();

    /**
     * Contient les correspondances entre les taxons du système et les codes alternatifs des taxons
     * provenant d'autres sources (autres systèmes, référentiels...)
     * @return this.alternativeTaxons Collection<AlternativeTaxon>
     */
    public Collection<AlternativeTaxon> getAlternativeTaxons()
    {
        return this.alternativeTaxons;
    }

    /**
     * Contient les correspondances entre les taxons du système et les codes alternatifs des taxons
     * provenant d'autres sources (autres systèmes, référentiels...)
     * @param alternativeTaxonsIn Collection<AlternativeTaxon>
     */
    public void setAlternativeTaxons(Collection<AlternativeTaxon> alternativeTaxonsIn)
    {
        this.alternativeTaxons = alternativeTaxonsIn;
    }

    /**
     * Contient les correspondances entre les taxons du système et les codes alternatifs des taxons
     * provenant d'autres sources (autres systèmes, référentiels...)
     * @param elementToAdd AlternativeTaxon
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addAlternativeTaxons(AlternativeTaxon elementToAdd)
    {
        return this.alternativeTaxons.add(elementToAdd);
    }

    /**
     * Contient les correspondances entre les taxons du système et les codes alternatifs des taxons
     * provenant d'autres sources (autres systèmes, référentiels...)
     * @param elementToRemove AlternativeTaxon
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeAlternativeTaxons(AlternativeTaxon elementToRemove)
    {
        return this.alternativeTaxons.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an AlternativeTaxonOrigin instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof AlternativeTaxonOrigin))
        {
            return false;
        }
        final AlternativeTaxonOrigin that = (AlternativeTaxonOrigin)object;
        if (this.alternTaxonOriginCd == null || that.getAlternTaxonOriginCd() == null || !this.alternTaxonOriginCd.equals(that.getAlternTaxonOriginCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.alternTaxonOriginCd == null ? 0 : this.alternTaxonOriginCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link AlternativeTaxonOrigin}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link AlternativeTaxonOrigin}.
         * @return new AlternativeTaxonOriginImpl()
         */
        public static AlternativeTaxonOrigin newInstance()
        {
            return new AlternativeTaxonOriginImpl();
        }

        /**
         * Constructs a new instance of {@link AlternativeTaxonOrigin}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param alternTaxonOriginNm String
         * @return newInstance
         */
        public static AlternativeTaxonOrigin newInstance(String alternTaxonOriginNm)
        {
            final AlternativeTaxonOrigin entity = new AlternativeTaxonOriginImpl();
            entity.setAlternTaxonOriginNm(alternTaxonOriginNm);
            return entity;
        }

        /**
         * Constructs a new instance of {@link AlternativeTaxonOrigin}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param alternTaxonOriginNm String
         * @param alternTaxonOriginCm String
         * @param updateDt Timestamp
         * @param alternativeTaxons Collection<AlternativeTaxon>
         * @return newInstance AlternativeTaxonOrigin
         */
        public static AlternativeTaxonOrigin newInstance(String alternTaxonOriginNm, String alternTaxonOriginCm, Timestamp updateDt, Collection<AlternativeTaxon> alternativeTaxons)
        {
            final AlternativeTaxonOrigin entity = new AlternativeTaxonOriginImpl();
            entity.setAlternTaxonOriginNm(alternTaxonOriginNm);
            entity.setAlternTaxonOriginCm(alternTaxonOriginCm);
            entity.setUpdateDt(updateDt);
            entity.setAlternativeTaxons(alternativeTaxons);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(AlternativeTaxonOrigin o)
    {
        int cmp = 0;
        if (this.getAlternTaxonOriginCd() != null)
        {
            cmp = this.getAlternTaxonOriginCd().compareTo(o.getAlternTaxonOriginCd());
        }
        else
        {
            if (this.getAlternTaxonOriginNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAlternTaxonOriginNm().compareTo(o.getAlternTaxonOriginNm()));
            }
            if (this.getAlternTaxonOriginCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAlternTaxonOriginCm().compareTo(o.getAlternTaxonOriginCm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// AlternativeTaxonOrigin.java merge-point
}