// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste, au niveau de la taxinomie, des scientifiques à l'origine de la nomenclature.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Author
    implements Serializable, Comparable<Author>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -9164479460456191622L;

    // Generate 6 attributes
    private Integer authorId;

    /**
     * Identifiant interne de l'auteur d'une publication
     * @return this.authorId Integer
     */
    public Integer getAuthorId()
    {
        return this.authorId;
    }

    /**
     * Identifiant interne de l'auteur d'une publication
     * @param authorIdIn Integer
     */
    public void setAuthorId(Integer authorIdIn)
    {
        this.authorId = authorIdIn;
    }

    private String authorNm;

    /**
     * Nom de l'auteur, unique et obligatoire.
     * @return this.authorNm String
     */
    public String getAuthorNm()
    {
        return this.authorNm;
    }

    /**
     * Nom de l'auteur, unique et obligatoire.
     * @param authorNmIn String
     */
    public void setAuthorNm(String authorNmIn)
    {
        this.authorNm = authorNmIn;
    }

    private String authorLocal;

    /**
     * Information permettant de localiser l'auteur (adresse, pays, ...)
     * @return this.authorLocal String
     */
    public String getAuthorLocal()
    {
        return this.authorLocal;
    }

    /**
     * Information permettant de localiser l'auteur (adresse, pays, ...)
     * @param authorLocalIn String
     */
    public void setAuthorLocal(String authorLocalIn)
    {
        this.authorLocal = authorLocalIn;
    }

    private String authorCm;

    /**
     * Commentaire sur l'auteur
     * @return this.authorCm String
     */
    public String getAuthorCm()
    {
        return this.authorCm;
    }

    /**
     * Commentaire sur l'auteur
     * @param authorCmIn String
     */
    public void setAuthorCm(String authorCmIn)
    {
        this.authorCm = authorCmIn;
    }

    private Date authorCreationDt;

    /**
     * Date de création de l'enrgistrement
     * @return this.authorCreationDt Date
     */
    public Date getAuthorCreationDt()
    {
        return this.authorCreationDt;
    }

    /**
     * Date de création de l'enrgistrement
     * @param authorCreationDtIn Date
     */
    public void setAuthorCreationDt(Date authorCreationDtIn)
    {
        this.authorCreationDt = authorCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de mise à jour de l'enregistrement
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de mise à jour de l'enregistrement
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<ReferenceDocument> referenceDocuments = new HashSet<ReferenceDocument>();

    /**
     * Liste les documents de référence concernant un taxon.
     * @return this.referenceDocuments Collection<ReferenceDocument>
     */
    public Collection<ReferenceDocument> getReferenceDocuments()
    {
        return this.referenceDocuments;
    }

    /**
     * Liste les documents de référence concernant un taxon.
     * @param referenceDocumentsIn Collection<ReferenceDocument>
     */
    public void setReferenceDocuments(Collection<ReferenceDocument> referenceDocumentsIn)
    {
        this.referenceDocuments = referenceDocumentsIn;
    }

    /**
     * Liste les documents de référence concernant un taxon.
     * @param elementToAdd ReferenceDocument
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addReferenceDocuments(ReferenceDocument elementToAdd)
    {
        return this.referenceDocuments.add(elementToAdd);
    }

    /**
     * Liste les documents de référence concernant un taxon.
     * @param elementToRemove ReferenceDocument
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeReferenceDocuments(ReferenceDocument elementToRemove)
    {
        return this.referenceDocuments.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an Author instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Author))
        {
            return false;
        }
        final Author that = (Author)object;
        if (this.authorId == null || that.getAuthorId() == null || !this.authorId.equals(that.getAuthorId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.authorId == null ? 0 : this.authorId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Author}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Author}.
         * @return new AuthorImpl()
         */
        public static Author newInstance()
        {
            return new AuthorImpl();
        }

        /**
         * Constructs a new instance of {@link Author}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param status Status
         * @return newInstance
         */
        public static Author newInstance(Status status)
        {
            final Author entity = new AuthorImpl();
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Author}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param authorNm String
         * @param authorLocal String
         * @param authorCm String
         * @param authorCreationDt Date
         * @param updateDt Timestamp
         * @param status Status
         * @param referenceDocuments Collection<ReferenceDocument>
         * @return newInstance Author
         */
        public static Author newInstance(String authorNm, String authorLocal, String authorCm, Date authorCreationDt, Timestamp updateDt, Status status, Collection<ReferenceDocument> referenceDocuments)
        {
            final Author entity = new AuthorImpl();
            entity.setAuthorNm(authorNm);
            entity.setAuthorLocal(authorLocal);
            entity.setAuthorCm(authorCm);
            entity.setAuthorCreationDt(authorCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setStatus(status);
            entity.setReferenceDocuments(referenceDocuments);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Author o)
    {
        int cmp = 0;
        if (this.getAuthorId() != null)
        {
            cmp = this.getAuthorId().compareTo(o.getAuthorId());
        }
        else
        {
            if (this.getAuthorNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAuthorNm().compareTo(o.getAuthorNm()));
            }
            if (this.getAuthorLocal() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAuthorLocal().compareTo(o.getAuthorLocal()));
            }
            if (this.getAuthorCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAuthorCm().compareTo(o.getAuthorCm()));
            }
            if (this.getAuthorCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAuthorCreationDt().compareTo(o.getAuthorCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Author.java merge-point
}