// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Citation faisant référence pour un taxon particulier.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Citation
    implements Serializable, Comparable<Citation>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1076349412632982927L;

    // Generate 4 attributes
    private Integer citId;

    /**
     * Identifiant interne de la citation
     * @return this.citId Integer
     */
    public Integer getCitId()
    {
        return this.citId;
    }

    /**
     * Identifiant interne de la citation
     * @param citIdIn Integer
     */
    public void setCitId(Integer citIdIn)
    {
        this.citId = citIdIn;
    }

    private String citNm;

    /**
     * Libellé de la citation
     * @return this.citNm String
     */
    public String getCitNm()
    {
        return this.citNm;
    }

    /**
     * Libellé de la citation
     * @param citNmIn String
     */
    public void setCitNm(String citNmIn)
    {
        this.citNm = citNmIn;
    }

    private Date citCreationDt;

    /**
     * Date de création de l'objet
     * @return this.citCreationDt Date
     */
    public Date getCitCreationDt()
    {
        return this.citCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param citCreationDtIn Date
     */
    public void setCitCreationDt(Date citCreationDtIn)
    {
        this.citCreationDt = citCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de maj de l'objet
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de maj de l'objet
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 3 associations
    private Collection<TaxonName> taxonNames = new HashSet<TaxonName>();

    /**
     * Liste les taxons (interface avec ERMS)
     * @return this.taxonNames Collection<TaxonName>
     */
    public Collection<TaxonName> getTaxonNames()
    {
        return this.taxonNames;
    }

    /**
     * Liste les taxons (interface avec ERMS)
     * @param taxonNamesIn Collection<TaxonName>
     */
    public void setTaxonNames(Collection<TaxonName> taxonNamesIn)
    {
        this.taxonNames = taxonNamesIn;
    }

    /**
     * Liste les taxons (interface avec ERMS)
     * @param elementToAdd TaxonName
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addTaxonNames(TaxonName elementToAdd)
    {
        return this.taxonNames.add(elementToAdd);
    }

    /**
     * Liste les taxons (interface avec ERMS)
     * @param elementToRemove TaxonName
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeTaxonNames(TaxonName elementToRemove)
    {
        return this.taxonNames.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<TaxonNameHistory> taxonNameHistIds = new HashSet<TaxonNameHistory>();

    /**
     * Cette table permet de conserver l'historique des modifications d'un taxon
     * @return this.taxonNameHistIds Collection<TaxonNameHistory>
     */
    public Collection<TaxonNameHistory> getTaxonNameHistIds()
    {
        return this.taxonNameHistIds;
    }

    /**
     * Cette table permet de conserver l'historique des modifications d'un taxon
     * @param taxonNameHistIdsIn Collection<TaxonNameHistory>
     */
    public void setTaxonNameHistIds(Collection<TaxonNameHistory> taxonNameHistIdsIn)
    {
        this.taxonNameHistIds = taxonNameHistIdsIn;
    }

    /**
     * Cette table permet de conserver l'historique des modifications d'un taxon
     * @param elementToAdd TaxonNameHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addTaxonNameHistIds(TaxonNameHistory elementToAdd)
    {
        return this.taxonNameHistIds.add(elementToAdd);
    }

    /**
     * Cette table permet de conserver l'historique des modifications d'un taxon
     * @param elementToRemove TaxonNameHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeTaxonNameHistIds(TaxonNameHistory elementToRemove)
    {
        return this.taxonNameHistIds.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an Citation instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Citation))
        {
            return false;
        }
        final Citation that = (Citation)object;
        if (this.citId == null || that.getCitId() == null || !this.citId.equals(that.getCitId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.citId == null ? 0 : this.citId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Citation}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Citation}.
         * @return new CitationImpl()
         */
        public static Citation newInstance()
        {
            return new CitationImpl();
        }

        /**
         * Constructs a new instance of {@link Citation}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param status Status
         * @return newInstance
         */
        public static Citation newInstance(Status status)
        {
            final Citation entity = new CitationImpl();
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Citation}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param citNm String
         * @param citCreationDt Date
         * @param updateDt Timestamp
         * @param taxonNames Collection<TaxonName>
         * @param status Status
         * @param taxonNameHistIds Collection<TaxonNameHistory>
         * @return newInstance Citation
         */
        public static Citation newInstance(String citNm, Date citCreationDt, Timestamp updateDt, Collection<TaxonName> taxonNames, Status status, Collection<TaxonNameHistory> taxonNameHistIds)
        {
            final Citation entity = new CitationImpl();
            entity.setCitNm(citNm);
            entity.setCitCreationDt(citCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setTaxonNames(taxonNames);
            entity.setStatus(status);
            entity.setTaxonNameHistIds(taxonNameHistIds);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Citation o)
    {
        int cmp = 0;
        if (this.getCitId() != null)
        {
            cmp = this.getCitId().compareTo(o.getCitId());
        }
        else
        {
            if (this.getCitNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getCitNm().compareTo(o.getCitNm()));
            }
            if (this.getCitCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getCitCreationDt().compareTo(o.getCitCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Citation.java merge-point
}