// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste les documents de référence concernant un taxon.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ReferenceDocument
    implements Serializable, Comparable<ReferenceDocument>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 5245706815407059828L;

    // Generate 6 attributes
    private Integer refDocId;

    /**
     * Identifiant interne de la publication
     * @return this.refDocId Integer
     */
    public Integer getRefDocId()
    {
        return this.refDocId;
    }

    /**
     * Identifiant interne de la publication
     * @param refDocIdIn Integer
     */
    public void setRefDocId(Integer refDocIdIn)
    {
        this.refDocId = refDocIdIn;
    }

    private String refDocRefer;

    /**
     * Référence de la publication (revue, titre, page, ...)
     * @return this.refDocRefer String
     */
    public String getRefDocRefer()
    {
        return this.refDocRefer;
    }

    /**
     * Référence de la publication (revue, titre, page, ...)
     * @param refDocReferIn String
     */
    public void setRefDocRefer(String refDocReferIn)
    {
        this.refDocRefer = refDocReferIn;
    }

    private Date refDocDt;

    /**
     * Date de parution du document
     * @return this.refDocDt Date
     */
    public Date getRefDocDt()
    {
        return this.refDocDt;
    }

    /**
     * Date de parution du document
     * @param refDocDtIn Date
     */
    public void setRefDocDt(Date refDocDtIn)
    {
        this.refDocDt = refDocDtIn;
    }

    private String refDocCm;

    /**
     * Commentaire sur la publication
     * @return this.refDocCm String
     */
    public String getRefDocCm()
    {
        return this.refDocCm;
    }

    /**
     * Commentaire sur la publication
     * @param refDocCmIn String
     */
    public void setRefDocCm(String refDocCmIn)
    {
        this.refDocCm = refDocCmIn;
    }

    private Date refDocCreationDt;

    /**
     * Date de création de l'objet
     * @return this.refDocCreationDt Date
     */
    public Date getRefDocCreationDt()
    {
        return this.refDocCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param refDocCreationDtIn Date
     */
    public void setRefDocCreationDt(Date refDocCreationDtIn)
    {
        this.refDocCreationDt = refDocCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de maj de l'objet
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de maj de l'objet
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 5 associations
    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<Author> authors = new HashSet<Author>();

    /**
     * Liste, au niveau de la taxinomie, des scientifiques à l'origine de la nomenclature.
     * @return this.authors Collection<Author>
     */
    public Collection<Author> getAuthors()
    {
        return this.authors;
    }

    /**
     * Liste, au niveau de la taxinomie, des scientifiques à l'origine de la nomenclature.
     * @param authorsIn Collection<Author>
     */
    public void setAuthors(Collection<Author> authorsIn)
    {
        this.authors = authorsIn;
    }

    /**
     * Liste, au niveau de la taxinomie, des scientifiques à l'origine de la nomenclature.
     * @param elementToAdd Author
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addAuthors(Author elementToAdd)
    {
        return this.authors.add(elementToAdd);
    }

    /**
     * Liste, au niveau de la taxinomie, des scientifiques à l'origine de la nomenclature.
     * @param elementToRemove Author
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeAuthors(Author elementToRemove)
    {
        return this.authors.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an ReferenceDocument instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ReferenceDocument))
        {
            return false;
        }
        final ReferenceDocument that = (ReferenceDocument)object;
        if (this.refDocId == null || that.getRefDocId() == null || !this.refDocId.equals(that.getRefDocId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.refDocId == null ? 0 : this.refDocId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link ReferenceDocument}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ReferenceDocument}.
         * @return new ReferenceDocumentImpl()
         */
        public static ReferenceDocument newInstance()
        {
            return new ReferenceDocumentImpl();
        }

        /**
         * Constructs a new instance of {@link ReferenceDocument}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param status Status
         * @return newInstance
         */
        public static ReferenceDocument newInstance(Status status)
        {
            final ReferenceDocument entity = new ReferenceDocumentImpl();
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link ReferenceDocument}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param refDocRefer String
         * @param refDocDt Date
         * @param refDocCm String
         * @param refDocCreationDt Date
         * @param updateDt Timestamp
         * @param status Status
         * @param authors Collection<Author>
         * @return newInstance ReferenceDocument
         */
        public static ReferenceDocument newInstance(String refDocRefer, Date refDocDt, String refDocCm, Date refDocCreationDt, Timestamp updateDt, Status status, Collection<Author> authors)
        {
            final ReferenceDocument entity = new ReferenceDocumentImpl();
            entity.setRefDocRefer(refDocRefer);
            entity.setRefDocDt(refDocDt);
            entity.setRefDocCm(refDocCm);
            entity.setRefDocCreationDt(refDocCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setStatus(status);
            entity.setAuthors(authors);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ReferenceDocument o)
    {
        int cmp = 0;
        if (this.getRefDocId() != null)
        {
            cmp = this.getRefDocId().compareTo(o.getRefDocId());
        }
        else
        {
            if (this.getRefDocRefer() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRefDocRefer().compareTo(o.getRefDocRefer()));
            }
            if (this.getRefDocDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRefDocDt().compareTo(o.getRefDocDt()));
            }
            if (this.getRefDocCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRefDocCm().compareTo(o.getRefDocCm()));
            }
            if (this.getRefDocCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRefDocCreationDt().compareTo(o.getRefDocCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ReferenceDocument.java merge-point
}