// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Liste des taxons qui sont la référence.
 * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment et
 * ne plus l'être par la suite.
 * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
 * référents à un moment mais ne peuvent plus l'être par la suite.
 * Le fonctionnement dans la table TAXON_NAME est le suivant :
 * - REF_TAXON_ID est toujours renseigné
 * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il s'agit
 * d'un taxon virtuel)
 * - sinon c'est un synonyme
 * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
 * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
 * NB : c'était le comportement initialement prévu.
 * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2, le
 * taxon T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les
 * synonymes et les résultats qu'il pouvait avoir).
 * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
 * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
 * alors pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les
 * autres synonymes, résultats...
 * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et qui
 * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
 * pour R2 est nécessaire
 * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
 * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
 * référents
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ReferenceTaxon
    implements Serializable, Comparable<ReferenceTaxon>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 9178266362854772000L;

    // Generate 2 attributes
    private Integer refTaxonId;

    /**
     * Identifiant interne du taxon référent.
     * @return this.refTaxonId Integer
     */
    public Integer getRefTaxonId()
    {
        return this.refTaxonId;
    }

    /**
     * Identifiant interne du taxon référent.
     * @param refTaxonIdIn Integer
     */
    public void setRefTaxonId(Integer refTaxonIdIn)
    {
        this.refTaxonId = refTaxonIdIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 8 associations
    private Collection<VirtualComponent> virtualComponents = new HashSet<VirtualComponent>();

    /**
     * 
     * @return this.virtualComponents Collection<VirtualComponent>
     */
    public Collection<VirtualComponent> getVirtualComponents()
    {
        return this.virtualComponents;
    }

    /**
     * 
     * @param virtualComponentsIn Collection<VirtualComponent>
     */
    public void setVirtualComponents(Collection<VirtualComponent> virtualComponentsIn)
    {
        this.virtualComponents = virtualComponentsIn;
    }

    /**
     * 
     * @param elementToAdd VirtualComponent
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addVirtualComponents(VirtualComponent elementToAdd)
    {
        return this.virtualComponents.add(elementToAdd);
    }

    /**
     * 
     * @param elementToRemove VirtualComponent
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeVirtualComponents(VirtualComponent elementToRemove)
    {
        return this.virtualComponents.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an ReferenceTaxon instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ReferenceTaxon))
        {
            return false;
        }
        final ReferenceTaxon that = (ReferenceTaxon)object;
        if (this.refTaxonId == null || that.getRefTaxonId() == null || !this.refTaxonId.equals(that.getRefTaxonId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.refTaxonId == null ? 0 : this.refTaxonId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link ReferenceTaxon}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ReferenceTaxon}.
         * @return new ReferenceTaxonImpl()
         */
        public static ReferenceTaxon newInstance()
        {
            return new ReferenceTaxonImpl();
        }


        /**
         * Constructs a new instance of {@link ReferenceTaxon}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param virtualComponents Collection<VirtualComponent>
         * @return newInstance ReferenceTaxon
         */
        public static ReferenceTaxon newInstance(Timestamp updateDt, Collection<VirtualComponent> virtualComponents)
        {
            final ReferenceTaxon entity = new ReferenceTaxonImpl();
            entity.setUpdateDt(updateDt);
            entity.setVirtualComponents(virtualComponents);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ReferenceTaxon o)
    {
        int cmp = 0;
        if (this.getRefTaxonId() != null)
        {
            cmp = this.getRefTaxonId().compareTo(o.getRefTaxonId());
        }
        else
        {
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ReferenceTaxon.java merge-point
}