// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import fr.ifremer.quadrige3.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Liste des taxons qui sont la référence.
 * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment et
 * ne plus l'être par la suite.
 * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
 * référents à un moment mais ne peuvent plus l'être par la suite.
 * Le fonctionnement dans la table TAXON_NAME est le suivant :
 * - REF_TAXON_ID est toujours renseigné
 * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il s'agit
 * d'un taxon virtuel)
 * - sinon c'est un synonyme
 * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
 * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
 * NB : c'était le comportement initialement prévu.
 * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2, le
 * taxon T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les
 * synonymes et les résultats qu'il pouvait avoir).
 * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
 * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
 * alors pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les
 * autres synonymes, résultats...
 * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et qui
 * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
 * pour R2 est nécessaire
 * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
 * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
 * référents
 * @see ReferenceTaxon
 */
public interface ReferenceTaxonDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link ReferenceTaxon}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of ReferenceTaxon from the persistent store.
     * @param refTaxonId
     * @return ReferenceTaxon
     */
    public ReferenceTaxon get(Integer refTaxonId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param refTaxonId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer refTaxonId);

    /**
     * Loads an instance of ReferenceTaxon from the persistent store.
     * @param refTaxonId
     * @return ReferenceTaxon
     */
    public ReferenceTaxon load(Integer refTaxonId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param refTaxonId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer refTaxonId);

    /**
     * Loads all entities of type {@link ReferenceTaxon}.
     *
     * @return the loaded entities.
     */
    public Collection<ReferenceTaxon> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of ReferenceTaxon and adds it to the persistent store.
     * @param referenceTaxon
     * @return ReferenceTaxon
     */
    public ReferenceTaxon create(ReferenceTaxon referenceTaxon);

    /**
     * <p>
     * Does the same thing as {@link #create(ReferenceTaxon)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param referenceTaxon
     * @return Object
     */
    public Object create(int transform, ReferenceTaxon referenceTaxon);

    /**
     * Creates a new instance of ReferenceTaxon and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of ReferenceTaxon
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<ReferenceTaxon> create(Collection<ReferenceTaxon> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(ReferenceTaxon)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<ReferenceTaxon> entities);

    /**
     * <p>
     * Creates a new <code>ReferenceTaxon</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return ReferenceTaxon
     */
    public ReferenceTaxon create(
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return ReferenceTaxon
     */
    public Object create(
        int transform,
        Timestamp updateDt);


    /**
     * Updates the <code>referenceTaxon</code> instance in the persistent store.
     * @param referenceTaxon
     */
    public void update(ReferenceTaxon referenceTaxon);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<ReferenceTaxon> entities);

    /**
     * Removes the instance of ReferenceTaxon from the persistent store.
     * @param referenceTaxon
     */
    public void remove(ReferenceTaxon referenceTaxon);

    /**
     * Removes the instance of ReferenceTaxon having the given
     * <code>identifier</code> from the persistent store.
     * @param refTaxonId
     */
    public void remove(Integer refTaxonId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<ReferenceTaxon> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<ReferenceTaxon> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.referential.taxon.ReferenceTaxonDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.referential.taxon.ReferenceTaxonDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final ReferenceTaxon entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,ReferenceTaxon)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.referential.taxon.ReferenceTaxonDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,ReferenceTaxon)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}