// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import fr.ifremer.quadrige3.core.dao.referential.TaxonGroupType;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.TaxonGroupPosition;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TaxonGroup
    implements Serializable, Comparable<TaxonGroup>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -7685359745665279044L;

    // Generate 8 attributes
    private Integer taxonGroupId;

    /**
     * Identifiant interne du groupe de taxon.
     * @return this.taxonGroupId Integer
     */
    public Integer getTaxonGroupId()
    {
        return this.taxonGroupId;
    }

    /**
     * Identifiant interne du groupe de taxon.
     * @param taxonGroupIdIn Integer
     */
    public void setTaxonGroupId(Integer taxonGroupIdIn)
    {
        this.taxonGroupId = taxonGroupIdIn;
    }

    private String taxonGroupNm;

    /**
     * Nom officiel du groupe de taxon (euryhalin, sténohalin, mobile, ...)
     * @return this.taxonGroupNm String
     */
    public String getTaxonGroupNm()
    {
        return this.taxonGroupNm;
    }

    /**
     * Nom officiel du groupe de taxon (euryhalin, sténohalin, mobile, ...)
     * @param taxonGroupNmIn String
     */
    public void setTaxonGroupNm(String taxonGroupNmIn)
    {
        this.taxonGroupNm = taxonGroupNmIn;
    }

    private String taxonGroupLb;

    /**
     * Chaine de caractère permettant la recherche du taxon.
     * @return this.taxonGroupLb String
     */
    public String getTaxonGroupLb()
    {
        return this.taxonGroupLb;
    }

    /**
     * Chaine de caractère permettant la recherche du taxon.
     * @param taxonGroupLbIn String
     */
    public void setTaxonGroupLb(String taxonGroupLbIn)
    {
        this.taxonGroupLb = taxonGroupLbIn;
    }

    private String taxonGroupCm;

    /**
     * Commentaire sur le groupe de taxon
     * @return this.taxonGroupCm String
     */
    public String getTaxonGroupCm()
    {
        return this.taxonGroupCm;
    }

    /**
     * Commentaire sur le groupe de taxon
     * @param taxonGroupCmIn String
     */
    public void setTaxonGroupCm(String taxonGroupCmIn)
    {
        this.taxonGroupCm = taxonGroupCmIn;
    }

    private String taxonGroupExclus;

    /**
     * Indique si les groupes de taxons fils sont exclusifs ou non. Par défaut, les fils ne sont pas
     * exclusifs. S'ils sont exclusifs, un même taxon ne pourra pas faire parti de plusieurs groupes
     * du taxon père porteur de cette information.
     * @return this.taxonGroupExclus String
     */
    public String getTaxonGroupExclus()
    {
        return this.taxonGroupExclus;
    }

    /**
     * Indique si les groupes de taxons fils sont exclusifs ou non. Par défaut, les fils ne sont pas
     * exclusifs. S'ils sont exclusifs, un même taxon ne pourra pas faire parti de plusieurs groupes
     * du taxon père porteur de cette information.
     * @param taxonGroupExclusIn String
     */
    public void setTaxonGroupExclus(String taxonGroupExclusIn)
    {
        this.taxonGroupExclus = taxonGroupExclusIn;
    }

    private String taxonGroupUpdate;

    /**
     * Indique si un groupe de taxons est modifiable ou non dans l'interface de mise à jour. Pour le
     * benthos, les groupes de type descriptif sont systématiquement définis comme non modifiables.
     * @return this.taxonGroupUpdate String
     */
    public String getTaxonGroupUpdate()
    {
        return this.taxonGroupUpdate;
    }

    /**
     * Indique si un groupe de taxons est modifiable ou non dans l'interface de mise à jour. Pour le
     * benthos, les groupes de type descriptif sont systématiquement définis comme non modifiables.
     * @param taxonGroupUpdateIn String
     */
    public void setTaxonGroupUpdate(String taxonGroupUpdateIn)
    {
        this.taxonGroupUpdate = taxonGroupUpdateIn;
    }

    private Date taxonGroupCreationDt;

    /**
     * Date de création de l'objet
     * @return this.taxonGroupCreationDt Date
     */
    public Date getTaxonGroupCreationDt()
    {
        return this.taxonGroupCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param taxonGroupCreationDtIn Date
     */
    public void setTaxonGroupCreationDt(Date taxonGroupCreationDtIn)
    {
        this.taxonGroupCreationDt = taxonGroupCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de maj de l'objet
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de maj de l'objet
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 11 associations
    private Collection<TaxonGroup> taxonGroups = new HashSet<TaxonGroup>();

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @return this.taxonGroups Collection<TaxonGroup>
     */
    public Collection<TaxonGroup> getTaxonGroups()
    {
        return this.taxonGroups;
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param taxonGroupsIn Collection<TaxonGroup>
     */
    public void setTaxonGroups(Collection<TaxonGroup> taxonGroupsIn)
    {
        this.taxonGroups = taxonGroupsIn;
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param elementToAdd TaxonGroup
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addTaxonGroups(TaxonGroup elementToAdd)
    {
        return this.taxonGroups.add(elementToAdd);
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param elementToRemove TaxonGroup
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeTaxonGroups(TaxonGroup elementToRemove)
    {
        return this.taxonGroups.remove(elementToRemove);
    }

    private TaxonGroup parentTaxonGroup;

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @return this.parentTaxonGroup TaxonGroup
     */
    public TaxonGroup getParentTaxonGroup()
    {
        return this.parentTaxonGroup;
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param parentTaxonGroupIn TaxonGroup
     */
    public void setParentTaxonGroup(TaxonGroup parentTaxonGroupIn)
    {
        this.parentTaxonGroup = parentTaxonGroupIn;
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<TaxonGroupHistoricalRecord> taxonGroupHistoricalRecords = new HashSet<TaxonGroupHistoricalRecord>();

    /**
     * Historique de l'évolution des contenus des groupes de taxons
     * @return this.taxonGroupHistoricalRecords Collection<TaxonGroupHistoricalRecord>
     */
    public Collection<TaxonGroupHistoricalRecord> getTaxonGroupHistoricalRecords()
    {
        return this.taxonGroupHistoricalRecords;
    }

    /**
     * Historique de l'évolution des contenus des groupes de taxons
     * @param taxonGroupHistoricalRecordsIn Collection<TaxonGroupHistoricalRecord>
     */
    public void setTaxonGroupHistoricalRecords(Collection<TaxonGroupHistoricalRecord> taxonGroupHistoricalRecordsIn)
    {
        this.taxonGroupHistoricalRecords = taxonGroupHistoricalRecordsIn;
    }

    /**
     * Historique de l'évolution des contenus des groupes de taxons
     * @param elementToAdd TaxonGroupHistoricalRecord
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addTaxonGroupHistoricalRecords(TaxonGroupHistoricalRecord elementToAdd)
    {
        return this.taxonGroupHistoricalRecords.add(elementToAdd);
    }

    /**
     * Historique de l'évolution des contenus des groupes de taxons
     * @param elementToRemove TaxonGroupHistoricalRecord
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeTaxonGroupHistoricalRecords(TaxonGroupHistoricalRecord elementToRemove)
    {
        return this.taxonGroupHistoricalRecords.remove(elementToRemove);
    }

    private TaxonGroupType taxonGroupType;

    /**
     * Typologie des groupes de taxons
     * @return this.taxonGroupType TaxonGroupType
     */
    public TaxonGroupType getTaxonGroupType()
    {
        return this.taxonGroupType;
    }

    /**
     * Typologie des groupes de taxons
     * @param taxonGroupTypeIn TaxonGroupType
     */
    public void setTaxonGroupType(TaxonGroupType taxonGroupTypeIn)
    {
        this.taxonGroupType = taxonGroupTypeIn;
    }

    private Collection<TaxonGroupPosition> taxonGroupPositions = new HashSet<TaxonGroupPosition>();

    /**
     * Groupe de taxon en un lieu pour un type de ressource.
     * @return this.taxonGroupPositions Collection<TaxonGroupPosition>
     */
    public Collection<TaxonGroupPosition> getTaxonGroupPositions()
    {
        return this.taxonGroupPositions;
    }

    /**
     * Groupe de taxon en un lieu pour un type de ressource.
     * @param taxonGroupPositionsIn Collection<TaxonGroupPosition>
     */
    public void setTaxonGroupPositions(Collection<TaxonGroupPosition> taxonGroupPositionsIn)
    {
        this.taxonGroupPositions = taxonGroupPositionsIn;
    }

    /**
     * Groupe de taxon en un lieu pour un type de ressource.
     * @param elementToAdd TaxonGroupPosition
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addTaxonGroupPositions(TaxonGroupPosition elementToAdd)
    {
        return this.taxonGroupPositions.add(elementToAdd);
    }

    /**
     * Groupe de taxon en un lieu pour un type de ressource.
     * @param elementToRemove TaxonGroupPosition
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeTaxonGroupPositions(TaxonGroupPosition elementToRemove)
    {
        return this.taxonGroupPositions.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an TaxonGroup instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TaxonGroup))
        {
            return false;
        }
        final TaxonGroup that = (TaxonGroup)object;
        if (this.taxonGroupId == null || that.getTaxonGroupId() == null || !this.taxonGroupId.equals(that.getTaxonGroupId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.taxonGroupId == null ? 0 : this.taxonGroupId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link TaxonGroup}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TaxonGroup}.
         * @return new TaxonGroupImpl()
         */
        public static TaxonGroup newInstance()
        {
            return new TaxonGroupImpl();
        }

        /**
         * Constructs a new instance of {@link TaxonGroup}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param taxonGroupNm String
         * @param status Status
         * @param taxonGroupType TaxonGroupType
         * @return newInstance
         */
        public static TaxonGroup newInstance(String taxonGroupNm, Status status, TaxonGroupType taxonGroupType)
        {
            final TaxonGroup entity = new TaxonGroupImpl();
            entity.setTaxonGroupNm(taxonGroupNm);
            entity.setStatus(status);
            entity.setTaxonGroupType(taxonGroupType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TaxonGroup}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param taxonGroupNm String
         * @param taxonGroupLb String
         * @param taxonGroupCm String
         * @param taxonGroupExclus String
         * @param taxonGroupUpdate String
         * @param taxonGroupCreationDt Date
         * @param updateDt Timestamp
         * @param taxonGroups Collection<TaxonGroup>
         * @param parentTaxonGroup TaxonGroup
         * @param status Status
         * @param taxonGroupHistoricalRecords Collection<TaxonGroupHistoricalRecord>
         * @param taxonGroupType TaxonGroupType
         * @param taxonGroupPositions Collection<TaxonGroupPosition>
         * @return newInstance TaxonGroup
         */
        public static TaxonGroup newInstance(String taxonGroupNm, String taxonGroupLb, String taxonGroupCm, String taxonGroupExclus, String taxonGroupUpdate, Date taxonGroupCreationDt, Timestamp updateDt, Collection<TaxonGroup> taxonGroups, TaxonGroup parentTaxonGroup, Status status, Collection<TaxonGroupHistoricalRecord> taxonGroupHistoricalRecords, TaxonGroupType taxonGroupType, Collection<TaxonGroupPosition> taxonGroupPositions)
        {
            final TaxonGroup entity = new TaxonGroupImpl();
            entity.setTaxonGroupNm(taxonGroupNm);
            entity.setTaxonGroupLb(taxonGroupLb);
            entity.setTaxonGroupCm(taxonGroupCm);
            entity.setTaxonGroupExclus(taxonGroupExclus);
            entity.setTaxonGroupUpdate(taxonGroupUpdate);
            entity.setTaxonGroupCreationDt(taxonGroupCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setTaxonGroups(taxonGroups);
            entity.setParentTaxonGroup(parentTaxonGroup);
            entity.setStatus(status);
            entity.setTaxonGroupHistoricalRecords(taxonGroupHistoricalRecords);
            entity.setTaxonGroupType(taxonGroupType);
            entity.setTaxonGroupPositions(taxonGroupPositions);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TaxonGroup o)
    {
        int cmp = 0;
        if (this.getTaxonGroupId() != null)
        {
            cmp = this.getTaxonGroupId().compareTo(o.getTaxonGroupId());
        }
        else
        {
            if (this.getTaxonGroupNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonGroupNm().compareTo(o.getTaxonGroupNm()));
            }
            if (this.getTaxonGroupLb() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonGroupLb().compareTo(o.getTaxonGroupLb()));
            }
            if (this.getTaxonGroupCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonGroupCm().compareTo(o.getTaxonGroupCm()));
            }
            if (this.getTaxonGroupExclus() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonGroupExclus().compareTo(o.getTaxonGroupExclus()));
            }
            if (this.getTaxonGroupUpdate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonGroupUpdate().compareTo(o.getTaxonGroupUpdate()));
            }
            if (this.getTaxonGroupCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonGroupCreationDt().compareTo(o.getTaxonGroupCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TaxonGroup.java merge-point
}