// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import fr.ifremer.quadrige3.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Liste les taxons (interface avec ERMS)
 * @see TaxonName
 */
public interface TaxonNameDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link TaxonName}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of TaxonName from the persistent store.
     * @param taxonNameId
     * @return TaxonName
     */
    public TaxonName get(Integer taxonNameId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param taxonNameId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer taxonNameId);

    /**
     * Loads an instance of TaxonName from the persistent store.
     * @param taxonNameId
     * @return TaxonName
     */
    public TaxonName load(Integer taxonNameId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param taxonNameId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer taxonNameId);

    /**
     * Loads all entities of type {@link TaxonName}.
     *
     * @return the loaded entities.
     */
    public Collection<TaxonName> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of TaxonName and adds it to the persistent store.
     * @param taxonName
     * @return TaxonName
     */
    public TaxonName create(TaxonName taxonName);

    /**
     * <p>
     * Does the same thing as {@link #create(TaxonName)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param taxonName
     * @return Object
     */
    public Object create(int transform, TaxonName taxonName);

    /**
     * Creates a new instance of TaxonName and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of TaxonName
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<TaxonName> create(Collection<TaxonName> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(TaxonName)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<TaxonName> entities);

    /**
     * <p>
     * Creates a new <code>TaxonName</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param taxonNameNm Nom scientifique du taxon, unique pour le niveau
     * @param taxonNameCompleteNm Nom concaténé du taxon
     * @param taxonNameIsNaming Indique si le taxon respecte les règles de nommage
     * @param taxonNameCm Commentaire sur le taxon
     * @param taxonNameUpperRk Rang du taxon parmis les fils d'un même père pour classement
     * @param taxonNameIsRefer Vrai si le taxon est le taxon référent, faux pour les synonymes.
     * @param taxonNameIsVirtual Indique si le taxon est virtuel ou non
     * @param taxonNameObsol Vrai si le taxon est devenu obsolète, il doit plus être proposé dans les listes de saisie
     * @param taxonNameTempor Vrai s'il s'agit d'une identification provisoire.
     * @param taxonNameCreationDt Date de création de l'objet
     * @param updateDt Date de mise à jour de l'objet
     * @param taxonStartDt Date de début de validité du taxon
     * @param taxonEndDt Date de fin de validité du taxon
     * @return TaxonName
     */
    public TaxonName create(
        String taxonNameNm,
        String taxonNameCompleteNm,
        Boolean taxonNameIsNaming,
        String taxonNameCm,
        Integer taxonNameUpperRk,
        Boolean taxonNameIsRefer,
        Boolean taxonNameIsVirtual,
        Boolean taxonNameObsol,
        Boolean taxonNameTempor,
        Date taxonNameCreationDt,
        Timestamp updateDt,
        Date taxonStartDt,
        Date taxonEndDt);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Boolean, String, Integer, Boolean, Boolean, Boolean, Boolean, Date, Timestamp, Date, Date)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param taxonNameNm Nom scientifique du taxon, unique pour le niveau
     * @param taxonNameCompleteNm Nom concaténé du taxon
     * @param taxonNameIsNaming Indique si le taxon respecte les règles de nommage
     * @param taxonNameCm Commentaire sur le taxon
     * @param taxonNameUpperRk Rang du taxon parmis les fils d'un même père pour classement
     * @param taxonNameIsRefer Vrai si le taxon est le taxon référent, faux pour les synonymes.
     * @param taxonNameIsVirtual Indique si le taxon est virtuel ou non
     * @param taxonNameObsol Vrai si le taxon est devenu obsolète, il doit plus être proposé dans les listes de saisie
     * @param taxonNameTempor Vrai s'il s'agit d'une identification provisoire.
     * @param taxonNameCreationDt Date de création de l'objet
     * @param updateDt Date de mise à jour de l'objet
     * @param taxonStartDt Date de début de validité du taxon
     * @param taxonEndDt Date de fin de validité du taxon
     * @return TaxonName
     */
    public Object create(
        int transform,
        String taxonNameNm,
        String taxonNameCompleteNm,
        Boolean taxonNameIsNaming,
        String taxonNameCm,
        Integer taxonNameUpperRk,
        Boolean taxonNameIsRefer,
        Boolean taxonNameIsVirtual,
        Boolean taxonNameObsol,
        Boolean taxonNameTempor,
        Date taxonNameCreationDt,
        Timestamp updateDt,
        Date taxonStartDt,
        Date taxonEndDt);

    /**
     * <p>
     * Creates a new <code>TaxonName</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param referenceTaxon
     * @param taxonomicLevel
     * @return TaxonName
     */
    public TaxonName create(
        ReferenceTaxon referenceTaxon,
        TaxonomicLevel taxonomicLevel);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param referenceTaxon
     * @param taxonomicLevel
     * @return Object
     */
    public Object create(
        int transform,
        ReferenceTaxon referenceTaxon,
        TaxonomicLevel taxonomicLevel);

    /**
     * Updates the <code>taxonName</code> instance in the persistent store.
     * @param taxonName
     */
    public void update(TaxonName taxonName);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<TaxonName> entities);

    /**
     * Removes the instance of TaxonName from the persistent store.
     * @param taxonName
     */
    public void remove(TaxonName taxonName);

    /**
     * Removes the instance of TaxonName having the given
     * <code>identifier</code> from the persistent store.
     * @param taxonNameId
     */
    public void remove(Integer taxonNameId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<TaxonName> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<TaxonName> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.referential.taxon.TaxonNameDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.referential.taxon.TaxonNameDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final TaxonName entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,TaxonName)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.referential.taxon.TaxonNameDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,TaxonName)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}