// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Liste des niveaux systématiques des taxons.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TaxonomicLevel
    implements Serializable, Comparable<TaxonomicLevel>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -379581566154259524L;

    // Generate 7 attributes
    private String taxLevelCd;

    /**
     * Code identifiant de façon unique le niveau
     * @return this.taxLevelCd String
     */
    public String getTaxLevelCd()
    {
        return this.taxLevelCd;
    }

    /**
     * Code identifiant de façon unique le niveau
     * @param taxLevelCdIn String
     */
    public void setTaxLevelCd(String taxLevelCdIn)
    {
        this.taxLevelCd = taxLevelCdIn;
    }

    private Integer taxLevelNb;

    /**
     * Numéro du rang taxinomique. décroissant du règne vers l'espèce
     * Ceci permet de limiter le choix des niveaux fils aux numéros inférieurs
     * @return this.taxLevelNb Integer
     */
    public Integer getTaxLevelNb()
    {
        return this.taxLevelNb;
    }

    /**
     * Numéro du rang taxinomique. décroissant du règne vers l'espèce
     * Ceci permet de limiter le choix des niveaux fils aux numéros inférieurs
     * @param taxLevelNbIn Integer
     */
    public void setTaxLevelNb(Integer taxLevelNbIn)
    {
        this.taxLevelNb = taxLevelNbIn;
    }

    private String taxLevelNm;

    /**
     * Libellé du niveau du taxon
     * @return this.taxLevelNm String
     */
    public String getTaxLevelNm()
    {
        return this.taxLevelNm;
    }

    /**
     * Libellé du niveau du taxon
     * @param taxLevelNmIn String
     */
    public void setTaxLevelNm(String taxLevelNmIn)
    {
        this.taxLevelNm = taxLevelNmIn;
    }

    private String taxLevelLb;

    /**
     * Mnémonique du niveau du taxon
     * @return this.taxLevelLb String
     */
    public String getTaxLevelLb()
    {
        return this.taxLevelLb;
    }

    /**
     * Mnémonique du niveau du taxon
     * @param taxLevelLbIn String
     */
    public void setTaxLevelLb(String taxLevelLbIn)
    {
        this.taxLevelLb = taxLevelLbIn;
    }

    private String taxLevelCm;

    /**
     * Commentaire décrivant le niveau du taxon
     * @return this.taxLevelCm String
     */
    public String getTaxLevelCm()
    {
        return this.taxLevelCm;
    }

    /**
     * Commentaire décrivant le niveau du taxon
     * @param taxLevelCmIn String
     */
    public void setTaxLevelCm(String taxLevelCmIn)
    {
        this.taxLevelCm = taxLevelCmIn;
    }

    private Date taxLevelCreationDt;

    /**
     * Date de création de l'objet
     * @return this.taxLevelCreationDt Date
     */
    public Date getTaxLevelCreationDt()
    {
        return this.taxLevelCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param taxLevelCreationDtIn Date
     */
    public void setTaxLevelCreationDt(Date taxLevelCreationDtIn)
    {
        this.taxLevelCreationDt = taxLevelCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de mise à jour de l'objet
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de mise à jour de l'objet
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<TaxonName> taxonNames = new HashSet<TaxonName>();

    /**
     * Liste les taxons (interface avec ERMS)
     * @return this.taxonNames Collection<TaxonName>
     */
    public Collection<TaxonName> getTaxonNames()
    {
        return this.taxonNames;
    }

    /**
     * Liste les taxons (interface avec ERMS)
     * @param taxonNamesIn Collection<TaxonName>
     */
    public void setTaxonNames(Collection<TaxonName> taxonNamesIn)
    {
        this.taxonNames = taxonNamesIn;
    }

    /**
     * Liste les taxons (interface avec ERMS)
     * @param elementToAdd TaxonName
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addTaxonNames(TaxonName elementToAdd)
    {
        return this.taxonNames.add(elementToAdd);
    }

    /**
     * Liste les taxons (interface avec ERMS)
     * @param elementToRemove TaxonName
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeTaxonNames(TaxonName elementToRemove)
    {
        return this.taxonNames.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an TaxonomicLevel instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TaxonomicLevel))
        {
            return false;
        }
        final TaxonomicLevel that = (TaxonomicLevel)object;
        if (this.taxLevelCd == null || that.getTaxLevelCd() == null || !this.taxLevelCd.equals(that.getTaxLevelCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.taxLevelCd == null ? 0 : this.taxLevelCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link TaxonomicLevel}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TaxonomicLevel}.
         * @return new TaxonomicLevelImpl()
         */
        public static TaxonomicLevel newInstance()
        {
            return new TaxonomicLevelImpl();
        }

        /**
         * Constructs a new instance of {@link TaxonomicLevel}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param taxLevelNm String
         * @param status Status
         * @return newInstance
         */
        public static TaxonomicLevel newInstance(String taxLevelNm, Status status)
        {
            final TaxonomicLevel entity = new TaxonomicLevelImpl();
            entity.setTaxLevelNm(taxLevelNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TaxonomicLevel}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param taxLevelNb Integer
         * @param taxLevelNm String
         * @param taxLevelLb String
         * @param taxLevelCm String
         * @param taxLevelCreationDt Date
         * @param updateDt Timestamp
         * @param status Status
         * @param taxonNames Collection<TaxonName>
         * @return newInstance TaxonomicLevel
         */
        public static TaxonomicLevel newInstance(Integer taxLevelNb, String taxLevelNm, String taxLevelLb, String taxLevelCm, Date taxLevelCreationDt, Timestamp updateDt, Status status, Collection<TaxonName> taxonNames)
        {
            final TaxonomicLevel entity = new TaxonomicLevelImpl();
            entity.setTaxLevelNb(taxLevelNb);
            entity.setTaxLevelNm(taxLevelNm);
            entity.setTaxLevelLb(taxLevelLb);
            entity.setTaxLevelCm(taxLevelCm);
            entity.setTaxLevelCreationDt(taxLevelCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setStatus(status);
            entity.setTaxonNames(taxonNames);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TaxonomicLevel o)
    {
        int cmp = 0;
        if (this.getTaxLevelCd() != null)
        {
            cmp = this.getTaxLevelCd().compareTo(o.getTaxLevelCd());
        }
        else
        {
            if (this.getTaxLevelNb() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxLevelNb().compareTo(o.getTaxLevelNb()));
            }
            if (this.getTaxLevelNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxLevelNm().compareTo(o.getTaxLevelNm()));
            }
            if (this.getTaxLevelLb() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxLevelLb().compareTo(o.getTaxLevelLb()));
            }
            if (this.getTaxLevelCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxLevelCm().compareTo(o.getTaxLevelCm()));
            }
            if (this.getTaxLevelCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxLevelCreationDt().compareTo(o.getTaxLevelCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TaxonomicLevel.java merge-point
}