// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.taxon;

import java.io.Serializable;

/**
 * 
 */
// HibernateEntity.vsl annotations merge-point
public abstract class VirtualComponent
    implements Serializable, Comparable<VirtualComponent>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -2345051973744045898L;

    private VirtualComponentPK virtualComponentPk;

    /**
     * Get the composite primary key identifier class
     * @return virtualComponentPk
     */
    public VirtualComponentPK getVirtualComponentPk()
    {
        return this.virtualComponentPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param virtualComponentPkIn
     */
    public void setVirtualComponentPk(VirtualComponentPK virtualComponentPkIn) {
        this.virtualComponentPk = virtualComponentPkIn;
    }

    // Generate 0 attributes
    // Generate 2 associations
    private TaxonName taxonName;

    /**
     * Liste les taxons (interface avec ERMS)
     * @return this.taxonName TaxonName
     */
    public TaxonName getTaxonName()
    {
        return this.taxonName;
    }

    /**
     * Liste les taxons (interface avec ERMS)
     * @param taxonNameIn TaxonName
     */
    public void setTaxonName(TaxonName taxonNameIn)
    {
        this.taxonName = taxonNameIn;
    }

    private ReferenceTaxon referenceTaxon;

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @return this.referenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getReferenceTaxon()
    {
        return this.referenceTaxon;
    }

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @param referenceTaxonIn ReferenceTaxon
     */
    public void setReferenceTaxon(ReferenceTaxon referenceTaxonIn)
    {
        this.referenceTaxon = referenceTaxonIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link VirtualComponent}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link VirtualComponent}.
         * @return new VirtualComponentImpl()
         */
        public static VirtualComponent newInstance()
        {
            return new VirtualComponentImpl();
        }


        /**
         * Constructs a new instance of {@link VirtualComponent}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param taxonName TaxonName
         * @param referenceTaxon ReferenceTaxon
         * @return newInstance VirtualComponent
         */
        public static VirtualComponent newInstance(TaxonName taxonName, ReferenceTaxon referenceTaxon)
        {
            final VirtualComponent entity = new VirtualComponentImpl();
            entity.setTaxonName(taxonName);
            entity.setReferenceTaxon(referenceTaxon);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(VirtualComponent o)
    {
        int cmp = 0;
        if (this.getVirtualComponentPk() != null)
        {
            cmp = this.getVirtualComponentPk().compareTo(o.getVirtualComponentPk());
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// VirtualComponent.java merge-point
}