// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Contient les informations sur les mesures utilisées dans le calcul d'une mesure
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ComputeMeasurement
    implements Serializable, Comparable<ComputeMeasurement>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 7358143345844603802L;

    // Generate 6 attributes
    private Integer compMeasId;

    /**
     * Identifiant des informations sur le calcul
     * @return this.compMeasId Integer
     */
    public Integer getCompMeasId()
    {
        return this.compMeasId;
    }

    /**
     * Identifiant des informations sur le calcul
     * @param compMeasIdIn Integer
     */
    public void setCompMeasId(Integer compMeasIdIn)
    {
        this.compMeasId = compMeasIdIn;
    }

    private Integer measId;

    /**
     * Identifiant interne du résultat calculé
     * @return this.measId Integer
     */
    public Integer getMeasId()
    {
        return this.measId;
    }

    /**
     * Identifiant interne du résultat calculé
     * @param measIdIn Integer
     */
    public void setMeasId(Integer measIdIn)
    {
        this.measId = measIdIn;
    }

    private Integer taxonMeasId;

    /**
     * Identifiant interne du résultat de dénombrement calculé
     * @return this.taxonMeasId Integer
     */
    public Integer getTaxonMeasId()
    {
        return this.taxonMeasId;
    }

    /**
     * Identifiant interne du résultat de dénombrement calculé
     * @param taxonMeasIdIn Integer
     */
    public void setTaxonMeasId(Integer taxonMeasIdIn)
    {
        this.taxonMeasId = taxonMeasIdIn;
    }

    private Integer depMeasId;

    /**
     * Identifiant interne du résultat intervenant dans le calcul
     * @return this.depMeasId Integer
     */
    public Integer getDepMeasId()
    {
        return this.depMeasId;
    }

    /**
     * Identifiant interne du résultat intervenant dans le calcul
     * @param depMeasIdIn Integer
     */
    public void setDepMeasId(Integer depMeasIdIn)
    {
        this.depMeasId = depMeasIdIn;
    }

    private Integer depTaxonMeasId;

    /**
     * Identifiant interne du résultat de dénombrement intervenant dans le calcul
     * @return this.depTaxonMeasId Integer
     */
    public Integer getDepTaxonMeasId()
    {
        return this.depTaxonMeasId;
    }

    /**
     * Identifiant interne du résultat de dénombrement intervenant dans le calcul
     * @param depTaxonMeasIdIn Integer
     */
    public void setDepTaxonMeasId(Integer depTaxonMeasIdIn)
    {
        this.depTaxonMeasId = depTaxonMeasIdIn;
    }

    private Timestamp updateDt;

    /**
     * Date de mise à jour
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de mise à jour
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 1 associations
    private ComputeFunction compFunctionCd;

    /**
     * Contient les différentes fonction de calcul pour les paramètres
     * @return this.compFunctionCd ComputeFunction
     */
    public ComputeFunction getCompFunctionCd()
    {
        return this.compFunctionCd;
    }

    /**
     * Contient les différentes fonction de calcul pour les paramètres
     * @param compFunctionCdIn ComputeFunction
     */
    public void setCompFunctionCd(ComputeFunction compFunctionCdIn)
    {
        this.compFunctionCd = compFunctionCdIn;
    }

    /**
     * Returns <code>true</code> if the argument is an ComputeMeasurement instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ComputeMeasurement))
        {
            return false;
        }
        final ComputeMeasurement that = (ComputeMeasurement)object;
        if (this.compMeasId == null || that.getCompMeasId() == null || !this.compMeasId.equals(that.getCompMeasId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.compMeasId == null ? 0 : this.compMeasId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link ComputeMeasurement}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ComputeMeasurement}.
         * @return new ComputeMeasurementImpl()
         */
        public static ComputeMeasurement newInstance()
        {
            return new ComputeMeasurementImpl();
        }

        /**
         * Constructs a new instance of {@link ComputeMeasurement}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param compFunctionCd ComputeFunction
         * @return newInstance
         */
        public static ComputeMeasurement newInstance(ComputeFunction compFunctionCd)
        {
            final ComputeMeasurement entity = new ComputeMeasurementImpl();
            entity.setCompFunctionCd(compFunctionCd);
            return entity;
        }

        /**
         * Constructs a new instance of {@link ComputeMeasurement}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param measId Integer
         * @param taxonMeasId Integer
         * @param depMeasId Integer
         * @param depTaxonMeasId Integer
         * @param updateDt Timestamp
         * @param compFunctionCd ComputeFunction
         * @return newInstance ComputeMeasurement
         */
        public static ComputeMeasurement newInstance(Integer measId, Integer taxonMeasId, Integer depMeasId, Integer depTaxonMeasId, Timestamp updateDt, ComputeFunction compFunctionCd)
        {
            final ComputeMeasurement entity = new ComputeMeasurementImpl();
            entity.setMeasId(measId);
            entity.setTaxonMeasId(taxonMeasId);
            entity.setDepMeasId(depMeasId);
            entity.setDepTaxonMeasId(depTaxonMeasId);
            entity.setUpdateDt(updateDt);
            entity.setCompFunctionCd(compFunctionCd);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ComputeMeasurement o)
    {
        int cmp = 0;
        if (this.getCompMeasId() != null)
        {
            cmp = this.getCompMeasId().compareTo(o.getCompMeasId());
        }
        else
        {
            if (this.getMeasId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMeasId().compareTo(o.getMeasId()));
            }
            if (this.getTaxonMeasId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasId().compareTo(o.getTaxonMeasId()));
            }
            if (this.getDepMeasId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepMeasId().compareTo(o.getDepMeasId()));
            }
            if (this.getDepTaxonMeasId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDepTaxonMeasId().compareTo(o.getDepTaxonMeasId()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ComputeMeasurement.java merge-point
}