// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/SpringHibernateDaoBase.vsl in <project>/mda/src/main/cartridge/custom/...
//
package fr.ifremer.quadrige3.core.dao.system;

import fr.ifremer.quadrige3.core.dao.PrincipalStore;
import fr.ifremer.quadrige3.core.dao.PropertySearch;
import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.data.event.Event;
import fr.ifremer.quadrige3.core.dao.technical.hibernate.HibernateDaoSupport;
import java.security.Principal;
import java.util.Collection;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import javax.annotation.Resource;
import org.andromda.spring.PaginationResult;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.Transformer;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.ScrollableResults;

/**
 * <p>
 * Base Spring DAO Class: is able to create, update, remove, load, and find
 * objects of type <code>EventPoint</code>.
 * </p>
 *
 * @see EventPoint
 */
public abstract class EventPointDaoBase
    extends HibernateDaoSupport    
    implements EventPointDao
{
    /**
     * {@inheritDoc}
     */
    @Override
    public Object get(final int transform, final Integer eventId)
    {
        if (eventId == null)
        {
            throw new IllegalArgumentException(
                "EventPoint.get - 'eventId' can not be null");
        }
        final EventPoint entity = get(EventPointImpl.class, eventId);
        return transformEntity(transform, entity);
    }
    /**
     * {@inheritDoc}
     */
    @Override
    public EventPoint get(Integer eventId)
    {
        return (EventPoint)this.get(TRANSFORM_NONE, eventId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object load(final int transform, final Integer eventId)
    {
        if (eventId == null)
        {
            throw new IllegalArgumentException(
                "EventPoint.load - 'eventId' can not be null");
        }
        final EventPoint entity = get(EventPointImpl.class, eventId);
        return transformEntity(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EventPoint load(Integer eventId)
    {
        return (EventPoint)this.load(TRANSFORM_NONE, eventId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<EventPoint> loadAll()
    {
        return (Collection<EventPoint>) this.loadAll(EventPointDao.TRANSFORM_NONE);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform)
    {
        return this.loadAll(transform, -1, -1);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int pageNumber, final int pageSize)
    {
        return this.loadAll(EventPointDao.TRANSFORM_NONE, pageNumber, pageSize);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize)
    {
        try
        {
            final Criteria criteria = this.getSession().createCriteria(EventPointImpl.class);
            if (pageNumber > 0 && pageSize > 0)
            {
                criteria.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                criteria.setMaxResults(pageSize);
            }
            final Collection<?> results = criteria.list();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex;
        }
    }

    /**
     * firstResult = (pageNumber - 1) * pageSize
     * @param pageNumber
     * @param pageSize
     * @return firstResult
     */
    protected int calculateFirstResult(int pageNumber, int pageSize)
    {
        int firstResult = 0;
        if (pageNumber > 0)
        {
            firstResult = (pageNumber - 1) * pageSize;
        }
        return firstResult;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EventPoint create(EventPoint eventPoint)
    {
        return (EventPoint)this.create(EventPointDao.TRANSFORM_NONE, eventPoint);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(final int transform, final EventPoint eventPoint)
    {
        if (eventPoint == null)
        {
            throw new IllegalArgumentException(
                "EventPoint.create - 'eventPoint' can not be null");
        }
        this.getSessionFactory().getCurrentSession().save(eventPoint);
        return this.transformEntity(transform, eventPoint);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<EventPoint> create(final Collection<EventPoint> entities)
    {
        return (Collection<EventPoint>) create(EventPointDao.TRANSFORM_NONE, entities);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> create(final int transform, final Collection<EventPoint> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "EventPoint.create - 'entities' can not be null");
        }
                    for (EventPoint entity : entities)
                    {
                        create(transform, entity);
                    }
        return entities;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EventPoint create(
        String eventPosition)
    {
        return (EventPoint)this.create(EventPointDao.TRANSFORM_NONE, eventPosition);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(
        final int transform,
        String eventPosition)
    {
        EventPoint entity = new EventPointImpl();
        entity.setEventPosition(eventPosition);
        return this.create(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EventPoint create(
        String eventPosition,
        Event event)
    {
        return (EventPoint)this.create(EventPointDao.TRANSFORM_NONE, eventPosition, event);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(
        final int transform,
        String eventPosition,
        Event event)
    {
        EventPoint entity = new EventPointImpl();
        entity.setEventPosition(eventPosition);
        entity.setEvent(event);
        return this.create(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(EventPoint eventPoint)
    {
        if (eventPoint == null)
        {
            throw new IllegalArgumentException(
                "EventPoint.update - 'eventPoint' can not be null");
        }
        this.getSessionFactory().getCurrentSession().update(eventPoint);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(final Collection<EventPoint> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "EventPoint.update - 'entities' can not be null");
        }
                    for (EventPoint entity : entities)
                    {
                        update(entity);
                    }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(EventPoint eventPoint)
    {
        if (eventPoint == null)
        {
            throw new IllegalArgumentException(
                "EventPoint.remove - 'eventPoint' can not be null");
        }
        this.getSessionFactory().getCurrentSession().delete(eventPoint);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Integer eventId)
    {
        if (eventId == null)
        {
            throw new IllegalArgumentException(
                "EventPoint.remove - 'eventId' can not be null");
        }
        EventPoint entity = this.get(eventId);
        if (entity != null)
        {
            this.remove(entity);
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Collection<EventPoint> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "EventPoint.remove - 'entities' can not be null");
        }
        deleteAll(entities);
    }
    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>EventPointDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link EventPointDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see EventPointDao#transformEntity(int, EventPoint)
     */
    public Object transformEntity(final int transform, final EventPoint entity)
    {
        Object target = null;
        if (entity != null)
        {
            switch (transform)
            {
                case EventPointDao.TRANSFORM_NONE : // fall-through
                default:
                    target = entity;
            }
        }
        return target;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void transformEntities(final int transform, final Collection<?> entities)
    {
        switch (transform)
        {
            case EventPointDao.TRANSFORM_NONE : // fall-through
                default:
                // do nothing;
        }
    }

    /**
     * @see EventPointDao#toEntities(Collection)
     */
    public void toEntities(final Collection<?> results)
    {
        if (results != null)
        {
            CollectionUtils.transform(results, this.ENTITYTRANSFORMER);
        }
    }

    /**
     * This anonymous transformer is designed to transform report query results
     * (which result in an array of entities) to {@link EventPoint}
     * using the Jakarta Commons-Collections Transformation API.
     */
    private Transformer ENTITYTRANSFORMER =
        new Transformer()
        {
            public Object transform(Object input)
            {
                Object result = null;
                if (input instanceof Object[])
                {
                    result = toEntity((Object[])input);
                }
                else if (input instanceof EventPoint)
                {
                    result = input;
                }
                return result;
            }
        };

    /**
     * @param row
     * @return EventPoint
     */
    protected EventPoint toEntity(Object[] row)
    {
        EventPoint target = null;
        if (row != null)
        {
            final int numberOfObjects = row.length;
            for (int ctr = 0; ctr < numberOfObjects; ctr++)
            {
                final Object object = row[ctr];
                if (object instanceof EventPoint)
                {
                    target = (EventPoint)object;
                    break;
                }
            }
        }
        return target;
    }

    /**
     * Gets the current <code>principal</code> if one has been set,
     * otherwise returns <code>null</code>.
     *
     * @return the current principal
     */
    protected Principal getPrincipal()
    {
        return PrincipalStore.get();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({ "unchecked" })
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search)
    {
        try
        {
            search.setPageNumber(pageNumber);
            search.setPageSize(pageSize);
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), EventPointImpl.class, search);
            final List results = propertySearch.executeAsList();
            this.transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), propertySearch.getTotalCount());
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search)
    {
        return this.search(EventPointDao.TRANSFORM_NONE, pageNumber, pageSize, search);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Set<?> search(final int transform, final Search search)
    {
        try
        {
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), EventPointImpl.class, search);
            final Set<?> results = propertySearch.executeAsSet();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings("unchecked")
    public Set<EventPoint> search(final Search search)
    {
        return (Set<EventPoint>) this.search(EventPointDao.TRANSFORM_NONE, search);
    }

    /**
     * Executes and returns the given Hibernate queryObject as a {@link PaginationResult} instance.
     * @param queryObject
     * @param transform
     * @param pageNumber
     * @param pageSize
     * @return PaginationResult
     */
    @SuppressWarnings({ "unchecked" })
    protected PaginationResult getPaginationResult(
        final Query queryObject,
        final int transform, int pageNumber, int pageSize)
    {
        try
        {
            final ScrollableResults scrollableResults = queryObject.scroll();
            scrollableResults.last();
            int totalCount = scrollableResults.getRowNumber();
            totalCount = totalCount >= 0 ? totalCount + 1 : 0;
            if (pageNumber > 0 && pageSize > 0)
            {
                queryObject.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                queryObject.setMaxResults(pageSize);
            }
            // Unchecked transformation because Set object is reused, cannot be strongly typed.
            Set results = new LinkedHashSet(queryObject.list());
            transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), totalCount);
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    // spring-hibernate-dao-base merge-point
}