// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system;

import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.MonitoringLocation;
import fr.ifremer.quadrige3.core.dao.referential.monitoringLocation.PositionningSystem;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Gestion de l'historique des géométries des lieux de surveillance.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class MonLocHisGeom
    implements Serializable, Comparable<MonLocHisGeom>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 3803139124304035734L;

    // Generate 3 attributes
    private Integer monLocHisGeomId;

    /**
     * Identifiant de la ligne d'historique
     * @return this.monLocHisGeomId Integer
     */
    public Integer getMonLocHisGeomId()
    {
        return this.monLocHisGeomId;
    }

    /**
     * Identifiant de la ligne d'historique
     * @param monLocHisGeomIdIn Integer
     */
    public void setMonLocHisGeomId(Integer monLocHisGeomIdIn)
    {
        this.monLocHisGeomId = monLocHisGeomIdIn;
    }

    private String monLocPosition;

    /**
     * Positionnement de l'objet
     * @return this.monLocPosition String
     */
    public String getMonLocPosition()
    {
        return this.monLocPosition;
    }

    /**
     * Positionnement de l'objet
     * @param monLocPositionIn String
     */
    public void setMonLocPosition(String monLocPositionIn)
    {
        this.monLocPosition = monLocPositionIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private PositionningSystem posSystemId;

    /**
     * Informations complémentaires sur le positionnement d'un objet.
     * @return this.posSystemId PositionningSystem
     */
    public PositionningSystem getPosSystemId()
    {
        return this.posSystemId;
    }

    /**
     * Informations complémentaires sur le positionnement d'un objet.
     * @param posSystemIdIn PositionningSystem
     */
    public void setPosSystemId(PositionningSystem posSystemIdIn)
    {
        this.posSystemId = posSystemIdIn;
    }

    private MonitoringLocation monitoringLocation;

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @return this.monitoringLocation MonitoringLocation
     */
    public MonitoringLocation getMonitoringLocation()
    {
        return this.monitoringLocation;
    }

    /**
     * Liste les lieux associés aux programmes de surveillance.
     * @param monitoringLocationIn MonitoringLocation
     */
    public void setMonitoringLocation(MonitoringLocation monitoringLocationIn)
    {
        this.monitoringLocation = monitoringLocationIn;
    }

    /**
     * Returns <code>true</code> if the argument is an MonLocHisGeom instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof MonLocHisGeom))
        {
            return false;
        }
        final MonLocHisGeom that = (MonLocHisGeom)object;
        if (this.monLocHisGeomId == null || that.getMonLocHisGeomId() == null || !this.monLocHisGeomId.equals(that.getMonLocHisGeomId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.monLocHisGeomId == null ? 0 : this.monLocHisGeomId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link MonLocHisGeom}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link MonLocHisGeom}.
         * @return new MonLocHisGeomImpl()
         */
        public static MonLocHisGeom newInstance()
        {
            return new MonLocHisGeomImpl();
        }

        /**
         * Constructs a new instance of {@link MonLocHisGeom}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param monLocPosition String
         * @param posSystemId PositionningSystem
         * @param monitoringLocation MonitoringLocation
         * @return newInstance
         */
        public static MonLocHisGeom newInstance(String monLocPosition, PositionningSystem posSystemId, MonitoringLocation monitoringLocation)
        {
            final MonLocHisGeom entity = new MonLocHisGeomImpl();
            entity.setMonLocPosition(monLocPosition);
            entity.setPosSystemId(posSystemId);
            entity.setMonitoringLocation(monitoringLocation);
            return entity;
        }

        /**
         * Constructs a new instance of {@link MonLocHisGeom}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param monLocPosition String
         * @param updateDt Timestamp
         * @param posSystemId PositionningSystem
         * @param monitoringLocation MonitoringLocation
         * @return newInstance MonLocHisGeom
         */
        public static MonLocHisGeom newInstance(String monLocPosition, Timestamp updateDt, PositionningSystem posSystemId, MonitoringLocation monitoringLocation)
        {
            final MonLocHisGeom entity = new MonLocHisGeomImpl();
            entity.setMonLocPosition(monLocPosition);
            entity.setUpdateDt(updateDt);
            entity.setPosSystemId(posSystemId);
            entity.setMonitoringLocation(monitoringLocation);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(MonLocHisGeom o)
    {
        int cmp = 0;
        if (this.getMonLocHisGeomId() != null)
        {
            cmp = this.getMonLocHisGeomId().compareTo(o.getMonLocHisGeomId());
        }
        else
        {
            if (this.getMonLocPosition() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMonLocPosition().compareTo(o.getMonLocPosition()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// MonLocHisGeom.java merge-point
}