// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/SpringHibernateDaoBase.vsl in <project>/mda/src/main/cartridge/custom/...
//
package fr.ifremer.quadrige3.core.dao.system;

import fr.ifremer.quadrige3.core.dao.PrincipalStore;
import fr.ifremer.quadrige3.core.dao.PropertySearch;
import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.data.survey.Occasion;
import fr.ifremer.quadrige3.core.dao.technical.hibernate.HibernateDaoSupport;
import java.security.Principal;
import java.util.Collection;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import javax.annotation.Resource;
import org.andromda.spring.PaginationResult;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.Transformer;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.ScrollableResults;

/**
 * <p>
 * Base Spring DAO Class: is able to create, update, remove, load, and find
 * objects of type <code>OccasPoint</code>.
 * </p>
 *
 * @see OccasPoint
 */
public abstract class OccasPointDaoBase
    extends HibernateDaoSupport    
    implements OccasPointDao
{
    /**
     * {@inheritDoc}
     */
    @Override
    public Object get(final int transform, final Integer occasId)
    {
        if (occasId == null)
        {
            throw new IllegalArgumentException(
                "OccasPoint.get - 'occasId' can not be null");
        }
        final OccasPoint entity = get(OccasPointImpl.class, occasId);
        return transformEntity(transform, entity);
    }
    /**
     * {@inheritDoc}
     */
    @Override
    public OccasPoint get(Integer occasId)
    {
        return (OccasPoint)this.get(TRANSFORM_NONE, occasId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object load(final int transform, final Integer occasId)
    {
        if (occasId == null)
        {
            throw new IllegalArgumentException(
                "OccasPoint.load - 'occasId' can not be null");
        }
        final OccasPoint entity = get(OccasPointImpl.class, occasId);
        return transformEntity(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public OccasPoint load(Integer occasId)
    {
        return (OccasPoint)this.load(TRANSFORM_NONE, occasId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<OccasPoint> loadAll()
    {
        return (Collection<OccasPoint>) this.loadAll(OccasPointDao.TRANSFORM_NONE);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform)
    {
        return this.loadAll(transform, -1, -1);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int pageNumber, final int pageSize)
    {
        return this.loadAll(OccasPointDao.TRANSFORM_NONE, pageNumber, pageSize);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize)
    {
        try
        {
            final Criteria criteria = this.getSession().createCriteria(OccasPointImpl.class);
            if (pageNumber > 0 && pageSize > 0)
            {
                criteria.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                criteria.setMaxResults(pageSize);
            }
            final Collection<?> results = criteria.list();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex;
        }
    }

    /**
     * firstResult = (pageNumber - 1) * pageSize
     * @param pageNumber
     * @param pageSize
     * @return firstResult
     */
    protected int calculateFirstResult(int pageNumber, int pageSize)
    {
        int firstResult = 0;
        if (pageNumber > 0)
        {
            firstResult = (pageNumber - 1) * pageSize;
        }
        return firstResult;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public OccasPoint create(OccasPoint occasPoint)
    {
        return (OccasPoint)this.create(OccasPointDao.TRANSFORM_NONE, occasPoint);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(final int transform, final OccasPoint occasPoint)
    {
        if (occasPoint == null)
        {
            throw new IllegalArgumentException(
                "OccasPoint.create - 'occasPoint' can not be null");
        }
        this.getSessionFactory().getCurrentSession().save(occasPoint);
        return this.transformEntity(transform, occasPoint);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<OccasPoint> create(final Collection<OccasPoint> entities)
    {
        return (Collection<OccasPoint>) create(OccasPointDao.TRANSFORM_NONE, entities);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> create(final int transform, final Collection<OccasPoint> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "OccasPoint.create - 'entities' can not be null");
        }
                    for (OccasPoint entity : entities)
                    {
                        create(transform, entity);
                    }
        return entities;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public OccasPoint create(
        String occasPosition)
    {
        return (OccasPoint)this.create(OccasPointDao.TRANSFORM_NONE, occasPosition);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(
        final int transform,
        String occasPosition)
    {
        OccasPoint entity = new OccasPointImpl();
        entity.setOccasPosition(occasPosition);
        return this.create(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public OccasPoint create(
        String occasPosition,
        Occasion occasion)
    {
        return (OccasPoint)this.create(OccasPointDao.TRANSFORM_NONE, occasPosition, occasion);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(
        final int transform,
        String occasPosition,
        Occasion occasion)
    {
        OccasPoint entity = new OccasPointImpl();
        entity.setOccasPosition(occasPosition);
        entity.setOccasion(occasion);
        return this.create(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(OccasPoint occasPoint)
    {
        if (occasPoint == null)
        {
            throw new IllegalArgumentException(
                "OccasPoint.update - 'occasPoint' can not be null");
        }
        this.getSessionFactory().getCurrentSession().update(occasPoint);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(final Collection<OccasPoint> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "OccasPoint.update - 'entities' can not be null");
        }
                    for (OccasPoint entity : entities)
                    {
                        update(entity);
                    }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(OccasPoint occasPoint)
    {
        if (occasPoint == null)
        {
            throw new IllegalArgumentException(
                "OccasPoint.remove - 'occasPoint' can not be null");
        }
        this.getSessionFactory().getCurrentSession().delete(occasPoint);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Integer occasId)
    {
        if (occasId == null)
        {
            throw new IllegalArgumentException(
                "OccasPoint.remove - 'occasId' can not be null");
        }
        OccasPoint entity = this.get(occasId);
        if (entity != null)
        {
            this.remove(entity);
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Collection<OccasPoint> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "OccasPoint.remove - 'entities' can not be null");
        }
        deleteAll(entities);
    }
    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>OccasPointDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link OccasPointDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see OccasPointDao#transformEntity(int, OccasPoint)
     */
    public Object transformEntity(final int transform, final OccasPoint entity)
    {
        Object target = null;
        if (entity != null)
        {
            switch (transform)
            {
                case OccasPointDao.TRANSFORM_NONE : // fall-through
                default:
                    target = entity;
            }
        }
        return target;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void transformEntities(final int transform, final Collection<?> entities)
    {
        switch (transform)
        {
            case OccasPointDao.TRANSFORM_NONE : // fall-through
                default:
                // do nothing;
        }
    }

    /**
     * @see OccasPointDao#toEntities(Collection)
     */
    public void toEntities(final Collection<?> results)
    {
        if (results != null)
        {
            CollectionUtils.transform(results, this.ENTITYTRANSFORMER);
        }
    }

    /**
     * This anonymous transformer is designed to transform report query results
     * (which result in an array of entities) to {@link OccasPoint}
     * using the Jakarta Commons-Collections Transformation API.
     */
    private Transformer ENTITYTRANSFORMER =
        new Transformer()
        {
            public Object transform(Object input)
            {
                Object result = null;
                if (input instanceof Object[])
                {
                    result = toEntity((Object[])input);
                }
                else if (input instanceof OccasPoint)
                {
                    result = input;
                }
                return result;
            }
        };

    /**
     * @param row
     * @return OccasPoint
     */
    protected OccasPoint toEntity(Object[] row)
    {
        OccasPoint target = null;
        if (row != null)
        {
            final int numberOfObjects = row.length;
            for (int ctr = 0; ctr < numberOfObjects; ctr++)
            {
                final Object object = row[ctr];
                if (object instanceof OccasPoint)
                {
                    target = (OccasPoint)object;
                    break;
                }
            }
        }
        return target;
    }

    /**
     * Gets the current <code>principal</code> if one has been set,
     * otherwise returns <code>null</code>.
     *
     * @return the current principal
     */
    protected Principal getPrincipal()
    {
        return PrincipalStore.get();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({ "unchecked" })
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search)
    {
        try
        {
            search.setPageNumber(pageNumber);
            search.setPageSize(pageSize);
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), OccasPointImpl.class, search);
            final List results = propertySearch.executeAsList();
            this.transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), propertySearch.getTotalCount());
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search)
    {
        return this.search(OccasPointDao.TRANSFORM_NONE, pageNumber, pageSize, search);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Set<?> search(final int transform, final Search search)
    {
        try
        {
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), OccasPointImpl.class, search);
            final Set<?> results = propertySearch.executeAsSet();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings("unchecked")
    public Set<OccasPoint> search(final Search search)
    {
        return (Set<OccasPoint>) this.search(OccasPointDao.TRANSFORM_NONE, search);
    }

    /**
     * Executes and returns the given Hibernate queryObject as a {@link PaginationResult} instance.
     * @param queryObject
     * @param transform
     * @param pageNumber
     * @param pageSize
     * @return PaginationResult
     */
    @SuppressWarnings({ "unchecked" })
    protected PaginationResult getPaginationResult(
        final Query queryObject,
        final int transform, int pageNumber, int pageSize)
    {
        try
        {
            final ScrollableResults scrollableResults = queryObject.scroll();
            scrollableResults.last();
            int totalCount = scrollableResults.getRowNumber();
            totalCount = totalCount >= 0 ? totalCount + 1 : 0;
            if (pageNumber > 0 && pageSize > 0)
            {
                queryObject.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                queryObject.setMaxResults(pageSize);
            }
            // Unchecked transformation because Set object is reused, cannot be strongly typed.
            Set results = new LinkedHashSet(queryObject.list());
            transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), totalCount);
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    // spring-hibernate-dao-base merge-point
}