// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system;

import fr.ifremer.quadrige3.core.dao.administration.user.Quser;
import fr.ifremer.quadrige3.core.dao.referential.ObjectType;
import java.io.Serializable;
import java.util.Collection;
import java.util.HashSet;

/**
 * Liste des sélections cartographique.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Selection
    implements Serializable, Comparable<Selection>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 4743617357468307693L;

    // Generate 3 attributes
    private Integer selId;

    /**
     * Identifiant interne de la sélection
     * @return this.selId Integer
     */
    public Integer getSelId()
    {
        return this.selId;
    }

    /**
     * Identifiant interne de la sélection
     * @param selIdIn Integer
     */
    public void setSelId(Integer selIdIn)
    {
        this.selId = selIdIn;
    }

    private Integer selSessionId;

    /**
     * Identifiant de la session utilisateur
     * @return this.selSessionId Integer
     */
    public Integer getSelSessionId()
    {
        return this.selSessionId;
    }

    /**
     * Identifiant de la session utilisateur
     * @param selSessionIdIn Integer
     */
    public void setSelSessionId(Integer selSessionIdIn)
    {
        this.selSessionId = selSessionIdIn;
    }

    private String selPosition;

    /**
     * Géométries sélectionnées
     * @return this.selPosition String
     */
    public String getSelPosition()
    {
        return this.selPosition;
    }

    /**
     * Géométries sélectionnées
     * @param selPositionIn String
     */
    public void setSelPosition(String selPositionIn)
    {
        this.selPosition = selPositionIn;
    }

    // Generate 3 associations
    private Collection<SelectionItem> selItemGeomObjectIds = new HashSet<SelectionItem>();

    /**
     * Liste des objets sélectionnés dans la vue cartographique.
     * @return this.selItemGeomObjectIds Collection<SelectionItem>
     */
    public Collection<SelectionItem> getSelItemGeomObjectIds()
    {
        return this.selItemGeomObjectIds;
    }

    /**
     * Liste des objets sélectionnés dans la vue cartographique.
     * @param selItemGeomObjectIdsIn Collection<SelectionItem>
     */
    public void setSelItemGeomObjectIds(Collection<SelectionItem> selItemGeomObjectIdsIn)
    {
        this.selItemGeomObjectIds = selItemGeomObjectIdsIn;
    }

    /**
     * Liste des objets sélectionnés dans la vue cartographique.
     * @param elementToAdd SelectionItem
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSelItemGeomObjectIds(SelectionItem elementToAdd)
    {
        return this.selItemGeomObjectIds.add(elementToAdd);
    }

    /**
     * Liste des objets sélectionnés dans la vue cartographique.
     * @param elementToRemove SelectionItem
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSelItemGeomObjectIds(SelectionItem elementToRemove)
    {
        return this.selItemGeomObjectIds.remove(elementToRemove);
    }

    private ObjectType objectTypeCd;

    /**
     * Liste des types d'objets qui peuvent être associés à la photo ou à un résultat. Cette liste
     * ne peut
     * pas être modifiée par l'utilisateur.
     * @return this.objectTypeCd ObjectType
     */
    public ObjectType getObjectTypeCd()
    {
        return this.objectTypeCd;
    }

    /**
     * Liste des types d'objets qui peuvent être associés à la photo ou à un résultat. Cette liste
     * ne peut
     * pas être modifiée par l'utilisateur.
     * @param objectTypeCdIn ObjectType
     */
    public void setObjectTypeCd(ObjectType objectTypeCdIn)
    {
        this.objectTypeCd = objectTypeCdIn;
    }

    private Quser quserId;

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @return this.quserId Quser
     */
    public Quser getQuserId()
    {
        return this.quserId;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param quserIdIn Quser
     */
    public void setQuserId(Quser quserIdIn)
    {
        this.quserId = quserIdIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Selection instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Selection))
        {
            return false;
        }
        final Selection that = (Selection)object;
        if (this.selId == null || that.getSelId() == null || !this.selId.equals(that.getSelId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.selId == null ? 0 : this.selId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Selection}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Selection}.
         * @return new SelectionImpl()
         */
        public static Selection newInstance()
        {
            return new SelectionImpl();
        }

        /**
         * Constructs a new instance of {@link Selection}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param selSessionId Integer
         * @return newInstance
         */
        public static Selection newInstance(Integer selSessionId)
        {
            final Selection entity = new SelectionImpl();
            entity.setSelSessionId(selSessionId);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Selection}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param selSessionId Integer
         * @param selPosition String
         * @param selItemGeomObjectIds Collection<SelectionItem>
         * @param objectTypeCd ObjectType
         * @param quserId Quser
         * @return newInstance Selection
         */
        public static Selection newInstance(Integer selSessionId, String selPosition, Collection<SelectionItem> selItemGeomObjectIds, ObjectType objectTypeCd, Quser quserId)
        {
            final Selection entity = new SelectionImpl();
            entity.setSelSessionId(selSessionId);
            entity.setSelPosition(selPosition);
            entity.setSelItemGeomObjectIds(selItemGeomObjectIds);
            entity.setObjectTypeCd(objectTypeCd);
            entity.setQuserId(quserId);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Selection o)
    {
        int cmp = 0;
        if (this.getSelId() != null)
        {
            cmp = this.getSelId().compareTo(o.getSelId());
        }
        else
        {
            if (this.getSelSessionId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSelSessionId().compareTo(o.getSelSessionId()));
            }
            if (this.getSelPosition() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSelPosition().compareTo(o.getSelPosition()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Selection.java merge-point
}