// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system.extraction;

import fr.ifremer.quadrige3.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Définit les éléments supplémentaires au filtre et nécessaires à l'extraction.
 * @see ExtractFilter
 */
public interface ExtractFilterDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link ExtractFilter}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of ExtractFilter from the persistent store.
     * @param extractFilterId
     * @return ExtractFilter
     */
    public ExtractFilter get(Integer extractFilterId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param extractFilterId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer extractFilterId);

    /**
     * Loads an instance of ExtractFilter from the persistent store.
     * @param extractFilterId
     * @return ExtractFilter
     */
    public ExtractFilter load(Integer extractFilterId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param extractFilterId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer extractFilterId);

    /**
     * Loads all entities of type {@link ExtractFilter}.
     *
     * @return the loaded entities.
     */
    public Collection<ExtractFilter> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of ExtractFilter and adds it to the persistent store.
     * @param extractFilter
     * @return ExtractFilter
     */
    public ExtractFilter create(ExtractFilter extractFilter);

    /**
     * <p>
     * Does the same thing as {@link #create(ExtractFilter)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param extractFilter
     * @return Object
     */
    public Object create(int transform, ExtractFilter extractFilter);

    /**
     * Creates a new instance of ExtractFilter and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of ExtractFilter
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<ExtractFilter> create(Collection<ExtractFilter> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(ExtractFilter)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<ExtractFilter> entities);

    /**
     * <p>
     * Creates a new <code>ExtractFilter</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param extractFilterNm Libellé du filtre d'extraction
     * @param extractFilterInSitu Détermine si l'extraction est de type in situ
     * @param extractFilterIsQualif Indique s'il s'agit d'une extraction dans le cadre d'une qualification ou d'une extraction de
résultat
     * @param extractFilterIsJan 1 si l'extraction concerne le mois de Janvier
     * @param extractFilterIsFeb 1 si l'extraction concerne le mois de Février
     * @param extractFilterIsMar 1 si l'extraction concerne le mois de Mars
     * @param extractFilterIsApr 1 si l'extraction concerne le mois de Avril
     * @param extractFilterIsMay 1 si l'extraction concerne le mois de Mai
     * @param extractFilterIsJun 1 si l'extraction concerne le mois de Juin
     * @param extractFilterIsJul 1 si l'extraction concerne le mois de Juillet
     * @param extractFilterIsAug 1 si l'extraction concerne le mois de Aout
     * @param extractFilterIsSep 1 si l'extraction concerne le mois de Septembre
     * @param extractFilterIsOct 1 si l'extraction concerne le mois de Octobre
     * @param extractFilterIsNov 1 si l'extraction concerne le mois de Novembre
     * @param extractFilterIsDec 1 si l'extraction concerne le mois de Decembre
     * @param extractFilterMinX Coordonnée min X de la boite englobante
     * @param extractFilterMinY Coordonnée min Y de la boite englobante
     * @param extractFilterMaxX Coordonnée max X de la boite englobante
     * @param extractFilterMaxY Coordonnée max Y de la boite englobante
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return ExtractFilter
     */
    public ExtractFilter create(
        String extractFilterNm,
        String extractFilterInSitu,
        String extractFilterIsQualif,
        String extractFilterIsJan,
        String extractFilterIsFeb,
        String extractFilterIsMar,
        String extractFilterIsApr,
        String extractFilterIsMay,
        String extractFilterIsJun,
        String extractFilterIsJul,
        String extractFilterIsAug,
        String extractFilterIsSep,
        String extractFilterIsOct,
        String extractFilterIsNov,
        String extractFilterIsDec,
        Float extractFilterMinX,
        Float extractFilterMinY,
        Float extractFilterMaxX,
        Float extractFilterMaxY,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, String, String, String, String, String, String, String, String, String, String, String, String, Float, Float, Float, Float, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param extractFilterNm Libellé du filtre d'extraction
     * @param extractFilterInSitu Détermine si l'extraction est de type in situ
     * @param extractFilterIsQualif Indique s'il s'agit d'une extraction dans le cadre d'une qualification ou d'une extraction de
résultat
     * @param extractFilterIsJan 1 si l'extraction concerne le mois de Janvier
     * @param extractFilterIsFeb 1 si l'extraction concerne le mois de Février
     * @param extractFilterIsMar 1 si l'extraction concerne le mois de Mars
     * @param extractFilterIsApr 1 si l'extraction concerne le mois de Avril
     * @param extractFilterIsMay 1 si l'extraction concerne le mois de Mai
     * @param extractFilterIsJun 1 si l'extraction concerne le mois de Juin
     * @param extractFilterIsJul 1 si l'extraction concerne le mois de Juillet
     * @param extractFilterIsAug 1 si l'extraction concerne le mois de Aout
     * @param extractFilterIsSep 1 si l'extraction concerne le mois de Septembre
     * @param extractFilterIsOct 1 si l'extraction concerne le mois de Octobre
     * @param extractFilterIsNov 1 si l'extraction concerne le mois de Novembre
     * @param extractFilterIsDec 1 si l'extraction concerne le mois de Decembre
     * @param extractFilterMinX Coordonnée min X de la boite englobante
     * @param extractFilterMinY Coordonnée min Y de la boite englobante
     * @param extractFilterMaxX Coordonnée max X de la boite englobante
     * @param extractFilterMaxY Coordonnée max Y de la boite englobante
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return ExtractFilter
     */
    public Object create(
        int transform,
        String extractFilterNm,
        String extractFilterInSitu,
        String extractFilterIsQualif,
        String extractFilterIsJan,
        String extractFilterIsFeb,
        String extractFilterIsMar,
        String extractFilterIsApr,
        String extractFilterIsMay,
        String extractFilterIsJun,
        String extractFilterIsJul,
        String extractFilterIsAug,
        String extractFilterIsSep,
        String extractFilterIsOct,
        String extractFilterIsNov,
        String extractFilterIsDec,
        Float extractFilterMinX,
        Float extractFilterMinY,
        Float extractFilterMaxX,
        Float extractFilterMaxY,
        Timestamp updateDt);


    /**
     * Updates the <code>extractFilter</code> instance in the persistent store.
     * @param extractFilter
     */
    public void update(ExtractFilter extractFilter);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<ExtractFilter> entities);

    /**
     * Removes the instance of ExtractFilter from the persistent store.
     * @param extractFilter
     */
    public void remove(ExtractFilter extractFilter);

    /**
     * Removes the instance of ExtractFilter having the given
     * <code>identifier</code> from the persistent store.
     * @param extractFilterId
     */
    public void remove(Integer extractFilterId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<ExtractFilter> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<ExtractFilter> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.system.extraction.ExtractFilterDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.system.extraction.ExtractFilterDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final ExtractFilter entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,ExtractFilter)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.system.extraction.ExtractFilterDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,ExtractFilter)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}