// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system.filter;

import fr.ifremer.quadrige3.core.dao.administration.user.Department;
import fr.ifremer.quadrige3.core.dao.administration.user.Quser;
import fr.ifremer.quadrige3.core.dao.system.extraction.ExtractFilter;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Table technique : Un filtre permet pour un utilisateur et un service de définie différents
 * critères d'accès aux données in situ
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Filter
    implements Serializable, Comparable<Filter>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1724276285302423531L;

    // Generate 9 attributes
    private Integer filterId;

    /**
     * Identifiant primaire du filtre
     * @return this.filterId Integer
     */
    public Integer getFilterId()
    {
        return this.filterId;
    }

    /**
     * Identifiant primaire du filtre
     * @param filterIdIn Integer
     */
    public void setFilterId(Integer filterIdIn)
    {
        this.filterId = filterIdIn;
    }

    private String filterNm;

    /**
     * Libellé du filtre
     * @return this.filterNm String
     */
    public String getFilterNm()
    {
        return this.filterNm;
    }

    /**
     * Libellé du filtre
     * @param filterNmIn String
     */
    public void setFilterNm(String filterNmIn)
    {
        this.filterNm = filterNmIn;
    }

    private String filterIsDefault;

    /**
     * '1' si le filtre est le filtre par défaut pour l'entité
     * @return this.filterIsDefault String
     */
    public String getFilterIsDefault()
    {
        return this.filterIsDefault;
    }

    /**
     * '1' si le filtre est le filtre par défaut pour l'entité
     * @param filterIsDefaultIn String
     */
    public void setFilterIsDefault(String filterIsDefaultIn)
    {
        this.filterIsDefault = filterIsDefaultIn;
    }

    private String filterIsExtract;

    /**
     * '1' si le filtre est utilisé dans le cadre d'une extraction
     * @return this.filterIsExtract String
     */
    public String getFilterIsExtract()
    {
        return this.filterIsExtract;
    }

    /**
     * '1' si le filtre est utilisé dans le cadre d'une extraction
     * @param filterIsExtractIn String
     */
    public void setFilterIsExtract(String filterIsExtractIn)
    {
        this.filterIsExtract = filterIsExtractIn;
    }

    private Float filterMinX;

    /**
     * X min de l'enveloppe
     * @return this.filterMinX Float
     */
    public Float getFilterMinX()
    {
        return this.filterMinX;
    }

    /**
     * X min de l'enveloppe
     * @param filterMinXIn Float
     */
    public void setFilterMinX(Float filterMinXIn)
    {
        this.filterMinX = filterMinXIn;
    }

    private Float filterMinY;

    /**
     * Y min
     * @return this.filterMinY Float
     */
    public Float getFilterMinY()
    {
        return this.filterMinY;
    }

    /**
     * Y min
     * @param filterMinYIn Float
     */
    public void setFilterMinY(Float filterMinYIn)
    {
        this.filterMinY = filterMinYIn;
    }

    private Float filterMaxX;

    /**
     * X max de l'enveloppe
     * @return this.filterMaxX Float
     */
    public Float getFilterMaxX()
    {
        return this.filterMaxX;
    }

    /**
     * X max de l'enveloppe
     * @param filterMaxXIn Float
     */
    public void setFilterMaxX(Float filterMaxXIn)
    {
        this.filterMaxX = filterMaxXIn;
    }

    private Float filterMaxY;

    /**
     * Y max
     * @return this.filterMaxY Float
     */
    public Float getFilterMaxY()
    {
        return this.filterMaxY;
    }

    /**
     * Y max
     * @param filterMaxYIn Float
     */
    public void setFilterMaxY(Float filterMaxYIn)
    {
        this.filterMaxY = filterMaxYIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 6 associations
    private Department department;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.department Department
     */
    public Department getDepartment()
    {
        return this.department;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param departmentIn Department
     */
    public void setDepartment(Department departmentIn)
    {
        this.department = departmentIn;
    }

    private Collection<FilterBlock> filterBlocks = new HashSet<FilterBlock>();

    /**
     * Table technique : Sous élément d'un filtre particulier.
     * @return this.filterBlocks Collection<FilterBlock>
     */
    public Collection<FilterBlock> getFilterBlocks()
    {
        return this.filterBlocks;
    }

    /**
     * Table technique : Sous élément d'un filtre particulier.
     * @param filterBlocksIn Collection<FilterBlock>
     */
    public void setFilterBlocks(Collection<FilterBlock> filterBlocksIn)
    {
        this.filterBlocks = filterBlocksIn;
    }

    /**
     * Table technique : Sous élément d'un filtre particulier.
     * @param elementToAdd FilterBlock
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addFilterBlocks(FilterBlock elementToAdd)
    {
        return this.filterBlocks.add(elementToAdd);
    }

    /**
     * Table technique : Sous élément d'un filtre particulier.
     * @param elementToRemove FilterBlock
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeFilterBlocks(FilterBlock elementToRemove)
    {
        return this.filterBlocks.remove(elementToRemove);
    }

    private Quser quser;

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @return this.quser Quser
     */
    public Quser getQuser()
    {
        return this.quser;
    }

    /**
     * Liste l'ensemble des agents et utilisateurs du système.
     * @param quserIn Quser
     */
    public void setQuser(Quser quserIn)
    {
        this.quser = quserIn;
    }

    private FilterType filterType;

    /**
     * Table technique : Type du filtre
     * @return this.filterType FilterType
     */
    public FilterType getFilterType()
    {
        return this.filterType;
    }

    /**
     * Table technique : Type du filtre
     * @param filterTypeIn FilterType
     */
    public void setFilterType(FilterType filterTypeIn)
    {
        this.filterType = filterTypeIn;
    }

    private ExtractFilter extractFilter;

    /**
     * Définit les éléments supplémentaires au filtre et nécessaires à l'extraction.
     * @return this.extractFilter ExtractFilter
     */
    public ExtractFilter getExtractFilter()
    {
        return this.extractFilter;
    }

    /**
     * Définit les éléments supplémentaires au filtre et nécessaires à l'extraction.
     * @param extractFilterIn ExtractFilter
     */
    public void setExtractFilter(ExtractFilter extractFilterIn)
    {
        this.extractFilter = extractFilterIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Filter instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Filter))
        {
            return false;
        }
        final Filter that = (Filter)object;
        if (this.filterId == null || that.getFilterId() == null || !this.filterId.equals(that.getFilterId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.filterId == null ? 0 : this.filterId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Filter}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Filter}.
         * @return new FilterImpl()
         */
        public static Filter newInstance()
        {
            return new FilterImpl();
        }

        /**
         * Constructs a new instance of {@link Filter}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param quser Quser
         * @param filterType FilterType
         * @return newInstance
         */
        public static Filter newInstance(Quser quser, FilterType filterType)
        {
            final Filter entity = new FilterImpl();
            entity.setQuser(quser);
            entity.setFilterType(filterType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Filter}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param filterNm String
         * @param filterIsDefault String
         * @param filterIsExtract String
         * @param filterMinX Float
         * @param filterMinY Float
         * @param filterMaxX Float
         * @param filterMaxY Float
         * @param updateDt Timestamp
         * @param department Department
         * @param filterBlocks Collection<FilterBlock>
         * @param quser Quser
         * @param filterType FilterType
         * @param extractFilter ExtractFilter
         * @return newInstance Filter
         */
        public static Filter newInstance(String filterNm, String filterIsDefault, String filterIsExtract, Float filterMinX, Float filterMinY, Float filterMaxX, Float filterMaxY, Timestamp updateDt, Department department, Collection<FilterBlock> filterBlocks, Quser quser, FilterType filterType, ExtractFilter extractFilter)
        {
            final Filter entity = new FilterImpl();
            entity.setFilterNm(filterNm);
            entity.setFilterIsDefault(filterIsDefault);
            entity.setFilterIsExtract(filterIsExtract);
            entity.setFilterMinX(filterMinX);
            entity.setFilterMinY(filterMinY);
            entity.setFilterMaxX(filterMaxX);
            entity.setFilterMaxY(filterMaxY);
            entity.setUpdateDt(updateDt);
            entity.setDepartment(department);
            entity.setFilterBlocks(filterBlocks);
            entity.setQuser(quser);
            entity.setFilterType(filterType);
            entity.setExtractFilter(extractFilter);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Filter o)
    {
        int cmp = 0;
        if (this.getFilterId() != null)
        {
            cmp = this.getFilterId().compareTo(o.getFilterId());
        }
        else
        {
            if (this.getFilterNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFilterNm().compareTo(o.getFilterNm()));
            }
            if (this.getFilterIsDefault() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFilterIsDefault().compareTo(o.getFilterIsDefault()));
            }
            if (this.getFilterIsExtract() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFilterIsExtract().compareTo(o.getFilterIsExtract()));
            }
            if (this.getFilterMinX() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFilterMinX().compareTo(o.getFilterMinX()));
            }
            if (this.getFilterMinY() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFilterMinY().compareTo(o.getFilterMinY()));
            }
            if (this.getFilterMaxX() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFilterMaxX().compareTo(o.getFilterMaxX()));
            }
            if (this.getFilterMaxY() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFilterMaxY().compareTo(o.getFilterMaxY()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Filter.java merge-point
}