// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system.filter;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Table technique : Sous élément d'un filtre particulier.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class FilterBlock
    implements Serializable, Comparable<FilterBlock>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -7778128250672266921L;

    // Generate 2 attributes
    private Integer filterBlockId;

    /**
     * Numéro du block dans le filtre. Il permet de constituer la clé primaire du block en se
     * combinant avec l'identifiant du filtre.
     * @return this.filterBlockId Integer
     */
    public Integer getFilterBlockId()
    {
        return this.filterBlockId;
    }

    /**
     * Numéro du block dans le filtre. Il permet de constituer la clé primaire du block en se
     * combinant avec l'identifiant du filtre.
     * @param filterBlockIdIn Integer
     */
    public void setFilterBlockId(Integer filterBlockIdIn)
    {
        this.filterBlockId = filterBlockIdIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private Filter filter;

    /**
     * Table technique : Un filtre permet pour un utilisateur et un service de définie différents
     * critères
     * d'accès aux données in situ
     * @return this.filter Filter
     */
    public Filter getFilter()
    {
        return this.filter;
    }

    /**
     * Table technique : Un filtre permet pour un utilisateur et un service de définie différents
     * critères
     * d'accès aux données in situ
     * @param filterIn Filter
     */
    public void setFilter(Filter filterIn)
    {
        this.filter = filterIn;
    }

    private Collection<FilterCriteria> filterCriterias = new HashSet<FilterCriteria>();

    /**
     * Table technique : Critère de filtrage dans un block du filtre. Il peut y en avoir plusieurs
     * @return this.filterCriterias Collection<FilterCriteria>
     */
    public Collection<FilterCriteria> getFilterCriterias()
    {
        return this.filterCriterias;
    }

    /**
     * Table technique : Critère de filtrage dans un block du filtre. Il peut y en avoir plusieurs
     * @param filterCriteriasIn Collection<FilterCriteria>
     */
    public void setFilterCriterias(Collection<FilterCriteria> filterCriteriasIn)
    {
        this.filterCriterias = filterCriteriasIn;
    }

    /**
     * Table technique : Critère de filtrage dans un block du filtre. Il peut y en avoir plusieurs
     * @param elementToAdd FilterCriteria
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addFilterCriterias(FilterCriteria elementToAdd)
    {
        return this.filterCriterias.add(elementToAdd);
    }

    /**
     * Table technique : Critère de filtrage dans un block du filtre. Il peut y en avoir plusieurs
     * @param elementToRemove FilterCriteria
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeFilterCriterias(FilterCriteria elementToRemove)
    {
        return this.filterCriterias.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an FilterBlock instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof FilterBlock))
        {
            return false;
        }
        final FilterBlock that = (FilterBlock)object;
        if (this.filterBlockId == null || that.getFilterBlockId() == null || !this.filterBlockId.equals(that.getFilterBlockId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.filterBlockId == null ? 0 : this.filterBlockId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link FilterBlock}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link FilterBlock}.
         * @return new FilterBlockImpl()
         */
        public static FilterBlock newInstance()
        {
            return new FilterBlockImpl();
        }

        /**
         * Constructs a new instance of {@link FilterBlock}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param filter Filter
         * @return newInstance
         */
        public static FilterBlock newInstance(Filter filter)
        {
            final FilterBlock entity = new FilterBlockImpl();
            entity.setFilter(filter);
            return entity;
        }

        /**
         * Constructs a new instance of {@link FilterBlock}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param filter Filter
         * @param filterCriterias Collection<FilterCriteria>
         * @return newInstance FilterBlock
         */
        public static FilterBlock newInstance(Timestamp updateDt, Filter filter, Collection<FilterCriteria> filterCriterias)
        {
            final FilterBlock entity = new FilterBlockImpl();
            entity.setUpdateDt(updateDt);
            entity.setFilter(filter);
            entity.setFilterCriterias(filterCriterias);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(FilterBlock o)
    {
        int cmp = 0;
        if (this.getFilterBlockId() != null)
        {
            cmp = this.getFilterBlockId().compareTo(o.getFilterBlockId());
        }
        else
        {
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// FilterBlock.java merge-point
}