// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system.filter;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Table technique : Critère de filtrage dans un block du filtre. Il peut y en avoir plusieurs
 */
// HibernateEntity.vsl annotations merge-point
public abstract class FilterCriteria
    implements Serializable, Comparable<FilterCriteria>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 6899562485041029517L;

    // Generate 2 attributes
    private Integer filterCritId;

    /**
     * Identifiant du critère, numéro d'ordre du critère dans le bloc
     * @return this.filterCritId Integer
     */
    public Integer getFilterCritId()
    {
        return this.filterCritId;
    }

    /**
     * Identifiant du critère, numéro d'ordre du critère dans le bloc
     * @param filterCritIdIn Integer
     */
    public void setFilterCritId(Integer filterCritIdIn)
    {
        this.filterCritId = filterCritIdIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 4 associations
    private FilterCriteriaType filterCriteriaType;

    /**
     * Table technique : type de critère
     * @return this.filterCriteriaType FilterCriteriaType
     */
    public FilterCriteriaType getFilterCriteriaType()
    {
        return this.filterCriteriaType;
    }

    /**
     * Table technique : type de critère
     * @param filterCriteriaTypeIn FilterCriteriaType
     */
    public void setFilterCriteriaType(FilterCriteriaType filterCriteriaTypeIn)
    {
        this.filterCriteriaType = filterCriteriaTypeIn;
    }

    private FilterOperatorType filterOperatorType;

    /**
     * Table technique : type d'opérateur d'un filtre (and, or, boite, ....)
     * @return this.filterOperatorType FilterOperatorType
     */
    public FilterOperatorType getFilterOperatorType()
    {
        return this.filterOperatorType;
    }

    /**
     * Table technique : type d'opérateur d'un filtre (and, or, boite, ....)
     * @param filterOperatorTypeIn FilterOperatorType
     */
    public void setFilterOperatorType(FilterOperatorType filterOperatorTypeIn)
    {
        this.filterOperatorType = filterOperatorTypeIn;
    }

    private Collection<FilterCriteriaValue> filterCriteriaValues = new HashSet<FilterCriteriaValue>();

    /**
     * Table technique : Valeurs constituants la liste des valeurs du critère d'un block d'un
     * filtre.
     * @return this.filterCriteriaValues Collection<FilterCriteriaValue>
     */
    public Collection<FilterCriteriaValue> getFilterCriteriaValues()
    {
        return this.filterCriteriaValues;
    }

    /**
     * Table technique : Valeurs constituants la liste des valeurs du critère d'un block d'un
     * filtre.
     * @param filterCriteriaValuesIn Collection<FilterCriteriaValue>
     */
    public void setFilterCriteriaValues(Collection<FilterCriteriaValue> filterCriteriaValuesIn)
    {
        this.filterCriteriaValues = filterCriteriaValuesIn;
    }

    /**
     * Table technique : Valeurs constituants la liste des valeurs du critère d'un block d'un
     * filtre.
     * @param elementToAdd FilterCriteriaValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addFilterCriteriaValues(FilterCriteriaValue elementToAdd)
    {
        return this.filterCriteriaValues.add(elementToAdd);
    }

    /**
     * Table technique : Valeurs constituants la liste des valeurs du critère d'un block d'un
     * filtre.
     * @param elementToRemove FilterCriteriaValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeFilterCriteriaValues(FilterCriteriaValue elementToRemove)
    {
        return this.filterCriteriaValues.remove(elementToRemove);
    }

    private FilterBlock filterBlock;

    /**
     * Table technique : Sous élément d'un filtre particulier.
     * @return this.filterBlock FilterBlock
     */
    public FilterBlock getFilterBlock()
    {
        return this.filterBlock;
    }

    /**
     * Table technique : Sous élément d'un filtre particulier.
     * @param filterBlockIn FilterBlock
     */
    public void setFilterBlock(FilterBlock filterBlockIn)
    {
        this.filterBlock = filterBlockIn;
    }

    /**
     * Returns <code>true</code> if the argument is an FilterCriteria instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof FilterCriteria))
        {
            return false;
        }
        final FilterCriteria that = (FilterCriteria)object;
        if (this.filterCritId == null || that.getFilterCritId() == null || !this.filterCritId.equals(that.getFilterCritId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.filterCritId == null ? 0 : this.filterCritId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link FilterCriteria}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link FilterCriteria}.
         * @return new FilterCriteriaImpl()
         */
        public static FilterCriteria newInstance()
        {
            return new FilterCriteriaImpl();
        }

        /**
         * Constructs a new instance of {@link FilterCriteria}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param filterCriteriaType FilterCriteriaType
         * @param filterOperatorType FilterOperatorType
         * @param filterBlock FilterBlock
         * @return newInstance
         */
        public static FilterCriteria newInstance(FilterCriteriaType filterCriteriaType, FilterOperatorType filterOperatorType, FilterBlock filterBlock)
        {
            final FilterCriteria entity = new FilterCriteriaImpl();
            entity.setFilterCriteriaType(filterCriteriaType);
            entity.setFilterOperatorType(filterOperatorType);
            entity.setFilterBlock(filterBlock);
            return entity;
        }

        /**
         * Constructs a new instance of {@link FilterCriteria}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param filterCriteriaType FilterCriteriaType
         * @param filterOperatorType FilterOperatorType
         * @param filterCriteriaValues Collection<FilterCriteriaValue>
         * @param filterBlock FilterBlock
         * @return newInstance FilterCriteria
         */
        public static FilterCriteria newInstance(Timestamp updateDt, FilterCriteriaType filterCriteriaType, FilterOperatorType filterOperatorType, Collection<FilterCriteriaValue> filterCriteriaValues, FilterBlock filterBlock)
        {
            final FilterCriteria entity = new FilterCriteriaImpl();
            entity.setUpdateDt(updateDt);
            entity.setFilterCriteriaType(filterCriteriaType);
            entity.setFilterOperatorType(filterOperatorType);
            entity.setFilterCriteriaValues(filterCriteriaValues);
            entity.setFilterBlock(filterBlock);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(FilterCriteria o)
    {
        int cmp = 0;
        if (this.getFilterCritId() != null)
        {
            cmp = this.getFilterCritId().compareTo(o.getFilterCritId());
        }
        else
        {
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// FilterCriteria.java merge-point
}