// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/SpringHibernateDaoBase.vsl in <project>/mda/src/main/cartridge/custom/...
//
package fr.ifremer.quadrige3.core.dao.system.filter;

import fr.ifremer.quadrige3.core.dao.PrincipalStore;
import fr.ifremer.quadrige3.core.dao.PropertySearch;
import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.technical.hibernate.HibernateDaoSupport;
import java.security.Principal;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import javax.annotation.Resource;
import org.andromda.spring.PaginationResult;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.Transformer;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.ScrollableResults;

/**
 * <p>
 * Base Spring DAO Class: is able to create, update, remove, load, and find
 * objects of type <code>FilterOperatorType</code>.
 * </p>
 *
 * @see FilterOperatorType
 */
public abstract class FilterOperatorTypeDaoBase
    extends HibernateDaoSupport    
    implements FilterOperatorTypeDao
{
    /**
     * {@inheritDoc}
     */
    @Override
    public Object get(final int transform, final Integer filterOperTypeId)
    {
        if (filterOperTypeId == null)
        {
            throw new IllegalArgumentException(
                "FilterOperatorType.get - 'filterOperTypeId' can not be null");
        }
        final FilterOperatorType entity = get(FilterOperatorTypeImpl.class, filterOperTypeId);
        return transformEntity(transform, entity);
    }
    /**
     * {@inheritDoc}
     */
    @Override
    public FilterOperatorType get(Integer filterOperTypeId)
    {
        return (FilterOperatorType)this.get(TRANSFORM_NONE, filterOperTypeId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object load(final int transform, final Integer filterOperTypeId)
    {
        if (filterOperTypeId == null)
        {
            throw new IllegalArgumentException(
                "FilterOperatorType.load - 'filterOperTypeId' can not be null");
        }
        final FilterOperatorType entity = get(FilterOperatorTypeImpl.class, filterOperTypeId);
        return transformEntity(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public FilterOperatorType load(Integer filterOperTypeId)
    {
        return (FilterOperatorType)this.load(TRANSFORM_NONE, filterOperTypeId);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<FilterOperatorType> loadAll()
    {
        return (Collection<FilterOperatorType>) this.loadAll(FilterOperatorTypeDao.TRANSFORM_NONE);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform)
    {
        return this.loadAll(transform, -1, -1);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int pageNumber, final int pageSize)
    {
        return this.loadAll(FilterOperatorTypeDao.TRANSFORM_NONE, pageNumber, pageSize);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize)
    {
        try
        {
            final Criteria criteria = this.getSession().createCriteria(FilterOperatorTypeImpl.class);
            if (pageNumber > 0 && pageSize > 0)
            {
                criteria.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                criteria.setMaxResults(pageSize);
            }
            final Collection<?> results = criteria.list();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex;
        }
    }

    /**
     * firstResult = (pageNumber - 1) * pageSize
     * @param pageNumber
     * @param pageSize
     * @return firstResult
     */
    protected int calculateFirstResult(int pageNumber, int pageSize)
    {
        int firstResult = 0;
        if (pageNumber > 0)
        {
            firstResult = (pageNumber - 1) * pageSize;
        }
        return firstResult;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public FilterOperatorType create(FilterOperatorType filterOperatorType)
    {
        return (FilterOperatorType)this.create(FilterOperatorTypeDao.TRANSFORM_NONE, filterOperatorType);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(final int transform, final FilterOperatorType filterOperatorType)
    {
        if (filterOperatorType == null)
        {
            throw new IllegalArgumentException(
                "FilterOperatorType.create - 'filterOperatorType' can not be null");
        }
        this.getSessionFactory().getCurrentSession().save(filterOperatorType);
        return this.transformEntity(transform, filterOperatorType);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({"unchecked"})
    public Collection<FilterOperatorType> create(final Collection<FilterOperatorType> entities)
    {
        return (Collection<FilterOperatorType>) create(FilterOperatorTypeDao.TRANSFORM_NONE, entities);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<?> create(final int transform, final Collection<FilterOperatorType> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "FilterOperatorType.create - 'entities' can not be null");
        }
                    for (FilterOperatorType entity : entities)
                    {
                        create(transform, entity);
                    }
        return entities;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public FilterOperatorType create(
        String filterOperTypeNm,
        Timestamp updateDt)
    {
        return (FilterOperatorType)this.create(FilterOperatorTypeDao.TRANSFORM_NONE, filterOperTypeNm, updateDt);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Object create(
        final int transform,
        String filterOperTypeNm,
        Timestamp updateDt)
    {
        FilterOperatorType entity = new FilterOperatorTypeImpl();
        entity.setFilterOperTypeNm(filterOperTypeNm);
        entity.setUpdateDt(updateDt);
        return this.create(transform, entity);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(FilterOperatorType filterOperatorType)
    {
        if (filterOperatorType == null)
        {
            throw new IllegalArgumentException(
                "FilterOperatorType.update - 'filterOperatorType' can not be null");
        }
        this.getSessionFactory().getCurrentSession().update(filterOperatorType);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(final Collection<FilterOperatorType> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "FilterOperatorType.update - 'entities' can not be null");
        }
                    for (FilterOperatorType entity : entities)
                    {
                        update(entity);
                    }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(FilterOperatorType filterOperatorType)
    {
        if (filterOperatorType == null)
        {
            throw new IllegalArgumentException(
                "FilterOperatorType.remove - 'filterOperatorType' can not be null");
        }
        this.getSessionFactory().getCurrentSession().delete(filterOperatorType);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Integer filterOperTypeId)
    {
        if (filterOperTypeId == null)
        {
            throw new IllegalArgumentException(
                "FilterOperatorType.remove - 'filterOperTypeId' can not be null");
        }
        FilterOperatorType entity = this.get(filterOperTypeId);
        if (entity != null)
        {
            this.remove(entity);
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void remove(Collection<FilterOperatorType> entities)
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "FilterOperatorType.remove - 'entities' can not be null");
        }
        deleteAll(entities);
    }
    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>FilterOperatorTypeDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link FilterOperatorTypeDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see FilterOperatorTypeDao#transformEntity(int, FilterOperatorType)
     */
    public Object transformEntity(final int transform, final FilterOperatorType entity)
    {
        Object target = null;
        if (entity != null)
        {
            switch (transform)
            {
                case FilterOperatorTypeDao.TRANSFORM_NONE : // fall-through
                default:
                    target = entity;
            }
        }
        return target;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void transformEntities(final int transform, final Collection<?> entities)
    {
        switch (transform)
        {
            case FilterOperatorTypeDao.TRANSFORM_NONE : // fall-through
                default:
                // do nothing;
        }
    }

    /**
     * @see FilterOperatorTypeDao#toEntities(Collection)
     */
    public void toEntities(final Collection<?> results)
    {
        if (results != null)
        {
            CollectionUtils.transform(results, this.ENTITYTRANSFORMER);
        }
    }

    /**
     * This anonymous transformer is designed to transform report query results
     * (which result in an array of entities) to {@link FilterOperatorType}
     * using the Jakarta Commons-Collections Transformation API.
     */
    private Transformer ENTITYTRANSFORMER =
        new Transformer()
        {
            public Object transform(Object input)
            {
                Object result = null;
                if (input instanceof Object[])
                {
                    result = toEntity((Object[])input);
                }
                else if (input instanceof FilterOperatorType)
                {
                    result = input;
                }
                return result;
            }
        };

    /**
     * @param row
     * @return FilterOperatorType
     */
    protected FilterOperatorType toEntity(Object[] row)
    {
        FilterOperatorType target = null;
        if (row != null)
        {
            final int numberOfObjects = row.length;
            for (int ctr = 0; ctr < numberOfObjects; ctr++)
            {
                final Object object = row[ctr];
                if (object instanceof FilterOperatorType)
                {
                    target = (FilterOperatorType)object;
                    break;
                }
            }
        }
        return target;
    }

    /**
     * Gets the current <code>principal</code> if one has been set,
     * otherwise returns <code>null</code>.
     *
     * @return the current principal
     */
    protected Principal getPrincipal()
    {
        return PrincipalStore.get();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings({ "unchecked" })
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search)
    {
        try
        {
            search.setPageNumber(pageNumber);
            search.setPageSize(pageSize);
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), FilterOperatorTypeImpl.class, search);
            final List results = propertySearch.executeAsList();
            this.transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), propertySearch.getTotalCount());
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search)
    {
        return this.search(FilterOperatorTypeDao.TRANSFORM_NONE, pageNumber, pageSize, search);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Set<?> search(final int transform, final Search search)
    {
        try
        {
            final PropertySearch propertySearch = new PropertySearch(
                this.getSession(), FilterOperatorTypeImpl.class, search);
            final Set<?> results = propertySearch.executeAsSet();
            this.transformEntities(transform, results);
            return results;
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings("unchecked")
    public Set<FilterOperatorType> search(final Search search)
    {
        return (Set<FilterOperatorType>) this.search(FilterOperatorTypeDao.TRANSFORM_NONE, search);
    }

    /**
     * Executes and returns the given Hibernate queryObject as a {@link PaginationResult} instance.
     * @param queryObject
     * @param transform
     * @param pageNumber
     * @param pageSize
     * @return PaginationResult
     */
    @SuppressWarnings({ "unchecked" })
    protected PaginationResult getPaginationResult(
        final Query queryObject,
        final int transform, int pageNumber, int pageSize)
    {
        try
        {
            final ScrollableResults scrollableResults = queryObject.scroll();
            scrollableResults.last();
            int totalCount = scrollableResults.getRowNumber();
            totalCount = totalCount >= 0 ? totalCount + 1 : 0;
            if (pageNumber > 0 && pageSize > 0)
            {
                queryObject.setFirstResult(this.calculateFirstResult(pageNumber, pageSize));
                queryObject.setMaxResults(pageSize);
            }
            // Unchecked transformation because Set object is reused, cannot be strongly typed.
            Set results = new LinkedHashSet(queryObject.list());
            transformEntities(transform, results);
            return new PaginationResult(results.toArray(new Object[results.size()]), totalCount);
        }
        catch (HibernateException ex)
        {
            throw ex; /*super.convertHibernateAccessException(ex);*/
        }
    }

    // spring-hibernate-dao-base merge-point
}