// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system.rule;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Cette table permet de conserver les fonctions de contrôle
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Function
    implements Serializable, Comparable<Function>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -6054206330509848492L;

    // Generate 5 attributes
    private Integer functionId;

    /**
     * Identifiant unique de la fonction
     * @return this.functionId Integer
     */
    public Integer getFunctionId()
    {
        return this.functionId;
    }

    /**
     * Identifiant unique de la fonction
     * @param functionIdIn Integer
     */
    public void setFunctionId(Integer functionIdIn)
    {
        this.functionId = functionIdIn;
    }

    private String functionNm;

    /**
     * Libellé de la fonction
     * @return this.functionNm String
     */
    public String getFunctionNm()
    {
        return this.functionNm;
    }

    /**
     * Libellé de la fonction
     * @param functionNmIn String
     */
    public void setFunctionNm(String functionNmIn)
    {
        this.functionNm = functionNmIn;
    }

    private String functionJavaFunctionClass;

    /**
     * Nom de la classe Java fournissant le code de la fonction : identifiant unique
     * @return this.functionJavaFunctionClass String
     */
    public String getFunctionJavaFunctionClass()
    {
        return this.functionJavaFunctionClass;
    }

    /**
     * Nom de la classe Java fournissant le code de la fonction : identifiant unique
     * @param functionJavaFunctionClassIn String
     */
    public void setFunctionJavaFunctionClass(String functionJavaFunctionClassIn)
    {
        this.functionJavaFunctionClass = functionJavaFunctionClassIn;
    }

    private Date functionCreationDt;

    /**
     * Date de création de la fonction
     * @return this.functionCreationDt Date
     */
    public Date getFunctionCreationDt()
    {
        return this.functionCreationDt;
    }

    /**
     * Date de création de la fonction
     * @param functionCreationDtIn Date
     */
    public void setFunctionCreationDt(Date functionCreationDtIn)
    {
        this.functionCreationDt = functionCreationDtIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 2 associations
    private Collection<FunctionParameter> functionParameters = new HashSet<FunctionParameter>();

    /**
     * Cette table permet de conserver les paramètres des fonctions de contrôle
     * @return this.functionParameters Collection<FunctionParameter>
     */
    public Collection<FunctionParameter> getFunctionParameters()
    {
        return this.functionParameters;
    }

    /**
     * Cette table permet de conserver les paramètres des fonctions de contrôle
     * @param functionParametersIn Collection<FunctionParameter>
     */
    public void setFunctionParameters(Collection<FunctionParameter> functionParametersIn)
    {
        this.functionParameters = functionParametersIn;
    }

    /**
     * Cette table permet de conserver les paramètres des fonctions de contrôle
     * @param elementToAdd FunctionParameter
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addFunctionParameters(FunctionParameter elementToAdd)
    {
        return this.functionParameters.add(elementToAdd);
    }

    /**
     * Cette table permet de conserver les paramètres des fonctions de contrôle
     * @param elementToRemove FunctionParameter
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeFunctionParameters(FunctionParameter elementToRemove)
    {
        return this.functionParameters.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an Function instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Function))
        {
            return false;
        }
        final Function that = (Function)object;
        if (this.functionId == null || that.getFunctionId() == null || !this.functionId.equals(that.getFunctionId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.functionId == null ? 0 : this.functionId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Function}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Function}.
         * @return new FunctionImpl()
         */
        public static Function newInstance()
        {
            return new FunctionImpl();
        }

        /**
         * Constructs a new instance of {@link Function}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param functionNm String
         * @param functionJavaFunctionClass String
         * @param functionCreationDt Date
         * @return newInstance
         */
        public static Function newInstance(String functionNm, String functionJavaFunctionClass, Date functionCreationDt)
        {
            final Function entity = new FunctionImpl();
            entity.setFunctionNm(functionNm);
            entity.setFunctionJavaFunctionClass(functionJavaFunctionClass);
            entity.setFunctionCreationDt(functionCreationDt);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Function}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param functionNm String
         * @param functionJavaFunctionClass String
         * @param functionCreationDt Date
         * @param updateDt Timestamp
         * @param functionParameters Collection<FunctionParameter>
         * @return newInstance Function
         */
        public static Function newInstance(String functionNm, String functionJavaFunctionClass, Date functionCreationDt, Timestamp updateDt, Collection<FunctionParameter> functionParameters)
        {
            final Function entity = new FunctionImpl();
            entity.setFunctionNm(functionNm);
            entity.setFunctionJavaFunctionClass(functionJavaFunctionClass);
            entity.setFunctionCreationDt(functionCreationDt);
            entity.setUpdateDt(updateDt);
            entity.setFunctionParameters(functionParameters);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Function o)
    {
        int cmp = 0;
        if (this.getFunctionId() != null)
        {
            cmp = this.getFunctionId().compareTo(o.getFunctionId());
        }
        else
        {
            if (this.getFunctionNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFunctionNm().compareTo(o.getFunctionNm()));
            }
            if (this.getFunctionJavaFunctionClass() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFunctionJavaFunctionClass().compareTo(o.getFunctionJavaFunctionClass()));
            }
            if (this.getFunctionCreationDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFunctionCreationDt().compareTo(o.getFunctionCreationDt()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Function.java merge-point
}