// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system.rule;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.vo.system.rule.RuleVO;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Cette table permet de conserver les règles de contrôle
 * @see Rule
 */
public interface RuleDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Rule}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link RuleVO}.
     */
    public static final int TRANSFORM_RULEVO = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toRuleVO(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toRuleVO(
        Rule source,
        RuleVO target);

    /**
     * Converts this DAO's entity to an object of type {@link RuleVO}.
     * @param entity
     * @return RuleVO
     */
    public RuleVO toRuleVO(Rule entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link RuleVO}.
     * @param entities
     */
    public Collection<RuleVO> toRuleVOCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link RuleVO}.
     * @param entities
     * @return RuleVO[]
     */
    public RuleVO[] toRuleVOArray(Collection<?> entities);

    /**
     * Copies the fields of {@link RuleVO} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void ruleVOToEntity(
        RuleVO source,
        Rule target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link RuleVO} to this DAO's entity.
     * @param ruleVO
     * @return Rule
     */
    public Rule ruleVOToEntity(RuleVO ruleVO);

    /**
     * Converts a Collection of instances of type {@link RuleVO} to this
     * DAO's entity.
     * @param instances
     */
    public void ruleVOToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of Rule from the persistent store.
     * @param ruleCd
     * @return Rule
     */
    public Rule get(String ruleCd);

    /**
     * <p>
     * Does the same thing as {@link #get(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param ruleCd the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, String ruleCd);

    /**
     * Loads an instance of Rule from the persistent store.
     * @param ruleCd
     * @return Rule
     */
    public Rule load(String ruleCd);

    /**
     * <p>
     * Does the same thing as {@link #load(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param ruleCd the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, String ruleCd);

    /**
     * Loads all entities of type {@link Rule}.
     *
     * @return the loaded entities.
     */
    public Collection<Rule> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Rule and adds it to the persistent store.
     * @param rule
     * @return Rule
     */
    public Rule create(Rule rule);

    /**
     * <p>
     * Does the same thing as {@link #create(Rule)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param rule
     * @return Object
     */
    public Object create(int transform, Rule rule);

    /**
     * Creates a new instance of Rule and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Rule
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Rule> create(Collection<Rule> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Rule)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Rule> entities);

    /**
     * <p>
     * Creates a new <code>Rule</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param ruleControledAttribut Attribut de l'élément contrôlé
     * @param ruleDc Description de la règle
     * @param ruleIsActive Indique si la règle est active ou non
     * @param ruleIsBlocking Indique si le non respect de la règle est bloquant ou non
     * @param ruleErrorMsg Message d'erreur renvoyé si la règle n'est pas respectée
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return Rule
     */
    public Rule create(
        String ruleControledAttribut,
        String ruleDc,
        String ruleIsActive,
        String ruleIsBlocking,
        String ruleErrorMsg,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, String, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param ruleControledAttribut Attribut de l'élément contrôlé
     * @param ruleDc Description de la règle
     * @param ruleIsActive Indique si la règle est active ou non
     * @param ruleIsBlocking Indique si le non respect de la règle est bloquant ou non
     * @param ruleErrorMsg Message d'erreur renvoyé si la règle n'est pas respectée
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return Rule
     */
    public Object create(
        int transform,
        String ruleControledAttribut,
        String ruleDc,
        String ruleIsActive,
        String ruleIsBlocking,
        String ruleErrorMsg,
        Timestamp updateDt);

    /**
     * <p>
     * Creates a new <code>Rule</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param ruleControledAttribut
     * @param function
     * @return Rule
     */
    public Rule create(
        String ruleControledAttribut,
        Function function);

    /**
     * <p>
     * Does the same thing as {@link #create(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param ruleControledAttribut
     * @param function
     * @return Object
     */
    public Object create(
        int transform,
        String ruleControledAttribut,
        Function function);

    /**
     * Updates the <code>rule</code> instance in the persistent store.
     * @param rule
     */
    public void update(Rule rule);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Rule> entities);

    /**
     * Removes the instance of Rule from the persistent store.
     * @param rule
     */
    public void remove(Rule rule);

    /**
     * Removes the instance of Rule having the given
     * <code>identifier</code> from the persistent store.
     * @param ruleCd
     */
    public void remove(String ruleCd);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Rule> entities);

    /**
     * 
     * @param rule 
     * @param updateDt 
     * @return RuleVO
     */
    public RuleVO save(RuleVO rule, Timestamp updateDt);

    /**
     * 
     * @param ruleCds 
     * @return void
     */
    public void removeByCds(String[] ruleCds);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Rule> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.system.rule.RuleDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link Rule} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link RuleVO} - {@link #TRANSFORM_RULEVO}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.system.rule.RuleDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Rule entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Rule)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.system.rule.RuleDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Rule)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}