// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system.rule;

import fr.ifremer.quadrige3.core.dao.Search;
import fr.ifremer.quadrige3.core.dao.referential.Status;
import fr.ifremer.quadrige3.core.vo.system.rule.RuleListVO;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Cette table permet de conserver les listes de règles de contrôle
 * @see RuleList
 */
public interface RuleListDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link RuleList}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link RuleListVO}.
     */
    public static final int TRANSFORM_RULELISTVO = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toRuleListVO(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toRuleListVO(
        RuleList source,
        RuleListVO target);

    /**
     * Converts this DAO's entity to an object of type {@link RuleListVO}.
     * @param entity
     * @return RuleListVO
     */
    public RuleListVO toRuleListVO(RuleList entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link RuleListVO}.
     * @param entities
     */
    public Collection<RuleListVO> toRuleListVOCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link RuleListVO}.
     * @param entities
     * @return RuleListVO[]
     */
    public RuleListVO[] toRuleListVOArray(Collection<?> entities);

    /**
     * Copies the fields of {@link RuleListVO} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void ruleListVOToEntity(
        RuleListVO source,
        RuleList target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link RuleListVO} to this DAO's entity.
     * @param ruleListVO
     * @return RuleList
     */
    public RuleList ruleListVOToEntity(RuleListVO ruleListVO);

    /**
     * Converts a Collection of instances of type {@link RuleListVO} to this
     * DAO's entity.
     * @param instances
     */
    public void ruleListVOToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of RuleList from the persistent store.
     * @param ruleListCd
     * @return RuleList
     */
    public RuleList get(String ruleListCd);

    /**
     * <p>
     * Does the same thing as {@link #get(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param ruleListCd the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, String ruleListCd);

    /**
     * Loads an instance of RuleList from the persistent store.
     * @param ruleListCd
     * @return RuleList
     */
    public RuleList load(String ruleListCd);

    /**
     * <p>
     * Does the same thing as {@link #load(String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param ruleListCd the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, String ruleListCd);

    /**
     * Loads all entities of type {@link RuleList}.
     *
     * @return the loaded entities.
     */
    public Collection<RuleList> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of RuleList and adds it to the persistent store.
     * @param ruleList
     * @return RuleList
     */
    public RuleList create(RuleList ruleList);

    /**
     * <p>
     * Does the same thing as {@link #create(RuleList)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param ruleList
     * @return Object
     */
    public Object create(int transform, RuleList ruleList);

    /**
     * Creates a new instance of RuleList and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of RuleList
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<RuleList> create(Collection<RuleList> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(RuleList)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<RuleList> entities);

    /**
     * <p>
     * Creates a new <code>RuleList</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param ruleListDc Description de la liste de règle de contrôle
     * @param ruleListIsActive Indique si la règle est active ou non
     * @param ruleListFirstMonth Mois de début d'application de la liste de règles
     * @param ruleListLastMonth Mois de fin d'application de la liste de règles
     * @param ruleListCreationDt Date de création de la liste de règle
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return RuleList
     */
    public RuleList create(
        String ruleListDc,
        String ruleListIsActive,
        Date ruleListFirstMonth,
        Date ruleListLastMonth,
        Date ruleListCreationDt,
        Timestamp updateDt);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Date, Date, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param ruleListDc Description de la liste de règle de contrôle
     * @param ruleListIsActive Indique si la règle est active ou non
     * @param ruleListFirstMonth Mois de début d'application de la liste de règles
     * @param ruleListLastMonth Mois de fin d'application de la liste de règles
     * @param ruleListCreationDt Date de création de la liste de règle
     * @param updateDt Date de modification de l'objet, mise à jour par le système
     * @return RuleList
     */
    public Object create(
        int transform,
        String ruleListDc,
        String ruleListIsActive,
        Date ruleListFirstMonth,
        Date ruleListLastMonth,
        Date ruleListCreationDt,
        Timestamp updateDt);

    /**
     * <p>
     * Creates a new <code>RuleList</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param ruleListDc
     * @param ruleListIsActive
     * @param status
     * @return RuleList
     */
    public RuleList create(
        String ruleListDc,
        String ruleListIsActive,
        Status status);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param ruleListDc
     * @param ruleListIsActive
     * @param status
     * @return Object
     */
    public Object create(
        int transform,
        String ruleListDc,
        String ruleListIsActive,
        Status status);

    /**
     * Updates the <code>ruleList</code> instance in the persistent store.
     * @param ruleList
     */
    public void update(RuleList ruleList);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<RuleList> entities);

    /**
     * Removes the instance of RuleList from the persistent store.
     * @param ruleList
     */
    public void remove(RuleList ruleList);

    /**
     * Removes the instance of RuleList having the given
     * <code>identifier</code> from the persistent store.
     * @param ruleListCd
     */
    public void remove(String ruleListCd);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<RuleList> entities);

    /**
     * 
     * @param ruleList 
     * @return RuleListVO
     */
    public RuleListVO save(RuleListVO ruleList);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<RuleList> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige3.core.dao.system.rule.RuleListDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link RuleList} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link RuleListVO} - {@link #TRANSFORM_RULELISTVO}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige3.core.dao.system.rule.RuleListDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final RuleList entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,RuleList)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige3.core.dao.system.rule.RuleListDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,RuleList)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}