// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.system.rule;

import fr.ifremer.quadrige3.core.dao.referential.Unit;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Fraction;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Matrix;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Method;
import fr.ifremer.quadrige3.core.dao.referential.pmfm.Parameter;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Cette table permet de conserver les PMFM concernés par une règle de contrôle
 */
// HibernateEntity.vsl annotations merge-point
public abstract class RulePmfm
    implements Serializable, Comparable<RulePmfm>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 568638865095291051L;

    // Generate 2 attributes
    private Integer rulePmfmId;

    /**
     * Identifiant unique du paramètre_PMFM de la règle de contrôle
     * @return this.rulePmfmId Integer
     */
    public Integer getRulePmfmId()
    {
        return this.rulePmfmId;
    }

    /**
     * Identifiant unique du paramètre_PMFM de la règle de contrôle
     * @param rulePmfmIdIn Integer
     */
    public void setRulePmfmId(Integer rulePmfmIdIn)
    {
        this.rulePmfmId = rulePmfmIdIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 6 associations
    private Unit unit;

    /**
     * Liste l'ensemble des unités de mesure.
     * @return this.unit Unit
     */
    public Unit getUnit()
    {
        return this.unit;
    }

    /**
     * Liste l'ensemble des unités de mesure.
     * @param unitIn Unit
     */
    public void setUnit(Unit unitIn)
    {
        this.unit = unitIn;
    }

    private Matrix matrix;

    /**
     * Support utilisé pour mesurer un paramètre.
     * @return this.matrix Matrix
     */
    public Matrix getMatrix()
    {
        return this.matrix;
    }

    /**
     * Support utilisé pour mesurer un paramètre.
     * @param matrixIn Matrix
     */
    public void setMatrix(Matrix matrixIn)
    {
        this.matrix = matrixIn;
    }

    private Method method;

    /**
     * Méthode utilisée pour mesurer un paramètre.
     * @return this.method Method
     */
    public Method getMethod()
    {
        return this.method;
    }

    /**
     * Méthode utilisée pour mesurer un paramètre.
     * @param methodIn Method
     */
    public void setMethod(Method methodIn)
    {
        this.method = methodIn;
    }

    private Parameter parameter;

    /**
     * Liste les différents paramètres mesurés. Attention, voir PARAMETRE SISMER.
     * @return this.parameter Parameter
     */
    public Parameter getParameter()
    {
        return this.parameter;
    }

    /**
     * Liste les différents paramètres mesurés. Attention, voir PARAMETRE SISMER.
     * @param parameterIn Parameter
     */
    public void setParameter(Parameter parameterIn)
    {
        this.parameter = parameterIn;
    }

    private Fraction fraction;

    /**
     * Liste les fractions (compléter la description).
     * @return this.fraction Fraction
     */
    public Fraction getFraction()
    {
        return this.fraction;
    }

    /**
     * Liste les fractions (compléter la description).
     * @param fractionIn Fraction
     */
    public void setFraction(Fraction fractionIn)
    {
        this.fraction = fractionIn;
    }

    private Rule rule;

    /**
     * Cette table permet de conserver les règles de contrôle
     * @return this.rule Rule
     */
    public Rule getRule()
    {
        return this.rule;
    }

    /**
     * Cette table permet de conserver les règles de contrôle
     * @param ruleIn Rule
     */
    public void setRule(Rule ruleIn)
    {
        this.rule = ruleIn;
    }

    /**
     * Returns <code>true</code> if the argument is an RulePmfm instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof RulePmfm))
        {
            return false;
        }
        final RulePmfm that = (RulePmfm)object;
        if (this.rulePmfmId == null || that.getRulePmfmId() == null || !this.rulePmfmId.equals(that.getRulePmfmId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.rulePmfmId == null ? 0 : this.rulePmfmId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link RulePmfm}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link RulePmfm}.
         * @return new RulePmfmImpl()
         */
        public static RulePmfm newInstance()
        {
            return new RulePmfmImpl();
        }

        /**
         * Constructs a new instance of {@link RulePmfm}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param parameter Parameter
         * @param rule Rule
         * @return newInstance
         */
        public static RulePmfm newInstance(Parameter parameter, Rule rule)
        {
            final RulePmfm entity = new RulePmfmImpl();
            entity.setParameter(parameter);
            entity.setRule(rule);
            return entity;
        }

        /**
         * Constructs a new instance of {@link RulePmfm}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDt Timestamp
         * @param unit Unit
         * @param matrix Matrix
         * @param method Method
         * @param parameter Parameter
         * @param fraction Fraction
         * @param rule Rule
         * @return newInstance RulePmfm
         */
        public static RulePmfm newInstance(Timestamp updateDt, Unit unit, Matrix matrix, Method method, Parameter parameter, Fraction fraction, Rule rule)
        {
            final RulePmfm entity = new RulePmfmImpl();
            entity.setUpdateDt(updateDt);
            entity.setUnit(unit);
            entity.setMatrix(matrix);
            entity.setMethod(method);
            entity.setParameter(parameter);
            entity.setFraction(fraction);
            entity.setRule(rule);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(RulePmfm o)
    {
        int cmp = 0;
        if (this.getRulePmfmId() != null)
        {
            cmp = this.getRulePmfmId().compareTo(o.getRulePmfmId());
        }
        else
        {
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// RulePmfm.java merge-point
}