/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
// Attention: Generated code! Do not modify by hand!
// Generated by: TypeSafeEnumeration.vsl in andromda-java-cartridge.
// Model Class:  Données::fr.ifremer.quadrige3.core::dao::system::synchronization::SynchronizationStatus
// Metafacade:   org.andromda.metafacades.uml.Enumeration
// Stereotype:  Enumeration
//
package fr.ifremer.quadrige3.core.dao.system.synchronization;

import fr.ifremer.quadrige3.core.dao.technical.QuadrigeEnumerationDef;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import static org.nuiton.i18n.I18n.n;

/**
 * 
 */
public enum SynchronizationStatus
    implements Serializable, QuadrigeEnumerationDef<String>
{
    DIRTY (
			"quadrige3.enumeration.SynchronizationStatus.DIRTY",
			n("quadrige3.enumeration.SynchronizationStatus.DIRTY.description"),
			"DIRTY"),
    READY_TO_SYNCHRONIZE (
			"quadrige3.enumeration.SynchronizationStatus.READY_TO_SYNCHRONIZE",
			n("quadrige3.enumeration.SynchronizationStatus.READY_TO_SYNCHRONIZE.description"),
			"READY_TO_SYNC"),
    SYNCHRONIZED (
			"quadrige3.enumeration.SynchronizationStatus.SYNCHRONIZED",
			n("quadrige3.enumeration.SynchronizationStatus.SYNCHRONIZED.description"),
			"SYNC"),
    DELETED (
			"quadrige3.enumeration.SynchronizationStatus.DELETED",
			n("quadrige3.enumeration.SynchronizationStatus.DELETED.description"),
			"DELETED"),
    SYNCHRONIZED_WITH_FILE (
			"quadrige3.enumeration.SynchronizationStatus.SYNCHRONIZED_WITH_FILE",
			n("quadrige3.enumeration.SynchronizationStatus.SYNCHRONIZED_WITH_FILE.description"),
			"FILE_SYNC");

    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1745703674816445465L;

    private String key;
    private String description;
    private String enumValue;

    /**
     * The constructor with enumeration literal value allowing
     * super classes to access it.
     */
    private SynchronizationStatus(String key, String description, String value)
    {
    	this.key = key;
    	this.description = description;
        this.enumValue = value;
    }
    
    @Override
     /**
      * Setter for value. Use to override value, from configuration
      */
     public void setValue(String newValue) {
		if (newValue != null && !this.enumValue.equals(newValue)) {
			// Update static lists
	    	values.remove(this.enumValue);
	    	literals.remove(this.enumValue);
	    	this.enumValue = newValue;
	    	values.put(this.enumValue, this);
	    	literals.add(this.enumValue);
		}
    }
    

    @Override
    public String getValueAsString()
    {
        return String.valueOf(this.enumValue);
    }

    /**
     * Retrieves an instance of SynchronizationStatus from <code>its name</code>.
     *
     * @param name the name to create the SynchronizationStatus from.
     * @return The enumeration literal named after the 'name' argument
     */
    public static SynchronizationStatus fromString(String name)
    {
        return SynchronizationStatus.valueOf(name);
    }

    /**
     * Returns an enumeration literal String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @return String with corresponding value
     */
    public String value()
    {
        return this.enumValue;
    }

    /**
     * Returns an instance of SynchronizationStatus from String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @param value the value to create the SynchronizationStatus from.
     * @return static Enumeration with corresponding value
     */
    public static SynchronizationStatus fromValue(String value)
    {
        for (SynchronizationStatus enumName: SynchronizationStatus.values())
        {
            if (enumName.getValue().equals(value))
            {
                return enumName;
            }
        }
        throw new IllegalArgumentException("SynchronizationStatus.fromValue(" + value + ')');
    }

    /**
     * Gets the underlying value of this type safe enumeration.
     * This method is necessary to comply with DaoBase implementation.
     * @return The name of this literal.
     */
    public String getValue()
    {
        return this.enumValue;
    }
    
    @Override
    public String getDescription() {
    	return description;
    }
    
    @Override
    public String getKey() {
    	return key;
    }
    
    @Override
    public Class<?> getType() {
    	return String.class;
    }
    
    /**
     * Returns an unmodifiable list containing the literals that are known by this enumeration.
     *
     * @return A List containing the actual literals defined by this enumeration, this list
     *         can not be modified.
     */
    public static List<String> literals()
    {
        return SynchronizationStatus.literals;
    }

    /**
     * Returns an unmodifiable list containing the names of the literals that are known
     * by this enumeration.
     *
     * @return A List containing the actual names of the literals defined by this
     *         enumeration, this list can not be modified.
     */
    public static List<String> names()
    {
        return SynchronizationStatus.names;
    }

    private static Map<String, SynchronizationStatus> values = new LinkedHashMap<String, SynchronizationStatus>(5, 1);
    private static List<String> literals = new ArrayList<String>(5);
    private static List<String> names = new ArrayList<String>(5);
    private static List<SynchronizationStatus> valueList = new ArrayList<SynchronizationStatus>(5);

    /**
     * Initializes the values.
     */
    static
    {
        synchronized (SynchronizationStatus.values)
        {
            SynchronizationStatus.values.put(DIRTY.enumValue, DIRTY);
            SynchronizationStatus.values.put(READY_TO_SYNCHRONIZE.enumValue, READY_TO_SYNCHRONIZE);
            SynchronizationStatus.values.put(SYNCHRONIZED.enumValue, SYNCHRONIZED);
            SynchronizationStatus.values.put(DELETED.enumValue, DELETED);
            SynchronizationStatus.values.put(SYNCHRONIZED_WITH_FILE.enumValue, SYNCHRONIZED_WITH_FILE);
        }
        synchronized (SynchronizationStatus.valueList)
        {
            SynchronizationStatus.valueList.add(DIRTY);
            SynchronizationStatus.valueList.add(READY_TO_SYNCHRONIZE);
            SynchronizationStatus.valueList.add(SYNCHRONIZED);
            SynchronizationStatus.valueList.add(DELETED);
            SynchronizationStatus.valueList.add(SYNCHRONIZED_WITH_FILE);
            // For Quadrige3, lists could be reload from configuration (see method 'setValue')
            //SynchronizationStatus.valueList = Collections.unmodifiableList(valueList);
        }
        synchronized (SynchronizationStatus.literals)
        {
            SynchronizationStatus.literals.add(DIRTY.enumValue);
            SynchronizationStatus.literals.add(READY_TO_SYNCHRONIZE.enumValue);
            SynchronizationStatus.literals.add(SYNCHRONIZED.enumValue);
            SynchronizationStatus.literals.add(DELETED.enumValue);
            SynchronizationStatus.literals.add(SYNCHRONIZED_WITH_FILE.enumValue);
            // For Quadrige3, lists could be reload from configuration (see method 'setValue')
            //SynchronizationStatus.literals = Collections.unmodifiableList(literals);
        }
        synchronized (SynchronizationStatus.names)
        {
            SynchronizationStatus.names.add("DIRTY");
            SynchronizationStatus.names.add("READY_TO_SYNCHRONIZE");
            SynchronizationStatus.names.add("SYNCHRONIZED");
            SynchronizationStatus.names.add("DELETED");
            SynchronizationStatus.names.add("SYNCHRONIZED_WITH_FILE");
            SynchronizationStatus.names = Collections.unmodifiableList(names);
        }
    }
    // type-safe-enumeration-object java merge-point
}