/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
/**
 * @author Generated on 02/06/2020 14:13:42+0100 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige3.core::vo::administration::program::ProgQuserProgPrivVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige3.core.vo.administration.program;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Liste des droits d'un utilisateur pour un programme particulier.
 */
public class ProgQuserProgPrivVO
    implements Serializable, Comparable<ProgQuserProgPrivVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = -448276901258779096L;

    // Class attributes
    /**
     * Date de modification de l'objet, mise à jour par le système
     */
    protected Timestamp updateDt;
    /**
     * Identifiant interne d'un agent
     */
    protected Integer quserId;
    /**
     * Identifiant du privilège (droit) sur les programmes
     */
    protected Integer progPrivId;
    /** TODO: Model Documentation for attribute progCd */
    protected String progCd;

    // Class associationEnds
    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     */
    protected ProgramVO programVO;

    /** Default Constructor with no properties */
    public ProgQuserProgPrivVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param quserIdIn Integer Identifiant interne d'un agent
     * @param progPrivIdIn Integer Identifiant du privilège (droit) sur les programmes
     * @param progCdIn String
     * @param programVOIn ProgramVO Activités à l'origine de la collecte d'un ensemble cohérent de données.
     */
    public ProgQuserProgPrivVO(final Integer quserIdIn, final Integer progPrivIdIn, final String progCdIn, final ProgramVO programVOIn)
    {
        this.quserId = quserIdIn;
        this.progPrivId = progPrivIdIn;
        this.progCd = progCdIn;
        this.programVO = programVOIn;
    }

    /**
     * Constructor with all properties
     * @param updateDtIn Timestamp
     * @param quserIdIn Integer
     * @param progPrivIdIn Integer
     * @param progCdIn String
     * @param programVOIn ProgramVO
     */
    public ProgQuserProgPrivVO(final Timestamp updateDtIn, final Integer quserIdIn, final Integer progPrivIdIn, final String progCdIn, final ProgramVO programVOIn)
    {
        this.updateDt = updateDtIn;
        this.quserId = quserIdIn;
        this.progPrivId = progPrivIdIn;
        this.progCd = progCdIn;
        this.programVO = programVOIn;
    }

    /**
     * Copies constructor from other ProgQuserProgPrivVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public ProgQuserProgPrivVO(final ProgQuserProgPrivVO otherBean)
    {
        this.updateDt = otherBean.getUpdateDt();
        this.quserId = otherBean.getQuserId();
        this.progPrivId = otherBean.getProgPrivId();
        this.progCd = otherBean.getProgCd();
        this.programVO = otherBean.getProgramVO();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final ProgQuserProgPrivVO otherBean)
    {
        if (null != otherBean)
        {
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setQuserId(otherBean.getQuserId());
            this.setProgPrivId(otherBean.getProgPrivId());
            this.setProgCd(otherBean.getProgCd());
            this.setProgramVO(otherBean.getProgramVO());
        }
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * Identifiant interne d'un agent
     * Get the quserId Attribute
     * @return quserId Integer
     */
    public Integer getQuserId()
    {
        return this.quserId;
    }

    /**
     * Identifiant interne d'un agent
     * @param value Integer
     */
    public void setQuserId(final Integer value)
    {
        this.quserId = value;
    }

    /**
     * Identifiant du privilège (droit) sur les programmes
     * Get the progPrivId Attribute
     * @return progPrivId Integer
     */
    public Integer getProgPrivId()
    {
        return this.progPrivId;
    }

    /**
     * Identifiant du privilège (droit) sur les programmes
     * @param value Integer
     */
    public void setProgPrivId(final Integer value)
    {
        this.progPrivId = value;
    }

    /**
     * TODO: Model Documentation for attribute progCd
     * Get the progCd Attribute
     * @return progCd String
     */
    public String getProgCd()
    {
        return this.progCd;
    }

    /**
     * 
     * @param value String
     */
    public void setProgCd(final String value)
    {
        this.progCd = value;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * Get the programVO Association
     * @return this.programVO ProgramVO
     */
    public ProgramVO getProgramVO()
    {
        return this.programVO;
    }

    /**
     * Sets the programVO
     * @param value ProgramVO
     */
    public void setProgramVO(ProgramVO value)
    {
        this.programVO = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        ProgQuserProgPrivVO rhs = (ProgQuserProgPrivVO) object;
        return new EqualsBuilder()
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getQuserId(), rhs.getQuserId())
            .append(this.getProgPrivId(), rhs.getProgPrivId())
            .append(this.getProgCd(), rhs.getProgCd())
            .append(this.getProgramVO(), rhs.getProgramVO())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final ProgQuserProgPrivVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getQuserId(), object.getQuserId())
            .append(this.getProgPrivId(), object.getProgPrivId())
            .append(this.getProgCd(), object.getProgCd())
            .append(this.getProgramVO(), object.getProgramVO())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getUpdateDt())
            .append(this.getQuserId())
            .append(this.getProgPrivId())
            .append(this.getProgCd())
            .append(this.getProgramVO())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("updateDt", this.getUpdateDt())
            .append("quserId", this.getQuserId())
            .append("progPrivId", this.getProgPrivId())
            .append("progCd", this.getProgCd())
            .append("programVO", this.getProgramVO())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // ProgQuserProgPrivVO value-object java merge-point
}