/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
/**
 * @author Generated on 02/06/2020 14:13:42+0100 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige3.core::vo::administration::program::ProgramVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige3.core.vo.administration.program;

import fr.ifremer.quadrige3.core.vo.administration.strategy.StrategyVO;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.Date;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Activités à l'origine de la collecte d'un ensemble cohérent de données.
 */
public class ProgramVO
    implements Serializable, Comparable<ProgramVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = 1403327231457432196L;

    // Class attributes
    /**
     * Code unique du programme
     */
    protected String progCd;
    /**
     * Libellé du programme
     */
    protected String progNm;
    /**
     * Description du programme
     */
    protected String progDc;
    /**
     * Date de création de l'objet
     */
    protected Date progCreationDt;
    /**
     * Date de mise à jour de l'objet
     */
    protected Timestamp updateDt;
    /**
     * Code de l'état de l'objet (actif ou inactif)
     */
    protected String statusCd;
    /** TODO: Model Documentation for attribute isDepartmentHermetic */
    protected String isDepartmentHermetic;

    // Class associationEnds
    /**
     * Définie les paramètres à mesurer dans un programme particulier.
     */
    protected StrategyVO[] strategyVOs;

    /**
     * Liste des lieux surveillés par un programme.
     */
    protected MonLocProgVO[] monLocProgVOs;

    /**
     * Liste des droits d'un service pour un programme particulier.
     */
    protected ProgDepProgPrivVO[] progDepProgPrivVOs;

    /**
     * Liste des droits d'un utilisateur pour un programme particulier.
     */
    protected ProgQuserProgPrivVO[] progQuserProgPrivVOs;

    /** Default Constructor with no properties */
    public ProgramVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param progCdIn String Code unique du programme
     * @param progNmIn String Libellé du programme
     * @param statusCdIn String Code de l'état de l'objet (actif ou inactif)
     * @param isDepartmentHermeticIn String
     */
    public ProgramVO(final String progCdIn, final String progNmIn, final String statusCdIn, final String isDepartmentHermeticIn)
    {
        this.progCd = progCdIn;
        this.progNm = progNmIn;
        this.statusCd = statusCdIn;
        this.isDepartmentHermetic = isDepartmentHermeticIn;
    }

    /**
     * Constructor with all properties
     * @param progCdIn String
     * @param progNmIn String
     * @param progDcIn String
     * @param progCreationDtIn Date
     * @param updateDtIn Timestamp
     * @param statusCdIn String
     * @param isDepartmentHermeticIn String
     * @param strategyVOsIn StrategyVO[]
     * @param monLocProgVOsIn MonLocProgVO[]
     * @param progDepProgPrivVOsIn ProgDepProgPrivVO[]
     * @param progQuserProgPrivVOsIn ProgQuserProgPrivVO[]
     */
    public ProgramVO(final String progCdIn, final String progNmIn, final String progDcIn, final Date progCreationDtIn, final Timestamp updateDtIn, final String statusCdIn, final String isDepartmentHermeticIn, final StrategyVO[] strategyVOsIn, final MonLocProgVO[] monLocProgVOsIn, final ProgDepProgPrivVO[] progDepProgPrivVOsIn, final ProgQuserProgPrivVO[] progQuserProgPrivVOsIn)
    {
        this.progCd = progCdIn;
        this.progNm = progNmIn;
        this.progDc = progDcIn;
        this.progCreationDt = progCreationDtIn;
        this.updateDt = updateDtIn;
        this.statusCd = statusCdIn;
        this.isDepartmentHermetic = isDepartmentHermeticIn;
        this.strategyVOs = strategyVOsIn;
        this.monLocProgVOs = monLocProgVOsIn;
        this.progDepProgPrivVOs = progDepProgPrivVOsIn;
        this.progQuserProgPrivVOs = progQuserProgPrivVOsIn;
    }

    /**
     * Copies constructor from other ProgramVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public ProgramVO(final ProgramVO otherBean)
    {
        this.progCd = otherBean.getProgCd();
        this.progNm = otherBean.getProgNm();
        this.progDc = otherBean.getProgDc();
        this.progCreationDt = otherBean.getProgCreationDt();
        this.updateDt = otherBean.getUpdateDt();
        this.statusCd = otherBean.getStatusCd();
        this.isDepartmentHermetic = otherBean.getIsDepartmentHermetic();
        this.strategyVOs = otherBean.getStrategyVOs();
        this.monLocProgVOs = otherBean.getMonLocProgVOs();
        this.progDepProgPrivVOs = otherBean.getProgDepProgPrivVOs();
        this.progQuserProgPrivVOs = otherBean.getProgQuserProgPrivVOs();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final ProgramVO otherBean)
    {
        if (null != otherBean)
        {
            this.setProgCd(otherBean.getProgCd());
            this.setProgNm(otherBean.getProgNm());
            this.setProgDc(otherBean.getProgDc());
            this.setProgCreationDt(otherBean.getProgCreationDt());
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setStatusCd(otherBean.getStatusCd());
            this.setIsDepartmentHermetic(otherBean.getIsDepartmentHermetic());
            this.setStrategyVOs(otherBean.getStrategyVOs());
            this.setMonLocProgVOs(otherBean.getMonLocProgVOs());
            this.setProgDepProgPrivVOs(otherBean.getProgDepProgPrivVOs());
            this.setProgQuserProgPrivVOs(otherBean.getProgQuserProgPrivVOs());
        }
    }

    /**
     * Code unique du programme
     * Get the progCd Attribute
     * @return progCd String
     */
    public String getProgCd()
    {
        return this.progCd;
    }

    /**
     * Code unique du programme
     * @param value String
     */
    public void setProgCd(final String value)
    {
        this.progCd = value;
    }

    /**
     * Libellé du programme
     * Get the progNm Attribute
     * @return progNm String
     */
    public String getProgNm()
    {
        return this.progNm;
    }

    /**
     * Libellé du programme
     * @param value String
     */
    public void setProgNm(final String value)
    {
        this.progNm = value;
    }

    /**
     * Description du programme
     * Get the progDc Attribute
     * @return progDc String
     */
    public String getProgDc()
    {
        return this.progDc;
    }

    /**
     * Description du programme
     * @param value String
     */
    public void setProgDc(final String value)
    {
        this.progDc = value;
    }

    /**
     * Date de création de l'objet
     * Get the progCreationDt Attribute
     * @return progCreationDt Date
     */
    public Date getProgCreationDt()
    {
        return this.progCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param value Date
     */
    public void setProgCreationDt(final Date value)
    {
        this.progCreationDt = value;
    }

    /**
     * Date de mise à jour de l'objet
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de mise à jour de l'objet
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * Code de l'état de l'objet (actif ou inactif)
     * Get the statusCd Attribute
     * @return statusCd String
     */
    public String getStatusCd()
    {
        return this.statusCd;
    }

    /**
     * Code de l'état de l'objet (actif ou inactif)
     * @param value String
     */
    public void setStatusCd(final String value)
    {
        this.statusCd = value;
    }

    /**
     * TODO: Model Documentation for attribute isDepartmentHermetic
     * Get the isDepartmentHermetic Attribute
     * @return isDepartmentHermetic String
     */
    public String getIsDepartmentHermetic()
    {
        return this.isDepartmentHermetic;
    }

    /**
     * 
     * @param value String
     */
    public void setIsDepartmentHermetic(final String value)
    {
        this.isDepartmentHermetic = value;
    }

    /**
     * Définie les paramètres à mesurer dans un programme particulier.
     * Get the strategyVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.strategyVOs StrategyVO[]
     */
    public StrategyVO[] getStrategyVOs()
    {
        return this.strategyVOs;
    }

    /**
     * Sets the strategyVOs
     * @param value StrategyVO[]
     */
    public void setStrategyVOs(StrategyVO[] value)
    {
        this.strategyVOs = value;
    }

    /**
     * Liste des lieux surveillés par un programme.
     * Get the monLocProgVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.monLocProgVOs MonLocProgVO[]
     */
    public MonLocProgVO[] getMonLocProgVOs()
    {
        return this.monLocProgVOs;
    }

    /**
     * Sets the monLocProgVOs
     * @param value MonLocProgVO[]
     */
    public void setMonLocProgVOs(MonLocProgVO[] value)
    {
        this.monLocProgVOs = value;
    }

    /**
     * Liste des droits d'un service pour un programme particulier.
     * Get the progDepProgPrivVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.progDepProgPrivVOs ProgDepProgPrivVO[]
     */
    public ProgDepProgPrivVO[] getProgDepProgPrivVOs()
    {
        return this.progDepProgPrivVOs;
    }

    /**
     * Sets the progDepProgPrivVOs
     * @param value ProgDepProgPrivVO[]
     */
    public void setProgDepProgPrivVOs(ProgDepProgPrivVO[] value)
    {
        this.progDepProgPrivVOs = value;
    }

    /**
     * Liste des droits d'un utilisateur pour un programme particulier.
     * Get the progQuserProgPrivVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.progQuserProgPrivVOs ProgQuserProgPrivVO[]
     */
    public ProgQuserProgPrivVO[] getProgQuserProgPrivVOs()
    {
        return this.progQuserProgPrivVOs;
    }

    /**
     * Sets the progQuserProgPrivVOs
     * @param value ProgQuserProgPrivVO[]
     */
    public void setProgQuserProgPrivVOs(ProgQuserProgPrivVO[] value)
    {
        this.progQuserProgPrivVOs = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        ProgramVO rhs = (ProgramVO) object;
        return new EqualsBuilder()
            .append(this.getProgCd(), rhs.getProgCd())
            .append(this.getProgNm(), rhs.getProgNm())
            .append(this.getProgDc(), rhs.getProgDc())
            .append(this.getProgCreationDt(), rhs.getProgCreationDt())
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getStatusCd(), rhs.getStatusCd())
            .append(this.getIsDepartmentHermetic(), rhs.getIsDepartmentHermetic())
            .append(this.getStrategyVOs(), rhs.getStrategyVOs())
            .append(this.getMonLocProgVOs(), rhs.getMonLocProgVOs())
            .append(this.getProgDepProgPrivVOs(), rhs.getProgDepProgPrivVOs())
            .append(this.getProgQuserProgPrivVOs(), rhs.getProgQuserProgPrivVOs())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final ProgramVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getProgCd(), object.getProgCd())
            .append(this.getProgNm(), object.getProgNm())
            .append(this.getProgDc(), object.getProgDc())
            .append(this.getProgCreationDt(), object.getProgCreationDt())
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getStatusCd(), object.getStatusCd())
            .append(this.getIsDepartmentHermetic(), object.getIsDepartmentHermetic())
            .append(this.getStrategyVOs(), object.getStrategyVOs())
            .append(this.getMonLocProgVOs(), object.getMonLocProgVOs())
            .append(this.getProgDepProgPrivVOs(), object.getProgDepProgPrivVOs())
            .append(this.getProgQuserProgPrivVOs(), object.getProgQuserProgPrivVOs())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getProgCd())
            .append(this.getProgNm())
            .append(this.getProgDc())
            .append(this.getProgCreationDt())
            .append(this.getUpdateDt())
            .append(this.getStatusCd())
            .append(this.getIsDepartmentHermetic())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getStrategyVOs())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getMonLocProgVOs())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getProgDepProgPrivVOs())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getProgQuserProgPrivVOs())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("progCd", this.getProgCd())
            .append("progNm", this.getProgNm())
            .append("progDc", this.getProgDc())
            .append("progCreationDt", this.getProgCreationDt())
            .append("updateDt", this.getUpdateDt())
            .append("statusCd", this.getStatusCd())
            .append("isDepartmentHermetic", this.getIsDepartmentHermetic())
            .append("strategyVOs", this.getStrategyVOs())
            .append("monLocProgVOs", this.getMonLocProgVOs())
            .append("progDepProgPrivVOs", this.getProgDepProgPrivVOs())
            .append("progQuserProgPrivVOs", this.getProgQuserProgPrivVOs())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // ProgramVO value-object java merge-point
}