/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
/**
 * @author Generated on 02/06/2020 14:13:42+0100 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige3.core::vo::administration::strategy::PmfmStrategyVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige3.core.vo.administration.strategy;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * PSFM associés à une stratégie
 * PMSF associés à une stratégie.
 */
public class PmfmStrategyVO
    implements Serializable, Comparable<PmfmStrategyVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = -6922384140927931168L;

    // Class attributes
    /** TODO: Model Documentation for attribute pmfmStratId */
    protected Integer pmfmStratId;
    /**
     * Nombre de fois où un paramètre peut être saisi
     * Il est constant pour tous les niveaux de saisie, est obligatoire et par défaut prend la
     * valeur 1
     */
    protected Double pmfmStratParAcquisNumber;
    /**
     * Rang pour la presentation des résultats
     */
    protected Integer pmfmStratPresRk;
    /**
     * Indique si la saisie du paramètre se fait sur des individus
     */
    protected String pmfmStratParIsIndiv;
    /** TODO: Model Documentation for attribute pmfmStratIsUniqueByTaxon */
    protected String pmfmStratIsUniqueByTaxon;
    /**
     * Date de modification de l'objet, mise à jour par le système
     */
    protected Timestamp updateDt;
    /** TODO: Model Documentation for attribute pmfmId */
    protected Integer pmfmId;
    /**
     * Code unique de l'unité d'incertitude
     */
    protected Integer precTypeId;
    /**
     * Code du niveau de saisie
     */
    protected String[] acquisLevelCds;
    /** TODO: Model Documentation for attribute uiFunctionCds */
    protected String[] uiFunctionCds;
    /**
     * Identifiant interne de la stratégie
     */
    protected Integer stratId;

    // Class associationEnds
    /**
     * Définie les paramètres à mesurer dans un programme particulier.
     */
    protected StrategyVO strategyVO;

    /** Default Constructor with no properties */
    public PmfmStrategyVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param pmfmStratIdIn Integer
     * @param pmfmStratParAcquisNumberIn Double Nombre de fois où un paramètre peut être saisi
Il est constant pour tous les niveaux de saisie, est obligatoire et par défaut prend la valeur 1
     * @param pmfmIdIn Integer
     * @param precTypeIdIn Integer Code unique de l'unité d'incertitude
     * @param acquisLevelCdsIn String[] Code du niveau de saisie
     * @param uiFunctionCdsIn String[]
     * @param stratIdIn Integer Identifiant interne de la stratégie
     * @param strategyVOIn StrategyVO Définie les paramètres à mesurer dans un programme particulier.
     */
    public PmfmStrategyVO(final Integer pmfmStratIdIn, final Double pmfmStratParAcquisNumberIn, final Integer pmfmIdIn, final Integer precTypeIdIn, final String[] acquisLevelCdsIn, final String[] uiFunctionCdsIn, final Integer stratIdIn, final StrategyVO strategyVOIn)
    {
        this.pmfmStratId = pmfmStratIdIn;
        this.pmfmStratParAcquisNumber = pmfmStratParAcquisNumberIn;
        this.pmfmId = pmfmIdIn;
        this.precTypeId = precTypeIdIn;
        this.acquisLevelCds = acquisLevelCdsIn;
        this.uiFunctionCds = uiFunctionCdsIn;
        this.stratId = stratIdIn;
        this.strategyVO = strategyVOIn;
    }

    /**
     * Constructor with all properties
     * @param pmfmStratIdIn Integer
     * @param pmfmStratParAcquisNumberIn Double
     * @param pmfmStratPresRkIn Integer
     * @param pmfmStratParIsIndivIn String
     * @param pmfmStratIsUniqueByTaxonIn String
     * @param updateDtIn Timestamp
     * @param pmfmIdIn Integer
     * @param precTypeIdIn Integer
     * @param acquisLevelCdsIn String[]
     * @param uiFunctionCdsIn String[]
     * @param stratIdIn Integer
     * @param strategyVOIn StrategyVO
     */
    public PmfmStrategyVO(final Integer pmfmStratIdIn, final Double pmfmStratParAcquisNumberIn, final Integer pmfmStratPresRkIn, final String pmfmStratParIsIndivIn, final String pmfmStratIsUniqueByTaxonIn, final Timestamp updateDtIn, final Integer pmfmIdIn, final Integer precTypeIdIn, final String[] acquisLevelCdsIn, final String[] uiFunctionCdsIn, final Integer stratIdIn, final StrategyVO strategyVOIn)
    {
        this.pmfmStratId = pmfmStratIdIn;
        this.pmfmStratParAcquisNumber = pmfmStratParAcquisNumberIn;
        this.pmfmStratPresRk = pmfmStratPresRkIn;
        this.pmfmStratParIsIndiv = pmfmStratParIsIndivIn;
        this.pmfmStratIsUniqueByTaxon = pmfmStratIsUniqueByTaxonIn;
        this.updateDt = updateDtIn;
        this.pmfmId = pmfmIdIn;
        this.precTypeId = precTypeIdIn;
        this.acquisLevelCds = acquisLevelCdsIn;
        this.uiFunctionCds = uiFunctionCdsIn;
        this.stratId = stratIdIn;
        this.strategyVO = strategyVOIn;
    }

    /**
     * Copies constructor from other PmfmStrategyVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public PmfmStrategyVO(final PmfmStrategyVO otherBean)
    {
        this.pmfmStratId = otherBean.getPmfmStratId();
        this.pmfmStratParAcquisNumber = otherBean.getPmfmStratParAcquisNumber();
        this.pmfmStratPresRk = otherBean.getPmfmStratPresRk();
        this.pmfmStratParIsIndiv = otherBean.getPmfmStratParIsIndiv();
        this.pmfmStratIsUniqueByTaxon = otherBean.getPmfmStratIsUniqueByTaxon();
        this.updateDt = otherBean.getUpdateDt();
        this.pmfmId = otherBean.getPmfmId();
        this.precTypeId = otherBean.getPrecTypeId();
        this.acquisLevelCds = otherBean.getAcquisLevelCds();
        this.uiFunctionCds = otherBean.getUiFunctionCds();
        this.stratId = otherBean.getStratId();
        this.strategyVO = otherBean.getStrategyVO();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final PmfmStrategyVO otherBean)
    {
        if (null != otherBean)
        {
            this.setPmfmStratId(otherBean.getPmfmStratId());
            this.setPmfmStratParAcquisNumber(otherBean.getPmfmStratParAcquisNumber());
            this.setPmfmStratPresRk(otherBean.getPmfmStratPresRk());
            this.setPmfmStratParIsIndiv(otherBean.getPmfmStratParIsIndiv());
            this.setPmfmStratIsUniqueByTaxon(otherBean.getPmfmStratIsUniqueByTaxon());
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setPmfmId(otherBean.getPmfmId());
            this.setPrecTypeId(otherBean.getPrecTypeId());
            this.setAcquisLevelCds(otherBean.getAcquisLevelCds());
            this.setUiFunctionCds(otherBean.getUiFunctionCds());
            this.setStratId(otherBean.getStratId());
            this.setStrategyVO(otherBean.getStrategyVO());
        }
    }

    /**
     * TODO: Model Documentation for attribute pmfmStratId
     * Get the pmfmStratId Attribute
     * @return pmfmStratId Integer
     */
    public Integer getPmfmStratId()
    {
        return this.pmfmStratId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setPmfmStratId(final Integer value)
    {
        this.pmfmStratId = value;
    }

    /**
     * Nombre de fois où un paramètre peut être saisi
     * Il est constant pour tous les niveaux de saisie, est obligatoire et par défaut prend la
     * valeur 1
     * Get the pmfmStratParAcquisNumber Attribute
     * @return pmfmStratParAcquisNumber Double
     */
    public Double getPmfmStratParAcquisNumber()
    {
        return this.pmfmStratParAcquisNumber;
    }

    /**
     * Nombre de fois où un paramètre peut être saisi
     * Il est constant pour tous les niveaux de saisie, est obligatoire et par défaut prend la
     * valeur 1
     * @param value Double
     */
    public void setPmfmStratParAcquisNumber(final Double value)
    {
        this.pmfmStratParAcquisNumber = value;
    }

    /**
     * Rang pour la presentation des résultats
     * Get the pmfmStratPresRk Attribute
     * @return pmfmStratPresRk Integer
     */
    public Integer getPmfmStratPresRk()
    {
        return this.pmfmStratPresRk;
    }

    /**
     * Rang pour la presentation des résultats
     * @param value Integer
     */
    public void setPmfmStratPresRk(final Integer value)
    {
        this.pmfmStratPresRk = value;
    }

    /**
     * Indique si la saisie du paramètre se fait sur des individus
     * Get the pmfmStratParIsIndiv Attribute
     * @return pmfmStratParIsIndiv String
     */
    public String getPmfmStratParIsIndiv()
    {
        return this.pmfmStratParIsIndiv;
    }

    /**
     * Indique si la saisie du paramètre se fait sur des individus
     * @param value String
     */
    public void setPmfmStratParIsIndiv(final String value)
    {
        this.pmfmStratParIsIndiv = value;
    }

    /**
     * TODO: Model Documentation for attribute pmfmStratIsUniqueByTaxon
     * Get the pmfmStratIsUniqueByTaxon Attribute
     * @return pmfmStratIsUniqueByTaxon String
     */
    public String getPmfmStratIsUniqueByTaxon()
    {
        return this.pmfmStratIsUniqueByTaxon;
    }

    /**
     * 
     * @param value String
     */
    public void setPmfmStratIsUniqueByTaxon(final String value)
    {
        this.pmfmStratIsUniqueByTaxon = value;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * TODO: Model Documentation for attribute pmfmId
     * Get the pmfmId Attribute
     * @return pmfmId Integer
     */
    public Integer getPmfmId()
    {
        return this.pmfmId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setPmfmId(final Integer value)
    {
        this.pmfmId = value;
    }

    /**
     * Code unique de l'unité d'incertitude
     * Get the precTypeId Attribute
     * @return precTypeId Integer
     */
    public Integer getPrecTypeId()
    {
        return this.precTypeId;
    }

    /**
     * Code unique de l'unité d'incertitude
     * @param value Integer
     */
    public void setPrecTypeId(final Integer value)
    {
        this.precTypeId = value;
    }

    /**
     * Code du niveau de saisie
     * Get the acquisLevelCds Attribute
     * @return acquisLevelCds String[]
     */
    public String[] getAcquisLevelCds()
    {
        return this.acquisLevelCds;
    }

    /**
     * Code du niveau de saisie
     * @param value String[]
     */
    public void setAcquisLevelCds(final String[] value)
    {
        this.acquisLevelCds = value;
    }

    /**
     * TODO: Model Documentation for attribute uiFunctionCds
     * Get the uiFunctionCds Attribute
     * @return uiFunctionCds String[]
     */
    public String[] getUiFunctionCds()
    {
        return this.uiFunctionCds;
    }

    /**
     * 
     * @param value String[]
     */
    public void setUiFunctionCds(final String[] value)
    {
        this.uiFunctionCds = value;
    }

    /**
     * Identifiant interne de la stratégie
     * Get the stratId Attribute
     * @return stratId Integer
     */
    public Integer getStratId()
    {
        return this.stratId;
    }

    /**
     * Identifiant interne de la stratégie
     * @param value Integer
     */
    public void setStratId(final Integer value)
    {
        this.stratId = value;
    }

    /**
     * Définie les paramètres à mesurer dans un programme particulier.
     * Get the strategyVO Association
     * @return this.strategyVO StrategyVO
     */
    public StrategyVO getStrategyVO()
    {
        return this.strategyVO;
    }

    /**
     * Sets the strategyVO
     * @param value StrategyVO
     */
    public void setStrategyVO(StrategyVO value)
    {
        this.strategyVO = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        PmfmStrategyVO rhs = (PmfmStrategyVO) object;
        return new EqualsBuilder()
            .append(this.getPmfmStratId(), rhs.getPmfmStratId())
            .append(this.getPmfmStratParAcquisNumber(), rhs.getPmfmStratParAcquisNumber())
            .append(this.getPmfmStratPresRk(), rhs.getPmfmStratPresRk())
            .append(this.getPmfmStratParIsIndiv(), rhs.getPmfmStratParIsIndiv())
            .append(this.getPmfmStratIsUniqueByTaxon(), rhs.getPmfmStratIsUniqueByTaxon())
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getPmfmId(), rhs.getPmfmId())
            .append(this.getPrecTypeId(), rhs.getPrecTypeId())
            .append(this.getAcquisLevelCds(), rhs.getAcquisLevelCds())
            .append(this.getUiFunctionCds(), rhs.getUiFunctionCds())
            .append(this.getStratId(), rhs.getStratId())
            .append(this.getStrategyVO(), rhs.getStrategyVO())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final PmfmStrategyVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getPmfmStratId(), object.getPmfmStratId())
            .append(this.getPmfmStratParAcquisNumber(), object.getPmfmStratParAcquisNumber())
            .append(this.getPmfmStratPresRk(), object.getPmfmStratPresRk())
            .append(this.getPmfmStratParIsIndiv(), object.getPmfmStratParIsIndiv())
            .append(this.getPmfmStratIsUniqueByTaxon(), object.getPmfmStratIsUniqueByTaxon())
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getPmfmId(), object.getPmfmId())
            .append(this.getPrecTypeId(), object.getPrecTypeId())
            .append(this.getAcquisLevelCds(), object.getAcquisLevelCds())
            .append(this.getUiFunctionCds(), object.getUiFunctionCds())
            .append(this.getStratId(), object.getStratId())
            .append(this.getStrategyVO(), object.getStrategyVO())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getPmfmStratId())
            .append(this.getPmfmStratParAcquisNumber())
            .append(this.getPmfmStratPresRk())
            .append(this.getPmfmStratParIsIndiv())
            .append(this.getPmfmStratIsUniqueByTaxon())
            .append(this.getUpdateDt())
            .append(this.getPmfmId())
            .append(this.getPrecTypeId())
            .append(this.getAcquisLevelCds())
            .append(this.getUiFunctionCds())
            .append(this.getStratId())
            .append(this.getStrategyVO())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("pmfmStratId", this.getPmfmStratId())
            .append("pmfmStratParAcquisNumber", this.getPmfmStratParAcquisNumber())
            .append("pmfmStratPresRk", this.getPmfmStratPresRk())
            .append("pmfmStratParIsIndiv", this.getPmfmStratParIsIndiv())
            .append("pmfmStratIsUniqueByTaxon", this.getPmfmStratIsUniqueByTaxon())
            .append("updateDt", this.getUpdateDt())
            .append("pmfmId", this.getPmfmId())
            .append("precTypeId", this.getPrecTypeId())
            .append("acquisLevelCds", this.getAcquisLevelCds())
            .append("uiFunctionCds", this.getUiFunctionCds())
            .append("stratId", this.getStratId())
            .append("strategyVO", this.getStrategyVO())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // PmfmStrategyVO value-object java merge-point
}