// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige3.core.dao.referential.transcribing;

import fr.ifremer.quadrige3.core.dao.referential.ObjectType;
import fr.ifremer.quadrige3.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Type de transcodage, permettant de faire communiquer un système d'information externes avec le
 * système Allegro.
 * Exemple :
 * - Reef DB : REEFDB-PMFM.PMFM_NM - transcodage des libellés de PMFM
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TranscribingItemType
    implements Serializable, Comparable<TranscribingItemType>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 7277825601781357658L;

    // Generate 8 attributes
    private Integer transcItemTypeId;

    /**
     * 
     * @return this.transcItemTypeId Integer
     */
    public Integer getTranscItemTypeId()
    {
        return this.transcItemTypeId;
    }

    /**
     * 
     * @param transcItemTypeIdIn Integer
     */
    public void setTranscItemTypeId(Integer transcItemTypeIdIn)
    {
        this.transcItemTypeId = transcItemTypeIdIn;
    }

    private String transcItemTypeLb;

    /**
     * Le mnémonique du type de transcodage.
     * Ce mnémonique respecte une structure qui permet d'identifier de manière unique le type de
     * transcodage.
     * Ce mnémonique peut ainsi être utilisé par des constantes, dans des requetes SQL, du code,
     * etc.
     * @return this.transcItemTypeLb String
     */
    public String getTranscItemTypeLb()
    {
        return this.transcItemTypeLb;
    }

    /**
     * Le mnémonique du type de transcodage.
     * Ce mnémonique respecte une structure qui permet d'identifier de manière unique le type de
     * transcodage.
     * Ce mnémonique peut ainsi être utilisé par des constantes, dans des requetes SQL, du code,
     * etc.
     * @param transcItemTypeLbIn String
     */
    public void setTranscItemTypeLb(String transcItemTypeLbIn)
    {
        this.transcItemTypeLb = transcItemTypeLbIn;
    }

    private String transcItemTypeNm;

    /**
     * Le libellé du type de transcodage.
     * Généralement, on utilise le formalisme suivant :
     * <code_système>-<table_système>.<champ_système>
     * @return this.transcItemTypeNm String
     */
    public String getTranscItemTypeNm()
    {
        return this.transcItemTypeNm;
    }

    /**
     * Le libellé du type de transcodage.
     * Généralement, on utilise le formalisme suivant :
     * <code_système>-<table_système>.<champ_système>
     * @param transcItemTypeNmIn String
     */
    public void setTranscItemTypeNm(String transcItemTypeNmIn)
    {
        this.transcItemTypeNm = transcItemTypeNmIn;
    }

    private String transcItemTypeDc;

    /**
     * 
     * @return this.transcItemTypeDc String
     */
    public String getTranscItemTypeDc()
    {
        return this.transcItemTypeDc;
    }

    /**
     * 
     * @param transcItemTypeDcIn String
     */
    public void setTranscItemTypeDc(String transcItemTypeDcIn)
    {
        this.transcItemTypeDc = transcItemTypeDcIn;
    }

    private String transcItemTypeCm;

    /**
     * Commentaire décrivant le rang taxinomique
     * @return this.transcItemTypeCm String
     */
    public String getTranscItemTypeCm()
    {
        return this.transcItemTypeCm;
    }

    /**
     * Commentaire décrivant le rang taxinomique
     * @param transcItemTypeCmIn String
     */
    public void setTranscItemTypeCm(String transcItemTypeCmIn)
    {
        this.transcItemTypeCm = transcItemTypeCmIn;
    }

    private String transcItemTypeIsMandatory = "0";

    /**
     * Permet de savoir si la classification est à maintenir obligatoirement (par l'équipe
     * d'exploitation).
     * @return this.transcItemTypeIsMandatory String
     */
    public String getTranscItemTypeIsMandatory()
    {
        return this.transcItemTypeIsMandatory;
    }

    /**
     * Permet de savoir si la classification est à maintenir obligatoirement (par l'équipe
     * d'exploitation).
     * @param transcItemTypeIsMandatoryIn String
     */
    public void setTranscItemTypeIsMandatory(String transcItemTypeIsMandatoryIn)
    {
        this.transcItemTypeIsMandatory = transcItemTypeIsMandatoryIn;
    }

    private Timestamp updateDt;

    /**
     * 
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * 
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private String transcItemTypeFilterQuery;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * SQL query that return an ID or a CODE, to limit the transcribing type to
     * a list of entities.
     * </p>
     * <p>
     * <b>For instance :</b>
     * </p>
     * <ul>
     * <li>
     * Limit a transcribing type to commercial species :
     * </li>
     * </ul>
     * <p>
     * select ID
     * <br>from TAXON_GROUP
     * <br>where TAXON_GROUP_TYPE_FK=2 -- FAO species
     * </p>
     * </body>
     * </html>
     * @return this.transcItemTypeFilterQuery String
     */
    public String getTranscItemTypeFilterQuery()
    {
        return this.transcItemTypeFilterQuery;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * SQL query that return an ID or a CODE, to limit the transcribing type to
     * a list of entities.
     * </p>
     * <p>
     * <b>For instance :</b>
     * </p>
     * <ul>
     * <li>
     * Limit a transcribing type to commercial species :
     * </li>
     * </ul>
     * <p>
     * select ID
     * <br>from TAXON_GROUP
     * <br>where TAXON_GROUP_TYPE_FK=2 -- FAO species
     * </p>
     * </body>
     * </html>
     * @param transcItemTypeFilterQueryIn String
     */
    public void setTranscItemTypeFilterQuery(String transcItemTypeFilterQueryIn)
    {
        this.transcItemTypeFilterQuery = transcItemTypeFilterQueryIn;
    }

    // Generate 4 associations
    private ObjectType objectType;

    /**
     * Liste des types d'objets qui peuvent être associés à la photo ou à un résultat. Cette liste
     * ne peut
     * pas être modifiée par l'utilisateur.
     * @return this.objectType ObjectType
     */
    public ObjectType getObjectType()
    {
        return this.objectType;
    }

    /**
     * Liste des types d'objets qui peuvent être associés à la photo ou à un résultat. Cette liste
     * ne peut
     * pas être modifiée par l'utilisateur.
     * @param objectTypeIn ObjectType
     */
    public void setObjectType(ObjectType objectTypeIn)
    {
        this.objectType = objectTypeIn;
    }

    private TranscribingSide transcribingSide;

    /**
     * Sens du transcodage.
     * @return this.transcribingSide TranscribingSide
     */
    public TranscribingSide getTranscribingSide()
    {
        return this.transcribingSide;
    }

    /**
     * Sens du transcodage.
     * @param transcribingSideIn TranscribingSide
     */
    public void setTranscribingSide(TranscribingSide transcribingSideIn)
    {
        this.transcribingSide = transcribingSideIn;
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    /**
     * Returns <code>true</code> if the argument is an TranscribingItemType instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TranscribingItemType))
        {
            return false;
        }
        final TranscribingItemType that = (TranscribingItemType)object;
        if (this.transcItemTypeId == null || that.getTranscItemTypeId() == null || !this.transcItemTypeId.equals(that.getTranscItemTypeId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.transcItemTypeId == null ? 0 : this.transcItemTypeId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link TranscribingItemType}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TranscribingItemType}.
         * @return new TranscribingItemTypeImpl()
         */
        public static TranscribingItemType newInstance()
        {
            return new TranscribingItemTypeImpl();
        }

        /**
         * Constructs a new instance of {@link TranscribingItemType}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param transcItemTypeLb String
         * @param transcItemTypeNm String
         * @param transcItemTypeIsMandatory String
         * @param objectType ObjectType
         * @param transcribingSide TranscribingSide
         * @param status Status
         * @return newInstance
         */
        public static TranscribingItemType newInstance(String transcItemTypeLb, String transcItemTypeNm, String transcItemTypeIsMandatory, ObjectType objectType, TranscribingSide transcribingSide, Status status)
        {
            final TranscribingItemType entity = new TranscribingItemTypeImpl();
            entity.setTranscItemTypeLb(transcItemTypeLb);
            entity.setTranscItemTypeNm(transcItemTypeNm);
            entity.setTranscItemTypeIsMandatory(transcItemTypeIsMandatory);
            entity.setObjectType(objectType);
            entity.setTranscribingSide(transcribingSide);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TranscribingItemType}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param transcItemTypeLb String
         * @param transcItemTypeNm String
         * @param transcItemTypeDc String
         * @param transcItemTypeCm String
         * @param transcItemTypeIsMandatory String
         * @param updateDt Timestamp
         * @param transcItemTypeFilterQuery String
         * @param objectType ObjectType
         * @param transcribingSide TranscribingSide
         * @param status Status
         * @return newInstance TranscribingItemType
         */
        public static TranscribingItemType newInstance(String transcItemTypeLb, String transcItemTypeNm, String transcItemTypeDc, String transcItemTypeCm, String transcItemTypeIsMandatory, Timestamp updateDt, String transcItemTypeFilterQuery, ObjectType objectType, TranscribingSide transcribingSide, Status status)
        {
            final TranscribingItemType entity = new TranscribingItemTypeImpl();
            entity.setTranscItemTypeLb(transcItemTypeLb);
            entity.setTranscItemTypeNm(transcItemTypeNm);
            entity.setTranscItemTypeDc(transcItemTypeDc);
            entity.setTranscItemTypeCm(transcItemTypeCm);
            entity.setTranscItemTypeIsMandatory(transcItemTypeIsMandatory);
            entity.setUpdateDt(updateDt);
            entity.setTranscItemTypeFilterQuery(transcItemTypeFilterQuery);
            entity.setObjectType(objectType);
            entity.setTranscribingSide(transcribingSide);
            entity.setStatus(status);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TranscribingItemType o)
    {
        int cmp = 0;
        if (this.getTranscItemTypeId() != null)
        {
            cmp = this.getTranscItemTypeId().compareTo(o.getTranscItemTypeId());
        }
        else
        {
            if (this.getTranscItemTypeLb() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTranscItemTypeLb().compareTo(o.getTranscItemTypeLb()));
            }
            if (this.getTranscItemTypeNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTranscItemTypeNm().compareTo(o.getTranscItemTypeNm()));
            }
            if (this.getTranscItemTypeDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTranscItemTypeDc().compareTo(o.getTranscItemTypeDc()));
            }
            if (this.getTranscItemTypeCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTranscItemTypeCm().compareTo(o.getTranscItemTypeCm()));
            }
            if (this.getTranscItemTypeIsMandatory() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTranscItemTypeIsMandatory().compareTo(o.getTranscItemTypeIsMandatory()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
            if (this.getTranscItemTypeFilterQuery() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTranscItemTypeFilterQuery().compareTo(o.getTranscItemTypeFilterQuery()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TranscribingItemType.java merge-point
}